/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/glob","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/collections","vs/base/common/stopwatch","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/idGenerator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Te=function(Y){for(var e=[],u=0,i=Y.length;u<i;u++)e[u]=Ie[Y[u]];return e};define(Ie[57],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(i,y){if(!i)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=u}),define(Ie[78],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(C){return C?C.replace(/\$\((.*?)\)/g,(D,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=u;class i{constructor(D,E,P){this.id=D,this.definition=E,this.description=P,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function y(C,D){const E=["codicon","codicon-"+C];return D&&E.push("codicon-modifier-"+D),E}e.getClassNamesArray=y;var A;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function E(T){if(T instanceof i)return["codicon","codicon-"+T.id];const S=D.exec(T.id);if(!S)return E(i.error);let[,I,_]=S;const g=["codicon","codicon-"+I];return _&&g.push("codicon-modifier-"+_.substr(1)),g}C.asClassNameArray=E;function P(T){return E(T).join(" ")}C.asClassName=P;function L(T){return"."+E(T).join(".")}C.asCSSSelector=L})(A=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[48],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function i(L){const T=[];for(let S in L)u.call(L,S)&&T.push(L[S]);return T}e.values=i;function y(L,T){for(let S in L)if(u.call(L,S)&&T({key:S,value:L[S]},function(){delete L[S]})===!1)return}e.forEach=y;function A(L,T){const S=Object.create(null);for(const I of L){const _=T(I);let g=S[_];g||(g=S[_]=[]),g.push(I)}return S}e.groupBy=A;function C(L){const T=Object.create(null);return L&&L.forEach((S,I)=>{T[I]=S}),T}e.fromMap=C;function D(L,T){const S=[],I=[];for(let _ of L)T.has(_)||S.push(_);for(let _ of T)L.has(_)||I.push(_);return{removed:S,added:I}}e.diffSets=D;function E(L,T){const S=[],I=[];for(let[_,g]of L)T.has(_)||S.push(g);for(let[_,g]of T)L.has(_)||I.push(g);return{removed:S,added:I}}e.diffMaps=E;class P{constructor(){this.map=new Map}add(T,S){let I=this.map.get(T);I||(I=new Set,this.map.set(T,I)),I.add(S)}delete(T,S){const I=this.map.get(T);!I||(I.delete(S),I.size===0&&this.map.delete(T))}forEach(T,S){const I=this.map.get(T);!I||I.forEach(S)}}e.SetMap=P}),define(Ie[58],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(C){return(D,E,P)=>{let L=null,T=null;if(typeof P.value=="function"?(L="value",T=P.value):typeof P.get=="function"&&(L="get",T=P.get),!T)throw new Error("not supported");P[L]=C(T,E)}}e.createDecorator=u;function i(C,D,E){let P=null,L=null;if(typeof E.value=="function"?(P="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",L=E.get),!L)throw new Error("not supported");const T=`$memoize$${D}`;E[P]=function(...S){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[T]}}e.memoize=i;function y(C,D,E){return u((P,L)=>{const T=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...I){this[S]||(this[S]=E?E():void 0),clearTimeout(this[T]),D&&(this[S]=D(this[S],...I),I=[this[S]]),this[T]=setTimeout(()=>{P.apply(this,I),this[S]=E?E():void 0},C)}})}e.debounce=y;function A(C,D,E){return u((P,L)=>{const T=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,_=`$throttle$pending$${L}`;return function(...g){if(this[S]||(this[S]=E?E():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...g)),this[_])return;const v=this[I]+C;v<=Date.now()?(this[I]=Date.now(),P.apply(this,[this[S]]),this[S]=E?E():void 0):(this[_]=!0,this[T]=setTimeout(()=>{this[_]=!1,this[I]=Date.now(),P.apply(this,[this[S]]),this[S]=E?E():void 0},v-Date.now()))}})}e.throttle=A}),define(Ie[11],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(h=>{h(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=u,e.errorHandler=new u;function i(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=i;function y(m){E(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=y;function A(m){E(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function C(m){if(m instanceof Error){let{name:o,message:h}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:o,message:h,stack:r}}return m}e.transformErrorForSerialization=C;const D="Canceled";function E(m){return m instanceof P?!0:m instanceof Error&&m.name===D&&m.message===D}e.isCancellationError=E;class P extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=P;function L(){const m=new Error(D);return m.name=m.message,m}e.canceled=L;function T(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=T;function S(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=S;function I(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function _(m){const o=new Error(`${m} has been disposed`);return o.name="DISPOSED",o}e.disposed=_;function g(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=g;class v extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=v;class p extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=p;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(o){if(o&&o instanceof f)return o;if(o&&o instanceof Error){const h=new f;return h.name=o.name,h.message=o.message,h.stack=o.stack,h}return new f(o)}}e.ErrorNoTelemetry=f;class a extends Error{constructor(o){super(o||"An unexpected bug occurred.");Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(Ie[16],Te([1,0,11]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(oe,_e=0){return oe[oe.length-(1+_e)]}e.tail=i;function y(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=y;function A(oe,_e,Pe=(pe,ve)=>pe===ve){if(oe===_e)return!0;if(!oe||!_e||oe.length!==_e.length)return!1;for(let pe=0,ve=oe.length;pe<ve;pe++)if(!Pe(oe[pe],_e[pe]))return!1;return!0}e.equals=A;function C(oe,_e,Pe){return D(oe.length,pe=>Pe(oe[pe],_e))}e.binarySearch=C;function D(oe,_e){let Pe=0,pe=oe-1;for(;Pe<=pe;){const ve=(Pe+pe)/2|0,Ae=_e(ve);if(Ae<0)Pe=ve+1;else if(Ae>0)pe=ve-1;else return ve}return-(Pe+1)}e.binarySearch2=D;function E(oe,_e){let Pe=0,pe=oe.length;if(pe===0)return 0;for(;Pe<pe;){const ve=Math.floor((Pe+pe)/2);_e(oe[ve])?pe=ve:Pe=ve+1}return Pe}e.findFirstInSorted=E;function P(oe,_e,Pe){if(oe=oe|0,oe>=_e.length)throw new TypeError("invalid index");let pe=_e[Math.floor(_e.length*Math.random())],ve=[],Ae=[],ce=[];for(let me of _e){const te=Pe(me,pe);te<0?ve.push(me):te>0?Ae.push(me):ce.push(me)}return oe<ve.length?P(oe,ve,Pe):oe<ve.length+ce.length?ce[0]:P(oe-(ve.length+ce.length),Ae,Pe)}e.quickSelect=P;function L(oe,_e){const Pe=[];let pe;for(const ve of oe.slice(0).sort(_e))!pe||_e(pe[0],ve)!==0?(pe=[ve],Pe.push(pe)):pe.push(ve);return Pe}e.groupBy=L;function T(oe,_e,Pe){const pe=[];function ve(me,te,ne){if(te===0&&ne.length===0)return;const U=pe[pe.length-1];U&&U.start+U.deleteCount===me?(U.deleteCount+=te,U.toInsert.push(...ne)):pe.push({start:me,deleteCount:te,toInsert:ne})}let Ae=0,ce=0;for(;;){if(Ae===oe.length){ve(Ae,0,_e.slice(ce));break}if(ce===_e.length){ve(Ae,oe.length-Ae,[]);break}const me=oe[Ae],te=_e[ce],ne=Pe(me,te);ne===0?(Ae+=1,ce+=1):ne<0?(ve(Ae,1,[]),Ae+=1):ne>0&&(ve(Ae,0,[te]),ce+=1)}return pe}e.sortedDiff=T;function S(oe,_e,Pe){const pe=T(oe,_e,Pe),ve=[],Ae=[];for(const ce of pe)ve.push(...oe.slice(ce.start,ce.start+ce.deleteCount)),Ae.push(...ce.toInsert);return{removed:ve,added:Ae}}e.delta=S;function I(oe,_e,Pe){if(Pe===0)return[];const pe=oe.slice(0,Pe).sort(_e);return g(oe,_e,pe,Pe,oe.length),pe}e.top=I;function _(oe,_e,Pe,pe,ve){return Pe===0?Promise.resolve([]):new Promise((Ae,ce)=>{(async()=>{const me=oe.length,te=oe.slice(0,Pe).sort(_e);for(let ne=Pe,U=Math.min(Pe+pe,me);ne<me;ne=U,U=Math.min(U+pe,me)){if(ne>Pe&&await new Promise($=>setTimeout($)),ve&&ve.isCancellationRequested)throw new u.CancellationError;g(oe,_e,te,ne,U)}return te})().then(Ae,ce)})}e.topAsync=_;function g(oe,_e,Pe,pe,ve){for(const Ae=Pe.length;pe<ve;pe++){const ce=oe[pe];if(_e(ce,Pe[Ae-1])<0){Pe.pop();const me=E(Pe,te=>_e(ce,te)<0);Pe.splice(me,0,ce)}}}function v(oe){return oe.filter(_e=>!!_e)}e.coalesce=v;function p(oe){let _e=0;for(let Pe=0;Pe<oe.length;Pe++)oe[Pe]&&(oe[_e]=oe[Pe],_e+=1);oe.length=_e}e.coalesceInPlace=p;function b(oe,_e,Pe){oe.splice(Pe,0,oe.splice(_e,1)[0])}e.move=b;function f(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=f;function a(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=a;function m(oe,_e=Pe=>Pe){const Pe=new Set;return oe.filter(pe=>{const ve=_e(pe);return Pe.has(ve)?!1:(Pe.add(ve),!0)})}e.distinct=m;function o(oe){const _e=new Set;return Pe=>{const pe=oe(Pe);return _e.has(pe)?!1:(_e.add(pe),!0)}}e.uniqueFilter=o;function h(oe,_e){const Pe=r(oe,_e);if(Pe!==-1)return oe[Pe]}e.findLast=h;function r(oe,_e){for(let Pe=oe.length-1;Pe>=0;Pe--){const pe=oe[Pe];if(_e(pe))return Pe}return-1}e.lastIndex=r;function s(oe,_e){return oe.length>0?oe[0]:_e}e.firstOrDefault=s;function n(oe,_e){return oe.length>0?oe[oe.length-1]:_e}e.lastOrDefault=n;function t(oe,_e,Pe=(pe,ve)=>pe===ve){let pe=0;for(let ve=0,Ae=Math.min(oe.length,_e.length);ve<Ae&&Pe(oe[ve],_e[ve]);ve++)pe++;return pe}e.commonPrefixLength=t;function c(oe){return[].concat(...oe)}e.flatten=c;function l(oe,_e){let Pe=typeof _e=="number"?oe:0;typeof _e=="number"?Pe=oe:(Pe=0,_e=oe);const pe=[];if(Pe<=_e)for(let ve=Pe;ve<_e;ve++)pe.push(ve);else for(let ve=Pe;ve>_e;ve--)pe.push(ve);return pe}e.range=l;function d(oe,_e,Pe){return oe.reduce((pe,ve)=>(pe[_e(ve)]=Pe?Pe(ve):ve,pe),Object.create(null))}e.index=d;function w(oe,_e){return oe.push(_e),()=>R(oe,_e)}e.insert=w;function R(oe,_e){const Pe=oe.indexOf(_e);if(Pe>-1)return oe.splice(Pe,1),_e}e.remove=R;function F(oe,_e,Pe){const pe=oe.slice(0,_e),ve=oe.slice(_e);return pe.concat(Pe,ve)}e.arrayInsert=F;function O(oe,_e){let Pe;if(typeof _e=="number"){let pe=_e;Pe=()=>{const ve=Math.sin(pe++)*179426549;return ve-Math.floor(ve)}}else Pe=Math.random;for(let pe=oe.length-1;pe>0;pe-=1){const ve=Math.floor(Pe()*(pe+1)),Ae=oe[pe];oe[pe]=oe[ve],oe[ve]=Ae}}e.shuffle=O;function k(oe,_e){const Pe=oe.indexOf(_e);Pe>-1&&(oe.splice(Pe,1),oe.unshift(_e))}e.pushToStart=k;function B(oe,_e){const Pe=oe.indexOf(_e);Pe>-1&&(oe.splice(Pe,1),oe.push(_e))}e.pushToEnd=B;function M(oe,_e){for(const Pe of _e)oe.push(Pe)}e.pushMany=M;function W(oe,_e){return Array.isArray(oe)?oe.map(_e):_e(oe)}e.mapArrayOrNot=W;function ee(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=ee;function H(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=H;function N(oe,_e){for(const Pe of oe){const pe=_e(Pe);if(pe!==void 0)return pe}}e.mapFind=N;function j(oe,_e,Pe){const pe=q(oe,_e),ve=oe.length,Ae=Pe.length;oe.length=ve+Ae;for(let ce=ve-1;ce>=pe;ce--)oe[ce+Ae]=oe[ce];for(let ce=0;ce<Ae;ce++)oe[ce+pe]=Pe[ce]}e.insertInto=j;function x(oe,_e,Pe,pe){const ve=q(oe,_e),Ae=oe.splice(ve,Pe);return j(oe,ve,pe),Ae}e.splice=x;function q(oe,_e){return _e<0?Math.max(_e+oe.length,0):Math.min(_e,oe.length)}var ie;(function(oe){function _e(ve){return ve<0}oe.isLessThan=_e;function Pe(ve){return ve>0}oe.isGreaterThan=Pe;function pe(ve){return ve===0}oe.isNeitherLessOrGreaterThan=pe,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function Q(oe,_e){return(Pe,pe)=>_e(oe(Pe),oe(pe))}e.compareBy=Q;const de=(oe,_e)=>oe-_e;e.numberComparator=de;function ue(oe,_e){if(oe.length===0)return;let Pe=oe[0];for(let pe=1;pe<oe.length;pe++){const ve=oe[pe];_e(ve,Pe)>0&&(Pe=ve)}return Pe}e.findMaxBy=ue;function X(oe,_e){if(oe.length===0)return;let Pe=oe[0];for(let pe=1;pe<oe.length;pe++){const ve=oe[pe];_e(ve,Pe)>=0&&(Pe=ve)}return Pe}e.findLastMaxBy=X;function ge(oe,_e){return ue(oe,(Pe,pe)=>-_e(Pe,pe))}e.findMinBy=ge;class Se{constructor(_e){this.items=_e,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_e){let Pe=this.firstIdx;for(;Pe<this.items.length&&_e(this.items[Pe]);)Pe++;const pe=Pe===this.firstIdx?null:this.items.slice(this.firstIdx,Pe);return this.firstIdx=Pe,pe}takeFromEndWhile(_e){let Pe=this.lastIdx;for(;Pe>=0&&_e(this.items[Pe]);)Pe--;const pe=Pe===this.lastIdx?null:this.items.slice(Pe+1,this.lastIdx+1);return this.lastIdx=Pe,pe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const _e=this.items[this.firstIdx];return this.firstIdx++,_e}removeLast(){const _e=this.items[this.lastIdx];return this.lastIdx--,_e}takeCount(_e){const Pe=this.items.slice(this.firstIdx,this.firstIdx+_e);return this.firstIdx+=_e,Pe}}e.ArrayQueue=Se}),define(Ie[59],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(i){const y=this;let A=!1,C;return function(){return A||(A=!0,C=i.apply(y,arguments)),C}}e.once=u}),define(Ie[79],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(Ie[60],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(i){function y(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=y;const A=Object.freeze([]);function C(){return A}i.empty=C;function*D(h){yield h}i.single=D;function E(h){return h||A}i.from=E;function P(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=P;function L(h){return h[Symbol.iterator]().next().value}i.first=L;function T(h,r){for(const s of h)if(r(s))return!0;return!1}i.some=T;function S(h,r){for(const s of h)if(r(s))return s}i.find=S;function*I(h,r){for(const s of h)r(s)&&(yield s)}i.filter=I;function*_(h,r){let s=0;for(const n of h)yield r(n,s++)}i.map=_;function*g(...h){for(const r of h)for(const s of r)yield s}i.concat=g;function*v(h){for(const r of h)for(const s of r)yield s}i.concatNested=v;function p(h,r,s){let n=s;for(const t of h)n=r(n,t);return n}i.reduce=p;function b(h,r){let s=0;for(const n of h)r(n,s++)}i.forEach=b;function*f(h,r,s=h.length){for(r<0&&(r+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);r<s;r++)yield h[r]}i.slice=f;function a(h,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,h];const n=h[Symbol.iterator]();for(let t=0;t<r;t++){const c=n.next();if(c.done)return[s,i.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}i.consume=a;function m(h){return a(h)[0]}i.collect=m;function o(h,r,s=(n,t)=>n===t){const n=h[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const c=n.next(),l=t.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!s(c.value,l.value))return!1}}i.equals=o})(u=e.Iterable||(e.Iterable={}))}),define(Ie[143],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var i;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function C(o,h=!1){let r=0,s=o.length,n="",t=0,c=16,l=0;function d(M){let W=0,ee=0;for(;W<M;){const H=o.charCodeAt(r);if(H>=48&&H<=57)ee=ee*16+H-48;else if(H>=65&&H<=70)ee=ee*16+H-65+10;else if(H>=97&&H<=102)ee=ee*16+H-97+10;else break;r++,W++}return W<M&&(ee=-1),ee}function w(M){r=M,n="",t=0,c=16,l=0}function R(){const M=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&P(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&P(o.charCodeAt(r)))for(r++;r<o.length&&P(o.charCodeAt(r));)r++;else return l=3,o.substring(M,r);let W=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&P(o.charCodeAt(r))){for(r++;r<o.length&&P(o.charCodeAt(r));)r++;W=r}else l=3;return o.substring(M,W)}function F(){let M="",W=r;for(;;){if(r>=s){M+=o.substring(W,r),l=2;break}const ee=o.charCodeAt(r);if(ee===34){M+=o.substring(W,r),r++;break}if(ee===92){if(M+=o.substring(W,r),r++,r>=s){l=2;break}switch(o.charCodeAt(r++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const N=d(4);N>=0?M+=String.fromCharCode(N):l=4;break}default:l=5}W=r;continue}if(ee>=0&&ee<=31)if(E(ee)){M+=o.substring(W,r),l=2;break}else l=6;r++}return M}function O(){if(n="",l=0,t=r,r>=s)return t=s,c=17;let M=o.charCodeAt(r);if(D(M)){do r++,n+=String.fromCharCode(M),M=o.charCodeAt(r);while(D(M));return c=15}if(E(M))return r++,n+=String.fromCharCode(M),M===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),c=14;switch(M){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,n=F(),c=10;case 47:{const W=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<s&&!E(o.charCodeAt(r));)r++;return n=o.substring(W,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const ee=s-1;let H=!1;for(;r<ee;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,l=1),n=o.substring(W,r),c=13}return n+=String.fromCharCode(M),r++,c=16}case 45:if(n+=String.fromCharCode(M),r++,r===s||!P(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),c=11;default:for(;r<s&&k(M);)r++,M=o.charCodeAt(r);if(t!==r){switch(n=o.substring(t,r),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(M),r++,c=16}}function k(M){if(D(M)||E(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>r,scan:h?B:O,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>l}}e.createScanner=C;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function E(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var L;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(L||(L={}));function T(o,h){const r=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function l(d,w,R,F){t.value=d,t.offset=w,t.length=R,t.type=F,t.colonOffset=void 0,n=t}try{f(o,{onObjectBegin:(d,w)=>{if(h<=d)throw s;n=void 0,c=h>d,r.push("")},onObjectProperty:(d,w,R)=>{if(h<w||(l(d,w,R,"property"),r[r.length-1]=d,h<=w+R))throw s},onObjectEnd:(d,w)=>{if(h<=d)throw s;n=void 0,r.pop()},onArrayBegin:(d,w)=>{if(h<=d)throw s;n=void 0,r.push(0)},onArrayEnd:(d,w)=>{if(h<=d)throw s;n=void 0,r.pop()},onLiteralValue:(d,w,R)=>{if(h<w||(l(d,w,R,m(d)),h<=w+R))throw s},onSeparator:(d,w,R)=>{if(h<=w)throw s;if(d===":"&&n&&n.type==="property")n.colonOffset=w,c=!1,n=void 0;else if(d===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(c=!0,r[r.length-1]=""),n=void 0}}})}catch(d){if(d!==s)throw d}return{path:r,previousNode:n,isAtPropertyKey:c,matches:d=>{let w=0;for(let R=0;w<d.length&&R<r.length;R++)if(d[w]===r[R]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.getLocation=T;function S(o,h=[],r=A.DEFAULT){let s=null,n=[];const t=[];function c(d){Array.isArray(n)?n.push(d):s!==null&&(n[s]=d)}return f(o,{onObjectBegin:()=>{const d={};c(d),t.push(n),n=d,s=null},onObjectProperty:d=>{s=d},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const d=[];c(d),t.push(n),n=d,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:c,onError:(d,w,R)=>{h.push({error:d,offset:w,length:R})}},r),n[0]}e.parse=S;function I(o,h=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(d){s.type==="property"&&(s.length=d-s.offset,s=s.parent)}function t(d){return s.children.push(d),d}f(o,{onObjectBegin:d=>{s=t({type:"object",offset:d,length:-1,parent:s,children:[]})},onObjectProperty:(d,w,R)=>{s=t({type:"property",offset:w,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:d,offset:w,length:R,parent:s})},onObjectEnd:(d,w)=>{s.length=d+w-s.offset,s=s.parent,n(d+w)},onArrayBegin:(d,w)=>{s=t({type:"array",offset:d,length:-1,parent:s,children:[]})},onArrayEnd:(d,w)=>{s.length=d+w-s.offset,s=s.parent,n(d+w)},onLiteralValue:(d,w,R)=>{t({type:m(d),offset:w,length:R,parent:s,value:d}),n(w+R)},onSeparator:(d,w,R)=>{s.type==="property"&&(d===":"?s.colonOffset=w:d===","&&n(w))},onError:(d,w,R)=>{h.push({error:d,offset:w,length:R})}},r);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=I;function _(o,h){if(!o)return;let r=o;for(let s of h)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=_;function g(o){if(!o.parent||!o.parent.children)return[];const h=g(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;h.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&h.push(r)}return h}e.getNodePath=g;function v(o){switch(o.type){case"array":return o.children.map(v);case"object":{const h=Object.create(null);for(let r of o.children){const s=r.children[1];s&&(h[r.children[0].value]=v(s))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=v;function p(o,h,r=!1){return h>=o.offset&&h<o.offset+o.length||r&&h===o.offset+o.length}e.contains=p;function b(o,h,r=!1){if(p(o,h,r)){const s=o.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=h;n++){const t=b(s[n],h,r);if(t)return t}return o}}e.findNodeAtOffset=b;function f(o,h,r=A.DEFAULT){const s=C(o,!1);function n(de){return de?()=>de(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(de){return de?ue=>de(ue,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(h.onObjectBegin),l=t(h.onObjectProperty),d=n(h.onObjectEnd),w=n(h.onArrayBegin),R=n(h.onArrayEnd),F=t(h.onLiteralValue),O=t(h.onSeparator),k=n(h.onComment),B=t(h.onError),M=r&&r.disallowComments,W=r&&r.allowTrailingComma;function ee(){for(;;){const de=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:M||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(de){case 12:case 13:M?H(10):k();break;case 16:H(1);break;case 15:case 14:break;default:return de}}}function H(de,ue=[],X=[]){if(B(de),ue.length+X.length>0){let ge=s.getToken();for(;ge!==17;){if(ue.indexOf(ge)!==-1){ee();break}else if(X.indexOf(ge)!==-1)break;ge=ee()}}}function N(de){const ue=s.getTokenValue();return de?F(ue):l(ue),ee(),!0}function j(){switch(s.getToken()){case 11:{let de=0;try{de=JSON.parse(s.getTokenValue()),typeof de!="number"&&(H(2),de=0)}catch{H(2)}F(de);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ee(),!0}function x(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(O(":"),ee(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function q(){c(),ee();let de=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(de||H(4,[],[]),O(","),ee(),s.getToken()===2&&W)break}else de&&H(6,[],[]);x()||H(4,[],[2,5]),de=!0}return d(),s.getToken()!==2?H(7,[2],[]):ee(),!0}function ie(){w(),ee();let de=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(de||H(4,[],[]),O(","),ee(),s.getToken()===4&&W)break}else de&&H(6,[],[]);Q()||H(4,[],[4,5]),de=!0}return R(),s.getToken()!==4?H(8,[4],[]):ee(),!0}function Q(){switch(s.getToken()){case 3:return ie();case 1:return q();case 10:return N(!0);default:return j()}}return ee(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=f;function a(o,h){let r=C(o),s=[],n,t=0,c;do switch(c=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:t!==c&&s.push(o.substring(t,c)),h!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,h)),t=r.getPosition();break}while(n!==17);return s.join("")}e.stripComments=a;function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Ie[80],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new u(()=>y(this.getValue()))}}e.Lazy=u}),define(Ie[6],Te([1,0,59,60]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let A=null;function C(n){A=n}if(e.setDisposableTracker=C,y){const n="__is_disposable_tracked__";C(new class{trackDisposable(t){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[n]||console.log(c)},3e3)}setParent(t,c){if(t&&t!==b.None)try{t[n]=!0}catch{}}markAsDisposed(t){if(t&&t!==b.None)try{t[n]=!0}catch{}}markAsSingleton(t){}})}function D(n){return A?.trackDisposable(n),n}function E(n){A?.markAsDisposed(n)}function P(n,t){A?.setParent(n,t)}function L(n,t){if(!!A)for(const c of n)A.setParent(c,t)}function T(n){return A?.markAsSingleton(n),n}e.markAsSingleton=T;class S extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=S;function I(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=I;function _(n){if(i.Iterable.is(n)){let t=[];for(const c of n)if(c)try{c.dispose()}catch(l){t.push(l)}if(t.length===1)throw t[0];if(t.length>1)throw new S(t);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=_;function g(...n){const t=v(()=>_(n));return L(n,t),t}e.combinedDisposable=g;function v(n){const t=D({dispose:(0,u.once)(()=>{E(t),n()})});return t}e.toDisposable=v;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{_(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return P(t,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new p,D(this),P(this._store,this)}dispose(){E(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&P(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&P(t,null),t}}e.MutableDisposable=f;class a{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(t){let c=t;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,E(this))},this}}e.SafeDisposable=m;class o{constructor(){this.references=new Map}acquire(t,...c){let l=this.references.get(t);l||(l={counter:0,object:this.createReferencedObject(t,...c)},this.references.set(t,l));const{object:d}=l,w=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(t,l.object),this.references.delete(t))});return l.counter++,{object:d,dispose:w}}}e.ReferenceCollection=o;class h{constructor(t){this.referenceCollection=t}async acquire(t,...c){const l=this.referenceCollection.acquire(t,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(d){throw l.dispose(),d}}}e.AsyncReferenceCollection=h;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(n){const t=new p;try{n(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(Ie[81],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class i{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let A=this._first;for(;A!==u.Undefined;){const C=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=C}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,C){const D=new u(A);if(this._first===u.Undefined)this._first=D,this._last=D;else if(C){const P=this._last;this._last=D,D.prev=P,P.next=D}else{const P=this._first;this._first=D,D.next=P,P.prev=D}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(D))}}shift(){if(this._first!==u.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==u.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===u.Undefined&&A.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):A.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):A.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[144],Te([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(pe,ve){for(var Ae=0;Ae<ve.length;Ae++){var ce=ve[Ae];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(pe,ce.key,ce)}}function u(pe,ve,Ae){return ve&&e(pe.prototype,ve),Ae&&e(pe,Ae),Object.defineProperty(pe,"prototype",{writable:!1}),pe}function i(pe,ve){if(!!pe){if(typeof pe=="string")return y(pe,ve);var Ae=Object.prototype.toString.call(pe).slice(8,-1);if(Ae==="Object"&&pe.constructor&&(Ae=pe.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(pe);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return y(pe,ve)}}function y(pe,ve){(ve==null||ve>pe.length)&&(ve=pe.length);for(var Ae=0,ce=new Array(ve);Ae<ve;Ae++)ce[Ae]=pe[Ae];return ce}function A(pe,ve){var Ae=typeof Symbol!="undefined"&&pe[Symbol.iterator]||pe["@@iterator"];if(Ae)return(Ae=Ae.call(pe)).next.bind(Ae);if(Array.isArray(pe)||(Ae=i(pe))||ve&&pe&&typeof pe.length=="number"){Ae&&(pe=Ae);var ce=0;return function(){return ce>=pe.length?{done:!0}:{done:!1,value:pe[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=C();function D(pe){Y.defaults=pe}var E=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(ve){return S[ve]};function _(pe,ve){if(ve){if(E.test(pe))return pe.replace(P,I)}else if(L.test(pe))return pe.replace(T,I);return pe}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(pe){return pe.replace(g,function(ve,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var p=/(^|[^\[])\^/g;function b(pe,ve){pe=typeof pe=="string"?pe:pe.source,ve=ve||"";var Ae={replace:function(me,te){return te=te.source||te,te=te.replace(p,"$1"),pe=pe.replace(me,te),Ae},getRegex:function(){return new RegExp(pe,ve)}};return Ae}var f=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(pe,ve,Ae){if(pe){var ce;try{ce=decodeURIComponent(v(Ae)).replace(f,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}ve&&!a.test(Ae)&&(Ae=n(ve,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch{return null}return Ae}var o={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(pe,ve){o[" "+pe]||(h.test(pe)?o[" "+pe]=pe+"/":o[" "+pe]=d(pe,"/",!0)),pe=o[" "+pe];var Ae=pe.indexOf(":")===-1;return ve.substring(0,2)==="//"?Ae?ve:pe.replace(r,"$1")+ve:ve.charAt(0)==="/"?Ae?ve:pe.replace(s,"$1")+ve:pe+ve}var t={exec:function(){}};function c(pe){for(var ve=1,Ae,ce;ve<arguments.length;ve++){Ae=arguments[ve];for(ce in Ae)Object.prototype.hasOwnProperty.call(Ae,ce)&&(pe[ce]=Ae[ce])}return pe}function l(pe,ve){var Ae=pe.replace(/\|/g,function(te,ne,U){for(var $=!1,G=ne;--G>=0&&U[G]==="\\";)$=!$;return $?"|":" |"}),ce=Ae.split(/ \|/),me=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),ce.length>ve)ce.splice(ve);else for(;ce.length<ve;)ce.push("");for(;me<ce.length;me++)ce[me]=ce[me].trim().replace(/\\\|/g,"|");return ce}function d(pe,ve,Ae){var ce=pe.length;if(ce===0)return"";for(var me=0;me<ce;){var te=pe.charAt(ce-me-1);if(te===ve&&!Ae)me++;else if(te!==ve&&Ae)me++;else break}return pe.slice(0,ce-me)}function w(pe,ve){if(pe.indexOf(ve[1])===-1)return-1;for(var Ae=pe.length,ce=0,me=0;me<Ae;me++)if(pe[me]==="\\")me++;else if(pe[me]===ve[0])ce++;else if(pe[me]===ve[1]&&(ce--,ce<0))return me;return-1}function R(pe){pe&&pe.sanitize&&!pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(pe,ve){if(ve<1)return"";for(var Ae="";ve>1;)ve&1&&(Ae+=pe),ve>>=1,pe+=pe;return Ae+pe}function O(pe,ve,Ae,ce){var me=ve.href,te=ve.title?_(ve.title):null,ne=pe[1].replace(/\\([\[\]])/g,"$1");if(pe[0].charAt(0)!=="!"){ce.state.inLink=!0;var U={type:"link",raw:Ae,href:me,title:te,text:ne,tokens:ce.inlineTokens(ne,[])};return ce.state.inLink=!1,U}return{type:"image",raw:Ae,href:me,title:te,text:_(ne)}}function k(pe,ve){var Ae=pe.match(/^(\s+)(?:```)/);if(Ae===null)return ve;var ce=Ae[1];return ve.split(`
`).map(function(me){var te=me.match(/^\s+/);if(te===null)return me;var ne=te[0];return ne.length>=ce.length?me.slice(ce.length):me}).join(`
`)}var B=function(){function pe(Ae){this.options=Ae||Y.defaults}var ve=pe.prototype;return ve.space=function(ce){var me=this.rules.block.newline.exec(ce);if(me&&me[0].length>0)return{type:"space",raw:me[0]}},ve.code=function(ce){var me=this.rules.block.code.exec(ce);if(me){var te=me[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:me[0],codeBlockStyle:"indented",text:this.options.pedantic?te:d(te,`
`)}}},ve.fences=function(ce){var me=this.rules.block.fences.exec(ce);if(me){var te=me[0],ne=k(te,me[3]||"");return{type:"code",raw:te,lang:me[2]?me[2].trim():me[2],text:ne}}},ve.heading=function(ce){var me=this.rules.block.heading.exec(ce);if(me){var te=me[2].trim();if(/#$/.test(te)){var ne=d(te,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(te=ne.trim())}var U={type:"heading",raw:me[0],depth:me[1].length,text:te,tokens:[]};return this.lexer.inline(U.text,U.tokens),U}},ve.hr=function(ce){var me=this.rules.block.hr.exec(ce);if(me)return{type:"hr",raw:me[0]}},ve.blockquote=function(ce){var me=this.rules.block.blockquote.exec(ce);if(me){var te=me[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:me[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ve.list=function(ce){var me=this.rules.block.list.exec(ce);if(me){var te,ne,U,$,G,K,he,we,se,De,ye,ze,Ve=me[1].trim(),Me=Ve.length>1,Je={type:"list",raw:"",ordered:Me,start:Me?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=Me?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=Me?Ve:"[*+-]");for(var J=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");ce&&(ze=!1,!(!(me=J.exec(ce))||this.rules.block.hr.test(ce)));){if(te=me[0],ce=ce.substring(te.length),we=me[2].split(`
`,1)[0],se=ce.split(`
`,1)[0],this.options.pedantic?($=2,ye=we.trimLeft()):($=me[2].search(/[^ ]/),$=$>4?1:$,ye=we.slice($),$+=me[1].length),K=!1,!we&&/^ *$/.test(se)&&(te+=se+`
`,ce=ce.substring(se.length+1),ze=!0),!ze)for(var re=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ce=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ce&&(De=ce.split(`
`,1)[0],we=De,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(re.test(we)||Ce.test(ce)));){if(we.search(/[^ ]/)>=$||!we.trim())ye+=`
`+we.slice($);else if(!K)ye+=`
`+we;else break;!K&&!we.trim()&&(K=!0),te+=De+`
`,ce=ce.substring(De.length+1)}Je.loose||(he?Je.loose=!0:/\n *\n *$/.test(te)&&(he=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(ye),ne&&(U=ne[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:te,task:!!ne,checked:U,loose:!1,text:ye}),Je.raw+=te}Je.items[Je.items.length-1].raw=te.trimRight(),Je.items[Je.items.length-1].text=ye.trimRight(),Je.raw=Je.raw.trimRight();var ae=Je.items.length;for(G=0;G<ae;G++){this.lexer.state.top=!1,Je.items[G].tokens=this.lexer.blockTokens(Je.items[G].text,[]);var ke=Je.items[G].tokens.filter(function(He){return He.type==="space"}),Ne=ke.every(function(He){for(var Ge=He.raw.split(""),qe=0,Ze=A(Ge),Xe;!(Xe=Ze()).done;){var rt=Xe.value;if(rt===`
`&&(qe+=1),qe>1)return!0}return!1});!Je.loose&&ke.length&&Ne&&(Je.loose=!0,Je.items[G].loose=!0)}return Je}},ve.html=function(ce){var me=this.rules.block.html.exec(ce);if(me){var te={type:"html",raw:me[0],pre:!this.options.sanitizer&&(me[1]==="pre"||me[1]==="script"||me[1]==="style"),text:me[0]};return this.options.sanitize&&(te.type="paragraph",te.text=this.options.sanitizer?this.options.sanitizer(me[0]):_(me[0]),te.tokens=[],this.lexer.inline(te.text,te.tokens)),te}},ve.def=function(ce){var me=this.rules.block.def.exec(ce);if(me){me[3]&&(me[3]=me[3].substring(1,me[3].length-1));var te=me[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:me[0],href:me[2],title:me[3]}}},ve.table=function(ce){var me=this.rules.block.table.exec(ce);if(me){var te={type:"table",header:l(me[1]).map(function(he){return{text:he}}),align:me[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:me[3]&&me[3].trim()?me[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=me[0];var ne=te.align.length,U,$,G,K;for(U=0;U<ne;U++)/^ *-+: *$/.test(te.align[U])?te.align[U]="right":/^ *:-+: *$/.test(te.align[U])?te.align[U]="center":/^ *:-+ *$/.test(te.align[U])?te.align[U]="left":te.align[U]=null;for(ne=te.rows.length,U=0;U<ne;U++)te.rows[U]=l(te.rows[U],te.header.length).map(function(he){return{text:he}});for(ne=te.header.length,$=0;$<ne;$++)te.header[$].tokens=[],this.lexer.inline(te.header[$].text,te.header[$].tokens);for(ne=te.rows.length,$=0;$<ne;$++)for(K=te.rows[$],G=0;G<K.length;G++)K[G].tokens=[],this.lexer.inline(K[G].text,K[G].tokens);return te}}},ve.lheading=function(ce){var me=this.rules.block.lheading.exec(ce);if(me){var te={type:"heading",raw:me[0],depth:me[2].charAt(0)==="="?1:2,text:me[1],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.paragraph=function(ce){var me=this.rules.block.paragraph.exec(ce);if(me){var te={type:"paragraph",raw:me[0],text:me[1].charAt(me[1].length-1)===`
`?me[1].slice(0,-1):me[1],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.text=function(ce){var me=this.rules.block.text.exec(ce);if(me){var te={type:"text",raw:me[0],text:me[0],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.escape=function(ce){var me=this.rules.inline.escape.exec(ce);if(me)return{type:"escape",raw:me[0],text:_(me[1])}},ve.tag=function(ce){var me=this.rules.inline.tag.exec(ce);if(me)return!this.lexer.state.inLink&&/^<a /i.test(me[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(me[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):_(me[0]):me[0]}},ve.link=function(ce){var me=this.rules.inline.link.exec(ce);if(me){var te=me[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ne=d(te.slice(0,-1),"\\");if((te.length-ne.length)%2==0)return}else{var U=w(me[2],"()");if(U>-1){var $=me[0].indexOf("!")===0?5:4,G=$+me[1].length+U;me[2]=me[2].substring(0,U),me[0]=me[0].substring(0,G).trim(),me[3]=""}}var K=me[2],he="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);we&&(K=we[1],he=we[3])}else he=me[3]?me[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(te)?K=K.slice(1):K=K.slice(1,-1)),O(me,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},me[0],this.lexer)}},ve.reflink=function(ce,me){var te;if((te=this.rules.inline.reflink.exec(ce))||(te=this.rules.inline.nolink.exec(ce))){var ne=(te[2]||te[1]).replace(/\s+/g," ");if(ne=me[ne.toLowerCase()],!ne||!ne.href){var U=te[0].charAt(0);return{type:"text",raw:U,text:U}}return O(te,ne,te[0],this.lexer)}},ve.emStrong=function(ce,me,te){te===void 0&&(te="");var ne=this.rules.inline.emStrong.lDelim.exec(ce);if(!!ne&&!(ne[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=ne[1]||ne[2]||"";if(!U||U&&(te===""||this.rules.inline.punctuation.exec(te))){var $=ne[0].length-1,G,K,he=$,we=0,se=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,me=me.slice(-1*ce.length+$);(ne=se.exec(me))!=null;)if(G=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!G){if(K=G.length,ne[3]||ne[4]){he+=K;continue}else if((ne[5]||ne[6])&&$%3&&!(($+K)%3)){we+=K;continue}if(he-=K,!(he>0)){if(K=Math.min(K,K+he+we),Math.min($,K)%2){var De=ce.slice(1,$+ne.index+K);return{type:"em",raw:ce.slice(0,$+ne.index+K+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var ye=ce.slice(2,$+ne.index+K-1);return{type:"strong",raw:ce.slice(0,$+ne.index+K+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}}}}},ve.codespan=function(ce){var me=this.rules.inline.code.exec(ce);if(me){var te=me[2].replace(/\n/g," "),ne=/[^ ]/.test(te),U=/^ /.test(te)&&/ $/.test(te);return ne&&U&&(te=te.substring(1,te.length-1)),te=_(te,!0),{type:"codespan",raw:me[0],text:te}}},ve.br=function(ce){var me=this.rules.inline.br.exec(ce);if(me)return{type:"br",raw:me[0]}},ve.del=function(ce){var me=this.rules.inline.del.exec(ce);if(me)return{type:"del",raw:me[0],text:me[2],tokens:this.lexer.inlineTokens(me[2],[])}},ve.autolink=function(ce,me){var te=this.rules.inline.autolink.exec(ce);if(te){var ne,U;return te[2]==="@"?(ne=_(this.options.mangle?me(te[1]):te[1]),U="mailto:"+ne):(ne=_(te[1]),U=ne),{type:"link",raw:te[0],text:ne,href:U,tokens:[{type:"text",raw:ne,text:ne}]}}},ve.url=function(ce,me){var te;if(te=this.rules.inline.url.exec(ce)){var ne,U;if(te[2]==="@")ne=_(this.options.mangle?me(te[0]):te[0]),U="mailto:"+ne;else{var $;do $=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while($!==te[0]);ne=_(te[0]),te[1]==="www."?U="http://"+ne:U=ne}return{type:"link",raw:te[0],text:ne,href:U,tokens:[{type:"text",raw:ne,text:ne}]}}},ve.inlineText=function(ce,me){var te=this.rules.inline.text.exec(ce);if(te){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):_(te[0]):te[0]:ne=_(this.options.smartypants?me(te[0]):te[0]),{type:"text",raw:te[0],text:ne}}},pe}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=b(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=b(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=b(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=b(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=b(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=c({},M),M.gfm=c({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=b(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=c({},M.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:b(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=b(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=b(M._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=b(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=b(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=b(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=b(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=b(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=b(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=b(W.reflink).replace("label",W._label).replace("ref",M._label).getRegex(),W.nolink=b(W.nolink).replace("ref",M._label).getRegex(),W.reflinkSearch=b(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=c({},W),W.pedantic=c({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=c({},W.normal,{escape:b(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=b(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=c({},W.gfm,{br:b(W.br).replace("{2,}","*").getRegex(),text:b(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ee(pe){return pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(pe){var ve="",Ae,ce,me=pe.length;for(Ae=0;Ae<me;Ae++)ce=pe.charCodeAt(Ae),Math.random()>.5&&(ce="x"+ce.toString(16)),ve+="&#"+ce+";";return ve}var N=function(){function pe(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Y.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:M.normal,inline:W.normal};this.options.pedantic?(ce.block=M.pedantic,ce.inline=W.pedantic):this.options.gfm&&(ce.block=M.gfm,this.options.breaks?ce.inline=W.breaks:ce.inline=W.gfm),this.tokenizer.rules=ce}pe.lex=function(ce,me){var te=new pe(me);return te.lex(ce)},pe.lexInline=function(ce,me){var te=new pe(me);return te.inlineTokens(ce)};var ve=pe.prototype;return ve.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`),this.blockTokens(ce,this.tokens);for(var me;me=this.inlineQueue.shift();)this.inlineTokens(me.src,me.tokens);return this.tokens},ve.blockTokens=function(ce,me){var te=this;me===void 0&&(me=[]),this.options.pedantic?ce=ce.replace(/\t/g,"    ").replace(/^ +$/gm,""):ce=ce.replace(/^( *)(\t+)/gm,function(he,we,se){return we+"    ".repeat(se.length)});for(var ne,U,$,G;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(ne=he.call({lexer:te},ce,me))?(ce=ce.substring(ne.raw.length),me.push(ne),!0):!1}))){if(ne=this.tokenizer.space(ce)){ce=ce.substring(ne.raw.length),ne.raw.length===1&&me.length>0?me[me.length-1].raw+=`
`:me.push(ne);continue}if(ne=this.tokenizer.code(ce)){ce=ce.substring(ne.raw.length),U=me[me.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+ne.raw,U.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):me.push(ne);continue}if(ne=this.tokenizer.fences(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.heading(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.hr(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.blockquote(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.list(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.html(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.def(ce)){ce=ce.substring(ne.raw.length),U=me[me.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+ne.raw,U.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.lheading(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if($=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,we=ce.slice(1),se=void 0;te.options.extensions.startBlock.forEach(function(De){se=De.call({lexer:this},we),typeof se=="number"&&se>=0&&(he=Math.min(he,se))}),he<1/0&&he>=0&&($=ce.substring(0,he+1))}(),this.state.top&&(ne=this.tokenizer.paragraph($))){U=me[me.length-1],G&&U.type==="paragraph"?(U.raw+=`
`+ne.raw,U.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):me.push(ne),G=$.length!==ce.length,ce=ce.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(ce)){ce=ce.substring(ne.raw.length),U=me[me.length-1],U&&U.type==="text"?(U.raw+=`
`+ne.raw,U.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):me.push(ne);continue}if(ce){var K="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,me},ve.inline=function(ce,me){this.inlineQueue.push({src:ce,tokens:me})},ve.inlineTokens=function(ce,me){var te=this;me===void 0&&(me=[]);var ne,U,$,G=ce,K,he,we;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,K.index)+"["+F("a",K[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,K.index)+"["+F("a",K[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,K.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(he||(we=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ne=ye.call({lexer:te},ce,me))?(ce=ce.substring(ne.raw.length),me.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.tag(ce)){ce=ce.substring(ne.raw.length),U=me[me.length-1],U&&ne.type==="text"&&U.type==="text"?(U.raw+=ne.raw,U.text+=ne.text):me.push(ne);continue}if(ne=this.tokenizer.link(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(ne.raw.length),U=me[me.length-1],U&&ne.type==="text"&&U.type==="text"?(U.raw+=ne.raw,U.text+=ne.text):me.push(ne);continue}if(ne=this.tokenizer.emStrong(ce,G,we)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.codespan(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.br(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.del(ce)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(ne=this.tokenizer.autolink(ce,H)){ce=ce.substring(ne.raw.length),me.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(ce,H))){ce=ce.substring(ne.raw.length),me.push(ne);continue}if($=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=ce.slice(1),Ve=void 0;te.options.extensions.startInline.forEach(function(Me){Ve=Me.call({lexer:this},ze),typeof Ve=="number"&&Ve>=0&&(ye=Math.min(ye,Ve))}),ye<1/0&&ye>=0&&($=ce.substring(0,ye+1))}(),ne=this.tokenizer.inlineText($,ee)){ce=ce.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(we=ne.raw.slice(-1)),he=!0,U=me[me.length-1],U&&U.type==="text"?(U.raw+=ne.raw,U.text+=ne.text):me.push(ne);continue}if(ce){var De="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return me},u(pe,null,[{key:"rules",get:function(){return{block:M,inline:W}}}]),pe}(),j=function(){function pe(Ae){this.options=Ae||Y.defaults}var ve=pe.prototype;return ve.code=function(ce,me,te){var ne=(me||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(ce,ne);U!=null&&U!==ce&&(te=!0,ce=U)}return ce=ce.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+_(ne,!0)+'">'+(te?ce:_(ce,!0))+`</code></pre>
`:"<pre><code>"+(te?ce:_(ce,!0))+`</code></pre>
`},ve.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},ve.html=function(ce){return ce},ve.heading=function(ce,me,te,ne){if(this.options.headerIds){var U=this.options.headerPrefix+ne.slug(te);return"<h"+me+' id="'+U+'">'+ce+"</h"+me+`>
`}return"<h"+me+">"+ce+"</h"+me+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(ce,me,te){var ne=me?"ol":"ul",U=me&&te!==1?' start="'+te+'"':"";return"<"+ne+U+`>
`+ce+"</"+ne+`>
`},ve.listitem=function(ce){return"<li>"+ce+`</li>
`},ve.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(ce){return"<p>"+ce+`</p>
`},ve.table=function(ce,me){return me&&(me="<tbody>"+me+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+me+`</table>
`},ve.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},ve.tablecell=function(ce,me){var te=me.header?"th":"td",ne=me.align?"<"+te+' align="'+me.align+'">':"<"+te+">";return ne+ce+("</"+te+`>
`)},ve.strong=function(ce){return"<strong>"+ce+"</strong>"},ve.em=function(ce){return"<em>"+ce+"</em>"},ve.codespan=function(ce){return"<code>"+ce+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(ce){return"<del>"+ce+"</del>"},ve.link=function(ce,me,te){if(ce=m(this.options.sanitize,this.options.baseUrl,ce),ce===null)return te;var ne='<a href="'+_(ce)+'"';return me&&(ne+=' title="'+me+'"'),ne+=">"+te+"</a>",ne},ve.image=function(ce,me,te){if(ce=m(this.options.sanitize,this.options.baseUrl,ce),ce===null)return te;var ne='<img src="'+ce+'" alt="'+te+'"';return me&&(ne+=' title="'+me+'"'),ne+=this.options.xhtml?"/>":">",ne},ve.text=function(ce){return ce},pe}(),x=function(){function pe(){}var ve=pe.prototype;return ve.strong=function(ce){return ce},ve.em=function(ce){return ce},ve.codespan=function(ce){return ce},ve.del=function(ce){return ce},ve.html=function(ce){return ce},ve.text=function(ce){return ce},ve.link=function(ce,me,te){return""+te},ve.image=function(ce,me,te){return""+te},ve.br=function(){return""},pe}(),q=function(){function pe(){this.seen={}}var ve=pe.prototype;return ve.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(ce,me){var te=ce,ne=0;if(this.seen.hasOwnProperty(te)){ne=this.seen[ce];do ne++,te=ce+"-"+ne;while(this.seen.hasOwnProperty(te))}return me||(this.seen[ce]=ne,this.seen[te]=0),te},ve.slug=function(ce,me){me===void 0&&(me={});var te=this.serialize(ce);return this.getNextSafeSlug(te,me.dryrun)},pe}(),ie=function(){function pe(Ae){this.options=Ae||Y.defaults,this.options.renderer=this.options.renderer||new j,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new q}pe.parse=function(ce,me){var te=new pe(me);return te.parse(ce)},pe.parseInline=function(ce,me){var te=new pe(me);return te.parseInline(ce)};var ve=pe.prototype;return ve.parse=function(ce,me){me===void 0&&(me=!0);var te="",ne,U,$,G,K,he,we,se,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,ke,Ne=ce.length;for(ne=0;ne<Ne;ne++){if(ye=ce[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(ke=this.options.extensions.renderers[ye.type].call({parser:this},ye),ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=ke||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,v(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(se="",we="",G=ye.header.length,U=0;U<G;U++)we+=this.renderer.tablecell(this.parseInline(ye.header[U].tokens),{header:!0,align:ye.align[U]});for(se+=this.renderer.tablerow(we),De="",G=ye.rows.length,U=0;U<G;U++){for(he=ye.rows[U],we="",K=he.length,$=0;$<K;$++)we+=this.renderer.tablecell(this.parseInline(he[$].tokens),{header:!1,align:ye.align[$]});De+=this.renderer.tablerow(we)}te+=this.renderer.table(se,De);continue}case"blockquote":{De=this.parse(ye.tokens),te+=this.renderer.blockquote(De);continue}case"list":{for(ze=ye.ordered,Ve=ye.start,Me=ye.loose,G=ye.items.length,De="",U=0;U<G;U++)J=ye.items[U],re=J.checked,Ce=J.task,Je="",J.task&&(ae=this.renderer.checkbox(re),Me?J.tokens.length>0&&J.tokens[0].type==="paragraph"?(J.tokens[0].text=ae+" "+J.tokens[0].text,J.tokens[0].tokens&&J.tokens[0].tokens.length>0&&J.tokens[0].tokens[0].type==="text"&&(J.tokens[0].tokens[0].text=ae+" "+J.tokens[0].tokens[0].text)):J.tokens.unshift({type:"text",text:ae}):Je+=ae),Je+=this.parse(J.tokens,Me),De+=this.renderer.listitem(Je,Ce,re);te+=this.renderer.list(De,ze,Ve);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(De=ye.tokens?this.parseInline(ye.tokens):ye.text;ne+1<Ne&&ce[ne+1].type==="text";)ye=ce[++ne],De+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=me?this.renderer.paragraph(De):De;continue}default:{var He='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return te},ve.parseInline=function(ce,me){me=me||this.renderer;var te="",ne,U,$,G=ce.length;for(ne=0;ne<G;ne++){if(U=ce[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&($=this.options.extensions.renderers[U.type].call({parser:this},U),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){te+=$||"";continue}switch(U.type){case"escape":{te+=me.text(U.text);break}case"html":{te+=me.html(U.text);break}case"link":{te+=me.link(U.href,U.title,this.parseInline(U.tokens,me));break}case"image":{te+=me.image(U.href,U.title,U.text);break}case"strong":{te+=me.strong(this.parseInline(U.tokens,me));break}case"em":{te+=me.em(this.parseInline(U.tokens,me));break}case"codespan":{te+=me.codespan(U.text);break}case"br":{te+=me.br();break}case"del":{te+=me.del(this.parseInline(U.tokens,me));break}case"text":{te+=me.text(U.text);break}default:{var K='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return te},pe}();function Q(pe,ve,Ae){if(typeof pe=="undefined"||pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");if(typeof ve=="function"&&(Ae=ve,ve=null),ve=c({},Q.defaults,ve||{}),R(ve),Ae){var ce=ve.highlight,me;try{me=N.lex(pe,ve)}catch($){return Ae($)}var te=function(G){var K;if(!G)try{ve.walkTokens&&Q.walkTokens(me,ve.walkTokens),K=ie.parse(me,ve)}catch(he){G=he}return ve.highlight=ce,G?Ae(G):Ae(null,K)};if(!ce||ce.length<3||(delete ve.highlight,!me.length))return te();var ne=0;Q.walkTokens(me,function($){$.type==="code"&&(ne++,setTimeout(function(){ce($.text,$.lang,function(G,K){if(G)return te(G);K!=null&&K!==$.text&&($.text=K,$.escaped=!0),ne--,ne===0&&te()})},0))}),ne===0&&te();return}try{var U=N.lex(pe,ve);return ve.walkTokens&&Q.walkTokens(U,ve.walkTokens),ie.parse(U,ve)}catch($){if($.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+_($.message+"",!0)+"</pre>";throw $}}Q.options=Q.setOptions=function(pe){return c(Q.defaults,pe),D(Q.defaults),Q},Q.getDefaults=C,Q.defaults=Y.defaults,Q.use=function(){for(var pe=arguments.length,ve=new Array(pe),Ae=0;Ae<pe;Ae++)ve[Ae]=arguments[Ae];var ce=c.apply(void 0,[{}].concat(ve)),me=Q.defaults.extensions||{renderers:{},childTokens:{}},te;ve.forEach(function(ne){if(ne.extensions&&(te=!0,ne.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var G=me.renderers?me.renderers[$.name]:null;G?me.renderers[$.name]=function(){for(var K=arguments.length,he=new Array(K),we=0;we<K;we++)he[we]=arguments[we];var se=$.renderer.apply(this,he);return se===!1&&(se=G.apply(this,he)),se}:me.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[$.level]?me[$.level].unshift($.tokenizer):me[$.level]=[$.tokenizer],$.start&&($.level==="block"?me.startBlock?me.startBlock.push($.start):me.startBlock=[$.start]:$.level==="inline"&&(me.startInline?me.startInline.push($.start):me.startInline=[$.start]))}$.childTokens&&(me.childTokens[$.name]=$.childTokens)})),ne.renderer&&function(){var $=Q.defaults.renderer||new j,G=function(we){var se=$[we];$[we]=function(){for(var De=arguments.length,ye=new Array(De),ze=0;ze<De;ze++)ye[ze]=arguments[ze];var Ve=ne.renderer[we].apply($,ye);return Ve===!1&&(Ve=se.apply($,ye)),Ve}};for(var K in ne.renderer)G(K);ce.renderer=$}(),ne.tokenizer&&function(){var $=Q.defaults.tokenizer||new B,G=function(we){var se=$[we];$[we]=function(){for(var De=arguments.length,ye=new Array(De),ze=0;ze<De;ze++)ye[ze]=arguments[ze];var Ve=ne.tokenizer[we].apply($,ye);return Ve===!1&&(Ve=se.apply($,ye)),Ve}};for(var K in ne.tokenizer)G(K);ce.tokenizer=$}(),ne.walkTokens){var U=Q.defaults.walkTokens;ce.walkTokens=function($){ne.walkTokens.call(this,$),U&&U.call(this,$)}}te&&(ce.extensions=me),Q.setOptions(ce)})},Q.walkTokens=function(pe,ve){for(var Ae=function(){var ne=me.value;switch(ve.call(Q,ne),ne.type){case"table":{for(var U=A(ne.header),$;!($=U()).done;){var G=$.value;Q.walkTokens(G.tokens,ve)}for(var K=A(ne.rows),he;!(he=K()).done;)for(var we=he.value,se=A(we),De;!(De=se()).done;){var ye=De.value;Q.walkTokens(ye.tokens,ve)}break}case"list":{Q.walkTokens(ne.items,ve);break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[ne.type]?Q.defaults.extensions.childTokens[ne.type].forEach(function(ze){Q.walkTokens(ne[ze],ve)}):ne.tokens&&Q.walkTokens(ne.tokens,ve)}},ce=A(pe),me;!(me=ce()).done;)Ae()},Q.parseInline=function(pe,ve){if(typeof pe=="undefined"||pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");ve=c({},Q.defaults,ve||{}),R(ve);try{var Ae=N.lexInline(pe,ve);return ve.walkTokens&&Q.walkTokens(Ae,ve.walkTokens),ie.parseInline(Ae,ve)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+_(ce.message+"",!0)+"</pre>";throw ce}},Q.Parser=ie,Q.parser=ie.parse,Q.Renderer=j,Q.TextRenderer=x,Q.Lexer=N,Q.lexer=N.lex,Q.Tokenizer=B,Q.Slugger=q,Q.parse=Q;var de=Q.options,ue=Q.setOptions,X=Q.use,ge=Q.walkTokens,Se=Q.parseInline,oe=Q,_e=ie.parse,Pe=N.lex;Y.Lexer=N,Y.Parser=ie,Y.Renderer=j,Y.Slugger=q,Y.TextRenderer=x,Y.Tokenizer=B,Y.getDefaults=C,Y.lexer=Pe,Y.marked=Q,Y.options=de,Y.parse=oe,Y.parseInline=Se,Y.parser=_e,Y.setOptions=ue,Y.use=X,Y.walkTokens=ge,Object.defineProperty(Y,"__esModule",{value:!0})}),define(Ie[94],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(D,E,P){return Math.min(Math.max(D,E),P)}e.clamp=u;function i(D,E){return(E+D%E)%E}e.rot=i;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class A{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class C{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function Y(y){const A=[];typeof y=="number"&&A.push("code/timeOrigin",y);function C(E){A.push(E,Date.now())}function D(){const E=[];for(let P=0;P<A.length;P+=2)E.push({name:A[P],startTime:A[P+1]});return E}return{mark:C,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(y+C.startTime)});return A}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function u(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=u(i))}(),define(Ie[13],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const u="en";let i=!1,y=!1,A=!1,C=!1,D=!1,E=!1,P=!1,L=!1,T=!1,S,I=u,_,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const p=typeof v?.versions?.electron=="string",b=p&&v?.type==="renderer";if(typeof navigator=="object"&&!b)g=navigator.userAgent,i=g.indexOf("Windows")>=0,y=g.indexOf("Macintosh")>=0,L=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,E=!0,S=navigator.language,I=S;else if(typeof v=="object"){i=v.platform==="win32",y=v.platform==="darwin",A=v.platform==="linux",C=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=p,T=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=u,I=u;const t=v.env.VSCODE_NLS_CONFIG;if(t)try{const c=JSON.parse(t),l=c.availableLanguages["*"];S=c.locale,I=l||u,_=c._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var f;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function a(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let m=0;y?m=1:i?m=3:A&&(m=2),e.isWindows=i,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=C,e.isNative=D,e.isElectron=P,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isCI=T,e.platform=m,e.userAgent=g,e.language=I;var o;(function(t){function c(){return e.language}t.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=l;function d(){return e.language==="en"}t.isDefault=d})(o=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=_,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let t=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let d=0,w=t.length;d<w;d++){const R=t[d];if(R.id===l.data.vscodeScheduleAsyncWork){t.splice(d,1),R.callback();return}}});let c=0;return l=>{const d=++c;t.push({id:d,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return t=>setTimeout(t)})();var h;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||L?2:i?1:3;let r=!0,s=!1;function n(){if(!s){s=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,r=new Uint16Array(t.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[40],Te([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const y=u.globals.vscode.process;i={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(Ie[9],Te([1,0,40]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,y=97,A=90,C=122,D=46,E=47,P=92,L=58,T=63;class S extends Error{constructor(a,m,o){let h;typeof m=="string"&&m.indexOf("not ")===0?(h="must not be",m=m.replace(/^not /,"")):h="must be";const r=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${r} ${h} of type ${m}`;s+=`. Received type ${typeof o}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function I(f,a){if(typeof f!="string")throw new S(a,"string",f)}function _(f){return f===E||f===P}function g(f){return f===E}function v(f){return f>=i&&f<=A||f>=y&&f<=C}function p(f,a,m,o){let h="",r=0,s=-1,n=0,t=0;for(let c=0;c<=f.length;++c){if(c<f.length)t=f.charCodeAt(c);else{if(o(t))break;t=E}if(o(t)){if(!(s===c-1||n===1))if(n===2){if(h.length<2||r!==2||h.charCodeAt(h.length-1)!==D||h.charCodeAt(h.length-2)!==D){if(h.length>2){const l=h.lastIndexOf(m);l===-1?(h="",r=0):(h=h.slice(0,l),r=h.length-1-h.lastIndexOf(m)),s=c,n=0;continue}else if(h.length!==0){h="",r=0,s=c,n=0;continue}}a&&(h+=h.length>0?`${m}..`:"..",r=2)}else h.length>0?h+=`${m}${f.slice(s+1,c)}`:h=f.slice(s+1,c),r=c-s-1;s=c,n=0}else t===D&&n!==-1?++n:n=-1}return h}function b(f,a){if(a===null||typeof a!="object")throw new S("pathObject","Object",a);const m=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return m?m===a.root?`${m}${o}`:`${m}${f}${o}`:o}e.win32={resolve(...f){let a="",m="",o=!1;for(let h=f.length-1;h>=-1;h--){let r;if(h>=0){if(r=f[h],I(r,"path"),r.length===0)continue}else a.length===0?r=u.cwd():(r=u.env[`=${a}`]||u.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${a}\\`));const s=r.length;let n=0,t="",c=!1;const l=r.charCodeAt(0);if(s===1)_(l)&&(n=1,c=!0);else if(_(l))if(c=!0,_(r.charCodeAt(1))){let d=2,w=d;for(;d<s&&!_(r.charCodeAt(d));)d++;if(d<s&&d!==w){const R=r.slice(w,d);for(w=d;d<s&&_(r.charCodeAt(d));)d++;if(d<s&&d!==w){for(w=d;d<s&&!_(r.charCodeAt(d));)d++;(d===s||d!==w)&&(t=`\\\\${R}\\${r.slice(w,d)}`,n=d)}}}else n=1;else v(l)&&r.charCodeAt(1)===L&&(t=r.slice(0,2),n=2,s>2&&_(r.charCodeAt(2))&&(c=!0,n=3));if(t.length>0)if(a.length>0){if(t.toLowerCase()!==a.toLowerCase())continue}else a=t;if(o){if(a.length>0)break}else if(m=`${r.slice(n)}\\${m}`,o=c,c&&a.length>0)break}return m=p(m,!o,"\\",_),o?`${a}\\${m}`:`${a}${m}`||"."},normalize(f){I(f,"path");const a=f.length;if(a===0)return".";let m=0,o,h=!1;const r=f.charCodeAt(0);if(a===1)return g(r)?"\\":f;if(_(r))if(h=!0,_(f.charCodeAt(1))){let n=2,t=n;for(;n<a&&!_(f.charCodeAt(n));)n++;if(n<a&&n!==t){const c=f.slice(t,n);for(t=n;n<a&&_(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&!_(f.charCodeAt(n));)n++;if(n===a)return`\\\\${c}\\${f.slice(t)}\\`;n!==t&&(o=`\\\\${c}\\${f.slice(t,n)}`,m=n)}}}else m=1;else v(r)&&f.charCodeAt(1)===L&&(o=f.slice(0,2),m=2,a>2&&_(f.charCodeAt(2))&&(h=!0,m=3));let s=m<a?p(f.slice(m),!h,"\\",_):"";return s.length===0&&!h&&(s="."),s.length>0&&_(f.charCodeAt(a-1))&&(s+="\\"),o===void 0?h?`\\${s}`:s:h?`${o}\\${s}`:`${o}${s}`},isAbsolute(f){I(f,"path");const a=f.length;if(a===0)return!1;const m=f.charCodeAt(0);return _(m)||a>2&&v(m)&&f.charCodeAt(1)===L&&_(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,m;for(let r=0;r<f.length;++r){const s=f[r];I(s,"path"),s.length>0&&(a===void 0?a=m=s:a+=`\\${s}`)}if(a===void 0)return".";let o=!0,h=0;if(typeof m=="string"&&_(m.charCodeAt(0))){++h;const r=m.length;r>1&&_(m.charCodeAt(1))&&(++h,r>2&&(_(m.charCodeAt(2))?++h:o=!1))}if(o){for(;h<a.length&&_(a.charCodeAt(h));)h++;h>=2&&(a=`\\${a.slice(h)}`)}return e.win32.normalize(a)},relative(f,a){if(I(f,"from"),I(a,"to"),f===a)return"";const m=e.win32.resolve(f),o=e.win32.resolve(a);if(m===o||(f=m.toLowerCase(),a=o.toLowerCase(),f===a))return"";let h=0;for(;h<f.length&&f.charCodeAt(h)===P;)h++;let r=f.length;for(;r-1>h&&f.charCodeAt(r-1)===P;)r--;const s=r-h;let n=0;for(;n<a.length&&a.charCodeAt(n)===P;)n++;let t=a.length;for(;t-1>n&&a.charCodeAt(t-1)===P;)t--;const c=t-n,l=s<c?s:c;let d=-1,w=0;for(;w<l;w++){const F=f.charCodeAt(h+w);if(F!==a.charCodeAt(n+w))break;F===P&&(d=w)}if(w!==l){if(d===-1)return o}else{if(c>l){if(a.charCodeAt(n+w)===P)return o.slice(n+w+1);if(w===2)return o.slice(n+w)}s>l&&(f.charCodeAt(h+w)===P?d=w:w===2&&(d=3)),d===-1&&(d=0)}let R="";for(w=h+d+1;w<=r;++w)(w===r||f.charCodeAt(w)===P)&&(R+=R.length===0?"..":"\\..");return n+=d,R.length>0?`${R}${o.slice(n,t)}`:(o.charCodeAt(n)===P&&++n,o.slice(n,t))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===P){if(a.charCodeAt(1)===P){const m=a.charCodeAt(2);if(m!==T&&m!==D)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===P)return`\\\\?\\${a}`;return f},dirname(f){I(f,"path");const a=f.length;if(a===0)return".";let m=-1,o=0;const h=f.charCodeAt(0);if(a===1)return _(h)?f:".";if(_(h)){if(m=o=1,_(f.charCodeAt(1))){let n=2,t=n;for(;n<a&&!_(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&_(f.charCodeAt(n));)n++;if(n<a&&n!==t){for(t=n;n<a&&!_(f.charCodeAt(n));)n++;if(n===a)return f;n!==t&&(m=o=n+1)}}}}else v(h)&&f.charCodeAt(1)===L&&(m=a>2&&_(f.charCodeAt(2))?3:2,o=m);let r=-1,s=!0;for(let n=a-1;n>=o;--n)if(_(f.charCodeAt(n))){if(!s){r=n;break}}else s=!1;if(r===-1){if(m===-1)return".";r=m}return f.slice(0,r)},basename(f,a){a!==void 0&&I(a,"ext"),I(f,"path");let m=0,o=-1,h=!0,r;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===L&&(m=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,n=-1;for(r=f.length-1;r>=m;--r){const t=f.charCodeAt(r);if(_(t)){if(!h){m=r+1;break}}else n===-1&&(h=!1,n=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return m===o?o=n:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=m;--r)if(_(f.charCodeAt(r))){if(!h){m=r+1;break}}else o===-1&&(h=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){I(f,"path");let a=0,m=-1,o=0,h=-1,r=!0,s=0;f.length>=2&&f.charCodeAt(1)===L&&v(f.charCodeAt(0))&&(a=o=2);for(let n=f.length-1;n>=a;--n){const t=f.charCodeAt(n);if(_(t)){if(!r){o=n+1;break}continue}h===-1&&(r=!1,h=n+1),t===D?m===-1?m=n:s!==1&&(s=1):m!==-1&&(s=-1)}return m===-1||h===-1||s===0||s===1&&m===h-1&&m===o+1?"":f.slice(m,h)},format:b.bind(null,"\\"),parse(f){I(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.length;let o=0,h=f.charCodeAt(0);if(m===1)return _(h)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(_(h)){if(o=1,_(f.charCodeAt(1))){let d=2,w=d;for(;d<m&&!_(f.charCodeAt(d));)d++;if(d<m&&d!==w){for(w=d;d<m&&_(f.charCodeAt(d));)d++;if(d<m&&d!==w){for(w=d;d<m&&!_(f.charCodeAt(d));)d++;d===m?o=d:d!==w&&(o=d+1)}}}}else if(v(h)&&f.charCodeAt(1)===L){if(m<=2)return a.root=a.dir=f,a;if(o=2,_(f.charCodeAt(2))){if(m===3)return a.root=a.dir=f,a;o=3}}o>0&&(a.root=f.slice(0,o));let r=-1,s=o,n=-1,t=!0,c=f.length-1,l=0;for(;c>=o;--c){if(h=f.charCodeAt(c),_(h)){if(!t){s=c+1;break}continue}n===-1&&(t=!1,n=c+1),h===D?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}return n!==-1&&(r===-1||l===0||l===1&&r===n-1&&r===s+1?a.base=a.name=f.slice(s,n):(a.name=f.slice(s,r),a.base=f.slice(s,n),a.ext=f.slice(r,n))),s>0&&s!==o?a.dir=f.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",m=!1;for(let o=f.length-1;o>=-1&&!m;o--){const h=o>=0?f[o]:u.cwd();I(h,"path"),h.length!==0&&(a=`${h}/${a}`,m=h.charCodeAt(0)===E)}return a=p(a,!m,"/",g),m?`/${a}`:a.length>0?a:"."},normalize(f){if(I(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===E,m=f.charCodeAt(f.length-1)===E;return f=p(f,!a,"/",g),f.length===0?a?"/":m?"./":".":(m&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return I(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let a;for(let m=0;m<f.length;++m){const o=f[m];I(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(I(f,"from"),I(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const m=1,o=f.length,h=o-m,r=1,s=a.length-r,n=h<s?h:s;let t=-1,c=0;for(;c<n;c++){const d=f.charCodeAt(m+c);if(d!==a.charCodeAt(r+c))break;d===E&&(t=c)}if(c===n)if(s>n){if(a.charCodeAt(r+c)===E)return a.slice(r+c+1);if(c===0)return a.slice(r+c)}else h>n&&(f.charCodeAt(m+c)===E?t=c:c===0&&(t=0));let l="";for(c=m+t+1;c<=o;++c)(c===o||f.charCodeAt(c)===E)&&(l+=l.length===0?"..":"/..");return`${l}${a.slice(r+t)}`},toNamespacedPath(f){return f},dirname(f){if(I(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===E;let m=-1,o=!0;for(let h=f.length-1;h>=1;--h)if(f.charCodeAt(h)===E){if(!o){m=h;break}}else o=!1;return m===-1?a?"/":".":a&&m===1?"//":f.slice(0,m)},basename(f,a){a!==void 0&&I(a,"ext"),I(f,"path");let m=0,o=-1,h=!0,r;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,n=-1;for(r=f.length-1;r>=0;--r){const t=f.charCodeAt(r);if(t===E){if(!h){m=r+1;break}}else n===-1&&(h=!1,n=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return m===o?o=n:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===E){if(!h){m=r+1;break}}else o===-1&&(h=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){I(f,"path");let a=-1,m=0,o=-1,h=!0,r=0;for(let s=f.length-1;s>=0;--s){const n=f.charCodeAt(s);if(n===E){if(!h){m=s+1;break}continue}o===-1&&(h=!1,o=s+1),n===D?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===m+1?"":f.slice(a,o)},format:b.bind(null,"/"),parse(f){I(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.charCodeAt(0)===E;let o;m?(a.root="/",o=1):o=0;let h=-1,r=0,s=-1,n=!0,t=f.length-1,c=0;for(;t>=o;--t){const l=f.charCodeAt(t);if(l===E){if(!n){r=t+1;break}continue}s===-1&&(n=!1,s=t+1),l===D?h===-1?h=t:c!==1&&(c=1):h!==-1&&(c=-1)}if(s!==-1){const l=r===0&&m?1:r;h===-1||c===0||c===1&&h===s-1&&h===r+1?a.base=a.name=f.slice(l,s):(a.name=f.slice(l,h),a.base=f.slice(l,s),a.ext=f.slice(h,s))}return r>0?a.dir=f.slice(0,r-1):m&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[95],Te([1,0,9]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(T){T.text="text/plain",T.binary="application/octet-stream",T.unknown="application/unknown",T.markdown="text/markdown",T.latex="text/latex",T.uriList="text/uri-list"})(i=e.Mimes||(e.Mimes={}));const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(T){const S=(0,u.extname)(T),I=y[S.toLowerCase()];return I!==void 0?I:D(T)}e.getMediaOrTextMime=C;function D(T){const S=(0,u.extname)(T);return A[S.toLowerCase()]}e.getMediaMime=D;function E(T){for(const S in A)if(A[S]===T)return S}e.getExtensionForMimeType=E;const P=/^(.+)\/(.+?)(;.+)?$/;function L(T,S){const I=P.exec(T);return I?`${I[1].toLowerCase()}/${I[2].toLowerCase()}${I[3]??""}`:S?void 0:T}e.normalizeMimeType=L}),define(Ie[96],Te([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var y;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(y=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(D,...E){const P=E.reduce((S,I)=>(S[I]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!P[S]).forEach(S=>{for(let I=0;I<L.length;I++)if(S.search(L[I])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=A;function C(D){!D||(delete D.DEBUG,u.isMacintosh&&delete D.DYLD_LIBRARY_PATH,u.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var i in u)(typeof exports=="object"?exports:Y)[i]=u[i]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function u(i){if(e[i])return e[i].exports;var y=e[i]={i,l:!1,exports:{}};return Y[i].call(y.exports,y,y.exports,u),y.l=!0,y.exports}return u.m=Y,u.c=e,u.d=function(i,y,A){u.o(i,y)||Object.defineProperty(i,y,{enumerable:!0,get:A})},u.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},u.t=function(i,y){if(1&y&&(i=u(i)),8&y||4&y&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&y&&typeof i!="string")for(var C in i)u.d(A,C,function(D){return i[D]}.bind(null,C));return A},u.n=function(i){var y=i&&i.__esModule?function(){return i.default}:function(){return i};return u.d(y,"a",y),y},u.o=function(i,y){return Object.prototype.hasOwnProperty.call(i,y)},u.p="",u(u.s=0)}([function(Y,e,u){(function(i){var y;e=Y.exports=X,y=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],E=e.src=[],P=0,L=P++;E[L]="0|[1-9]\\d*";var T=P++;E[T]="[0-9]+";var S=P++;E[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=P++;E[I]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var _=P++;E[_]="("+E[T]+")\\.("+E[T]+")\\.("+E[T]+")";var g=P++;E[g]="(?:"+E[L]+"|"+E[S]+")";var v=P++;E[v]="(?:"+E[T]+"|"+E[S]+")";var p=P++;E[p]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var b=P++;E[b]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var f=P++;E[f]="[0-9A-Za-z-]+";var a=P++;E[a]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var m=P++,o="v?"+E[I]+E[p]+"?"+E[a]+"?";E[m]="^"+o+"$";var h="[v=\\s]*"+E[_]+E[b]+"?"+E[a]+"?",r=P++;E[r]="^"+h+"$";var s=P++;E[s]="((?:<|>)?=?)";var n=P++;E[n]=E[T]+"|x|X|\\*";var t=P++;E[t]=E[L]+"|x|X|\\*";var c=P++;E[c]="[v=\\s]*("+E[t]+")(?:\\.("+E[t]+")(?:\\.("+E[t]+")(?:"+E[p]+")?"+E[a]+"?)?)?";var l=P++;E[l]="[v=\\s]*("+E[n]+")(?:\\.("+E[n]+")(?:\\.("+E[n]+")(?:"+E[b]+")?"+E[a]+"?)?)?";var d=P++;E[d]="^"+E[s]+"\\s*"+E[c]+"$";var w=P++;E[w]="^"+E[s]+"\\s*"+E[l]+"$";var R=P++;E[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=P++;E[F]="(?:~>?)";var O=P++;E[O]="(\\s*)"+E[F]+"\\s+",D[O]=new RegExp(E[O],"g");var k=P++;E[k]="^"+E[F]+E[c]+"$";var B=P++;E[B]="^"+E[F]+E[l]+"$";var M=P++;E[M]="(?:\\^)";var W=P++;E[W]="(\\s*)"+E[M]+"\\s+",D[W]=new RegExp(E[W],"g");var ee=P++;E[ee]="^"+E[M]+E[c]+"$";var H=P++;E[H]="^"+E[M]+E[l]+"$";var N=P++;E[N]="^"+E[s]+"\\s*("+h+")$|^$";var j=P++;E[j]="^"+E[s]+"\\s*("+o+")$|^$";var x=P++;E[x]="(\\s*)"+E[s]+"\\s*("+h+"|"+E[c]+")",D[x]=new RegExp(E[x],"g");var q=P++;E[q]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var ie=P++;E[ie]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var Q=P++;E[Q]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)y(de,E[de]),D[de]||(D[de]=new RegExp(E[de]));function ue(se,De){if(se instanceof X)return se;if(typeof se!="string"||se.length>A||!(De?D[r]:D[m]).test(se))return null;try{return new X(se,De)}catch{return null}}function X(se,De){if(se instanceof X){if(se.loose===De)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(se,De);y("SemVer",se,De),this.loose=De;var ye=se.trim().match(De?D[r]:D[m]);if(!ye)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ve=+ze;if(Ve>=0&&Ve<C)return Ve}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(se,De){var ye=ue(se,De);return ye?ye.version:null},e.clean=function(se,De){var ye=ue(se.trim().replace(/^[=v]+/,""),De);return ye?ye.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(se){return y("SemVer.compare",this.version,this.loose,se),se instanceof X||(se=new X(se,this.loose)),this.compareMain(se)||this.comparePre(se)},X.prototype.compareMain=function(se){return se instanceof X||(se=new X(se,this.loose)),Se(this.major,se.major)||Se(this.minor,se.minor)||Se(this.patch,se.patch)},X.prototype.comparePre=function(se){if(se instanceof X||(se=new X(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var De=0;do{var ye=this.prerelease[De],ze=se.prerelease[De];if(y("prerelease compare",De,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return Se(ye,ze)}while(++De)},X.prototype.inc=function(se,De){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,De,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new X(se,ye).inc(De,ze).version}catch{return null}},e.diff=function(se,De){if(pe(se,De))return null;var ye=ue(se),ze=ue(De);if(ye.prerelease.length||ze.prerelease.length){for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==ze[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==ze[Ve])return Ve},e.compareIdentifiers=Se;var ge=/^[0-9]+$/;function Se(se,De){var ye=ge.test(se),ze=ge.test(De);return ye&&ze&&(se=+se,De=+De),ye&&!ze?-1:ze&&!ye?1:se<De?-1:se>De?1:0}function oe(se,De,ye){return new X(se,ye).compare(new X(De,ye))}function _e(se,De,ye){return oe(se,De,ye)>0}function Pe(se,De,ye){return oe(se,De,ye)<0}function pe(se,De,ye){return oe(se,De,ye)===0}function ve(se,De,ye){return oe(se,De,ye)!==0}function Ae(se,De,ye){return oe(se,De,ye)>=0}function ce(se,De,ye){return oe(se,De,ye)<=0}function me(se,De,ye,ze){var Ve;switch(De){case"===":typeof se=="object"&&(se=se.version),typeof ye=="object"&&(ye=ye.version),Ve=se===ye;break;case"!==":typeof se=="object"&&(se=se.version),typeof ye=="object"&&(ye=ye.version),Ve=se!==ye;break;case"":case"=":case"==":Ve=pe(se,ye,ze);break;case"!=":Ve=ve(se,ye,ze);break;case">":Ve=_e(se,ye,ze);break;case">=":Ve=Ae(se,ye,ze);break;case"<":Ve=Pe(se,ye,ze);break;case"<=":Ve=ce(se,ye,ze);break;default:throw new TypeError("Invalid operator: "+De)}return Ve}function te(se,De){if(se instanceof te){if(se.loose===De)return se;se=se.value}if(!(this instanceof te))return new te(se,De);y("comparator",se,De),this.loose=De,this.parse(se),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(se,De){return Se(De,se)},e.major=function(se,De){return new X(se,De).major},e.minor=function(se,De){return new X(se,De).minor},e.patch=function(se,De){return new X(se,De).patch},e.compare=oe,e.compareLoose=function(se,De){return oe(se,De,!0)},e.rcompare=function(se,De,ye){return oe(De,se,ye)},e.sort=function(se,De){return se.sort(function(ye,ze){return e.compare(ye,ze,De)})},e.rsort=function(se,De){return se.sort(function(ye,ze){return e.rcompare(ye,ze,De)})},e.gt=_e,e.lt=Pe,e.eq=pe,e.neq=ve,e.gte=Ae,e.lte=ce,e.cmp=me,e.Comparator=te;var ne={};function U(se,De){if(se instanceof U)return se.loose===De?se:new U(se.raw,De);if(se instanceof te)return new U(se.value,De);if(!(this instanceof U))return new U(se,De);if(this.loose=De,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function $(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,ke,Ne){return((De=$(ye)?"":$(ze)?">="+ye+".0.0":$(Ve)?">="+ye+"."+ze+".0":">="+De)+" "+(J=$(re)?"":$(Ce)?"<"+(+re+1)+".0.0":$(ae)?"<"+re+"."+(+Ce+1)+".0":ke?"<="+re+"."+Ce+"."+ae+"-"+ke:"<="+J)).trim()}function K(se,De){for(var ye=0;ye<se.length;ye++)if(!se[ye].test(De))return!1;if(De.prerelease.length){for(ye=0;ye<se.length;ye++)if(y(se[ye].semver),se[ye].semver!==ne&&se[ye].semver.prerelease.length>0){var ze=se[ye].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function he(se,De,ye){try{De=new U(De,ye)}catch{return!1}return De.test(se)}function we(se,De,ye,ze){var Ve,Me,Je,J,re;switch(se=new X(se,ze),De=new U(De,ze),ye){case">":Ve=_e,Me=ce,Je=Pe,J=">",re=">=";break;case"<":Ve=Pe,Me=Ae,Je=_e,J="<",re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(se,De,ze))return!1;for(var Ce=0;Ce<De.set.length;++Ce){var ae=De.set[Ce],ke=null,Ne=null;if(ae.forEach(function(He){He.semver===ne&&(He=new te(">=0.0.0")),ke=ke||He,Ne=Ne||He,Ve(He.semver,ke.semver,ze)?ke=He:Je(He.semver,Ne.semver,ze)&&(Ne=He)}),ke.operator===J||ke.operator===re||(!Ne.operator||Ne.operator===J)&&Me(se,Ne.semver)||Ne.operator===re&&Je(se,Ne.semver))return!1}return!0}te.prototype.parse=function(se){var De=this.loose?D[N]:D[j],ye=se.match(De);if(!ye)throw new TypeError("Invalid comparator: "+se);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new X(ye[2],this.loose):this.semver=ne},te.prototype.toString=function(){return this.value},te.prototype.test=function(se){return y("Comparator.test",se,this.loose),this.semver===ne||(typeof se=="string"&&(se=new X(se,this.loose)),me(se,this.operator,this.semver,this.loose))},te.prototype.intersects=function(se,De){if(!(se instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new U(se.value,De),he(this.value,ye,De);if(se.operator==="")return ye=new U(this.value,De),he(se.semver,ye,De);var ze=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Me=this.semver.version===se.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),J=me(this.semver,"<",se.semver,De)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),re=me(this.semver,">",se.semver,De)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return ze||Ve||Me&&Je||J||re},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(se){var De=this.loose;se=se.trim(),y("range",se,De);var ye=De?D[ie]:D[q];se=se.replace(ye,G),y("hyphen replace",se),se=se.replace(D[x],"$1$2$3"),y("comparator trim",se,D[x]),se=(se=(se=se.replace(D[O],"$1~")).replace(D[W],"$1^")).split(/\s+/).join(" ");var ze=De?D[N]:D[j],Ve=se.split(" ").map(function(Me){return function(Je,J){return y("comp",Je),Je=function(re,Ce){return re.trim().split(/\s+/).map(function(ae){return function(ke,Ne){y("caret",ke,Ne);var He=Ne?D[H]:D[ee];return ke.replace(He,function(Ge,qe,Ze,Xe,rt){var tt;return y("caret",ke,Ge,qe,Ze,Xe,rt),$(qe)?tt="":$(Ze)?tt=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Xe)?tt=qe==="0"?">="+qe+"."+Ze+".0 <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+".0 <"+(+qe+1)+".0.0":rt?(y("replaceCaret pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=qe==="0"?Ze==="0"?">="+qe+"."+Ze+"."+Xe+rt+" <"+qe+"."+Ze+"."+(+Xe+1):">="+qe+"."+Ze+"."+Xe+rt+" <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+"."+Xe+rt+" <"+(+qe+1)+".0.0"):(y("no pr"),tt=qe==="0"?Ze==="0"?">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+Ze+"."+(+Xe+1):">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+(+Ze+1)+".0":">="+qe+"."+Ze+"."+Xe+" <"+(+qe+1)+".0.0"),y("caret return",tt),tt})}(ae,Ce)}).join(" ")}(Je,J),y("caret",Je),Je=function(re,Ce){return re.trim().split(/\s+/).map(function(ae){return function(ke,Ne){var He=Ne?D[B]:D[k];return ke.replace(He,function(Ge,qe,Ze,Xe,rt){var tt;return y("tilde",ke,Ge,qe,Ze,Xe,rt),$(qe)?tt="":$(Ze)?tt=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Xe)?tt=">="+qe+"."+Ze+".0 <"+qe+"."+(+Ze+1)+".0":rt?(y("replaceTilde pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=">="+qe+"."+Ze+"."+Xe+rt+" <"+qe+"."+(+Ze+1)+".0"):tt=">="+qe+"."+Ze+"."+Xe+" <"+qe+"."+(+Ze+1)+".0",y("tilde return",tt),tt})}(ae,Ce)}).join(" ")}(Je,J),y("tildes",Je),Je=function(re,Ce){return y("replaceXRanges",re,Ce),re.split(/\s+/).map(function(ae){return function(ke,Ne){ke=ke.trim();var He=Ne?D[w]:D[d];return ke.replace(He,function(Ge,qe,Ze,Xe,rt,tt){y("xRange",ke,Ge,qe,Ze,Xe,rt,tt);var st=$(Ze),ot=st||$(Xe),Et=ot||$(rt);return qe==="="&&Et&&(qe=""),st?Ge=qe===">"||qe==="<"?"<0.0.0":"*":qe&&Et?(ot&&(Xe=0),Et&&(rt=0),qe===">"?(qe=">=",ot?(Ze=+Ze+1,Xe=0,rt=0):Et&&(Xe=+Xe+1,rt=0)):qe==="<="&&(qe="<",ot?Ze=+Ze+1:Xe=+Xe+1),Ge=qe+Ze+"."+Xe+"."+rt):ot?Ge=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":Et&&(Ge=">="+Ze+"."+Xe+".0 <"+Ze+"."+(+Xe+1)+".0"),y("xRange return",Ge),Ge})}(ae,Ce)}).join(" ")}(Je,J),y("xrange",Je),Je=function(re,Ce){return y("replaceStars",re,Ce),re.trim().replace(D[Q],"")}(Je,J),y("stars",Je),Je}(Me,De)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(Me){return!!Me.match(ze)})),Ve=Ve.map(function(Me){return new te(Me,De)})},U.prototype.intersects=function(se,De){if(!(se instanceof U))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return se.set.some(function(Ve){return Ve.every(function(Me){return ze.intersects(Me,De)})})})})},e.toComparators=function(se,De){return new U(se,De).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},U.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new X(se,this.loose));for(var De=0;De<this.set.length;De++)if(K(this.set[De],se))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(se,De,ye){var ze=null,Ve=null;try{var Me=new U(De,ye)}catch{return null}return se.forEach(function(Je){Me.test(Je)&&(ze&&Ve.compare(Je)!==-1||(Ve=new X(ze=Je,ye)))}),ze},e.minSatisfying=function(se,De,ye){var ze=null,Ve=null;try{var Me=new U(De,ye)}catch{return null}return se.forEach(function(Je){Me.test(Je)&&(ze&&Ve.compare(Je)!==1||(Ve=new X(ze=Je,ye)))}),ze},e.validRange=function(se,De){try{return new U(se,De).range||"*"}catch{return null}},e.ltr=function(se,De,ye){return we(se,De,"<",ye)},e.gtr=function(se,De,ye){return we(se,De,">",ye)},e.outside=we,e.prerelease=function(se,De){var ye=ue(se,De);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(se,De,ye){return se=new U(se,ye),De=new U(De,ye),se.intersects(De)},e.coerce=function(se){if(se instanceof X)return se;if(typeof se!="string")return null;var De=se.match(D[R]);return De==null?null:ue((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(Y,e){var u,i,y=Y.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function D(v){if(u===setTimeout)return setTimeout(v,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(v,0);try{return u(v,0)}catch{try{return u.call(null,v,0)}catch{return u.call(this,v,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{i=typeof clearTimeout=="function"?clearTimeout:C}catch{i=C}})();var E,P=[],L=!1,T=-1;function S(){L&&E&&(L=!1,E.length?P=E.concat(P):T=-1,P.length&&I())}function I(){if(!L){var v=D(S);L=!0;for(var p=P.length;p;){for(E=P,P=[];++T<p;)E&&E[T].run();T=-1,p=P.length}E=null,L=!1,function(b){if(i===clearTimeout)return clearTimeout(b);if((i===C||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(b);try{i(b)}catch{try{return i.call(null,b)}catch{return i.call(this,b)}}}(v)}}function _(v,p){this.fun=v,this.array=p}function g(){}y.nextTick=function(v){var p=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)p[b-1]=arguments[b];P.push(new _(v,p)),P.length!==1||L||D(I)},_.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=g,y.addListener=g,y.once=g,y.off=g,y.removeListener=g,y.removeAllListeners=g,y.emit=g,y.prependListener=g,y.prependOnceListener=g,y.listeners=function(v){return[]},y.binding=function(v){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(v){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[49],Te([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=u.globals.performance&&typeof u.globals.performance.now=="function";class y{constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new y(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=y}),define(Ie[3],Te([1,0,11,59,6,81,49]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,E=!1;var P;(function(t){t.None=()=>y.Disposable.None;function c(ue){if(E){const{onListenerDidAdd:X}=ue,ge=_.create();let Se=0;ue.onListenerDidAdd=()=>{++Se==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),X?.()}}}function l(ue){return(X,ge=null,Se)=>{let oe=!1,_e;return _e=ue(Pe=>{if(!oe)return _e?_e.dispose():oe=!0,X.call(ge,Pe)},null,Se),oe&&_e.dispose(),_e}}t.once=l;function d(ue,X,ge){return B((Se,oe=null,_e)=>ue(Pe=>Se.call(oe,X(Pe)),null,_e),ge)}t.map=d;function w(ue,X,ge){return B((Se,oe=null,_e)=>ue(Pe=>{X(Pe),Se.call(oe,Pe)},null,_e),ge)}t.forEach=w;function R(ue,X,ge){return B((Se,oe=null,_e)=>ue(Pe=>X(Pe)&&Se.call(oe,Pe),null,_e),ge)}t.filter=R;function F(ue){return ue}t.signal=F;function O(...ue){return(X,ge=null,Se)=>(0,y.combinedDisposable)(...ue.map(oe=>oe(_e=>X.call(ge,_e),null,Se)))}t.any=O;function k(ue,X,ge,Se){let oe=ge;return d(ue,_e=>(oe=X(oe,_e),oe),Se)}t.reduce=k;function B(ue,X){let ge;const Se={onFirstListenerAdd(){ge=ue(oe.fire,oe)},onLastListenerRemove(){ge.dispose()}};X||c(Se);const oe=new v(Se);return X&&X.add(oe),oe.event}function M(ue,X,ge=100,Se=!1,oe,_e){let Pe,pe,ve,Ae=0;const ce={leakWarningThreshold:oe,onFirstListenerAdd(){Pe=ue(te=>{Ae++,pe=X(pe,te),Se&&!ve&&(me.fire(pe),pe=void 0),clearTimeout(ve),ve=setTimeout(()=>{const ne=pe;pe=void 0,ve=void 0,(!Se||Ae>1)&&me.fire(ne),Ae=0},ge)})},onLastListenerRemove(){Pe.dispose()}};_e||c(ce);const me=new v(ce);return _e&&_e.add(me),me.event}t.debounce=M;function W(ue,X=(Se,oe)=>Se===oe,ge){let Se=!0,oe;return R(ue,_e=>{const Pe=Se||!X(_e,oe);return Se=!1,oe=_e,Pe},ge)}t.latch=W;function ee(ue,X,ge){return[t.filter(ue,X,ge),t.filter(ue,Se=>!X(Se),ge)]}t.split=ee;function H(ue,X=!1,ge=[]){let Se=ge.slice(),oe=ue(pe=>{Se?Se.push(pe):Pe.fire(pe)});const _e=()=>{Se&&Se.forEach(pe=>Pe.fire(pe)),Se=null},Pe=new v({onFirstListenerAdd(){oe||(oe=ue(pe=>Pe.fire(pe)))},onFirstListenerDidAdd(){Se&&(X?setTimeout(_e):_e())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return Pe.event}t.buffer=H;class N{constructor(X){this.event=X}map(X){return new N(d(this.event,X))}forEach(X){return new N(w(this.event,X))}filter(X){return new N(R(this.event,X))}reduce(X,ge){return new N(k(this.event,X,ge))}latch(){return new N(W(this.event))}debounce(X,ge=100,Se=!1,oe){return new N(M(this.event,X,ge,Se,oe))}on(X,ge,Se){return this.event(X,ge,Se)}once(X,ge,Se){return l(this.event)(X,ge,Se)}}function j(ue){return new N(ue)}t.chain=j;function x(ue,X,ge=Se=>Se){const Se=(...pe)=>Pe.fire(ge(...pe)),oe=()=>ue.on(X,Se),_e=()=>ue.removeListener(X,Se),Pe=new v({onFirstListenerAdd:oe,onLastListenerRemove:_e});return Pe.event}t.fromNodeEventEmitter=x;function q(ue,X,ge=Se=>Se){const Se=(...pe)=>Pe.fire(ge(...pe)),oe=()=>ue.addEventListener(X,Se),_e=()=>ue.removeEventListener(X,Se),Pe=new v({onFirstListenerAdd:oe,onLastListenerRemove:_e});return Pe.event}t.fromDOMEventEmitter=q;function ie(ue){return new Promise(X=>l(ue)(X))}t.toPromise=ie;function Q(ue,X){return X(void 0),ue(ge=>X(ge))}t.runAndSubscribe=Q;function de(ue,X){let ge=null;function Se(_e){ge?.dispose(),ge=new y.DisposableStore,X(_e,ge)}Se(void 0);const oe=ue(_e=>Se(_e));return(0,y.toDisposable)(()=>{oe.dispose(),ge?.dispose()})}t.runAndSubscribeWithStore=de})(P=e.Event||(e.Event={}));class L{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${L._idPool++}`}start(c){this._stopWatch=new C.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let T=-1;function S(t){const c=T;return T=t,{dispose(){T=c}}}e.setGlobalLeakWarningThreshold=S;class I{constructor(c,l=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,l){let d=T;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),d<=0||l<d)return;this._stacks||(this._stacks=new Map);const w=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,w+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let R,F=0;for(const[O,k]of this._stacks)(!R||F<k)&&(R=O,F=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${F}):`),console.warn(R)}return()=>{const R=this._stacks.get(c.value)||0;this._stacks.set(c.value,R-1)}}}class _{constructor(c){this.value=c}static create(){return new _(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(c,l,d){this.callback=c,this.callbackThis=l,this.stack=d,this.subscription=new y.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class v{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=T>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const l of c)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,l,d)=>{this._listeners||(this._listeners=new A.LinkedList);const w=this._listeners.isEmpty();w&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,F;this._leakageMon&&this._listeners.size>=30&&(F=_.create(),R=this._leakageMon.check(F,this._listeners.size+1)),D&&(F=F??_.create());const O=new g(c,l,F),k=this._listeners.push(O);w&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,l);const B=O.subscription.set(()=>{R&&R(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return d instanceof y.DisposableStore?d.add(B):Array.isArray(d)&&d.push(B),B}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b);for(let l of this._listeners)this._deliveryQueue.push(this,l,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class p{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(c,l,d){this._queue.push(new f(c,l,d))}clear(c){const l=new A.LinkedList;for(const d of this._queue)d.emitter!==c&&l.push(d);this._queue=l}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=p;class b extends p{clear(c){this._queue.clear()}}class f{constructor(c,l,d){this.emitter=c,this.listener=l,this.event=d}}class a extends v{async fireAsync(c,l,d){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const w of this._listeners)this._asyncDeliveryQueue.push([w,c]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[w,R]=this._asyncDeliveryQueue.shift(),F=[],O={...R,token:l,waitUntil:k=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");d&&(k=d(k,w.callback)),F.push(k)}};try{w.invoke(O)}catch(k){(0,u.onUnexpectedError)(k);continue}Object.freeze(F),await Promise.allSettled(F).then(k=>{for(const B of k)B.status==="rejected"&&(0,u.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=a;class m extends v{constructor(c){super(c);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=m;class o extends m{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=o;class h extends v{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const l={event:c,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const d=()=>{this.hasListeners&&this.unhook(l);const w=this.events.indexOf(l);this.events.splice(w,1)};return(0,y.toDisposable)((0,i.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(l=>this.emitter.fire(l))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(c){return(l,d,w)=>c(R=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>l.call(d,R)):l.call(d,R)},void 0,w)}bufferEvents(c){const l=[];this.buffers.push(l);const d=c();return this.buffers.pop(),l.forEach(w=>w()),d}}e.EventBufferer=s;class n{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=y.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=n}),define(Ie[21],Te([1,0,3]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,E){const P=setTimeout(D.bind(E),0);return{dispose(){clearTimeout(P)}}});var y;(function(D){function E(P){return P===D.None||P===D.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}D.isCancellationToken=E,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(y=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=y.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=C}),define(Ie[145],Te([1,0,21]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new u.CancellationTokenSource,E=this.task(D.token);return this.result={promise:E,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=i;class y{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const E=JSON.stringify(D);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=y;class A{constructor(D){this.fn=D,this._map=new Map}get cachedValues(){return this._map}get(D){if(this._map.has(D))return this._map.get(D);const E=this.fn(D);return this._map.set(D,E),E}}e.CachedFunction=A}),define(Ie[97],Te([1,0,11,6]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(a){const m=a;return m?typeof m.read=="function":!1}e.isReadable=y;function A(a){const m=a;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function C(a){const m=a;return m?A(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=C;function D(a,m){return new E(a,m)}e.newWriteableStream=D;class E{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let h;switch(m){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const r=h.indexOf(o);r>=0&&h.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(a,m){const o=[];let h;for(;(h=a.read())!==null;)o.push(h);return m(o)}e.consumeReadable=P;function L(a,m,o){const h=[];let r;for(;(r=a.read())!==null&&h.length<o;)h.push(r);return r===null&&h.length>0?m(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=L;function T(a,m){return new Promise((o,h)=>{const r=[];S(a,{onData:s=>{m&&r.push(s)},onError:s=>{m?h(s):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}e.consumeStream=T;function S(a,m){let o=!1;return a.on("error",h=>{o||m.onError(h)}),a.on("end",()=>{o||m.onEnd()}),a.on("data",h=>{o||m.onData(h)}),(0,i.toDisposable)(()=>o=!0)}e.listenStream=S;function I(a,m){return new Promise((o,h)=>{const r=new i.DisposableStore,s=[],n=l=>{if(s.push(l),s.length>m)return r.dispose(),a.pause(),o({stream:a,buffer:s,ended:!1})},t=l=>h(l),c=()=>o({stream:a,buffer:s,ended:!0});r.add((0,i.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),r.add((0,i.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),r.add((0,i.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=I;function _(a,m){const o=D(m);return o.end(a),o}e.toStream=_;function g(){const a=D(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=g;function v(a){let m=!1;return{read:()=>m?null:(m=!0,a)}}e.toReadable=v;function p(a,m,o){const h=D(o);return S(a,{onData:r=>h.write(m.data(r)),onError:r=>h.error(m.error?m.error(r):r),onEnd:()=>h.end()}),h}e.transform=p;function b(a,m,o){let h=!1;return{read:()=>{const r=m.read();return h?r:(h=!0,r!==null?o([a,r]):a)}}}e.prefixedReadable=b;function f(a,m,o){let h=!1;const r=D(o);return S(m,{onData:s=>h?r.write(s):(h=!0,r.write(o([a,s]))),onError:s=>r.error(s),onEnd:()=>{h||(h=!0,r.write(a)),r.end()}}),r}e.prefixedStream=f}),define(Ie[23],Te([1,0,97]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let y,A;class C{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return i?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return i&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,d){return!(d?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(l)):(y||(y=new TextEncoder),new C(y.encode(l)))}static fromByteArray(l){const d=C.alloc(l.length);for(let w=0,R=l.length;w<R;w++)d.buffer[w]=l[w];return d}static concat(l,d){if(typeof d=="undefined"){d=0;for(let F=0,O=l.length;F<O;F++)d+=l[F].byteLength}const w=C.alloc(d);let R=0;for(let F=0,O=l.length;F<O;F++){const k=l[F];w.set(k,R),R+=k.byteLength}return w}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,d){return new C(this.buffer.subarray(l,d))}set(l,d){if(l instanceof C)this.buffer.set(l.buffer,d);else if(l instanceof Uint8Array)this.buffer.set(l,d);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),d);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return P(this.buffer,l)}writeUInt32BE(l,d){L(this.buffer,l,d)}readUInt32LE(l){return T(this.buffer,l)}writeUInt32LE(l,d){S(this.buffer,l,d)}readUInt8(l){return I(this.buffer,l)}writeUInt8(l,d){_(this.buffer,l,d)}}e.VSBuffer=C;function D(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=D;function E(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255}e.writeUInt16LE=E;function P(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=P;function L(c,l,d){c[d+3]=l,l=l>>>8,c[d+2]=l,l=l>>>8,c[d+1]=l,l=l>>>8,c[d]=l}e.writeUInt32BE=L;function T(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=T;function S(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255,l=l>>>8,c[d+2]=l&255,l=l>>>8,c[d+3]=l&255}e.writeUInt32LE=S;function I(c,l){return c[l]}e.readUInt8=I;function _(c,l,d){c[d]=l}e.writeUInt8=_;function g(c){return u.consumeReadable(c,l=>C.concat(l))}e.readableToBuffer=g;function v(c){return u.toReadable(c)}e.bufferToReadable=v;function p(c){return u.consumeStream(c,l=>C.concat(l))}e.streamToBuffer=p;async function b(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await p(c.stream)])}e.bufferedStreamToBuffer=b;function f(c){return u.toStream(c,l=>C.concat(l))}e.bufferToStream=f;function a(c){return u.transform(c,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=a;function m(c){return u.newWriteableStream(l=>C.concat(l),c)}e.newWriteableBufferStream=m;function o(c,l){return u.prefixedReadable(c,l,d=>C.concat(d))}e.prefixedBufferReadable=o;function h(c,l){return u.prefixedStream(c,l,d=>C.concat(d))}e.prefixedBufferStream=h;function r(c){let l=0,d=0,w=0;const R=new Uint8Array(Math.floor(c.length/4*3)),F=k=>{switch(d){case 3:R[w++]=l|k,d=0;break;case 2:R[w++]=l|k>>>2,l=k<<6,d=3;break;case 1:R[w++]=l|k>>>4,l=k<<4,d=2;break;default:l=k<<2,d=1}};for(let k=0;k<c.length;k++){const B=c.charCodeAt(k);if(B>=65&&B<=90)F(B-65);else if(B>=97&&B<=122)F(B-97+26);else if(B>=48&&B<=57)F(B-48+52);else if(B===43||B===45)F(62);else if(B===47||B===95)F(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const O=w;for(;d>0;)F(0);return C.wrap(R).slice(0,O)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},l=!0,d=!1){const w=d?n:s;let R="";const F=c.byteLength%3;let O=0;for(;O<c.byteLength-F;O+=3){const k=c[O+0],B=c[O+1],M=c[O+2];R+=w[k>>>2],R+=w[(k<<4|B>>>4)&63],R+=w[(B<<2|M>>>6)&63],R+=w[M&63]}if(F===1){const k=c[O+0];R+=w[k>>>2],R+=w[k<<4&63],l&&(R+="==")}else if(F===2){const k=c[O+0],B=c[O+1];R+=w[k>>>2],R+=w[(k<<4|B>>>4)&63],R+=w[B<<2&63],l&&(R+="=")}return R}e.encodeBase64=t}),define(Ie[8],Te([1,0,145,80]),function(Y,e,u,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function D(ae,...ke){return ke.length===0?ae:ae.replace(C,function(Ne,He){const Ge=parseInt(He,10);return isNaN(Ge)||Ge<0||Ge>=ke.length?Ne:ke[Ge]})}e.format=D;const E=/{([^}]+)}/g;function P(ae,ke){return ae.replace(E,(Ne,He)=>ke[He]??Ne)}e.format2=P;function L(ae){return ae.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.escape=L;function T(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function S(ae,ke){let Ne=0;const He=ke.charCodeAt(0);for(let Ge=ae.length-1;Ge>=0;Ge--)ae.charCodeAt(Ge)===He&&Ne++;return Ne}e.count=S;function I(ae,ke,Ne="\u2026"){return ae.length<=ke?ae:`${ae.substr(0,ke)}${Ne}`}e.truncate=I;function _(ae,ke=" "){const Ne=g(ae,ke);return v(Ne,ke)}e.trim=_;function g(ae,ke){if(!ae||!ke)return ae;const Ne=ke.length;if(Ne===0||ae.length===0)return ae;let He=0;for(;ae.indexOf(ke,He)===He;)He=He+Ne;return ae.substring(He)}e.ltrim=g;function v(ae,ke){if(!ae||!ke)return ae;const Ne=ke.length,He=ae.length;if(Ne===0||He===0)return ae;let Ge=He,qe=-1;for(;qe=ae.lastIndexOf(ke,Ge-1),!(qe===-1||qe+Ne!==Ge);){if(qe===0)return"";Ge=qe}return ae.substring(0,Ge)}e.rtrim=v;function p(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function b(ae){return ae.replace(/\*/g,"")}e.stripWildcards=b;function f(ae,ke,Ne={}){if(!ae)throw new Error("Cannot create regex from empty string");ke||(ae=T(ae)),Ne.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let He="";return Ne.global&&(He+="g"),Ne.matchCase||(He+="i"),Ne.multiline&&(He+="m"),Ne.unicode&&(He+="u"),new RegExp(ae,He)}e.createRegExp=f;function a(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function m(ae){return!!ae.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function o(ae){return(ae.global?"g":"")+(ae.ignoreCase?"i":"")+(ae.multiline?"m":"")+(ae.unicode?"u":"")}e.regExpFlags=o;function h(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=h;function r(ae){for(let ke=0,Ne=ae.length;ke<Ne;ke++){const He=ae.charCodeAt(ke);if(He!==32&&He!==9)return ke}return-1}e.firstNonWhitespaceIndex=r;function s(ae,ke=0,Ne=ae.length){for(let He=ke;He<Ne;He++){const Ge=ae.charCodeAt(He);if(Ge!==32&&Ge!==9)return ae.substring(ke,He)}return ae.substring(ke,Ne)}e.getLeadingWhitespace=s;function n(ae,ke=ae.length-1){for(let Ne=ke;Ne>=0;Ne--){const He=ae.charCodeAt(Ne);if(He!==32&&He!==9)return Ne}return-1}e.lastNonWhitespaceIndex=n;function t(ae,ke,Ne){let He=[],Ge=0;for(const qe of ae.matchAll(ke)){if(He.push(ae.slice(Ge,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Ge=qe.index+qe[0].length,He.push(Ne(qe[0],...qe.slice(1),qe.index,ae,qe.groups))}return He.push(ae.slice(Ge)),Promise.all(He).then(qe=>qe.join(""))}e.replaceAsync=t;function c(ae,ke){return ae<ke?-1:ae>ke?1:0}e.compare=c;function l(ae,ke,Ne=0,He=ae.length,Ge=0,qe=ke.length){for(;Ne<He&&Ge<qe;Ne++,Ge++){let rt=ae.charCodeAt(Ne),tt=ke.charCodeAt(Ge);if(rt<tt)return-1;if(rt>tt)return 1}const Ze=He-Ne,Xe=qe-Ge;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstring=l;function d(ae,ke){return w(ae,ke,0,ae.length,0,ke.length)}e.compareIgnoreCase=d;function w(ae,ke,Ne=0,He=ae.length,Ge=0,qe=ke.length){for(;Ne<He&&Ge<qe;Ne++,Ge++){let rt=ae.charCodeAt(Ne),tt=ke.charCodeAt(Ge);if(rt===tt)continue;if(rt>=128||tt>=128)return l(ae.toLowerCase(),ke.toLowerCase(),Ne,He,Ge,qe);R(rt)&&(rt-=32),R(tt)&&(tt-=32);const st=rt-tt;if(st!==0)return st}const Ze=He-Ne,Xe=qe-Ge;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstringIgnoreCase=w;function R(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=R;function F(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=F;function O(ae,ke){return ae.length===ke.length&&w(ae,ke)===0}e.equalsIgnoreCase=O;function k(ae,ke){const Ne=ke.length;return ke.length>ae.length?!1:w(ae,ke,0,Ne)===0}e.startsWithIgnoreCase=k;function B(ae,ke){let Ne,He=Math.min(ae.length,ke.length);for(Ne=0;Ne<He;Ne++)if(ae.charCodeAt(Ne)!==ke.charCodeAt(Ne))return Ne;return He}e.commonPrefixLength=B;function M(ae,ke){let Ne,He=Math.min(ae.length,ke.length);const Ge=ae.length-1,qe=ke.length-1;for(Ne=0;Ne<He;Ne++)if(ae.charCodeAt(Ge-Ne)!==ke.charCodeAt(qe-Ne))return Ne;return He}e.commonSuffixLength=M;function W(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=W;function ee(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=ee;function H(ae,ke){return(ae-55296<<10)+(ke-56320)+65536}e.computeCodePoint=H;function N(ae,ke,Ne){const He=ae.charCodeAt(Ne);if(W(He)&&Ne+1<ke){const Ge=ae.charCodeAt(Ne+1);if(ee(Ge))return H(He,Ge)}return He}e.getNextCodePoint=N;function j(ae,ke){const Ne=ae.charCodeAt(ke-1);if(ee(Ne)&&ke>1){const He=ae.charCodeAt(ke-2);if(W(He))return H(He,Ne)}return Ne}class x{constructor(ke,Ne=0){this._str=ke,this._len=ke.length,this._offset=Ne}get offset(){return this._offset}setOffset(ke){this._offset=ke}prevCodePoint(){const ke=j(this._str,this._offset);return this._offset-=ke>=65536?2:1,ke}nextCodePoint(){const ke=N(this._str,this._len,this._offset);return this._offset+=ke>=65536?2:1,ke}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class q{constructor(ke,Ne=0){this._iterator=new x(ke,Ne)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ke=ye.getInstance(),Ne=this._iterator,He=Ne.offset;let Ge=ke.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const qe=Ne.offset,Ze=ke.getGraphemeBreakType(Ne.nextCodePoint());if(se(Ge,Ze)){Ne.setOffset(qe);break}Ge=Ze}return Ne.offset-He}prevGraphemeLength(){const ke=ye.getInstance(),Ne=this._iterator,He=Ne.offset;let Ge=ke.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const qe=Ne.offset,Ze=ke.getGraphemeBreakType(Ne.prevCodePoint());if(se(Ze,Ge)){Ne.setOffset(qe);break}Ge=Ze}return He-Ne.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function ie(ae,ke){return new q(ae,ke).nextGraphemeLength()}e.nextCharLength=ie;function Q(ae,ke){return new q(ae,ke).prevGraphemeLength()}e.prevCharLength=Q;function de(ae,ke){ke>0&&ee(ae.charCodeAt(ke))&&ke--;const Ne=ke+ie(ae,ke);return[Ne-Q(ae,Ne),Ne]}e.getCharContainingOffset=de;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(ae){return ue.test(ae)}e.containsRTL=X;const ge=/^[\t\n\r\x20-\x7E]*$/;function Se(ae){return ge.test(ae)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=oe;function _e(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=_e;function Pe(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=Pe;function pe(ae,ke){if(ae.length<ke)return ae;const Ne=/\b/g;let He=0;for(;Ne.test(ae)&&!(ae.length-Ne.lastIndex<ke);)He=Ne.lastIndex,Ne.lastIndex+=1;return ae.substring(He).replace(/^\s/,"")}e.lcut=pe;const ve=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function me(ae){return ae&&(ae=ae.replace(ve,""),ae=ae.replace(Ae,""),ae=ae.replace(ce,"")),ae}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function te(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=te;function ne(ae){return te(ae)?ae.substr(1):ae}e.stripUTF8BOM=ne;function U(ae,ke){if(!ae||!ke||ae.length<ke.length)return!1;const Ne=ke.length,He=ae.toLowerCase();let Ge=0,qe=-1;for(;Ge<Ne;){const Ze=He.indexOf(ke[Ge],qe+1);if(Ze<0)return!1;qe=Ze,Ge++}return!0}e.fuzzyContains=U;function $(ae,ke=!1){return ae?(ke&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=$;function G(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=G;function K(ae,ke=1){if(ke===0)return"";let Ne=-1;do Ne=ae.indexOf(`
`,Ne+1),ke--;while(ke>0&&Ne>=0);return Ne===-1?ae:(ae[Ne-1]==="\r"&&Ne--,ae.substr(0,Ne))}e.getNLines=K;function he(ae){const ke=90-65+1;return ae=ae%(2*ke),ae<ke?String.fromCharCode(97+ae):String.fromCharCode(65+ae-ke)}e.singleLetterHash=he;function we(ae){return ye.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=we;function se(ae,ke){return ae===0?ke!==5&&ke!==7:ae===2&&ke===3?!1:ae===4||ae===2||ae===3||ke===4||ke===2||ke===3?!0:!(ae===8&&(ke===8||ke===9||ke===11||ke===12)||(ae===11||ae===9)&&(ke===9||ke===10)||(ae===12||ae===10)&&ke===10||ke===5||ke===13||ke===7||ae===1||ae===13&&ke===14||ae===6&&ke===6)}var De;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(De=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=ze()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Ne=this._data,He=Ne.length/3;let Ge=1;for(;Ge<=He;)if(ke<Ne[3*Ge])Ge=2*Ge;else if(ke>Ne[3*Ge+1])Ge=2*Ge+1;else return Ne[3*Ge+2];return 0}}ye._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(ae,ke){if(ae===0)return 0;const Ne=Me(ae,ke);if(Ne!==void 0)return Ne;const He=new x(ke,ae);return He.prevCodePoint(),He.offset}e.getLeftDeleteOffset=Ve;function Me(ae,ke){const Ne=new x(ke,ae);let He=Ne.prevCodePoint();for(;Je(He)||He===65039||He===8419;){if(Ne.offset===0)return;He=Ne.prevCodePoint()}if(!Pe(He))return;let Ge=Ne.offset;return Ge>0&&Ne.prevCodePoint()===8205&&(Ge=Ne.offset),Ge}function Je(ae){return 127995<=ae&&ae<=127999}var J;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(J||(J={})),e.noBreakWhitespace="\xA0";class re{constructor(ke){this.confusableDictionary=ke}static getInstance(ke){return re.cache.get(Array.from(ke))}static getLocales(){return re._locales.getValue()}isAmbiguous(ke){return this.confusableDictionary.has(ke)}getPrimaryConfusable(ke){return this.confusableDictionary.get(ke)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=re,y=re,re.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),re.cache=new u.LRUCachedFunction(ae=>{function ke(tt){const st=new Map;for(let ot=0;ot<tt.length;ot+=2)st.set(tt[ot],tt[ot+1]);return st}function Ne(tt,st){const ot=new Map(tt);for(const[Et,Ot]of st)ot.set(Et,Ot);return ot}function He(tt,st){if(!tt)return st;const ot=new Map;for(const[Et,Ot]of tt)st.has(Et)&&ot.set(Et,Ot);return ot}const Ge=y.ambiguousCharacterData.getValue();let qe=ae.filter(tt=>!tt.startsWith("_")&&tt in Ge);qe.length===0&&(qe=["_default"]);let Ze;for(const tt of qe){const st=ke(Ge[tt]);Ze=He(Ze,st)}const Xe=ke(Ge._common),rt=Ne(Xe,Ze);return new re(rt)}),re._locales=new i.Lazy(()=>Object.keys(re.ambiguousCharacterData.getValue()).filter(ae=>!ae.startsWith("_")));class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(ke){return Ce.getData().has(ke)}static get codePoints(){return Ce.getData()}}e.InvisibleCharacters=Ce,Ce._data=void 0}),define(Ie[61],Te([1,0,8]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(p){return y(p,0)}e.hash=i;function y(p,b){switch(typeof p){case"object":return p===null?A(349,b):Array.isArray(p)?E(p,b):P(p,b);case"string":return D(p,b);case"boolean":return C(p,b);case"number":return A(p,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=y;function A(p,b){return(b<<5)-b+p|0}e.numberHash=A;function C(p,b){return A(p?433:863,b)}function D(p,b){b=A(149417,b);for(let f=0,a=p.length;f<a;f++)b=A(p.charCodeAt(f),b);return b}e.stringHash=D;function E(p,b){return b=A(104579,b),p.reduce((f,a)=>y(a,f),b)}function P(p,b){return b=A(181387,b),Object.keys(p).sort().reduce((f,a)=>(f=D(a,f),y(p[a],f)),b)}class L{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=y(b,this._value),this._value}}e.Hasher=L;var T;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function S(p,b,f=32){const a=f-b,m=~((1<<a)-1);return(p<<b|(m&p)>>>a)>>>0}function I(p,b=0,f=p.byteLength,a=0){for(let m=0;m<f;m++)p[b+m]=a}function _(p,b,f="0"){for(;p.length<b;)p=f+p;return p}function g(p,b=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):_((p>>>0).toString(16),b/4)}e.toHexString=g;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const f=b.length;if(f===0)return;const a=this._buff;let m=this._buffLen,o=this._leftoverHighSurrogate,h,r;for(o!==0?(h=o,r=-1,o=0):(h=b.charCodeAt(0),r=0);;){let s=h;if(u.isHighSurrogate(h))if(r+1<f){const n=b.charCodeAt(r+1);u.isLowSurrogate(n)?(r++,s=u.computeCodePoint(h,n)):s=65533}else{o=h;break}else u.isLowSurrogate(h)&&(s=65533);if(m=this._push(a,m,s),r++,r<f)h=b.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=o}_push(b,f,a){return a<128?b[f++]=a:a<2048?(b[f++]=192|(a&1984)>>>6,b[f++]=128|(a&63)>>>0):a<65536?(b[f++]=224|(a&61440)>>>12,b[f++]=128|(a&4032)>>>6,b[f++]=128|(a&63)>>>0):(b[f++]=240|(a&1835008)>>>18,b[f++]=128|(a&258048)>>>12,b[f++]=128|(a&4032)>>>6,b[f++]=128|(a&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,I(this._buff,this._buffLen),this._buffLen>56&&(this._step(),I(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,f=this._buffDV;for(let c=0;c<64;c+=4)b.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)b.setUint32(c,S(b.getUint32(c-12,!1)^b.getUint32(c-32,!1)^b.getUint32(c-56,!1)^b.getUint32(c-64,!1),1),!1);let a=this._h0,m=this._h1,o=this._h2,h=this._h3,r=this._h4,s,n,t;for(let c=0;c<80;c++)c<20?(s=m&o|~m&h,n=1518500249):c<40?(s=m^o^h,n=1859775393):c<60?(s=m&o|m&h|o&h,n=2400959708):(s=m^o^h,n=3395469782),t=S(a,5)+s+r+n+b.getUint32(c*4,!1)&4294967295,r=h,h=o,o=S(m,30),m=a,a=t;this._h0=this._h0+a&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[25],Te([1,0,16,8]),function(Y,e,u,i){"use strict";var y,A,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(n,t,c){let l=n.get(t);return l===void 0&&(l=c,n.set(t,l)),l}e.getOrSet=E;function P(n){const t=[];return n.forEach((c,l)=>{t.push(`${l} => ${c}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=P;function L(n){const t=[];return n.forEach(c=>{t.push(c)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=L;class T{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return c-l}value(){return this._value[this._pos]}}e.StringIterator=T;class S{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class I{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let c=t.length-1;c>=0;c--,this._valueLen--){const l=this._value.charCodeAt(c);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var _;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(_||(_={}));class g{constructor(t,c){this._ignorePathCasing=t,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(p||(p={}));class b{constructor(t){this._iter=t}static forUris(t=()=>!1,c=()=>!1){return new b(new g(t,c))}static forPaths(t=!1){return new b(new I(void 0,!t))}static forStrings(){return new b(new T)}static forConfigKeys(){return new b(new S)}clear(){this._root=void 0}fill(t,c){if(c){const l=c.slice(0);(0,u.shuffle)(l);for(let d of l)this.set(d,t)}else{const l=t.slice(0);(0,u.shuffle)(l);for(let d of l)this.set(d[0],d[1])}}set(t,c){const l=this._iter.reset(t);let d;this._root||(this._root=new v,this._root.segment=l.value());const w=[];for(d=this._root;;){const F=l.cmp(d.segment);if(F>0)d.left||(d.left=new v,d.left.segment=l.value()),w.push([-1,d]),d=d.left;else if(F<0)d.right||(d.right=new v,d.right.segment=l.value()),w.push([1,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new v,d.mid.segment=l.value()),w.push([0,d]),d=d.mid;else break}const R=d.value;d.value=c,d.key=t;for(let F=w.length-1;F>=0;F--){const O=w[F][1];O.updateHeight();const k=O.balanceFactor();if(k<-1||k>1){const B=w[F][0],M=w[F+1][0];if(B===1&&M===1)w[F][1]=O.rotateLeft();else if(B===-1&&M===-1)w[F][1]=O.rotateRight();else if(B===1&&M===-1)O.right=w[F+1][1]=w[F+1][1].rotateRight(),w[F][1]=O.rotateLeft();else if(B===-1&&M===1)O.left=w[F+1][1]=w[F+1][1].rotateLeft(),w[F][1]=O.rotateRight();else throw new Error;if(F>0)switch(w[F-1][0]){case-1:w[F-1][1].left=w[F][1];break;case 1:w[F-1][1].right=w[F][1];break;case 0:w[F-1][1].mid=w[F][1];break}else this._root=w[0][1]}}return R}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const d=c.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else break}return l}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const l=this._iter.reset(t),d=[];let w=this._root;for(;w;){const R=l.cmp(w.segment);if(R>0)d.push([-1,w]),w=w.left;else if(R<0)d.push([1,w]),w=w.right;else if(l.hasNext())l.next(),d.push([0,w]),w=w.mid;else break}if(!!w){if(c?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const R=this._min(w.right),{key:F,value:O,segment:k}=R;this._delete(R.key,!1),w.key=F,w.value=O,w.segment=k}else{const R=w.left??w.right;if(d.length>0){const[F,O]=d[d.length-1];switch(F){case-1:O.left=R;break;case 0:O.mid=R;break;case 1:O.right=R;break}}else this._root=R}for(let R=d.length-1;R>=0;R--){const F=d[R][1];F.updateHeight();const O=F.balanceFactor();if(O>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),d[R][1]=F.rotateLeft()):O<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),d[R][1]=F.rotateRight()),R>0)switch(d[R-1][0]){case-1:d[R-1][1].left=d[R][1];break;case 1:d[R-1][1].right=d[R][1];break;case 0:d[R-1][1].mid=d[R][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let l=this._root,d;for(;l;){const w=c.cmp(l.segment);if(w>0)l=l.left;else if(w<0)l=l.right;else if(c.hasNext())c.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const d=c.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[c,l]of this)t(l,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const l=c.balanceFactor();return l<-1||l>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=b;class f{constructor(t,c){this.uri=t,this.value=c}}class a{constructor(t,c){this[y]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new f(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(let[l,d]of this.map)t(d.value,d.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();class m{constructor(t,c){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(c),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,c){this._map.forEach((l,d)=>t.call(c,d,d,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class h{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const l=this._map.get(t);if(!!l)return c!==0&&this.touch(l,c),l.value}set(t,c,l=0){let d=this._map.get(t);if(d)d.value=c,l!==0&&this.touch(d,l);else{switch(d={key:t,value:c,next:void 0,previous:void 0},l){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const l=this._state;let d=this._head;for(;d;){if(c?t.bind(c)(d.value,d.key,this):t(d.value,d.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,c=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.key,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return d}values(){const t=this,c=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.value,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return d}entries(){const t=this,c=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:[l.key,l.value],done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return d}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,l=this.size;for(;c&&l>t;)this._map.delete(c.key),c=c.next,l--;this._head=c,this._size=l,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,l=t.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const l=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(l.previous=d,d.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const l=t.next,d=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=d,d.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,l)=>{t.push([l,c])}),t}fromJSON(t){this.clear();for(const[c,l]of t)this.set(c,l)}}e.LinkedMap=h;class r extends h{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){D.set(this,void 0),et(this,D,t,"f")}get size(){return Ue(this,D,"f").size}forEach(t,c){Ue(this,D,"f").forEach(t,c)}get(t){return Ue(this,D,"f").get(t)}has(t){return Ue(this,D,"f").has(t)}entries(){return Ue(this,D,"f").entries()}keys(){return Ue(this,D,"f").keys()}values(){return Ue(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ue(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(Ie[98],Te([1,0,25,8]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...te){return function(ne,U){for(let $=0,G=te.length;$<G;$++){const K=te[$](ne,U);if(K)return K}return null}}e.or=y,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(te,ne,U){if(!U||U.length<ne.length)return null;let $;return te?$=i.startsWithIgnoreCase(U,ne):$=U.indexOf(ne)===0,$?ne.length>0?[{start:0,end:ne.length}]:[]:null}function C(te,ne){const U=ne.toLowerCase().indexOf(te.toLowerCase());return U===-1?null:[{start:U,end:U+te.length}]}e.matchesContiguousSubString=C;function D(te,ne){return E(te.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=D;function E(te,ne,U,$){if(U===te.length)return[];if($===ne.length)return null;if(te[U]===ne[$]){let G=null;return(G=E(te,ne,U+1,$+1))?p({start:$,end:$+1},G):null}return E(te,ne,U,$+1)}function P(te){return 97<=te&&te<=122}function L(te){return 65<=te&&te<=90}e.isUpper=L;function T(te){return 48<=te&&te<=57}function S(te){return te===32||te===9||te===10||te===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>I.add(te.charCodeAt(0)));function _(te){return S(te)||I.has(te)}function g(te,ne){return te===ne||_(te)&&_(ne)}function v(te){return P(te)||L(te)||T(te)}function p(te,ne){return ne.length===0?ne=[te]:te.end===ne[0].start?ne[0].start=te.start:ne.unshift(te),ne}function b(te,ne){for(let U=ne;U<te.length;U++){const $=te.charCodeAt(U);if(L($)||T($)||U>0&&!v(te.charCodeAt(U-1)))return U}return te.length}function f(te,ne,U,$){if(U===te.length)return[];if($===ne.length)return null;if(te[U]!==ne[$].toLowerCase())return null;{let G=null,K=$+1;for(G=f(te,ne,U+1,$+1);!G&&(K=b(ne,K))<ne.length;)G=f(te,ne,U+1,K),K++;return G===null?null:p({start:$,end:$+1},G)}}function a(te){let ne=0,U=0,$=0,G=0,K=0;for(let ye=0;ye<te.length;ye++)K=te.charCodeAt(ye),L(K)&&ne++,P(K)&&U++,v(K)&&$++,T(K)&&G++;const he=ne/te.length,we=U/te.length,se=$/te.length,De=G/te.length;return{upperPercent:he,lowerPercent:we,alphaPercent:se,numericPercent:De}}function m(te){const{upperPercent:ne,lowerPercent:U}=te;return U===0&&ne>.6}function o(te){const{upperPercent:ne,lowerPercent:U,alphaPercent:$,numericPercent:G}=te;return U>.2&&ne<.8&&$>.6&&G<.2}function h(te){let ne=0,U=0,$=0,G=0;for(let K=0;K<te.length;K++)$=te.charCodeAt(K),L($)&&ne++,P($)&&U++,S($)&&G++;return(ne===0||U===0)&&G===0?te.length<=30:ne<=5}function r(te,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!h(te)||ne.length>60)return null;const U=a(ne);if(!o(U)){if(!m(U))return null;ne=ne.toLowerCase()}let $=null,G=0;for(te=te.toLowerCase();G<ne.length&&($=f(te,ne,0,G))===null;)G=b(ne,G+1);return $}e.matchesCamelCase=r;function s(te,ne,U=!1){if(!ne||ne.length===0)return null;let $=null,G=0;for(te=te.toLowerCase(),ne=ne.toLowerCase();G<ne.length&&($=n(te,ne,0,G,U))===null;)G=t(ne,G+1);return $}e.matchesWords=s;function n(te,ne,U,$,G){if(U===te.length)return[];if($===ne.length)return null;if(g(te.charCodeAt(U),ne.charCodeAt($))){let K=null,he=$+1;if(K=n(te,ne,U+1,$+1,G),!G)for(;!K&&(he=t(ne,he))<ne.length;)K=n(te,ne,U+1,he,G),he++;return K===null?null:p({start:$,end:$+1},K)}else return null}function t(te,ne){for(let U=ne;U<te.length;U++)if(_(te.charCodeAt(U))||U>0&&_(te.charCodeAt(U-1)))return U;return te.length}const c=y(e.matchesPrefix,r,C),l=y(e.matchesPrefix,r,D),d=new u.LRUCache(1e4);function w(te,ne,U=!1){if(typeof te!="string"||typeof ne!="string")return null;let $=d.get(te);$||($=new RegExp(i.convertSimple2RegExpPattern(te),"i"),d.set(te,$));const G=$.exec(ne);return G?[{start:G.index,end:G.index+G[0].length}]:U?l(te,ne):c(te,ne)}e.matchesFuzzy=w;function R(te,ne){const U=_e(te,te.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?O(U):null}e.matchesFuzzy2=R;function F(te,ne,U,$,G,K){const he=Math.min(13,te.length);for(;U<he;U++){const we=_e(te,ne,U,$,G,K,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,K]}e.anyScore=F;function O(te){if(typeof te=="undefined")return[];const ne=[],U=te[1];for(let $=te.length-1;$>1;$--){const G=te[$]+U,K=ne[ne.length-1];K&&K.end===G?K.end=G+1:ne.push({start:G,end:G+1})}return ne}e.createMatches=O;const k=128;function B(){const te=[],ne=[];for(let U=0;U<=k;U++)ne[U]=0;for(let U=0;U<=k;U++)te.push(ne.slice(0));return te}function M(te){const ne=[];for(let U=0;U<=te;U++)ne[U]=0;return ne}const W=M(2*k),ee=M(2*k),H=B(),N=B(),j=B(),x=!1;function q(te,ne,U,$,G){function K(we,se,De=" "){for(;we.length<se;)we=De+we;return we}let he=` |   |${$.split("").map(we=>K(we,3)).join("|")}
`;for(let we=0;we<=U;we++)we===0?he+=" |":he+=`${ne[we-1]}|`,he+=te[we].slice(0,G+1).map(se=>K(se.toString(),3)).join("|")+`
`;return he}function ie(te,ne,U,$){te=te.substr(ne),U=U.substr($),console.log(q(N,te,te.length,U,U.length)),console.log(q(j,te,te.length,U,U.length)),console.log(q(H,te,te.length,U,U.length))}function Q(te,ne){if(ne<0||ne>=te.length)return!1;const U=te.codePointAt(ne);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(U)}}function de(te,ne){if(ne<0||ne>=te.length)return!1;switch(te.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ue(te,ne,U){return ne[te]!==U[te]}function X(te,ne,U,$,G,K,he=!1){for(;ne<U&&G<K;)te[ne]===$[G]&&(he&&(W[ne]=G),ne+=1),G+=1;return ne===U}e.isPatternInWord=X;var ge;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Se;(function(te){te.Default=[-100,0];function ne(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}te.isDefault=ne})(Se=e.FuzzyScore||(e.FuzzyScore={}));class oe{constructor(ne,U){this.firstMatchCanBeWeak=ne,this.boostFullMatch=U}}e.FuzzyScoreOptions=oe,oe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function _e(te,ne,U,$,G,K,he=oe.default){const we=te.length>k?k:te.length,se=$.length>k?k:$.length;if(U>=we||K>=se||we-U>se-K||!X(ne,U,we,G,K,se,!0))return;Pe(we,se,U,K,ne,G);let De=1,ye=1,ze=U,Ve=K;const Me=[!1];for(De=1,ze=U;ze<we;De++,ze++){const ae=W[ze],ke=ee[ze],Ne=ze+1<we?ee[ze+1]:se;for(ye=ae-K+1,Ve=ae;Ve<Ne;ye++,Ve++){let He=Number.MIN_SAFE_INTEGER,Ge=!1;Ve<=ke&&(He=pe(te,ne,ze,U,$,G,Ve,se,K,H[De-1][ye-1]===0,Me));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(Ge=!0,qe=He+N[De-1][ye-1]);const Ze=Ve>ae,Xe=Ze?N[De][ye-1]+(H[De][ye-1]>0?-5:0):0,rt=Ve>ae+1&&H[De][ye-1]>0,tt=rt?N[De][ye-2]+(H[De][ye-2]>0?-5:0):0;if(rt&&(!Ze||tt>=Xe)&&(!Ge||tt>=qe))N[De][ye]=tt,j[De][ye]=3,H[De][ye]=0;else if(Ze&&(!Ge||Xe>=qe))N[De][ye]=Xe,j[De][ye]=2,H[De][ye]=0;else if(Ge)N[De][ye]=qe,j[De][ye]=1,H[De][ye]=H[De-1][ye-1]+1;else throw new Error("not possible")}}if(x&&ie(te,U,$,K),!Me[0]&&!he.firstMatchCanBeWeak)return;De--,ye--;const Je=[N[De][ye],K];let J=0,re=0;for(;De>=1;){let ae=ye;do{const ke=j[De][ae];if(ke===3)ae=ae-2;else if(ke===2)ae=ae-1;else break}while(ae>=1);J>1&&ne[U+De-1]===G[K+ye-1]&&!ue(ae+K-1,$,G)&&J+1>H[De][ae]&&(ae=ye),ae===ye?J++:J=1,re||(re=ae),De--,ye=ae-1,Je.push(ye)}se===we&&he.boostFullMatch&&(Je[0]+=2);const Ce=re-we;return Je[0]-=Ce,Je}e.fuzzyScore=_e;function Pe(te,ne,U,$,G,K){let he=te-1,we=ne-1;for(;he>=U&&we>=$;)G[he]===K[we]&&(ee[he]=we,he--),we--}function pe(te,ne,U,$,G,K,he,we,se,De,ye){if(ne[U]!==K[he])return Number.MIN_SAFE_INTEGER;let ze=1,Ve=!1;return he===U-$?ze=te[U]===G[he]?7:5:ue(he,G,K)&&(he===0||!ue(he-1,G,K))?(ze=te[U]===G[he]?7:5,Ve=!0):Q(K,he)&&(he===0||!Q(K,he-1))?ze=5:(Q(K,he-1)||de(K,he-1))&&(ze=5,Ve=!0),ze>1&&U===$&&(ye[0]=!0),Ve||(Ve=ue(he,G,K)||Q(K,he-1)||de(K,he-1)),U===$?he>se&&(ze-=Ve?3:5):De?ze+=Ve?2:0:ze+=Ve?0:1,he+1===we&&(ze-=Ve?3:5),ze}function ve(te,ne,U,$,G,K,he){return ce(te,ne,U,$,G,K,!0,he)}e.fuzzyScoreGracefulAggressive=ve;function Ae(te,ne,U,$,G,K,he){return ce(te,ne,U,$,G,K,!1,he)}e.fuzzyScoreGraceful=Ae;function ce(te,ne,U,$,G,K,he,we){let se=_e(te,ne,U,$,G,K,we);if(se&&!he)return se;if(te.length>=3){const De=Math.min(7,te.length-1);for(let ye=U+1;ye<De;ye++){const ze=me(te,ye);if(ze){const Ve=_e(ze,ze.toLowerCase(),U,$,G,K,we);Ve&&(Ve[0]-=3,(!se||Ve[0]>se[0])&&(se=Ve))}}}return se}function me(te,ne){if(ne+1>=te.length)return;const U=te[ne],$=te[ne+1];if(U!==$)return te.slice(0,ne)+$+U+te.slice(ne+2)}}),define(Ie[146],Te([1,0,78,98,8]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(u.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${A.source}`,"g");function E(v){return v.replace(D,(p,b)=>b?p:`\\${p}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${A.source}`,"g");function L(v){return v.replace(P,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function S(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(T,(p,b,f,a)=>f?p:b||a||"")}e.stripIcons=S;function I(v){const p=v.indexOf(e.iconStartMarker);return p===-1?{text:v}:_(v,p)}e.parseLabelWithIcons=I;function _(v,p){const b=[];let f="";function a(c){if(c){f+=c;for(const l of c)b.push(h)}}let m=-1,o="",h=0,r,s,n=p;const t=v.length;for(a(v.substr(0,p));n<t;)r=v[n],s=v[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(m=n,a(o),o=e.iconStartMarker,n++):r===")"&&m!==-1?(h+=n-m+1,m=-1,o=""):m!==-1?C.test(r)?o+=r:(a(o),m=-1,o=""):a(r),n++;return a(o),{text:f,iconOffsets:b}}function g(v,p,b=!1){const{text:f,iconOffsets:a}=p;if(!a||a.length===0)return(0,i.matchesFuzzy)(v,f,b);const m=(0,y.ltrim)(f," "),o=f.length-m.length,h=(0,i.matchesFuzzy)(v,m,b);if(h)for(const r of h){const s=a[r.start+o]+o;r.start+=s,r.end+=s}return h}e.matchesFuzzyIconAware=g}),define(Ie[82],Te([1,0,25]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new u.LRUCache(1e4);function y(P){return E(P,"NFC",i)}e.normalizeNFC=y;const A=new u.LRUCache(1e4);function C(P){return E(P,"NFD",A)}e.normalizeNFD=C;const D=/[^\u0000-\u0080]/;function E(P,L,T){if(!P)return P;const S=T.get(P);if(S)return S;let I;return D.test(P)?I=P.normalize(L):I=P,T.set(P,I),I}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return C(L).replace(P,"")}}()}),define(Ie[41],Te([1,0,8]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(i||(i={})),function(y){const A="error",C="warning",D="warn",E="info",P="ignore";function L(S){return S?u.equalsIgnoreCase(A,S)?y.Error:u.equalsIgnoreCase(C,S)||u.equalsIgnoreCase(D,S)?y.Warning:u.equalsIgnoreCase(E,S)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function T(S){switch(S){case y.Error:return A;case y.Warning:return C;case y.Info:return E;default:return P}}y.toString=T}(i||(i={})),e.default=i}),define(Ie[12],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(c){return Array.isArray(c)}e.isArray=u;function i(c){return typeof c=="string"}e.isString=i;function y(c){return Array.isArray(c)&&c.every(l=>i(l))}e.isStringArray=y;function A(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=A;function C(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=C;function D(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=D;function E(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=E;function P(c){return c===!0||c===!1}e.isBoolean=P;function L(c){return typeof c=="undefined"}e.isUndefined=L;function T(c){return!S(c)}e.isDefined=T;function S(c){return L(c)||c===null}e.isUndefinedOrNull=S;function I(c,l){if(!c)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=I;function _(c){if(S(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=_;function g(...c){const l=[];for(let d=0;d<c.length;d++){const w=c[d];if(S(w))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);l.push(w)}return l}e.assertAllDefined=g;const v=Object.prototype.hasOwnProperty;function p(c){if(!A(c))return!1;for(let l in c)if(v.call(c,l))return!1;return!0}e.isEmptyObject=p;function b(c){return typeof c=="function"}e.isFunction=b;function f(...c){return c.length>0&&c.every(b)}e.areFunctions=f;function a(c,l){const d=Math.min(c.length,l.length);for(let w=0;w<d;w++)m(c[w],l[w])}e.validateConstraints=a;function m(c,l){if(i(l)){if(typeof c!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(b(l)){try{if(c instanceof l)return}catch{}if(!S(c)&&c.constructor===l||l.length===1&&l.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function o(c){let l=[],d=Object.getPrototypeOf(c);for(;Object.prototype!==d;)l=l.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return l}e.getAllPropertyNames=o;function h(c){const l=[];for(const d of o(c))typeof c[d]=="function"&&l.push(d);return l}e.getAllMethodNames=h;function r(c,l){const d=R=>function(){const F=Array.prototype.slice.call(arguments,0);return l(R,F)};let w={};for(const R of c)w[R]=d(R);return w}e.createProxyObject=r;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function n(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=n;function t(c,l="Unreachable"){throw new Error(l)}e.assertNever=t}),define(Ie[30],Te([1,0,9,13,8,12]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(n){return n===47||n===92}e.isPathSeparator=C;function D(n){return n.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=D;function E(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=E;function P(n,t=u.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(C(l)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let w=3;const R=w;for(;w<c&&!C(n.charCodeAt(w));w++);if(R!==w&&!C(n.charCodeAt(w+1))){for(w+=1;w<c;w++)if(C(n.charCodeAt(w)))return n.slice(0,w+1).replace(/[\\/]/g,t)}}return t}else if(p(l)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let d=n.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(C(n.charCodeAt(d)))return n.slice(0,d+1)}return""}e.getRoot=P;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let c=2;const l=c;for(;c<n.length&&(t=n.charCodeAt(c),t!==92);c++);return!(l===c||(t=n.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(n,t=i.isWindows){const c=t?T:S;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||t&&I.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=_;function g(n,t,c){const l=n===t;return!c||l?l:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=g;function v(n,t,c,l=u.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let w=t.length;return t.charAt(t.length-1)===l&&w--,n.charAt(w)===l}return t.charAt(t.length-1)!==l&&(t+=l),n.indexOf(t)===0}e.isEqualOrParent=v;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function b(n,t){return i.isWindows&&n.endsWith(":")&&(n+=u.sep),(0,u.isAbsolute)(n)||(n=(0,u.join)(t,n)),n=(0,u.normalize)(n),i.isWindows?(n=(0,y.rtrim)(n,u.sep),n.endsWith(":")&&(n+=u.sep)):(n=(0,y.rtrim)(n,u.sep),n||(n=u.sep)),n}e.sanitizeFilePath=b;function f(n){const t=(0,u.normalize)(n);return i.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===u.posix.sep}e.isRootOrDriveLetter=f;function a(n,t=i.isWindows){return t?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function m(n){return a(n)?n[0]:void 0}e.getDriveLetter=m;function o(n,t,c){return t.length>n.length?-1:n===t?0:(c&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=o;function h(n){const t=n.split(":");let c,l,d;for(const w of t){const R=Number(w);(0,A.isNumber)(R)?l===void 0?l=R:d===void 0&&(d=R):c=c?[c,w].join(":"):w}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:d!==void 0?d:l!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,c=8){let l="";for(let w=0;w<c;w++)l+=r.charAt(Math.floor(Math.random()*r.length));let d;return t?d=`${t}-${l}`:d=l,n?(0,u.join)(n,d):d}e.randomPath=s}),define(Ie[24],Te([1,0,12]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const v=Array.isArray(g)?[]:{};return Object.keys(g).forEach(p=>{g[p]&&typeof g[p]=="object"?v[p]=i(g[p]):v[p]=g[p]}),v}e.deepClone=i;function y(g){if(!g||typeof g!="object")return g;const v=[g];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const b in p)if(A.call(p,b)){const f=p[b];typeof f=="object"&&!Object.isFrozen(f)&&!(0,u.isTypedArray)(f)&&v.push(f)}}return g}e.deepFreeze=y;const A=Object.prototype.hasOwnProperty;function C(g,v){return D(g,v,new Set)}e.cloneAndChange=C;function D(g,v,p){if((0,u.isUndefinedOrNull)(g))return g;const b=v(g);if(typeof b!="undefined")return b;if((0,u.isArray)(g)){const f=[];for(const a of g)f.push(D(a,v,p));return f}if((0,u.isObject)(g)){if(p.has(g))throw new Error("Cannot clone recursive data-structure");p.add(g);const f={};for(let a in g)A.call(g,a)&&(f[a]=D(g[a],v,p));return p.delete(g),f}return g}function E(g,v,p=!0){return(0,u.isObject)(g)?((0,u.isObject)(v)&&Object.keys(v).forEach(b=>{b in g?p&&((0,u.isObject)(g[b])&&(0,u.isObject)(v[b])?E(g[b],v[b],p):g[b]=v[b]):g[b]=v[b]}),g):v}e.mixin=E;function P(g,v){if(g===v)return!0;if(g==null||v===null||v===void 0||typeof g!=typeof v||typeof g!="object"||Array.isArray(g)!==Array.isArray(v))return!1;let p,b;if(Array.isArray(g)){if(g.length!==v.length)return!1;for(p=0;p<g.length;p++)if(!P(g[p],v[p]))return!1}else{const f=[];for(b in g)f.push(b);f.sort();const a=[];for(b in v)a.push(b);if(a.sort(),!P(f,a))return!1;for(p=0;p<f.length;p++)if(!P(g[f[p]],v[f[p]]))return!1}return!0}e.equals=P;function L(g){const v=new Set;return JSON.stringify(g,(p,b)=>{if((0,u.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=L;function T(g,v,p){const b=v(g);return typeof b=="undefined"?p:b}e.getOrDefault=T;function S(g,v){const p=Object.create(null);return!g||!v||Object.keys(v).forEach(f=>{const a=g[f],m=v[f];P(a,m)||(p[f]=m)}),p}e.distinct=S;function I(g,v){const p=v.toLowerCase(),b=Object.keys(g).find(f=>f.toLowerCase()===p);return b?g[b]:g[v]}e.getCaseInsensitive=I;function _(g,v){const p=Object.create(null);for(const[b,f]of Object.entries(g))v(b,f)&&(p[b]=f);return p}e.filter=_}),define(Ie[99],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function i(A){return A<0?0:A>255?255:A|0}e.toUint8=i;function y(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=y}),define(Ie[2],Te([1,0,9,13]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function D(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!y.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,s){return!r&&!s?"file":r}function P(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==T&&(s=T+s):s=T;break}return s}const L="",T="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(s,n,t,c,l,d=!1){typeof s=="object"?(this.scheme=s.scheme||L,this.authority=s.authority||L,this.path=s.path||L,this.query=s.query||L,this.fragment=s.fragment||L):(this.scheme=E(s,d),this.authority=n||L,this.path=P(this.scheme,t||L),this.query=c||L,this.fragment=l||L,D(this,d))}static isUri(s){return s instanceof I?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:t,path:c,query:l,fragment:d}=s;return n===void 0?n=this.scheme:n===null&&(n=L),t===void 0?t=this.authority:t===null&&(t=L),c===void 0?c=this.path:c===null&&(c=L),l===void 0?l=this.query:l===null&&(l=L),d===void 0?d=this.fragment:d===null&&(d=L),n===this.scheme&&t===this.authority&&c===this.path&&l===this.query&&d===this.fragment?this:new g(n,t,c,l,d)}static parse(s,n=!1){const t=S.exec(s);return t?new g(t[2]||L,h(t[4]||L),h(t[5]||L),h(t[7]||L),h(t[9]||L),n):new g(L,L,L,L,L)}static file(s){let n=L;if(i.isWindows&&(s=s.replace(/\\/g,T)),s[0]===T&&s[1]===T){const t=s.indexOf(T,2);t===-1?(n=s.substring(2),s=T):(n=s.substring(2,t),s=s.substring(t)||T)}return new g("file",n,s,L,L)}static from(s){const n=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return D(n,!0),n}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return i.isWindows&&s.scheme==="file"?t=I.file(u.win32.join(f(s,!0),...n)).path:t=u.posix.join(s.path,...n),s.with({path:t})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof I)return s;{const n=new g(s);return n._formatted=s.external,n._fsPath=s._sep===_?s.fsPath:null,n}}else return s}}e.URI=I;const _=i.isWindows?1:void 0;class g extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=_),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,s){let n,t=-1;for(let c=0;c<r.length;c++){const l=r.charCodeAt(c);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47)t!==-1&&(n+=encodeURIComponent(r.substring(t,c)),t=-1),n!==void 0&&(n+=r.charAt(c));else{n===void 0&&(n=r.substr(0,c));const d=v[l];d!==void 0?(t!==-1&&(n+=encodeURIComponent(r.substring(t,c)),t=-1),n+=d):t===-1&&(t=c)}}return t!==-1&&(n+=encodeURIComponent(r.substring(t))),n!==void 0?n:r}function b(r){let s;for(let n=0;n<r.length;n++){const t=r.charCodeAt(n);t===35||t===63?(s===void 0&&(s=r.substr(0,n)),s+=v[t]):s!==void 0&&(s+=r[n])}return s!==void 0?s:r}function f(r,s){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=f;function a(r,s){const n=s?b:p;let t="",{scheme:c,authority:l,path:d,query:w,fragment:R}=r;if(c&&(t+=c,t+=":"),(l||c==="file")&&(t+=T,t+=T),l){let F=l.indexOf("@");if(F!==-1){const O=l.substr(0,F);l=l.substr(F+1),F=O.indexOf(":"),F===-1?t+=n(O,!1):(t+=n(O.substr(0,F),!1),t+=":",t+=n(O.substr(F+1),!1)),t+="@"}l=l.toLowerCase(),F=l.indexOf(":"),F===-1?t+=n(l,!1):(t+=n(l.substr(0,F),!1),t+=l.substr(F))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const F=d.charCodeAt(1);F>=65&&F<=90&&(d=`/${String.fromCharCode(F+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const F=d.charCodeAt(0);F>=65&&F<=90&&(d=`${String.fromCharCode(F+32)}:${d.substr(2)}`)}t+=n(d,!0)}return w&&(t+="?",t+=n(w,!1)),R&&(t+="#",t+=s?R:p(R,!1)),t}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(r){return r.match(o)?r.replace(o,s=>m(s)):r}}),define(Ie[62],Te([1,0,23,8,2]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,D)}e.stringify=A;function C(P){let L=JSON.parse(P);return L=E(L),L}e.parse=C;function D(P,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,i.regExpFlags)(L)}:L}function E(P,L=0){if(!P||L>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return y.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof u.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let T=0;T<P.length;++T)P[T]=E(P[T],L+1);else for(const T in P)Object.hasOwnProperty.call(P,T)&&(P[T]=E(P[T],L+1))}return P}e.revive=E}),define(Ie[10],Te([1,0,13,2]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${y.vscodeRemoteResource}`}set(E,P,L){this._hosts[E]=P,this._ports[E]=L}setConnectionToken(E,P){this._connectionTokens[E]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const P=E.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const T=this._ports[P],S=this._connectionTokens[P];let I=`path=${encodeURIComponent(E.path)}`;return typeof S=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),i.URI.from({scheme:u.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${T}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new A;class C{asBrowserUri(E,P){const L=this.toUri(E,P);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${y.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(E,P){const L=this.toUri(E,P);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==C.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(E,P){return i.URI.isUri(E)?E:i.URI.parse(P.toUrl(E))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(Ie[22],Te([1,0,30,10,9,13,8,2]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(I){return(0,D.uriToFsPath)(I,!0)}e.originalFSPath=E;class P{constructor(_){this._ignorePathCasing=_}compare(_,g,v=!1){return _===g?0:(0,C.compare)(this.getComparisonKey(_,v),this.getComparisonKey(g,v))}isEqual(_,g,v=!1){return _===g?!0:!_||!g?!1:this.getComparisonKey(_,v)===this.getComparisonKey(g,v)}getComparisonKey(_,g=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,g,v=!1){if(_.scheme===g.scheme){if(_.scheme===i.Schemas.file)return u.isEqualOrParent(E(_),E(g),this._ignorePathCasing(_))&&_.query===g.query&&(v||_.fragment===g.fragment);if((0,e.isEqualAuthority)(_.authority,g.authority))return u.isEqualOrParent(_.path,g.path,this._ignorePathCasing(_),"/")&&_.query===g.query&&(v||_.fragment===g.fragment)}return!1}joinPath(_,...g){return D.URI.joinPath(_,...g)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return y.posix.basename(_.path)}extname(_){return y.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let g;return _.scheme===i.Schemas.file?g=D.URI.file(y.dirname(E(_))).path:(g=y.posix.dirname(_.path),_.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),g="/")),_.with({path:g})}normalizePath(_){if(!_.path.length)return _;let g;return _.scheme===i.Schemas.file?g=D.URI.file(y.normalize(E(_))).path:g=y.posix.normalize(_.path),_.with({path:g})}relativePath(_,g){if(_.scheme!==g.scheme||!(0,e.isEqualAuthority)(_.authority,g.authority))return;if(_.scheme===i.Schemas.file){const b=y.relative(E(_),E(g));return A.isWindows?u.toSlashes(b):b}let v=_.path||"/",p=g.path||"/";if(this._ignorePathCasing(_)){let b=0;for(const f=Math.min(v.length,p.length);b<f&&!(v.charCodeAt(b)!==p.charCodeAt(b)&&v.charAt(b).toLowerCase()!==p.charAt(b).toLowerCase());b++);v=p.substr(0,b)+v.substr(b)}return y.posix.relative(v,p)}resolvePath(_,g){if(_.scheme===i.Schemas.file){const v=D.URI.file(y.resolve(E(_),g));return _.with({authority:v.authority,path:v.path})}return g=u.toPosixPath(g),_.with({path:y.posix.resolve(_.path,g)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,g){return _===g||_!==void 0&&g!==void 0&&(0,C.equalsIgnoreCase)(_,g)}hasTrailingPathSeparator(_,g=y.sep){if(_.scheme===i.Schemas.file){const v=E(_);return v.length>u.getRoot(v).length&&v[v.length-1]===g}else{const v=_.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,g=y.sep){return(0,e.hasTrailingPathSeparator)(_,g)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,g=y.sep){let v=!1;if(_.scheme===i.Schemas.file){const p=E(_);v=p!==void 0&&p.length===u.getRoot(p).length&&p[p.length-1]===g}else{g="/";const p=_.path;v=p.length===1&&p.charCodeAt(p.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(_,g)?_.with({path:_.path+"/"}):_}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(I=>I.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,_){const g=[];for(let v=0;v<I.length;v++){const p=_(I[v]);I.some((b,f)=>f===v?!1:(0,e.isEqualOrParent)(p,_(b)))||g.push(I[v])}return g}e.distinctParents=L;var T;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function _(g){const v=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,m]=f.split(":");a&&m&&v.set(a,m)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&v.set(I.META_DATA_MIME,b),v}I.parseMetaData=_})(T=e.DataUri||(e.DataUri={}));function S(I,_,g){if(_){let v=I.path;return v&&v[0]!==y.posix.sep&&(v=y.posix.sep+v),I.with({scheme:g,authority:_,path:v})}return I.with({scheme:g})}e.toLocalResource=S}),define(Ie[17],Te([1,0,21,11,3,6,22,13]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=E;function P(ue){const X=new u.CancellationTokenSource,ge=ue(X.token),Se=new Promise((oe,_e)=>{const Pe=X.token.onCancellationRequested(()=>{Pe.dispose(),X.dispose(),_e(new i.CancellationError)});Promise.resolve(ge).then(pe=>{Pe.dispose(),X.dispose(),oe(pe)},pe=>{Pe.dispose(),X.dispose(),_e(pe)})});return new class{cancel(){X.cancel()}then(oe,_e){return Se.then(oe,_e)}catch(oe){return this.then(void 0,oe)}finally(oe){return Se.finally(oe)}}}e.createCancelablePromise=P;function L(ue,X,ge){return new Promise((Se,oe)=>{const _e=X.onCancellationRequested(()=>{_e.dispose(),Se(ge)});ue.then(Se,oe).finally(()=>_e.dispose())})}e.raceCancellation=L;function T(ue,X){return new Promise((ge,Se)=>{const oe=X.onCancellationRequested(()=>{oe.dispose(),Se(new i.CancellationError)});ue.then(ge,Se).finally(()=>oe.dispose())})}e.raceCancellationError=T;async function S(ue){let X=-1;const ge=ue.map((oe,_e)=>oe.then(Pe=>(X=_e,Pe))),Se=await Promise.race(ge);return ue.forEach((oe,_e)=>{_e!==X&&oe.cancel()}),Se}e.raceCancellablePromises=S;function I(ue,X,ge){let Se;const oe=setTimeout(()=>{Se?.(void 0),ge?.()},X);return Promise.race([ue.finally(()=>clearTimeout(oe)),new Promise(_e=>Se=_e)])}e.raceTimeout=I;function _(ue){return new Promise((X,ge)=>{const Se=ue();E(Se)?Se.then(X,ge):X(Se)})}e.asPromise=_;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(X){if(this.activePromise){if(this.queuedPromiseFactory=X,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(ge,ge).then(Se)})}return new Promise((ge,Se)=>{this.queuedPromise.then(ge,Se)})}return this.activePromise=X(),new Promise((ge,Se)=>{this.activePromise.then(oe=>{this.activePromise=null,ge(oe)},oe=>{this.activePromise=null,Se(oe)})})}}e.Throttler=g;class v{constructor(){this.current=Promise.resolve(null)}queue(X){return this.current=this.current.then(()=>X(),()=>X())}}e.Sequencer=v;class p{constructor(){this.promiseMap=new Map}queue(X,ge){const oe=(this.promiseMap.get(X)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(X)===oe&&this.promiseMap.delete(X)});return this.promiseMap.set(X,oe),oe}}e.SequencerByKey=p;const b=(ue,X)=>{let ge=!0;const Se=setTimeout(()=>{ge=!1,X()},ue);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Se),ge=!1}}},f=ue=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ue())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(X){this.defaultDelay=X,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(X,ge=this.defaultDelay){this.task=X,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((oe,_e)=>{this.doResolve=oe,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const oe=this.task;return this.task=null,oe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?f(Se):b(ge,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class m{constructor(X){this.delayer=new a(X),this.throttler=new g}trigger(X,ge){return this.delayer.trigger(()=>this.throttler.queue(X),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class o{constructor(){this._isOpen=!1,this._promise=new Promise((X,ge)=>{this._completePromise=X})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class h extends o{constructor(X){super();this._timeout=setTimeout(()=>this.open(),X)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function r(ue,X){return X?new Promise((ge,Se)=>{const oe=setTimeout(()=>{_e.dispose(),ge()},ue),_e=X.onCancellationRequested(()=>{clearTimeout(oe),_e.dispose(),Se(new i.CancellationError)})}):P(ge=>r(ue,ge))}e.timeout=r;function s(ue,X=0){const ge=setTimeout(ue,X);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=s;function n(ue){const X=[];let ge=0;const Se=ue.length;function oe(){return ge<Se?ue[ge++]():null}function _e(Pe){Pe!=null&&X.push(Pe);const pe=oe();return pe?pe.then(_e):Promise.resolve(X)}return Promise.resolve(null).then(_e)}e.sequence=n;function t(ue,X=Se=>!!Se,ge=null){let Se=0;const oe=ue.length,_e=()=>{if(Se>=oe)return Promise.resolve(ge);const Pe=ue[Se++];return Promise.resolve(Pe()).then(ve=>X(ve)?Promise.resolve(ve):_e())};return _e()}e.first=t;function c(ue,X=Se=>!!Se,ge=null){if(ue.length===0)return Promise.resolve(ge);let Se=ue.length;const oe=()=>{Se=-1;for(const _e of ue)_e.cancel?.()};return new Promise((_e,Pe)=>{for(const pe of ue)pe.then(ve=>{--Se>=0&&X(ve)?(oe(),_e(ve)):Se===0&&_e(ge)}).catch(ve=>{--Se>=0&&(oe(),Pe(ve))})})}e.firstParallel=c;class l{constructor(X){this._size=0,this.maxDegreeOfParalellism=X,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(X){return this._size++,new Promise((ge,Se)=>{this.outstandingPromises.push({factory:X,c:ge,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const X=this.outstandingPromises.shift();this.runningPromises++;const ge=X.factory();ge.then(X.c,X.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class d extends l{constructor(){super(1)}}e.Queue=d;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const X=new j;return this.drainers.add(X),X.p}isDrained(){for(const[,X]of this.queues)if(X.size>0)return!1;return!0}queueFor(X,ge=C.extUri){const Se=ge.getComparisonKey(X);let oe=this.queues.get(Se);return oe||(oe=new d,y.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,oe)),oe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const X of this.drainers)X.complete();this.drainers.clear()}dispose(){for(const[,X]of this.queues)X.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class R{constructor(X,ge){this._token=-1,typeof X=="function"&&typeof ge=="number"&&this.setIfNotSet(X,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(X,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,X()},ge)}setIfNotSet(X,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,X()},ge))}}e.TimeoutTimer=R;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(X,ge){this.cancel(),this._token=setInterval(()=>{X()},ge)}}e.IntervalTimer=F;class O{constructor(X,ge){this.timeoutToken=-1,this.runner=X,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(X=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,X)}get delay(){return this.timeout}set delay(X){this.timeout=X}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class k{constructor(X,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=X,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(X=this.timeout){X%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(X/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class B extends O{constructor(X,ge){super(X,ge);this.units=[]}work(X){this.units.push(X),this.isScheduled()||this.schedule()}doRun(){const X=this.units;this.units=[],this.runner&&this.runner(X)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class M extends A.Disposable{constructor(X,ge){super();this.options=X,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(X){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+X.length>this.options.maxBufferedWork)return!1}else if(this.pending+X.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...X),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,D.setTimeout0)(()=>{if(X)return;const ge=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.runWhenIdle=(ue,X)=>{const ge=requestIdleCallback(ue,typeof X=="number"?{timeout:X}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(ge))}}}}();class W{constructor(X){this._didRun=!1,this._executor=()=>{try{this._value=X()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function ee(ue,X,ge){let Se;for(let oe=0;oe<ge;oe++)try{return await ue()}catch(_e){Se=_e,await r(X)}throw Se}e.retry=ee;class H{hasPending(X){return this._pending?typeof X=="number"?this._pending.taskId===X:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(X,ge,Se){return this._pending={taskId:X,cancel:()=>Se?.(),promise:ge},ge.then(()=>this.donePending(X),()=>this.donePending(X)),ge}donePending(X){this._pending&&X===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const X=this._next;this._next=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}setNext(X){if(this._next)this._next.run=X;else{let ge,Se;const oe=new Promise((_e,Pe)=>{ge=_e,Se=Pe});this._next={run:X,promise:oe,promiseResolve:ge,promiseReject:Se}}return this._next.promise}}e.TaskSequentializer=H;class N{constructor(X,ge=()=>Date.now()){this.interval=X,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const X=this.nowFn();return X-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=X,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((X,ge)=>{this.completeCallback=X,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(X){return new Promise(ge=>{this.completeCallback(X),this.resolved=!0,ge()})}error(X){return new Promise(ge=>{this.errorCallback(X),this.rejected=!0,ge()})}cancel(){new Promise(X=>{this.errorCallback(new i.CancellationError),this.rejected=!0,X()})}}e.DeferredPromise=j;var x;(function(ue){async function X(Se){let oe;const _e=await Promise.all(Se.map(Pe=>Pe.then(pe=>pe,pe=>{oe||(oe=pe)})));if(typeof oe!="undefined")throw oe;return _e}ue.settled=X;function ge(Se){return new Promise(async(oe,_e)=>{try{await Se(oe,_e)}catch(Pe){_e(Pe)}})}ue.withAsyncBody=ge})(x=e.Promises||(e.Promises={}));var q;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(q||(q={}));class ie{constructor(X){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ge={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(X(ge)),this.resolve()}catch(Se){this.reject(Se)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(X){return new ie(ge=>{ge.emitMany(X)})}static fromPromise(X){return new ie(async ge=>{ge.emitMany(await X)})}static fromPromises(X){return new ie(async ge=>{await Promise.all(X.map(async Se=>ge.emitOne(await Se)))})}static merge(X){return new ie(async ge=>{await Promise.all(X.map(async Se=>{for await(const oe of Se)ge.emitOne(oe)}))})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(X<this._results.length)return{done:!1,value:this._results[X++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(X,ge){return new ie(async Se=>{for await(const oe of X)Se.emitOne(ge(oe))})}map(X){return ie.map(this,X)}static filter(X,ge){return new ie(async Se=>{for await(const oe of X)ge(oe)&&Se.emitOne(oe)})}filter(X){return ie.filter(this,X)}static coalesce(X){return ie.filter(X,ge=>!!ge)}coalesce(){return ie.coalesce(this)}static async toPromise(X){const ge=[];for await(const Se of X)ge.push(Se);return ge}toPromise(){return ie.toPromise(this)}emitOne(X){this._state===0&&(this._results.push(X),this._onStateChanged.fire())}emitMany(X){this._state===0&&(this._results=this._results.concat(X),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(X){this._state===0&&(this._state=2,this._error=X,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class Q extends ie{constructor(X,ge){super(ge);this._source=X}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function de(ue){const X=new u.CancellationTokenSource,ge=ue(X.token);return new Q(X,async Se=>{const oe=X.token.onCancellationRequested(()=>{oe.dispose(),X.dispose(),Se.reject(new i.CancellationError)});try{for await(const _e of ge){if(X.token.isCancellationRequested)return;Se.emitOne(_e)}oe.dispose(),X.dispose()}catch(_e){oe.dispose(),X.dispose(),Se.reject(_e)}})}e.createCancelableAsyncIterable=de}),define(Ie[100],Te([1,0,17,9]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new u.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(d,w,R=!1){const F=d||"",O=w||"",k=y.value.collator.compare(F,O);return y.value.collatorIsNumeric&&k===0&&F!==O?F<O?-1:1:k}e.compareFileNames=D;function E(d,w){const R=A.value.collator;return d=d||"",w=w||"",m(R,d,w)}e.compareFileNamesDefault=E;function P(d,w){const R=A.value.collator;return d=d||"",w=w||"",s(d,w)||m(R,d,w)}e.compareFileNamesUpper=P;function L(d,w){const R=A.value.collator;return d=d||"",w=w||"",r(d,w)||m(R,d,w)}e.compareFileNamesLower=L;function T(d,w){return d=d||"",w=w||"",d===w?0:d<w?-1:1}e.compareFileNamesUnicode=T;function S(d,w,R=!1){R||(d=d&&d.toLowerCase(),w=w&&w.toLowerCase());const[F,O]=f(d),[k,B]=f(w);return F!==k?F<k?-1:1:O===B?0:O<B?-1:1}e.noIntlCompareFileNames=S;function I(d,w){const[R,F]=f(d),[O,k]=f(w);let B=y.value.collator.compare(F,k);if(B===0){if(y.value.collatorIsNumeric&&F!==k)return F<k?-1:1;if(B=y.value.collator.compare(R,O),y.value.collatorIsNumeric&&B===0&&R!==O)return R<O?-1:1}return B}e.compareFileExtensions=I;function _(d,w){d=d||"",w=w||"";const R=a(d),F=a(w),O=A.value.collator,k=C.value.collator;return m(k,R,F)||m(O,d,w)}e.compareFileExtensionsDefault=_;function g(d,w){d=d||"",w=w||"";const R=a(d),F=a(w),O=A.value.collator,k=C.value.collator;return m(k,R,F)||s(d,w)||m(O,d,w)}e.compareFileExtensionsUpper=g;function v(d,w){d=d||"",w=w||"";const R=a(d),F=a(w),O=A.value.collator,k=C.value.collator;return m(k,R,F)||r(d,w)||m(O,d,w)}e.compareFileExtensionsLower=v;function p(d,w){d=d||"",w=w||"";const R=a(d).toLowerCase(),F=a(w).toLowerCase();return R!==F?R<F?-1:1:d!==w?d<w?-1:1:0}e.compareFileExtensionsUnicode=p;const b=/^(.*?)(\.([^.]*))?$/;function f(d,w=!1){const R=d?b.exec(d):[];let F=[R&&R[1]||"",R&&R[3]||""];return w&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function a(d){const w=d?b.exec(d):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function m(d,w,R){let F=d.compare(w,R);return F!==0?F:w.length!==R.length?w.length<R.length?-1:1:0}function o(d){const w=d.charAt(0);return w.toLocaleUpperCase()!==w}function h(d){const w=d.charAt(0);return w.toLocaleLowerCase()!==w}function r(d,w){return o(d)&&h(w)?-1:h(d)&&o(w)?1:0}function s(d,w){return h(d)&&o(w)?-1:o(d)&&h(w)?1:0}function n(d,w,R=!1){return R||(d=d&&d.toLowerCase(),w=w&&w.toLowerCase()),d===w?0:d<w?-1:1}function t(d,w,R=!1){const F=d.split(i.sep),O=w.split(i.sep),k=F.length-1,B=O.length-1;let M,W;for(let ee=0;;ee++){if(M=k===ee,W=B===ee,M&&W)return D(F[ee],O[ee],R);if(M)return-1;if(W)return 1;const H=n(F[ee],O[ee],R);if(H!==0)return H}}e.comparePaths=t;function c(d,w,R){const F=d.toLowerCase(),O=w.toLowerCase(),k=l(d,w,R);if(k)return k;const B=F.endsWith(R),M=O.endsWith(R);if(B!==M)return B?-1:1;const W=D(F,O);return W!==0?W:F.localeCompare(O)}e.compareAnything=c;function l(d,w,R){const F=d.toLowerCase(),O=w.toLowerCase(),k=F.startsWith(R),B=O.startsWith(R);if(k!==B)return k?-1:1;if(k&&B){if(F.length<O.length)return-1;if(F.length>O.length)return 1}return 0}e.compareByPrefix=l}),define(Ie[101],Te([1,0,100,98,61,9,13,8]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,P=[E,[]];function L(H,N,j,x){if(!H||!N)return P;const q=H.length,ie=N.length;if(q<ie)return P;const Q=H.toLowerCase();return T(N,j,ie,H,Q,q,x)}e.scoreFuzzy=L;function T(H,N,j,x,q,ie,Q){const de=[],ue=[];for(let oe=0;oe<j;oe++){const _e=oe*ie,Pe=_e-ie,pe=oe>0,ve=H[oe],Ae=N[oe];for(let ce=0;ce<ie;ce++){const me=ce>0,te=_e+ce,ne=te-1,U=Pe+ce-1,$=me?de[ne]:0,G=pe&&me?de[U]:0,K=pe&&me?ue[U]:0;let he;!G&&pe?he=0:he=S(ve,Ae,x,q,ce,K),he&&G+he>=$&&(Q||pe||q.startsWith(N,ce))?(ue[te]=K+1,de[te]=G+he):(ue[te]=E,de[te]=$)}}const X=[];let ge=j-1,Se=ie-1;for(;ge>=0&&Se>=0;){const oe=ge*ie+Se;ue[oe]===E||(X.push(Se),ge--),Se--}return[de[j*ie-1],X.reverse()]}function S(H,N,j,x,q,ie){let Q=0;if(!I(N,x[q]))return Q;if(Q+=1,ie>0&&(Q+=ie*5),H===j[q]&&(Q+=1),q===0)Q+=8;else{const de=_(j.charCodeAt(q-1));de?Q+=de:(0,i.isUpper)(j.charCodeAt(q))&&ie===0&&(Q+=2)}return Q}function I(H,N){return H===N?!0:H==="/"||H==="\\"?N==="/"||N==="\\":!1}function _(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function v(H,N,j=0,x=0){const q=N;return q.values&&q.values.length>1?p(H,q.values,j,x):b(H,N,j,x)}e.scoreFuzzy2=v;function p(H,N,j,x){let q=0;const ie=[];for(const Q of N){const[de,ue]=b(H,Q,j,x);if(typeof de!="number")return g;q+=de,ie.push(...ue)}return[q,l(ie)]}function b(H,N,j,x){const q=(0,i.fuzzyScore)(N.original,N.originalLowercase,j,H,H.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,i.createMatches)(q)]:g}const f=Object.freeze({score:0}),a=1<<18,m=1<<17,o=1<<16;function h(H,N,j,x){const q=x.values?x.values:[x];return(0,y.hash)({[x.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:H,description:N,allowNonContiguousMatches:j}})}function r(H,N,j,x,q){if(!H||!N.normalized)return f;const ie=x.getItemLabel(H);if(!ie)return f;const Q=x.getItemDescription(H),de=h(ie,Q,j,N),ue=q[de];if(ue)return ue;const X=s(ie,Q,x.getItemPath(H),N,j);return q[de]=X,X}e.scoreItemFuzzy=r;function s(H,N,j,x,q){const ie=!j||!x.containsPathSeparator;return j&&(C.isLinux?x.pathNormalized===j:(0,D.equalsIgnoreCase)(x.pathNormalized,j))?{score:a,labelMatch:[{start:0,end:H.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:x.values&&x.values.length>1?n(H,N,j,x.values,ie,q):t(H,N,j,x,ie,q)}function n(H,N,j,x,q,ie){let Q=0;const de=[],ue=[];for(const X of x){const{score:ge,labelMatch:Se,descriptionMatch:oe}=t(H,N,j,X,q,ie);if(ge===E)return f;Q+=ge,Se&&de.push(...Se),oe&&ue.push(...oe)}return{score:Q,labelMatch:l(de),descriptionMatch:l(ue)}}function t(H,N,j,x,q,ie){if(q||!N){const[Q,de]=L(H,x.normalized,x.normalizedLowercase,ie&&!x.expectContiguousMatch);if(Q){const ue=(0,i.matchesPrefix)(x.normalized,H);let X;return ue?(X=m,X+=Math.round(x.normalized.length/H.length*100)):X=o,{score:X+Q,labelMatch:ue||c(de)}}}if(N){let Q=N;j&&(Q=`${N}${A.sep}`);const de=Q.length,ue=`${Q}${H}`,[X,ge]=L(ue,x.normalized,x.normalizedLowercase,ie&&!x.expectContiguousMatch);if(X){const Se=c(ge),oe=[],_e=[];return Se.forEach(Pe=>{Pe.start<de&&Pe.end>de?(oe.push({start:0,end:Pe.end-de}),_e.push({start:Pe.start,end:de})):Pe.start>=de?oe.push({start:Pe.start-de,end:Pe.end-de}):_e.push(Pe)}),{score:X,labelMatch:oe,descriptionMatch:_e}}}return f}function c(H){const N=[];if(!H)return N;let j;for(const x of H)j&&j.end===x?j.end+=1:(j={start:x,end:x+1},N.push(j));return N}function l(H){const N=H.sort((q,ie)=>q.start-ie.start),j=[];let x;for(const q of N)!x||!d(x,q)?(x=q,j.push(q)):(x.start=Math.min(x.start,q.start),x.end=Math.max(x.end,q.end));return j}function d(H,N){return!(H.end<N.start||N.end<H.start)}function w(H,N,j,x,q,ie){const Q=r(H,j,x,q,ie),de=r(N,j,x,q,ie),ue=Q.score,X=de.score;if((ue===a||X===a)&&ue!==X)return ue===a?-1:1;if(ue>o||X>o){if(ue!==X)return ue>X?-1:1;if(ue<m&&X<m){const ve=F(Q.labelMatch,de.labelMatch);if(ve!==0)return ve}const Pe=q.getItemLabel(H)||"",pe=q.getItemLabel(N)||"";if(Pe.length!==pe.length)return Pe.length-pe.length}if(ue!==X)return ue>X?-1:1;const ge=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Se=Array.isArray(de.labelMatch)&&de.labelMatch.length>0;if(ge&&!Se)return-1;if(Se&&!ge)return 1;const oe=R(H,Q,q),_e=R(N,de,q);return oe&&_e&&oe!==_e?_e>oe?-1:1:O(H,N,j,q)}e.compareItemsByFuzzyScore=w;function R(H,N,j){let x=-1,q=-1;if(N.descriptionMatch&&N.descriptionMatch.length?x=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(x=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(q=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const ie=j.getItemDescription(H);ie&&(q+=ie.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(q=N.descriptionMatch[N.descriptionMatch.length-1].end);return q-x}function F(H,N){if(!H&&!N||(!H||!H.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!H||!H.length)return 1;const j=H[0].start,q=H[H.length-1].end-j,ie=N[0].start,de=N[N.length-1].end-ie;return q===de?0:de<q?1:-1}function O(H,N,j,x){const q=x.getItemLabel(H)||"",ie=x.getItemLabel(N)||"",Q=x.getItemDescription(H),de=x.getItemDescription(N),ue=q.length+(Q?Q.length:0),X=ie.length+(de?de.length:0);if(ue!==X)return ue-X;const ge=x.getItemPath(H),Se=x.getItemPath(N);return ge&&Se&&ge.length!==Se.length?ge.length-Se.length:q!==ie?(0,u.compareAnything)(q,ie,j.normalized):Q&&de&&Q!==de?(0,u.compareAnything)(Q,de,j.normalized):ge&&Se&&ge!==Se?(0,u.compareAnything)(ge,Se,j.normalized):0}function k(H){return H.startsWith('"')&&H.endsWith('"')}const B=" ";function M(H){typeof H!="string"&&(H="");const N=H.toLowerCase(),{pathNormalized:j,normalized:x,normalizedLowercase:q}=W(H),ie=j.indexOf(A.sep)>=0,Q=k(H);let de;const ue=H.split(B);if(ue.length>1)for(const X of ue){const ge=k(X),{pathNormalized:Se,normalized:oe,normalizedLowercase:_e}=W(X);oe&&(de||(de=[]),de.push({original:X,originalLowercase:X.toLowerCase(),pathNormalized:Se,normalized:oe,normalizedLowercase:_e,expectContiguousMatch:ge}))}return{original:H,originalLowercase:N,pathNormalized:j,normalized:x,normalizedLowercase:q,values:de,containsPathSeparator:ie,expectContiguousMatch:Q}}e.prepareQuery=M;function W(H){let N;C.isWindows?N=H.replace(/\//g,A.sep):N=H.replace(/\\/g,A.sep);const j=(0,D.stripWildcards)(N).replace(/\s|"/g,"");return{pathNormalized:N,normalized:j,normalizedLowercase:j.toLowerCase()}}function ee(H){return Array.isArray(H)?M(H.map(N=>N.original).join(B)):M(H.original)}e.pieceToQuery=ee}),define(Ie[34],Te([1,0,16,17,30,25,9,13,8]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",T="[^/\\\\]",S=/\//g;function I(j,x){switch(j){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}${x?`|${L}${T}+`:""})*?`}}function _(j,x){if(!j)return[];const q=[];let ie=!1,Q=!1,de="";for(const ue of j){switch(ue){case x:if(!ie&&!Q){q.push(de),de="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=ue}return de&&q.push(de),q}e.splitGlobAware=_;function g(j){if(!j)return"";let x="";const q=_(j,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))x=".*";else{let ie=!1;q.forEach((Q,de)=>{if(Q===e.GLOBSTAR){if(ie)return;x+=I(2,de===q.length-1)}else{let ue=!1,X="",ge=!1,Se="";for(const oe of Q){if(oe!=="}"&&ue){X+=oe;continue}if(ge&&(oe!=="]"||!Se)){let _e;oe==="-"?_e=oe:(oe==="^"||oe==="!")&&!Se?_e="^":oe===e.GLOB_SPLIT?_e="":_e=(0,E.escapeRegExpCharacters)(oe),Se+=_e;continue}switch(oe){case"{":ue=!0;continue;case"[":ge=!0;continue;case"}":{x+=`(?:${_(X,",").map(pe=>g(pe)).join("|")})`,ue=!1,X="";break}case"]":{x+="["+Se+"]",ge=!1,Se="";break}case"?":x+=T;continue;case"*":x+=I(1);continue;default:x+=(0,E.escapeRegExpCharacters)(oe)}}de<q.length-1&&(q[de+1]!==e.GLOBSTAR||de+2<q.length)&&(x+=L)}ie=Q===e.GLOBSTAR})}return x}const v=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),h=function(){return!1},r=function(){return null};function s(j,x){if(!j)return r;let q;typeof j!="string"?q=j.pattern:q=j,q=q.trim();const ie=`${q}_${!!x.trimForExclusions}`;let Q=o.get(ie);if(Q)return n(Q,j);let de;return v.test(q)?Q=c(q.substr(4),q):(de=p.exec(t(q,x)))?Q=l(de[1],q):(x.trimForExclusions?f:b).test(q)?Q=d(q,x):(de=a.exec(t(q,x)))?Q=w(de[1].substr(1),q,!0):(de=m.exec(t(q,x)))?Q=w(de[1],q,!1):Q=R(q),o.set(ie,Q),n(Q,j)}function n(j,x){if(typeof x=="string")return j;const q=function(ie,Q){return(0,y.isEqualOrParent)(ie,x.base,!D.isLinux)?j(ie.substr(x.base.length+1),Q):null};return q.allBasenames=j.allBasenames,q.allPaths=j.allPaths,q.basenames=j.basenames,q.patterns=j.patterns,q}function t(j,x){return x.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function c(j,x){return function(q,ie){return typeof q=="string"&&q.endsWith(j)?x:null}}function l(j,x){const q=`/${j}`,ie=`\\${j}`,Q=function(ue,X){return typeof ue!="string"?null:X?X===j?x:null:ue===j||ue.endsWith(q)||ue.endsWith(ie)?x:null},de=[j];return Q.basenames=de,Q.patterns=[x],Q.allBasenames=de,Q}function d(j,x){const q=H(j.slice(1,-1).split(",").map(X=>s(X,x)).filter(X=>X!==r),j),ie=q.length;if(!ie)return r;if(ie===1)return q[0];const Q=function(X,ge){for(let Se=0,oe=q.length;Se<oe;Se++)if(q[Se](X,ge))return j;return null},de=q.find(X=>!!X.allBasenames);de&&(Q.allBasenames=de.allBasenames);const ue=q.reduce((X,ge)=>ge.allPaths?X.concat(ge.allPaths):X,[]);return ue.length&&(Q.allPaths=ue),Q}function w(j,x,q){const ie=C.sep===C.posix.sep,Q=ie?j:j.replace(S,C.sep),de=C.sep+Q,ue=C.posix.sep+j;let X;return q?X=function(ge,Se){return typeof ge=="string"&&(ge===Q||ge.endsWith(de)||!ie&&(ge===j||ge.endsWith(ue)))?x:null}:X=function(ge,Se){return typeof ge=="string"&&(ge===Q||!ie&&ge===j)?x:null},X.allPaths=[(q?"*/":"./")+j],X}function R(j){try{const x=new RegExp(`^${g(j)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?j:null}}catch{return r}}function F(j,x,q){return!j||typeof x!="string"?!1:O(j)(x,void 0,q)}e.match=F;function O(j,x={}){if(!j)return h;if(typeof j=="string"||k(j)){const q=s(j,x);if(q===r)return h;const ie=function(Q,de){return!!q(Q,de)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return W(j,x)}e.parse=O;function k(j){const x=j;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=k;function B(j){return j.allBasenames||[]}e.getBasenameTerms=B;function M(j){return j.allPaths||[]}e.getPathTerms=M;function W(j,x){const q=H(Object.getOwnPropertyNames(j).map(X=>ee(X,j[X],x)).filter(X=>X!==r)),ie=q.length;if(!ie)return r;if(!q.some(X=>!!X.requiresSiblings)){if(ie===1)return q[0];const X=function(oe,_e){let Pe;for(let pe=0,ve=q.length;pe<ve;pe++){const Ae=q[pe](oe,_e);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Pe||(Pe=[]),Pe.push(Ae))}return Pe?(async()=>{for(const pe of Pe){const ve=await pe;if(typeof ve=="string")return ve}return null})():null},ge=q.find(oe=>!!oe.allBasenames);ge&&(X.allBasenames=ge.allBasenames);const Se=q.reduce((oe,_e)=>_e.allPaths?oe.concat(_e.allPaths):oe,[]);return Se.length&&(X.allPaths=Se),X}const Q=function(X,ge,Se){let oe,_e;for(let Pe=0,pe=q.length;Pe<pe;Pe++){const ve=q[Pe];ve.requiresSiblings&&Se&&(ge||(ge=(0,C.basename)(X)),oe||(oe=ge.substr(0,ge.length-(0,C.extname)(X).length)));const Ae=ve(X,ge,oe,Se);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(_e||(_e=[]),_e.push(Ae))}return _e?(async()=>{for(const Pe of _e){const pe=await Pe;if(typeof pe=="string")return pe}return null})():null},de=q.find(X=>!!X.allBasenames);de&&(Q.allBasenames=de.allBasenames);const ue=q.reduce((X,ge)=>ge.allPaths?X.concat(ge.allPaths):X,[]);return ue.length&&(Q.allPaths=ue),Q}function ee(j,x,q){if(x===!1)return r;const ie=s(j,q);if(ie===r)return r;if(typeof x=="boolean")return ie;if(x){const Q=x.when;if(typeof Q=="string"){const de=(ue,X,ge,Se)=>{if(!Se||!ie(ue,X))return null;const oe=Q.replace("$(basename)",ge),_e=Se(oe);return(0,i.isThenable)(_e)?_e.then(Pe=>Pe?j:null):_e?j:null};return de.requiresSiblings=!0,de}}return ie}function H(j,x){const q=j.filter(X=>!!X.basenames);if(q.length<2)return j;const ie=q.reduce((X,ge)=>{const Se=ge.basenames;return Se?X.concat(Se):X},[]);let Q;if(x){Q=[];for(let X=0,ge=ie.length;X<ge;X++)Q.push(x)}else Q=q.reduce((X,ge)=>{const Se=ge.patterns;return Se?X.concat(Se):X},[]);const de=function(X,ge){if(typeof X!="string")return null;if(!ge){let oe;for(oe=X.length;oe>0;oe--){const _e=X.charCodeAt(oe-1);if(_e===47||_e===92)break}ge=X.substr(oe)}const Se=ie.indexOf(ge);return Se!==-1?Q[Se]:null};de.basenames=ie,de.patterns=Q,de.allBasenames=ie;const ue=j.filter(X=>!X.basenames);return ue.push(de),ue}function N(j,x){return(0,u.equals)(j,x,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}e.patternsEquals=N}),define(Ie[102],Te([1,0,11,146,22,8,2]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(v="",p=!1){if(this.value=v,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(v,p=0){return this.value+=S(this.supportThemeIcons?(0,i.escapeIcons)(v):v).replace(/([ \t]+)/g,(b,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,p){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(v,p,b){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(v),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(v,p){const b=new RegExp((0,A.escapeRegExpCharacters)(p),"g");return v.replace(b,(f,a)=>v.charAt(a-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=E;function P(g){return L(g)?!g.value:Array.isArray(g)?g.every(P):!0}e.isEmptyMarkdownString=P;function L(g){return g instanceof E?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function T(g,v){return g===v?!0:!g||!v?!1:g.value===v.value&&g.isTrusted===v.isTrusted&&g.supportThemeIcons===v.supportThemeIcons&&g.supportHtml===v.supportHtml&&(g.baseUri===v.baseUri||!!g.baseUri&&!!v.baseUri&&(0,y.isEqual)(C.URI.from(g.baseUri),C.URI.from(v.baseUri)))}e.markdownStringEqual=T;function S(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function I(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=I;function _(g){const v=[],p=g.split("|").map(f=>f.trim());g=p[0];const b=p[1];if(b){const f=/height=(\d+)/.exec(b),a=/width=(\d+)/.exec(b),m=f?f[1]:"",o=a?a[1]:"",h=isFinite(parseInt(o)),r=isFinite(parseInt(m));h&&v.push(`width="${o}"`),r&&v.push(`height="${m}"`)}return{href:g,dimensions:v}}e.parseHrefAndDimensions=_}),define(Ie[103],Te([1,0,16,30,10,9,13,22,8,2]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(t,c){const{os:l,tildify:d,relative:w}=c;if(w){const O=T(t,w,l);if(typeof O=="string")return O}let R=t.fsPath;if(l===1&&!C.isWindows?R=R.replace(/\//g,"\\"):l!==1&&C.isWindows&&(R=R.replace(/\\/g,"/")),l!==1&&d?.userHome){let O=d.userHome.fsPath,k;t.scheme!==d.userHome.scheme&&t.path.startsWith(A.posix.sep)?k=d.userHome.with({path:t.path}).fsPath:k=t.fsPath,R=g(k,O,l)}return(l===1?A.win32:A.posix).normalize(I(R,l===1))}e.getPathLabel=L;function T(t,c,l){const d=l===1?A.win32:A.posix,w=l===3?D.extUri:D.extUriIgnorePathCase,R=c.getWorkspace(),F=(0,u.firstOrDefault)(R.folders);if(!F)return;t.scheme!==F.uri.scheme&&t.path.startsWith(A.posix.sep)&&(t=F.uri.with({path:t.path}));const O=c.getWorkspaceFolder(t);if(!O)return;let k;if(w.isEqual(O.uri,t)?k="":k=w.relativePath(O.uri,t)??"",k&&(k=d.normalize(k)),R.folders.length>1&&!c.noPrefix){const B=O.name?O.name:w.basenameOrAuthority(O.uri);k=k?`${B} \u2022 ${k}`:B}return k}function S(t){if(!t)return;typeof t=="string"&&(t=P.URI.file(t));const c=(0,D.basename)(t)||(t.scheme===y.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,i.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=S;function I(t,c=C.isWindows){return(0,i.hasDriveLetter)(t,c)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let _=Object.create(null);function g(t,c,l=C.OS){if(l===1||!t||!c)return t;let d=_.original===c?_.normalized:void 0;d||(d=c,C.isWindows&&(d=(0,i.toSlashes)(d)),d=`${(0,E.rtrim)(d,A.posix.sep)}${A.posix.sep}`,_={original:c,normalized:d});let w=t;return C.isWindows&&(w=(0,i.toSlashes)(w)),(l===3?w.startsWith(d):(0,E.startsWithIgnoreCase)(w,d))?`~/${w.substr(d.length)}`:t}e.tildify=g;function v(t,c){return t.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=v;const p="\u2026",b="\\\\",f="~";function a(t,c=A.sep){const l=new Array(t.length);let d=!1;for(let w=0;w<t.length;w++){let R=t[w];if(R===""){l[w]=`.${c}`;continue}if(!R){l[w]=R;continue}d=!0;let F="",O=R;O.indexOf(b)===0?(F=O.substr(0,O.indexOf(b)+b.length),O=O.substr(O.indexOf(b)+b.length)):O.indexOf(c)===0?(F=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(f)===0&&(F=O.substr(0,O.indexOf(f)+f.length),O=O.substr(O.indexOf(f)+f.length));const k=O.split(c);for(let B=1;d&&B<=k.length;B++)for(let M=k.length-B;d&&M>=0;M--){d=!1;let W=k.slice(M,M+B).join(c);for(let ee=0;!d&&ee<t.length;ee++)if(ee!==w&&t[ee]&&t[ee].indexOf(W)>-1){const H=M+B===k.length,N=M>0&&t[ee].indexOf(c)>-1?c+W:W,j=t[ee].endsWith(N);d=!H||j}if(!d){let ee="";(k[0].endsWith(":")||F!=="")&&(M===1&&(M=0,B++,W=k[0]+c+W),M>0&&(ee=k[0]+c),ee=F+ee),M>0&&(ee=ee+p+c),ee=ee+W,M+B<k.length&&(ee=ee+c+p),l[w]=ee}}d&&(l[w]=R)}return l}e.shorten=a;var m;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function o(t,c=Object.create(null)){const l=[];let d=!1,w="";for(const R of t)if(R==="$"||d&&R==="{")w&&l.push({value:w,type:m.TEXT}),w="",d=!0;else if(R==="}"&&d){const F=c[w];if(typeof F=="string")F.length&&l.push({value:F,type:m.VARIABLE});else if(F){const O=l[l.length-1];(!O||O.type!==m.SEPARATOR)&&l.push({value:F.label,type:m.SEPARATOR})}w="",d=!1}else w+=R;return w&&!d&&l.push({value:w,type:m.TEXT}),l.filter((R,F)=>{if(R.type===m.SEPARATOR){const O=l[F-1],k=l[F+1];return[O,k].every(B=>B&&(B.type===m.VARIABLE||B.type===m.TEXT)&&B.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function h(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function r(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function s(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(t){const c=t.indexOf("/")!==-1?A.posix:A.win32,l=c.basename(t),d=c.dirname(t);return l.length?{name:l,parentPath:d}:{name:d,parentPath:""}}e.splitName=n}),define(Ie[104],Te([1,0,2]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class y{constructor(T){this._uriTransformer=T}transformIncoming(T){const S=this._uriTransformer.transformIncoming(T);return S===T?T:i(u.URI.from(S))}transformOutgoing(T){const S=this._uriTransformer.transformOutgoing(T);return S===T?T:i(u.URI.from(S))}transformOutgoingURI(T){const S=this._uriTransformer.transformOutgoing(T);return S===T?T:u.URI.from(S)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,T,S){if(!L||S>200)return null;if(typeof L=="object"){if(L instanceof u.URI)return T.transformOutgoing(L);for(let I in L)if(Object.hasOwnProperty.call(L,I)){const _=A(L[I],T,S+1);_!==null&&(L[I]=_)}}return null}function C(L,T){const S=A(L,T,0);return S===null?L:S}e.transformOutgoingURIs=C;function D(L,T,S,I){if(!L||I>200)return null;if(typeof L=="object"){if(L.$mid===1)return S?u.URI.revive(T.transformIncoming(L)):T.transformIncoming(L);for(let _ in L)if(Object.hasOwnProperty.call(L,_)){const g=D(L[_],T,S,I+1);g!==null&&(L[_]=g)}}return null}function E(L,T){const S=D(L,T,!1,0);return S===null?L:S}e.transformIncomingURIs=E;function P(L,T){const S=D(L,T,!0,0);return S===null?L:S}e.transformAndReviveIncomingURIs=P}),define(Ie[35],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(y){return u.test(y)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let E=0;E<D.length;E++)D[E]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));return function(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let E=0,P="";return P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P+="-",P+=C[A[E++]],P+=C[A[E++]],P+="-",P+=C[A[E++]],P+=C[A[E++]],P+="-",P+=C[A[E++]],P+=C[A[E++]],P+="-",P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P+=C[A[E++]],P}}()}),define(Ie[147],Te([1,0,105]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(A="utf8"){this.stringDecoder=new u.StringDecoder(A),this.remaining=null}write(A){const C=[],D=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(D.length<1)return C;let E=0,P,L=E;for(;L<D.length;)if(P=D.charCodeAt(L),P===13||P===10){if(C.push(D.substring(E,L)),L++,L<D.length){const T=P;P=D.charCodeAt(L),(T===13&&P===10||T===10&&P===13)&&L++}E=L}else L++;return this.remaining=E<D.length?D.substr(E):null,C}end(){return this.remaining}}e.LineDecoder=i}),define(Ie[29],Te([1,0,63,64,298,17,30,82,9,13,22,2]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function I(M,W=S.UNLINK){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===S.UNLINK?g(M):_(M)}async function _(M){try{const W=(0,C.randomPath)((0,i.tmpdir)());try{await u.promises.rename(M,W)}catch{return g(M)}g(W).catch(ee=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function g(M){return(0,y.promisify)(u.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function v(M){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function p(M,W){return a(await(W?b(M):(0,y.promisify)(u.readdir)(M)))}async function b(M){try{return await(0,y.promisify)(u.readdir)(M,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const W=[],ee=await p(M);for(const H of ee){let N=!1,j=!1,x=!1;try{const q=await e.Promises.lstat((0,E.join)(M,H));N=q.isFile(),j=q.isDirectory(),x=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}W.push({name:H,isFile:()=>N,isDirectory:()=>j,isSymbolicLink:()=>x})}return W}function f(M){return a(u.readdirSync(M))}e.readdirSync=f;function a(M){return M.map(W=>typeof W=="string"?P.isMacintosh?(0,D.normalizeNFC)(W):W:(W.name=P.isMacintosh?(0,D.normalizeNFC)(W.name):W.name,W))}async function m(M){const W=await p(M),ee=[];for(const H of W)await h.existsDirectory((0,E.join)(M,H))&&ee.push(H);return ee}function o(M,W=1e3){return new Promise(ee=>{let H=!1;const N=setInterval(()=>{H||(H=!0,u.access(M,j=>{H=!1,j&&(clearInterval(N),ee(void 0))}))},W)})}e.whenDeleted=o;var h;(function(M){async function W(N){let j;try{if(j=await e.Promises.lstat(N),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(N),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(P.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw q}throw x}}M.stat=W;async function ee(N){try{const{stat:j,symbolicLink:x}=await M.stat(N);return j.isFile()&&x?.dangling!==!0}catch{}return!1}M.existsFile=ee;async function H(N){try{const{stat:j,symbolicLink:x}=await M.stat(N);return j.isDirectory()&&x?.dangling!==!0}catch{}return!1}M.existsDirectory=H})(h=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function s(M,W,ee){return r.queueFor(T.URI.file(M),L.extUriBiasedIgnorePathCase).queue(()=>{const H=l(ee);return new Promise((N,j)=>t(M,W,H,x=>x?j(x):N()))})}let n=!0;function t(M,W,ee,H){if(!n)return u.writeFile(M,W,{mode:ee.mode,flag:ee.flag},H);u.open(M,ee.flag,ee.mode,(N,j)=>{if(N)return H(N);u.writeFile(j,W,x=>{if(x)return u.close(j,()=>H(x));u.fdatasync(j,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),n=!1),u.close(j,ie=>H(ie))))})})}function c(M,W,ee){const H=l(ee);if(!n)return u.writeFileSync(M,W,{mode:H.mode,flag:H.flag});const N=u.openSync(M,H.flag,H.mode);try{u.writeFileSync(N,W);try{u.fdatasyncSync(N)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),n=!1}}finally{u.closeSync(N)}}e.writeFileSync=c;function l(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,W){if(M!==W)try{await e.Promises.rename(M,W)}catch(ee){if(M.toLowerCase()!==W.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await w(M,W,{preserveSymlinks:!1}),await I(M,S.MOVE);else throw ee}}async function w(M,W,ee){return F(M,W,{root:{source:M,target:W},options:ee,handledSourcePaths:new Set})}const R=511;async function F(M,W,ee){if(ee.handledSourcePaths.has(M))return;ee.handledSourcePaths.add(M);const{stat:H,symbolicLink:N}=await h.stat(M);if(N){if(ee.options.preserveSymlinks)try{return await B(M,W,ee)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(N.dangling)return}return H.isDirectory()?O(M,W,H.mode&R,ee):k(M,W,H.mode&R)}async function O(M,W,ee,H){await e.Promises.mkdir(W,{recursive:!0,mode:ee});const N=await p(M);for(const j of N)await F((0,E.join)(M,j),(0,E.join)(W,j),H)}async function k(M,W,ee){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,ee)}async function B(M,W,ee){let H=await e.Promises.readlink(M);(0,C.isEqualOrParent)(H,ee.root.source,!P.isLinux)&&(H=(0,E.join)(ee.root.target,H.substr(ee.root.source.length+1))),await e.Promises.symlink(H,W)}e.Promises=new class{get access(){return(0,y.promisify)(u.access)}get stat(){return(0,y.promisify)(u.stat)}get lstat(){return(0,y.promisify)(u.lstat)}get utimes(){return(0,y.promisify)(u.utimes)}get read(){return(M,W,ee,H,N)=>new Promise((j,x)=>{u.read(M,W,ee,H,N,(q,ie,Q)=>q?x(q):j({bytesRead:ie,buffer:Q}))})}get readFile(){return(0,y.promisify)(u.readFile)}get write(){return(M,W,ee,H,N)=>new Promise((j,x)=>{u.write(M,W,ee,H,N,(q,ie,Q)=>q?x(q):j({bytesWritten:ie,buffer:Q}))})}get appendFile(){return(0,y.promisify)(u.appendFile)}get fdatasync(){return(0,y.promisify)(u.fdatasync)}get truncate(){return(0,y.promisify)(u.truncate)}get rename(){return(0,y.promisify)(u.rename)}get copyFile(){return(0,y.promisify)(u.copyFile)}get open(){return(0,y.promisify)(u.open)}get close(){return(0,y.promisify)(u.close)}get symlink(){return(0,y.promisify)(u.symlink)}get readlink(){return(0,y.promisify)(u.readlink)}get chmod(){return(0,y.promisify)(u.chmod)}get mkdir(){return(0,y.promisify)(u.mkdir)}get unlink(){return(0,y.promisify)(u.unlink)}get rmdir(){return(0,y.promisify)(u.rmdir)}get realpath(){return(0,y.promisify)(u.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return I}get move(){return d}get copy(){return w}}}),define(Ie[106],Te([1,0,63,9,13,8,29]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(y.isLinux)return S;const I=(0,i.dirname)(S);if(S===I)return S;const _=((0,i.basename)(S)||S).toLowerCase();try{const v=(0,C.readdirSync)(I).filter(p=>p.toLowerCase()===_);if(v.length===1){const p=D(I);if(p)return(0,i.join)(p,v[0])}else if(v.length>1){const p=v.indexOf(_);if(p>=0){const b=D(I);if(b)return(0,i.join)(b,v[p])}}}catch{}return null}e.realcaseSync=D;async function E(S){if(y.isLinux)return S;const I=(0,i.dirname)(S);if(S===I)return S;const _=((0,i.basename)(S)||S).toLowerCase();try{const v=(await C.Promises.readdir(I)).filter(p=>p.toLowerCase()===_);if(v.length===1){const p=await E(I);if(p)return(0,i.join)(p,v[0])}else if(v.length>1){const p=v.indexOf(_);if(p>=0){const b=await E(I);if(b)return(0,i.join)(b,v[p])}}}catch{}return null}e.realcase=E;async function P(S){try{return await C.Promises.realpath(S)}catch{const _=T(S);return await C.Promises.access(_,u.constants.R_OK),_}}e.realpath=P;function L(S){try{return u.realpathSync(S)}catch{const _=T(S);return u.accessSync(_,u.constants.R_OK),_}}e.realpathSync=L;function T(S){return(0,A.rtrim)((0,i.normalize)(S),i.sep)}});var je=this&&this.__decorate||function(Y,e,u,i){var y=arguments.length,A=y<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,u):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,u,i);else for(var D=Y.length-1;D>=0;D--)(C=Y[D])&&(A=(y<3?C(A):y>3?C(e,u,A):C(e,u))||A);return y>3&&A&&Object.defineProperty(e,u,A),A};define(Ie[107],Te([1,0,16,17,23,21,58,11,3,6,62,8,12]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var I;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(I=e.RequestType||(e.RequestType={}));function _(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function v(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(p||(p={}));class b{constructor(x){this.buffer=x,this.pos=0}read(x){const q=this.buffer.slice(this.pos,this.pos+x);return this.pos+=q.byteLength,q}}class f{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(a||(a={}));function m(j){const x=y.VSBuffer.alloc(4);return x.writeUInt32BE(j,0),x}function o(j){return j.read(4).readUInt32BE(0)}function h(j){const x=y.VSBuffer.alloc(1);return x.writeUInt8(j,0),x}const r={Undefined:h(a.Undefined),String:h(a.String),Buffer:h(a.Buffer),VSBuffer:h(a.VSBuffer),Array:h(a.Array),Object:h(a.Object)},s=typeof Buffer!="undefined";function n(j,x){if(typeof x=="undefined")j.write(r.Undefined);else if(typeof x=="string"){const q=y.VSBuffer.fromString(x);j.write(r.String),j.write(m(q.byteLength)),j.write(q)}else if(s&&Buffer.isBuffer(x)){const q=y.VSBuffer.wrap(x);j.write(r.Buffer),j.write(m(q.byteLength)),j.write(q)}else if(x instanceof y.VSBuffer)j.write(r.VSBuffer),j.write(m(x.byteLength)),j.write(x);else if(Array.isArray(x)){j.write(r.Array),j.write(m(x.length));for(const q of x)n(j,q)}else{const q=y.VSBuffer.fromString(JSON.stringify(x));j.write(r.Object),j.write(m(q.byteLength)),j.write(q)}}function t(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(o(j)).toString();case a.Buffer:return j.read(o(j)).buffer;case a.VSBuffer:return j.read(o(j));case a.Array:{const q=o(j),ie=[];for(let Q=0;Q<q;Q++)ie.push(t(j));return ie}case a.Object:return JSON.parse(j.read(o(j)).toString())}}class c{constructor(x,q,ie=null,Q=1e3){this.protocol=x,this.ctx=q,this.logger=ie,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(de=>this.onRawMessage(de)),this.sendResponse({type:200})}registerChannel(x,q){this.channels.set(x,q),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const q=this.send([x.type]);this.logger?.logOutgoing(q,0,1,v(x.type));return}case 201:case 202:case 204:case 203:{const q=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(q,x.id,1,v(x.type),x.data);return}}}send(x,q=void 0){const ie=new f;return n(ie,x),n(ie,q),this.sendBuffer(ie.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const q=new b(x),ie=t(q),Q=t(q),de=ie[0];switch(de){case 100:return this.logger?.logIncoming(x.byteLength,ie[1],1,`${_(de)}: ${ie[2]}.${ie[3]}`,Q),this.onPromise({type:de,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 102:return this.logger?.logIncoming(x.byteLength,ie[1],1,`${_(de)}: ${ie[2]}.${ie[3]}`,Q),this.onEventListen({type:de,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 101:return this.logger?.logIncoming(x.byteLength,ie[1],1,`${_(de)}`),this.disposeActiveRequest({type:de,id:ie[1]});case 103:return this.logger?.logIncoming(x.byteLength,ie[1],1,`${_(de)}`),this.disposeActiveRequest({type:de,id:ie[1]})}}onPromise(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const ie=new A.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,x.name,x.arg,ie.token)}catch(X){Q=Promise.reject(X)}const de=x.id;Q.then(X=>{this.sendResponse({id:de,data:X,type:201}),this.activeRequests.delete(x.id)},X=>{X instanceof Error?this.sendResponse({id:de,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:de,data:X,type:203}),this.activeRequests.delete(x.id)});const ue=(0,P.toDisposable)(()=>ie.cancel());this.activeRequests.set(x.id,ue)}onEventListen(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const ie=x.id,de=q.listen(this.ctx,x.name,x.arg)(ue=>this.sendResponse({id:ie,data:ue,type:204}));this.activeRequests.set(x.id,de)}disposeActiveRequest(x){const q=this.activeRequests.get(x.id);q&&(q.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let q=this.pendingRequests.get(x.channelName);q||(q=[],this.pendingRequests.set(x.channelName,q));const ie=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:x,timeoutTimer:ie})}flushPendingRequests(x){const q=this.pendingRequests.get(x);if(q){for(const ie of q)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var l;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(x,q=null){this.protocol=x,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=q}getChannel(x){const q=this;return{call(ie,Q,de){return q.isDisposed?Promise.reject(D.canceled()):q.requestPromise(x,ie,Q,de)},listen(ie,Q){return q.isDisposed?E.Event.None:q.requestEvent(x,ie,Q)}}}requestPromise(x,q,ie,Q=A.CancellationToken.None){const de=this.lastRequestId++,X={id:de,type:100,channelName:x,name:q,arg:ie};if(Q.isCancellationRequested)return Promise.reject(D.canceled());let ge;return new Promise((oe,_e)=>{if(Q.isCancellationRequested)return _e(D.canceled());const Pe=()=>{const ce=me=>{switch(me.type){case 201:this.handlers.delete(de),oe(me.data);break;case 202:{this.handlers.delete(de);const te=new Error(me.data.message);te.stack=me.data.stack,te.name=me.data.name,_e(te);break}case 203:this.handlers.delete(de),_e(me.data);break}};this.handlers.set(de,ce),this.sendRequest(X)};let pe=null;this.state===p.Idle?Pe():(pe=(0,i.createCancelablePromise)(ce=>this.whenInitialized()),pe.then(()=>{pe=null,Pe()}));const ve=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:de,type:101}),_e(D.canceled())},Ae=Q.onCancellationRequested(ve);ge=(0,P.combinedDisposable)((0,P.toDisposable)(ve),Ae),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(x,q,ie){const Q=this.lastRequestId++,ue={id:Q,type:102,channelName:x,name:q,arg:ie};let X=null;const ge=new E.Emitter({onFirstListenerAdd:()=>{X=(0,i.createCancelablePromise)(oe=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ge),this.sendRequest(ue)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ge),this.sendRequest({id:Q,type:103}))}}),Se=oe=>ge.fire(oe.data);return this.handlers.set(Q,Se),ge.event}sendRequest(x){switch(x.type){case 100:case 102:{const q=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(q,x.id,0,`${_(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const q=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(q,x.id,0,_(x.type));return}}}send(x,q=void 0){const ie=new f;return n(ie,x),n(ie,q),this.sendBuffer(ie.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const q=new b(x),ie=t(q),Q=t(q),de=ie[0];switch(de){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,v(de)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,ie[1],0,v(de),Q),this.onResponse({type:ie[0],id:ie[1],data:Q})}}onResponse(x){if(x.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(x.id);q&&q(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([C.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class w{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:q,onDidClientDisconnect:ie})=>{E.Event.once(q.onMessage)(de=>{const ue=new b(de),X=t(ue),ge=new c(q,X),Se=new d(q);this.channels.forEach((_e,Pe)=>ge.registerChannel(Pe,_e));const oe={channelServer:ge,channelClient:Se,ctx:X};this._connections.add(oe),this._onDidAddConnection.fire(oe),ie(()=>{ge.dispose(),Se.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)})})})}get connections(){const x=[];return this._connections.forEach(q=>x.push(q)),x}getChannel(x,q){const ie=this;return{call(Q,de,ue){let X;if((0,S.isFunction)(q)){let Se=(0,u.getRandomElement)(ie.connections.filter(q));X=Se?Promise.resolve(Se):E.Event.toPromise(E.Event.filter(ie.onDidAddConnection,q))}else X=q.routeCall(ie,Q,de);const ge=X.then(Se=>Se.channelClient.getChannel(x));return F(ge).call(Q,de,ue)},listen(Q,de){if((0,S.isFunction)(q))return ie.getMulticastEvent(x,q,Q,de);const ue=q.routeEvent(ie,Q,de).then(X=>X.channelClient.getChannel(x));return F(ue).listen(Q,de)}}}getMulticastEvent(x,q,ie,Q){const de=this;let ue=new P.DisposableStore;const X=new E.Emitter({onFirstListenerAdd:()=>{ue=new P.DisposableStore;const ge=new E.EventMultiplexer,Se=new Map,oe=Pe=>{const ve=Pe.channelClient.getChannel(x).listen(ie,Q),Ae=ge.add(ve);Se.set(Pe,Ae)},_e=Pe=>{const pe=Se.get(Pe);!pe||(pe.dispose(),Se.delete(Pe))};de.connections.filter(q).forEach(oe),E.Event.filter(de.onDidAddConnection,q)(oe,void 0,ue),de.onDidRemoveConnection(_e,void 0,ue),ge.event(X.fire,X,ue),ue.add(ge)},onLastListenerRemove:()=>{ue.dispose()}});return X.event}registerChannel(x,q){this.channels.set(x,q),this._connections.forEach(ie=>{ie.channelServer.registerChannel(x,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class R{constructor(x,q,ie=null){const Q=new f;n(Q,q),x.send(Q.buffer),this.channelClient=new d(x,ie),this.channelServer=new c(x,q,ie)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,q){this.channelServer.registerChannel(x,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function F(j){return{call(x,q,ie){return j.then(Q=>Q.call(x,q,ie))},listen(x,q){const ie=new E.Relay;return j.then(Q=>ie.input=Q.listen(x,q)),ie.event}}}e.getDelayedChannel=F;function O(j){let x=!1;return{call(q,ie,Q){return x?j.call(q,ie,Q):(0,i.timeout)(0).then(()=>x=!0).then(()=>j.call(q,ie,Q))},listen(q,ie){if(x)return j.listen(q,ie);const Q=new E.Relay;return(0,i.timeout)(0).then(()=>x=!0).then(()=>Q.input=j.listen(q,ie)),Q.event}}}e.getNextTickChannel=O;class k{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const q of x.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=k;var B;(function(j){function x(de,ue){const X=de,ge=ue&&ue.disableMarshalling,Se=new Map;for(const oe in X)ie(oe)&&Se.set(oe,E.Event.buffer(X[oe],!0));return new class{listen(oe,_e,Pe){const pe=Se.get(_e);if(pe)return pe;if(Q(_e)){const ve=X[_e];if(typeof ve=="function")return ve.call(X,Pe)}throw new Error(`Event not found: ${_e}`)}call(oe,_e,Pe){const pe=X[_e];if(typeof pe=="function"){if(!ge&&Array.isArray(Pe))for(let ve=0;ve<Pe.length;ve++)Pe[ve]=(0,L.revive)(Pe[ve]);return pe.apply(X,Pe)}throw new Error(`Method not found: ${_e}`)}}}j.fromService=x;function q(de,ue){const X=ue&&ue.disableMarshalling;return new Proxy({},{get(ge,Se){if(typeof Se=="string")return ue?.properties?.has(Se)?ue.properties.get(Se):Q(Se)?function(oe){return de.listen(Se,oe)}:ie(Se)?de.listen(Se):async function(...oe){let _e;ue&&!(0,S.isUndefinedOrNull)(ue.context)?_e=[ue.context,...oe]:_e=oe;const Pe=await de.call(Se,_e);return X?Pe:(0,L.revive)(Pe)};throw new Error(`Property not found: ${String(Se)}`)}})}j.toService=q;function ie(de){return de[0]==="o"&&de[1]==="n"&&T.isUpperAsciiLetter(de.charCodeAt(2))}function Q(de){return/^onDynamic/.test(de)&&T.isUpperAsciiLetter(de.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let x=j.toString();if(x!=="[object Object]")return x}return j}function ee(j){return Array.isArray(j)?j.map(W):W(j)}function H(j,x,q,ie,Q,de,ue){ue=ee(ue);const X=M[Q],ge=X[ie%X.length];let Se=[`%c[${j}]%c[${String(x).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${de}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(de)?(Se=Se.concat(ue),Se.push(")")):Se.push(ue),console.log.apply(console,Se)}e.logWithColors=H;class N{constructor(x,q){this._outgoingPrefix=x,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,q,ie,Q,de){this._totalOutgoing+=x,H(this._outgoingPrefix,this._totalOutgoing,x,q,ie,Q,de)}logIncoming(x,q,ie,Q,de){this._totalIncoming+=x,H(this._incomingPrefix,this._totalIncoming,x,q,ie,Q,de)}}e.IPCLogger=N}),define(Ie[108],Te([1,0,23,3,6,107]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const n=new WeakMap;let t=0;function c(d,w){if(!n.has(d)){const R=String(++t);n.set(d,R)}return n.get(d)}function l(d,w,R,F){if(!s.enableDiagnostics)return;const O=c(d,w);if(F instanceof u.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const k=u.VSBuffer.alloc(F.byteLength);k.set(F),s.records.push({timestamp:Date.now(),id:O,label:w,type:R,buff:k})}else s.records.push({timestamp:Date.now(),id:O,label:w,type:R,data:F})}s.traceSocketEvent=l})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=u.VSBuffer.alloc(0)),P}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,t){if(n===0)return L();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const w=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=n),w}if(this._chunks[0].byteLength>n){const w=this._chunks[0].slice(0,n);return t&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),w}let c=u.VSBuffer.alloc(n),l=0,d=0;for(;n>0;){const w=this._chunks[d];if(w.byteLength>n){const R=w.slice(0,n);c.set(R,l),l+=n,t&&(this._chunks[d]=w.slice(n),this._totalLength-=n),n-=n}else c.set(w,l),l+=w.byteLength,t?(this._chunks.shift(),this._totalLength-=w.byteLength):d++,n-=w.byteLength}return c}}e.ChunkStream=T;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(S||(S={}));function I(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var _;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(_=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(n,t,c,l){this.type=n,this.id=t,this.ack=c,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(n){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:I(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,l=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new g(c,l,d,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=u.VSBuffer.alloc(13);t.writeUInt8(n.type,0),t.writeUInt32BE(n.id,1),t.writeUInt32BE(n.ack,5),t.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:I(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(t,n.data)}_bufferAdd(n,t){const c=this._totalLength===0;return this._data.push(n,t),this._totalLength+=n.byteLength+t.byteLength,c}_bufferTake(){const n=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,t){this._bufferAdd(n,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class b extends y.Disposable{constructor(n){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(1,0,0,n))}}e.Protocol=b;class f extends A.IPCClient{constructor(n,t,c=null){super(n,t,c);this.protocol=n}static fromSocket(n,t){return new f(new b(n),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=f;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class m{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],t=0,c=this._first;for(;c;)n[t++]=c.data,c=c.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const t=new m(n);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class h{constructor(){this.lastRuns=[];const n=Date.now();for(let t=0;t<h._HISTORY_LENGTH;t++)this.lastRuns[t]=n-1e3*t;setInterval(()=>{for(let t=h._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const n=Date.now(),t=(1+h._HISTORY_LENGTH)*1e3;let c=0;for(let l=0;l<h._HISTORY_LENGTH;l++)n-this.lastRuns[l]<=t&&c++;return 1-c/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class r{constructor(n,t=null,c=h.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(5,0,0,L());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new g(7,0,0,L());this._socketWriter.write(n)}sendResume(){const n=new g(8,0,0,L());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,t){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,L());this._socketWriter.write(n);const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new g(6,0,0,L())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new g(1,t,this._incomingAckId,n);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(n){const t=new g(2,0,0,n);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),t=Date.now()-n.writtenTime,c=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&c>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const d=Math.max(2e4-t,2e4-c,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},d)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,L());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(Ie[109],Te([1,0,99]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(D){const E=(0,u.toUint8)(D);this._defaultValue=E,this._asciiMap=i._createAsciiMap(E),this._map=new Map}static _createAsciiMap(D){const E=new Uint8Array(256);for(let P=0;P<256;P++)E[P]=D;return E}set(D,E){const P=(0,u.toUint8)(E);D>=0&&D<256?this._asciiMap[D]=P:this._map.set(D,P)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=i;var y;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(y||(y={}));class A{constructor(){this._actual=new i(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(Ie[50],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(y,A){this.lineNumber=y,this.column=A}with(y=this.lineNumber,A=this.column){return y===this.lineNumber&&A===this.column?this:new u(y,A)}delta(y=0,A=0){return this.with(this.lineNumber+y,this.column+A)}equals(y){return u.equals(this,y)}static equals(y,A){return!y&&!A?!0:!!y&&!!A&&y.lineNumber===A.lineNumber&&y.column===A.column}isBefore(y){return u.isBefore(this,y)}static isBefore(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<A.column}isBeforeOrEqual(y){return u.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<=A.column}static compare(y,A){const C=y.lineNumber|0,D=A.lineNumber|0;if(C===D){const E=y.column|0,P=A.column|0;return E-P}return C-D}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new u(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=u}),define(Ie[36],Te([1,0,50]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(A,C,D,E){A>D||A===D&&C>E?(this.startLineNumber=D,this.startColumn=E,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=D,this.endColumn=E)}isEmpty(){return i.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return i.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return i.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return i.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return i.plusRange(this,A)}static plusRange(A,C){let D,E,P,L;return C.startLineNumber<A.startLineNumber?(D=C.startLineNumber,E=C.startColumn):C.startLineNumber===A.startLineNumber?(D=C.startLineNumber,E=Math.min(C.startColumn,A.startColumn)):(D=A.startLineNumber,E=A.startColumn),C.endLineNumber>A.endLineNumber?(P=C.endLineNumber,L=C.endColumn):C.endLineNumber===A.endLineNumber?(P=C.endLineNumber,L=Math.max(C.endColumn,A.endColumn)):(P=A.endLineNumber,L=A.endColumn),new i(D,E,P,L)}intersectRanges(A){return i.intersectRanges(this,A)}static intersectRanges(A,C){let D=A.startLineNumber,E=A.startColumn,P=A.endLineNumber,L=A.endColumn,T=C.startLineNumber,S=C.startColumn,I=C.endLineNumber,_=C.endColumn;return D<T?(D=T,E=S):D===T&&(E=Math.max(E,S)),P>I?(P=I,L=_):P===I&&(L=Math.min(L,_)),D>P||D===P&&E>L?null:new i(D,E,P,L)}equalsRange(A){return i.equalsRange(this,A)}static equalsRange(A,C){return!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(A){return new u.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(A){return new u.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new i(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new i(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(A){return new i(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,C=A){return new i(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new i(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const P=A.startLineNumber|0,L=C.startLineNumber|0;if(P===L){const T=A.startColumn|0,S=C.startColumn|0;if(T===S){const I=A.endLineNumber|0,_=C.endLineNumber|0;if(I===_){const g=A.endColumn|0,v=C.endColumn|0;return g-v}return I-_}return T-S}return P-L}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=i}),define(Ie[148],Te([1,0,50,36]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class A extends i.Range{constructor(D,E,P,L){super(D,E,P,L);this.selectionStartLineNumber=D,this.selectionStartColumn=E,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,E){return D.selectionStartLineNumber===E.selectionStartLineNumber&&D.selectionStartColumn===E.selectionStartColumn&&D.positionLineNumber===E.positionLineNumber&&D.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,E){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,E):new A(D,E,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,E){return this.getDirection()===0?new A(D,E,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,E)}static fromPositions(D,E=D){return new A(D.lineNumber,D.column,E.lineNumber,E.column)}static fromRange(D,E){return E===0?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new A(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,E){if(D&&!E||!D&&E)return!1;if(!D&&!E)return!0;if(D.length!==E.length)return!1;for(let P=0,L=D.length;P<L;P++)if(!this.selectionsEqual(D[P],E[P]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,E,P,L,T){return T===0?new A(D,E,P,L):new A(P,L,D,E)}}e.Selection=A}),define(Ie[149],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[150],Te([1,0,109]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends u.CharacterClassifier{constructor(D){super(0);for(let E=0,P=D.length;E<P;E++)this.set(D.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function A(C){const D={};return E=>(D.hasOwnProperty(E)||(D[E]=C(E)),D[E])}e.getMapForWordSeparators=A(C=>new y(C))}),define(Ie[110],Te([1,0,60,6,81]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(T=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)T.indexOf(I)>=0||(S+="\\"+I);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=A();function C(T){let S=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)S=T;else{let I="g";T.ignoreCase&&(I+="i"),T.multiline&&(I+="m"),T.unicode&&(I+="u"),S=new RegExp(T.source,I)}return S.lastIndex=0,S}e.ensureValidWordDefinition=C;const D=new y.LinkedList;D.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(T){const S=D.unshift(T);return(0,i.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=E;function P(T,S,I,_,g){if(g||(g=u.Iterable.first(D)),I.length>g.maxLen){let a=T-g.maxLen/2;return a<0?a=0:_+=a,I=I.substring(a,T+g.maxLen/2),P(T,S,I,_,g)}const v=Date.now(),p=T-1-_;let b=-1,f=null;for(let a=1;!(Date.now()-v>=g.timeBudget);a++){const m=p-g.windowSize*a;S.lastIndex=Math.max(0,m);const o=L(S,I,p,b);if(!o&&f||(f=o,m<=0))break;b=m}if(f){const a={word:f[0],startColumn:_+1+f.index,endColumn:_+1+f.index+f[0].length};return S.lastIndex=0,a}return null}e.getWordAtText=P;function L(T,S,I,_){let g;for(;g=T.exec(S);){const v=g.index||0;if(v<=I&&T.lastIndex>=I)return g;if(_>0&&v>_)return null}return null}}),define(Ie[151],Te([1,0,34,9]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(A,C,D,E,P,L){if(Array.isArray(A)){let T=0;for(const S of A){const I=y(S,C,D,E,P,L);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof A=="string")return E?A==="*"?5:A===D?10:0:0;if(A){const{language:T,pattern:S,scheme:I,hasAccessToAllModels:_,notebookType:g}=A;if(!E&&!_)return 0;g&&P&&(C=P);let v=0;if(I)if(I===C.scheme)v=10;else if(I==="*")v=5;else return 0;if(T)if(T===D)v=10;else if(T==="*")v=Math.max(v,5);else return 0;if(g)if(g===L)v=10;else if(g==="*"&&L!==void 0)v=Math.max(v,5);else return 0;if(S){let p;if(typeof S=="string"?p=S:p={...S,base:(0,i.normalize)(S.base)},p===C.fsPath||(0,u.match)(p,C.fsPath))v=10;else return 0}return v}else return 0}}e.score=y}),define(Ie[152],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class i{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let E=0,P=D.notIn.length;E<P;E++)switch(D.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,E){if(D.getTokenCount()===0)return!0;const P=D.findTokenIndexAtOffset(E-2),L=D.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(D,E){for(let P=D;P<=E;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class y{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of D)A(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),A(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),A(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),A(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&A(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=y;function A(C,D,E){C.has(D)?C.get(D).push(E):C.set(D,[E])}}),define(Ie[153],Te([1,0,109]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class y{constructor(_,g,v){const p=new Uint8Array(_*g);for(let b=0,f=_*g;b<f;b++)p[b]=v;this._data=p,this.rows=_,this.cols=g}get(_,g){return this._data[_*this.cols+g]}set(_,g,v){this._data[_*this.cols+g]=v}}e.Uint8Matrix=y;class A{constructor(_){let g=0,v=0;for(let b=0,f=_.length;b<f;b++){const[a,m,o]=_[b];m>g&&(g=m),a>v&&(v=a),o>v&&(v=o)}g++,v++;const p=new y(v,g,0);for(let b=0,f=_.length;b<f;b++){const[a,m,o]=_[b];p.set(a,m,o)}this._states=p,this._maxCharCode=g}nextState(_,g){return g<0||g>=this._maxCharCode?0:this._states.get(_,g)}}e.StateMachine=A;let C=null;function D(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var E;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let P=null;function L(){if(P===null){P=new u.CharacterClassifier(0);const I=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<I.length;g++)P.set(I.charCodeAt(g),1);const _=".,;:";for(let g=0;g<_.length;g++)P.set(_.charCodeAt(g),2)}return P}class T{static _createLink(_,g,v,p,b){let f=b-1;do{const a=g.charCodeAt(f);if(_.get(a)!==2)break;f--}while(f>p);if(p>0){const a=g.charCodeAt(p-1),m=g.charCodeAt(f);(a===40&&m===41||a===91&&m===93||a===123&&m===125)&&f--}return{range:{startLineNumber:v,startColumn:p+1,endLineNumber:v,endColumn:f+2},url:g.substring(p,f+1)}}static computeLinks(_,g=D()){const v=L(),p=[];for(let b=1,f=_.getLineCount();b<=f;b++){const a=_.getLineContent(b),m=a.length;let o=0,h=0,r=0,s=1,n=!1,t=!1,c=!1,l=!1;for(;o<m;){let d=!1;const w=a.charCodeAt(o);if(s===13){let R;switch(w){case 40:n=!0,R=0;break;case 41:R=n?0:1;break;case 91:c=!0,t=!0,R=0;break;case 93:c=!1,R=t?0:1;break;case 123:l=!0,R=0;break;case 125:R=l?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=c?0:1;break;default:R=v.get(w)}R===1&&(p.push(T._createLink(v,a,b,h,o)),d=!0)}else if(s===12){let R;w===91?(t=!0,R=0):R=v.get(w),R===1?d=!0:s=13}else s=g.nextState(s,w),s===0&&(d=!0);d&&(s=1,n=!1,t=!1,l=!1,h=o+1,r=w),o++}s===13&&p.push(T._createLink(v,a,b,h,m))}return p}}e.LinkComputer=T;function S(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:T.computeLinks(I)}e.computeLinks=S}),define(Ie[111],Te([1,0,24]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class L{constructor(f,a){this._findMatchBrand=void 0,this.range=f,this.matches=a}}e.FindMatch=L;var T;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var S;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(S=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class _{constructor(f,a,m,o,h,r){this.identifier=f,this.range=a,this.text=m,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=h,this._isTracked=r}}e.ValidAnnotatedEditOperation=_;class g{constructor(f,a,m){this.regex=f,this.wordSeparators=a,this.simpleSearch=m}}e.SearchData=g;class v{constructor(f,a,m){this.reverseEdits=f,this.changes=a,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=v;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(Ie[154],Te([1,0,16,99]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,P){E=(0,i.toUint32)(E);const L=this.values,T=this.prefixSum,S=P.length;return S===0?!1:(this.values=new Uint32Array(L.length+S),this.values.set(L.subarray(0,E),0),this.values.set(L.subarray(E),E+S),this.values.set(P,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,P){return E=(0,i.toUint32)(E),P=(0,i.toUint32)(P),this.values[E]===P?!1:(this.values[E]=P,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,P){E=(0,i.toUint32)(E),P=(0,i.toUint32)(P);const L=this.values,T=this.prefixSum;if(E>=L.length)return!1;const S=L.length-E;return P>=S&&(P=S),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,E),0),this.values.set(L.subarray(E+P),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,i.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),E>=this.values.length&&(E=this.values.length-1);for(let L=P;L<=E;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let P=0,L=this.values.length-1,T=0,S=0,I=0;for(;P<=L;)if(T=P+(L-P)/2|0,S=this.prefixSum[T],I=S-this.values[T],E<I)L=T-1;else if(E>=S)P=T+1;else break;return new C(T,E-I)}}e.PrefixSumComputer=y;class A{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const P=this._indexBySum[E],L=P>0?this._prefixSum[P-1]:0;return new C(P,E-L)}removeValues(E,P){this._values.splice(E,P),this._invalidate(E)}insertValues(E,P){this._values=(0,u.arrayInsert)(this._values,E,P),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,P=this._values.length;E<P;E++){const L=this._values[E],T=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=T+L;for(let S=0;S<L;S++)this._indexBySum[T+S]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,P){this._values[E]!==P&&(this._values[E]=P,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(E,P){this.index=E,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=P}}e.PrefixSumIndexOfResult=C}),define(Ie[155],Te([1,0,8,50,154]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,E,P,L){this._uri=D,this._lines=E,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const E=D.changes;for(const P of E)this._acceptDeleteRange(P.range),this._acceptInsertText(new i.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,E=this._lines.length,P=new Uint32Array(E);for(let L=0;L<E;L++)P[L]=this._lines[L].length+D;this._lineStarts=new y.PrefixSumComputer(P)}}_setLineText(D,E){this._lines[D]=E,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,E){if(E.length===0)return;const P=(0,u.splitLines)(E);if(P.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+P[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}P[P.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let T=1;T<P.length;T++)this._lines.splice(D.lineNumber+T-1,0,P[T]),L[T-1]=P[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=A}),define(Ie[156],Te([1,0,8,150,50,36,111]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class E{constructor(b,f,a,m){this.searchString=b,this.isRegex=f,this.matchCase=a,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=P(this.searchString):b=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!f)return null;let a=!this.isRegex&&!b;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new C.SearchData(f,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=E;function P(p){if(!p||p.length===0)return!1;for(let b=0,f=p.length;b<f;b++)if(p.charCodeAt(b)===92){if(b++,b>=f)break;const m=p.charCodeAt(b);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=P;function L(p,b,f){if(!f)return new C.FindMatch(p,null);const a=[];for(let m=0,o=b.length;m<o;m++)a[m]=b[m];return new C.FindMatch(p,a)}e.createFindMatch=L;class T{constructor(b){const f=[];let a=0;for(let m=0,o=b.length;m<o;m++)b.charCodeAt(m)===10&&(f[a++]=m);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(b){const f=this._lineFeedsOffsets;let a=0,m=f.length-1;if(m===-1||b<=f[0])return 0;for(;a<m;){const o=a+((m-a)/2>>0);f[o]>=b?m=o-1:f[o+1]>=b?(a=o,m=o):a=o+1}return a+1}}class S{static findMatches(b,f,a,m,o){const h=f.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(b,a,new v(h.wordSeparators,h.regex),m,o):this._doFindMatchesLineByLine(b,a,h,m,o):[]}static _getMultilineMatchRange(b,f,a,m,o,h){let r,s=0;m?(s=m.findLineFeedCountBeforeOffset(o),r=f+o+s):r=f+o;let n;if(m){const d=m.findLineFeedCountBeforeOffset(o+h.length)-s;n=r+h.length+d}else n=r+h.length;const t=b.getPositionAt(r),c=b.getPositionAt(n);return new A.Range(t.lineNumber,t.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(b,f,a,m,o){const h=b.getOffsetAt(f.getStartPosition()),r=b.getValueInRange(f,1),s=b.getEOL()===`\r
`?new T(r):null,n=[];let t=0,c;for(a.reset(0);c=a.next(r);)if(n[t++]=L(this._getMultilineMatchRange(b,h,r,s,c.index,c[0]),c,m),t>=o)return n;return n}static _doFindMatchesLineByLine(b,f,a,m,o){const h=[];let r=0;if(f.startLineNumber===f.endLineNumber){const n=b.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(a,n,f.startLineNumber,f.startColumn-1,r,h,m,o),h}const s=b.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(a,s,f.startLineNumber,f.startColumn-1,r,h,m,o);for(let n=f.startLineNumber+1;n<f.endLineNumber&&r<o;n++)r=this._findMatchesInLine(a,b.getLineContent(n),n,0,r,h,m,o);if(r<o){const n=b.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(a,n,f.endLineNumber,0,r,h,m,o)}return h}static _findMatchesInLine(b,f,a,m,o,h,r,s){const n=b.wordSeparators;if(!r&&b.simpleSearch){const l=b.simpleSearch,d=l.length,w=f.length;let R=-d;for(;(R=f.indexOf(l,R+d))!==-1;)if((!n||g(n,f,w,R,d))&&(h[o++]=new C.FindMatch(new A.Range(a,R+1+m,a,R+1+d+m),null),o>=s))return o;return o}const t=new v(b.wordSeparators,b.regex);let c;t.reset(0);do if(c=t.next(f),c&&(h[o++]=L(new A.Range(a,c.index+1+m,a,c.index+1+c[0].length+m),c,r),o>=s))return o;while(c);return o}static findNextMatch(b,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const h=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(b,a,h,m):this._doFindNextMatchLineByLine(b,a,h,m)}static _doFindNextMatchMultiline(b,f,a,m){const o=new y.Position(f.lineNumber,1),h=b.getOffsetAt(o),r=b.getLineCount(),s=b.getValueInRange(new A.Range(o.lineNumber,o.column,r,b.getLineMaxColumn(r)),1),n=b.getEOL()===`\r
`?new T(s):null;a.reset(f.column-1);let t=a.next(s);return t?L(this._getMultilineMatchRange(b,h,s,n,t.index,t[0]),t,m):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(b,new y.Position(1,1),a,m):null}static _doFindNextMatchLineByLine(b,f,a,m){const o=b.getLineCount(),h=f.lineNumber,r=b.getLineContent(h),s=this._findFirstMatchInLine(a,r,h,f.column,m);if(s)return s;for(let n=1;n<=o;n++){const t=(h+n-1)%o,c=b.getLineContent(t+1),l=this._findFirstMatchInLine(a,c,t+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(b,f,a,m,o){b.reset(m-1);const h=b.next(f);return h?L(new A.Range(a,h.index+1,a,h.index+1+h[0].length),h,o):null}static findPreviousMatch(b,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const h=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(b,a,h,m):this._doFindPreviousMatchLineByLine(b,a,h,m)}static _doFindPreviousMatchMultiline(b,f,a,m){const o=this._doFindMatchesMultiline(b,new A.Range(1,1,f.lineNumber,f.column),a,m,10*D);if(o.length>0)return o[o.length-1];const h=b.getLineCount();return f.lineNumber!==h||f.column!==b.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(b,new y.Position(h,b.getLineMaxColumn(h)),a,m):null}static _doFindPreviousMatchLineByLine(b,f,a,m){const o=b.getLineCount(),h=f.lineNumber,r=b.getLineContent(h).substring(0,f.column-1),s=this._findLastMatchInLine(a,r,h,m);if(s)return s;for(let n=1;n<=o;n++){const t=(o+h-n-1)%o,c=b.getLineContent(t+1),l=this._findLastMatchInLine(a,c,t+1,m);if(l)return l}return null}static _findLastMatchInLine(b,f,a,m){let o=null,h;for(b.reset(0);h=b.next(f);)o=L(new A.Range(a,h.index+1,a,h.index+1+h[0].length),h,m);return o}}e.TextModelSearch=S;function I(p,b,f,a,m){if(a===0)return!0;const o=b.charCodeAt(a-1);if(p.get(o)!==0||o===13||o===10)return!0;if(m>0){const h=b.charCodeAt(a);if(p.get(h)!==0)return!0}return!1}function _(p,b,f,a,m){if(a+m===f)return!0;const o=b.charCodeAt(a+m);if(p.get(o)!==0||o===13||o===10)return!0;if(m>0){const h=b.charCodeAt(a+m-1);if(p.get(h)!==0)return!0}return!1}function g(p,b,f,a,m){return I(p,b,f,a,m)&&_(p,b,f,a,m)}e.isValidMatch=g;class v{constructor(b,f){this._wordSeparators=b,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const f=b.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(a=this._searchRegex.exec(b),!a))return null;const m=a.index,o=a[0].length;if(m===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){u.getNextCodePoint(b,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=o,!this._wordSeparators||g(this._wordSeparators,b,f,m,o))return a}while(a);return null}}e.Searcher=v}),define(Ie[112],Te([1,0,23,13]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(y||(y={}));function A(T){for(let S=0,I=T.length;S<I;S+=4){const _=T[S+0],g=T[S+1],v=T[S+2],p=T[S+3];T[S+0]=p,T[S+1]=v,T[S+2]=g,T[S+3]=_}}function C(T){const S=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return i.isLittleEndian()||A(S),u.VSBuffer.wrap(S)}function D(T){const S=T.buffer;if(i.isLittleEndian()||A(S),S.byteOffset%4==0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const I=new Uint8Array(S.byteLength);return I.set(S),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function E(T){const S=new Uint32Array(P(T));let I=0;if(S[I++]=T.id,T.type==="full")S[I++]=1,S[I++]=T.data.length,S.set(T.data,I),I+=T.data.length;else{S[I++]=2,S[I++]=T.deltas.length;for(const _ of T.deltas)S[I++]=_.start,S[I++]=_.deleteCount,_.data?(S[I++]=_.data.length,S.set(_.data,I),I+=_.data.length):S[I++]=0}return C(S)}e.encodeSemanticTokensDto=E;function P(T){let S=0;if(S+=1+1,T.type==="full")S+=1+T.data.length;else{S+=1,S+=(1+1+1)*T.deltas.length;for(const I of T.deltas)I.data&&(S+=I.data.length)}return S}function L(T){const S=D(T);let I=0;const _=S[I++];if(S[I++]===1){const b=S[I++],f=S.subarray(I,I+b);return I+=b,{id:_,type:"full",data:f}}const v=S[I++],p=[];for(let b=0;b<v;b++){const f=S[I++],a=S[I++],m=S[I++];let o;m>0&&(o=S.subarray(I,I+m),I+=m),p[b]={start:f,deleteCount:a,data:o}}return{id:_,type:"delta",deltas:p}}e.decodeSemanticTokensDto=L}),define(Ie[157],Te([1,0,3,6]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class y{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,E){return this._map.set(D,E),this.fire([D]),(0,i.toDisposable)(()=>{this._map.get(D)===E&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,E){this._factories.get(D)?.dispose();const P=new A(this,D,E);return this._factories.set(D,P),(0,i.toDisposable)(()=>{const L=this._factories.get(D);!L||L!==P||(this._factories.delete(D),L.dispose())})}async getOrCreate(D){const E=this.get(D);if(E)return E;const P=this._factories.get(D);return!P||P.isResolved?null:(await P.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const P=this._factories.get(D);return!!(!P||P.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=y;class A extends i.Disposable{constructor(D,E,P){super();this._registry=D,this._languageId=E,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(Ie[65],Te([1,0,78,2,36,157]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(d,w,R){this._tokenBrand=void 0,this.offset=d,this.type=w,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class D{constructor(d,w){this._tokenizationResultBrand=void 0,this.tokens=d,this.endState=w}}e.TokenizationResult=D;class E{constructor(d,w){this._encodedTokenizationResultBrand=void 0,this.tokens=d,this.endState=w}}e.EncodedTokenizationResult=E;var P;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(P=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(l){const d=new Map;d.set(0,u.Codicon.symbolMethod),d.set(1,u.Codicon.symbolFunction),d.set(2,u.Codicon.symbolConstructor),d.set(3,u.Codicon.symbolField),d.set(4,u.Codicon.symbolVariable),d.set(5,u.Codicon.symbolClass),d.set(6,u.Codicon.symbolStruct),d.set(7,u.Codicon.symbolInterface),d.set(8,u.Codicon.symbolModule),d.set(9,u.Codicon.symbolProperty),d.set(10,u.Codicon.symbolEvent),d.set(11,u.Codicon.symbolOperator),d.set(12,u.Codicon.symbolUnit),d.set(13,u.Codicon.symbolValue),d.set(15,u.Codicon.symbolEnum),d.set(14,u.Codicon.symbolConstant),d.set(15,u.Codicon.symbolEnum),d.set(16,u.Codicon.symbolEnumMember),d.set(17,u.Codicon.symbolKeyword),d.set(27,u.Codicon.symbolSnippet),d.set(18,u.Codicon.symbolText),d.set(19,u.Codicon.symbolColor),d.set(20,u.Codicon.symbolFile),d.set(21,u.Codicon.symbolReference),d.set(22,u.Codicon.symbolCustomColor),d.set(23,u.Codicon.symbolFolder),d.set(24,u.Codicon.symbolTypeParameter),d.set(25,u.Codicon.account),d.set(26,u.Codicon.issues);function w(O){let k=d.get(O);return k||(console.info("No codicon found for CompletionItemKind "+O),k=u.Codicon.symbolProperty),k}l.toIcon=w;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function F(O,k){let B=R.get(O);return typeof B=="undefined"&&!k&&(B=9),B}l.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(l){l[l.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(l){return l&&i.URI.isUri(l.uri)&&y.Range.isIRange(l.range)&&(y.Range.isIRange(l.originSelectionRange)||y.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=b;var f;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var a;(function(l){l[l.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var m;(function(l){const d=new Map;d.set(0,u.Codicon.symbolFile),d.set(1,u.Codicon.symbolModule),d.set(2,u.Codicon.symbolNamespace),d.set(3,u.Codicon.symbolPackage),d.set(4,u.Codicon.symbolClass),d.set(5,u.Codicon.symbolMethod),d.set(6,u.Codicon.symbolProperty),d.set(7,u.Codicon.symbolField),d.set(8,u.Codicon.symbolConstructor),d.set(9,u.Codicon.symbolEnum),d.set(10,u.Codicon.symbolInterface),d.set(11,u.Codicon.symbolFunction),d.set(12,u.Codicon.symbolVariable),d.set(13,u.Codicon.symbolConstant),d.set(14,u.Codicon.symbolString),d.set(15,u.Codicon.symbolNumber),d.set(16,u.Codicon.symbolBoolean),d.set(17,u.Codicon.symbolArray),d.set(18,u.Codicon.symbolObject),d.set(19,u.Codicon.symbolKey),d.set(20,u.Codicon.symbolNull),d.set(21,u.Codicon.symbolEnumMember),d.set(22,u.Codicon.symbolStruct),d.set(23,u.Codicon.symbolEvent),d.set(24,u.Codicon.symbolOperator),d.set(25,u.Codicon.symbolTypeParameter);function w(R){let F=d.get(R);return F||(console.info("No codicon found for SymbolKind "+R),F=u.Codicon.symbolProperty),F}l.toIcon=w})(m=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(d){this.value=d}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var h;(function(l){function d(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}l.is=d})(h=e.Command||(e.Command={}));var r;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var n;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(n=e.CommentMode||(e.CommentMode={}));var t;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(t=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var c;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[158],Te([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(Ie[159],Te([1,0,158]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,y=i*60,A=y*24,C=A*7,D=A*30,E=A*365;function P(T,S,I){typeof T!="number"&&(T=T.getTime());const _=Math.round((new Date().getTime()-T)/1e3);if(_<-30)return(0,u.localize)(0,null,P(new Date().getTime()+_*1e3,!1));if(_<30)return(0,u.localize)(1,null);let g;return _<i?(g=_,S?g===1?I?(0,u.localize)(2,null,g):(0,u.localize)(3,null,g):I?(0,u.localize)(4,null,g):(0,u.localize)(5,null,g):g===1?I?(0,u.localize)(6,null,g):(0,u.localize)(7,null,g):I?(0,u.localize)(8,null,g):(0,u.localize)(9,null,g)):_<y?(g=Math.floor(_/i),S?g===1?I?(0,u.localize)(10,null,g):(0,u.localize)(11,null,g):I?(0,u.localize)(12,null,g):(0,u.localize)(13,null,g):g===1?I?(0,u.localize)(14,null,g):(0,u.localize)(15,null,g):I?(0,u.localize)(16,null,g):(0,u.localize)(17,null,g)):_<A?(g=Math.floor(_/y),S?g===1?I?(0,u.localize)(18,null,g):(0,u.localize)(19,null,g):I?(0,u.localize)(20,null,g):(0,u.localize)(21,null,g):g===1?I?(0,u.localize)(22,null,g):(0,u.localize)(23,null,g):I?(0,u.localize)(24,null,g):(0,u.localize)(25,null,g)):_<C?(g=Math.floor(_/A),S?g===1?(0,u.localize)(26,null,g):(0,u.localize)(27,null,g):g===1?(0,u.localize)(28,null,g):(0,u.localize)(29,null,g)):_<D?(g=Math.floor(_/C),S?g===1?I?(0,u.localize)(30,null,g):(0,u.localize)(31,null,g):I?(0,u.localize)(32,null,g):(0,u.localize)(33,null,g):g===1?I?(0,u.localize)(34,null,g):(0,u.localize)(35,null,g):I?(0,u.localize)(36,null,g):(0,u.localize)(37,null,g)):_<E?(g=Math.floor(_/D),S?g===1?I?(0,u.localize)(38,null,g):(0,u.localize)(39,null,g):I?(0,u.localize)(40,null,g):(0,u.localize)(41,null,g):g===1?I?(0,u.localize)(42,null,g):(0,u.localize)(43,null,g):I?(0,u.localize)(44,null,g):(0,u.localize)(45,null,g)):(g=Math.floor(_/E),S?g===1?I?(0,u.localize)(46,null,g):(0,u.localize)(47,null,g):I?(0,u.localize)(48,null,g):(0,u.localize)(49,null,g):g===1?I?(0,u.localize)(50,null,g):(0,u.localize)(51,null,g):I?(0,u.localize)(52,null,g):(0,u.localize)(53,null,g))}e.fromNow=P;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ie[160],Te([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(Ie[51],Te([1,0,16,12,160]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(T,S){return S&&(T.stack||T.stacktrace)?y.localize(0,null,D(T),C(T.stack)||C(T.stacktrace)):D(T)}function C(T){return Array.isArray(T)?T.join(`
`):T}function D(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?y.localize(1,null,T.message):T.message||y.localize(2,null)}function E(T=null,S=!1){if(!T)return y.localize(3,null);if(Array.isArray(T)){const I=u.coalesce(T),_=E(I[0],S);return I.length>1?y.localize(4,null,_,I.length):_}if(i.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return A(I.error,S);if(I.exception)return A(I.exception,S)}return T.stack?A(T,S):T.message?T.message:y.localize(5,null)}e.toErrorMessage=E;function P(T){const S=T;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=P;function L(T,S){let I;return typeof T=="string"?I=new Error(T):I=T,I.actions=S,I}e.createErrorWithActions=L}),define(Ie[161],Te([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(Ie[113],Te([1,0,42,30,10,24,9,13,40,96,12,147,29,161]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function _(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(m,o){if(D.isWindows)try{const h={stdio:["pipe","pipe","ignore"]};o&&(h.cwd=o);const r=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],h);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,t)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(h){return Promise.resolve({success:!1,error:h,code:h.status?_(h.status):1})}else if(D.isLinux||D.isMacintosh)try{const h=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{u.execFile(h,[m.pid.toString()],{encoding:"utf8",shell:!0},(s,n,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(h){return Promise.resolve({success:!1,error:h})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function v(m=E.env){return m.comspec||"cmd.exe"}e.getWindowsShell=v;class p{constructor(o,h,r,s){if(h!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=h,this.shell=r,this.options=s;else{const n=o;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(E.env).forEach(t=>{n[t]=E.env[t]}),Object.keys(this.options.env).forEach(t=>{n[t]=this.options.env[t]}),this.options.env=n}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const h=o.lastIndexOf(C.sep);return h!==-1&&(o=o.substring(h+1)),p.WellKnowCommands[o]?o:"other"}start(o){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(E.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(h=>{let r,s;const n=new Promise((t,c)=>{r=t,s=c});if(h){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=u.exec(t,this.options,(c,l,d)=>{this.childProcess=null;const w=c;w&&w.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:d.toString()}):this.handleExec(r,o,c,l,d)})}else{let t=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,o,s);const d={terminated:this.terminateRequested};L.isNumber(l)&&(d.cmdCode=l),r(d)};if(this.shell&&D.isWindows){const l=A.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let d=!1,w=!1;const R=[];let F=this.ensureQuotes(this.cmd);R.push(F.value),d=F.quoted,this.args&&this.args.forEach(k=>{F=this.ensureQuotes(k),R.push(F.value),w=w&&F.quoted});const O=["/s","/c"];d?w?O.push('"'+R.join(" ")+'"'):R.length>1?O.push('"'+R[0]+'" '+R.slice(1).join(" ")):O.push('"'+R[0]+'"'):O.push(R.join(" ")),t=u.spawn(v(),O,l)}else this.cmd&&(t=u.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(L.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),t.pid&&(this.childProcess.on("close",c),this.handleSpawn(t,r,o,s,!0)))}return n})}handleClose(o,h,r,s){}ensureQuotes(o){return p.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,g(o,this.options.cwd).then(h=>(h.success&&(this.childProcess=null),h))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!D.isWindows)return o(!1);const h=u.spawn(v(),["/s","/c"]);h.on("error",r=>o(!0)),h.on("exit",r=>o(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class b extends p{constructor(o,h,r,s){super(o,h,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,h,r,s,n){[s,n].forEach((t,c)=>{const l=new T.LineDecoder;l.write(t).forEach(R=>{h({line:R,source:c===0?0:1})});const w=l.end();w&&h({line:w,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,h,r,s,n){const t=new T.LineDecoder,c=new T.LineDecoder;o.stdout.on("data",l=>{t.write(l).forEach(w=>r({line:w,source:0}))}),o.stderr.on("data",l=>{c.write(l).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=c}handleClose(o,h,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=b;function f(m){let o=[],h=!1;const r=function(s){if(h){o.push(s);return}(!m.send(s,t=>{if(t&&console.error(t),h=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(l=>r(l))}})||D.isWindows)&&(h=!0)};return{send:r}}e.createQueuedSender=f;var a;(function(m){async function o(h,r,s){if(C.isAbsolute(h))return h;if(r===void 0&&(r=E.cwd()),C.dirname(h)!=="."||(s===void 0&&L.isString(E.env.PATH)&&(s=E.env.PATH.split(C.delimiter)),s===void 0||s.length===0))return C.join(r,h);async function t(c){if(await S.Promises.exists(c)){let l;try{l=await S.Promises.stat(c)}catch(d){d.message.startsWith("EACCES")&&(l=await S.Promises.lstat(c))}return l?!l.isDirectory():!1}return!1}for(let c of s){let l;if(C.isAbsolute(c)?l=C.join(c,h):l=C.join(r,c,h),await t(l))return l;let d=l+".com";if(await t(d)||(d=l+".exe",await t(d)))return d}return C.join(r,h)}m.findExecutable=o})(a=e.win32||(e.win32={}))}),define(Ie[162],Te([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(Ie[114],Te([1,0,162,13,110,16,24,149]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=P;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(re,Ce,ae,ke){this.id=re,this.name=Ce,this.defaultValue=ae,this.schema=ke}applyUpdate(re,Ce){return I(re,Ce)}compute(re,Ce,ae){return ae}}class S{constructor(re,Ce){this.newValue=re,this.didChange=Ce}}e.ApplyUpdateResult=S;function I(J,re){if(typeof J!="object"||typeof re!="object"||!J||!re)return new S(re,J!==re);if(Array.isArray(J)||Array.isArray(re)){const ae=Array.isArray(J)&&Array.isArray(re)&&A.equals(J,re);return new S(re,ae)}let Ce=!1;for(const ae in re)if(re.hasOwnProperty(ae)){const ke=I(J[ae],re[ae]);ke.didChange&&(J[ae]=ke.newValue,Ce=!0)}return new S(J,Ce)}class _{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Ce){return I(re,Ce)}validate(re){return this.defaultValue}}class g{constructor(re,Ce,ae,ke){this.id=re,this.name=Ce,this.defaultValue=ae,this.schema=ke}applyUpdate(re,Ce){return I(re,Ce)}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Ce,ae){return ae}}function v(J,re){return typeof J=="undefined"?re:J==="false"?!1:Boolean(J)}e.boolean=v;class p extends g{constructor(re,Ce,ae,ke=void 0){typeof ke!="undefined"&&(ke.type="boolean",ke.default=ae);super(re,Ce,ae,ke)}validate(re){return v(re,this.defaultValue)}}function b(J,re,Ce,ae){if(typeof J=="undefined")return re;let ke=parseInt(J,10);return isNaN(ke)?re:(ke=Math.max(Ce,ke),ke=Math.min(ae,ke),ke|0)}e.clampedInt=b;class f extends g{constructor(re,Ce,ae,ke,Ne,He=void 0){typeof He!="undefined"&&(He.type="integer",He.default=ae,He.minimum=ke,He.maximum=Ne);super(re,Ce,ae,He);this.minimum=ke,this.maximum=Ne}static clampedInt(re,Ce,ae,ke){return b(re,Ce,ae,ke)}validate(re){return f.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class a extends g{constructor(re,Ce,ae,ke,Ne){typeof Ne!="undefined"&&(Ne.type="number",Ne.default=ae);super(re,Ce,ae,Ne);this.validationFn=ke}static clamp(re,Ce,ae){return re<Ce?Ce:re>ae?ae:re}static float(re,Ce){if(typeof re=="number")return re;if(typeof re=="undefined")return Ce;const ae=parseFloat(re);return isNaN(ae)?Ce:ae}validate(re){return this.validationFn(a.float(re,this.defaultValue))}}class m extends g{static string(re,Ce){return typeof re!="string"?Ce:re}constructor(re,Ce,ae,ke=void 0){typeof ke!="undefined"&&(ke.type="string",ke.default=ae);super(re,Ce,ae,ke)}validate(re){return m.string(re,this.defaultValue)}}function o(J,re,Ce){return typeof J!="string"||Ce.indexOf(J)===-1?re:J}e.stringSet=o;class h extends g{constructor(re,Ce,ae,ke,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=ke,Ne.default=ae);super(re,Ce,ae,Ne);this._allowedValues=ke}validate(re){return o(re,this.defaultValue,this._allowedValues)}}class r extends T{constructor(re,Ce,ae,ke,Ne,He,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=Ne,Ge.default=ke);super(re,Ce,ae,Ge);this._allowedValues=Ne,this._convert=He}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function s(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ce,ae){return ae===0?re.accessibilitySupport:ae}}class t extends T{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:u.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertSpace:v(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(J){switch(J){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function R(J){switch(J){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class F extends _{constructor(){super(129)}compute(re,Ce,ae){const ke=["monaco-editor"];return Ce.get(34)&&ke.push(Ce.get(34)),re.extraEditorClassName&&ke.push(re.extraEditorClassName),Ce.get(67)==="default"?ke.push("mouse-default"):Ce.get(67)==="copy"&&ke.push("mouse-copy"),Ce.get(101)&&ke.push("showUnused"),Ce.get(127)&&ke.push("showDeprecated"),ke.join(" ")}}class O extends p{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(re,Ce,ae){return ae&&re.emptySelectionClipboard}}class k extends T{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:u.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:u.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{cursorMoveOnType:v(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":o(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":o(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(Ce.loop,this.defaultValue.loop)}}}class B extends T{constructor(){super(46,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?B.OFF:re==="true"?B.ON:re:Boolean(re)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class M extends _{constructor(){super(45)}compute(re,Ce,ae){return re.fontInfo}}class W extends g{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(re){const Ce=a.float(re,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(re,Ce,ae){return re.fontInfo.fontSize}}class ee extends T{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.MINIMUM_VALUE,maximum:ee.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(f.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.MINIMUM_VALUE,ee.MAXIMUM_VALUE))}}ee.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],ee.MINIMUM_VALUE=1,ee.MAXIMUM_VALUE=1e3;class H extends T{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},ae=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...Ce},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:ae,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:ae,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:ae,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:ae,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:ae,description:u.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{multiple:o(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??o(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??o(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??o(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??o(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??o(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends T{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:u.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:v(Ce.enabled,this.defaultValue.enabled),delay:f.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:v(Ce.sticky,this.defaultValue.sticky),above:v(Ce.above,this.defaultValue.above)}}}var j;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class x extends _{constructor(){super(132)}compute(re,Ce,ae){return x.computeLayout(Ce,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Ce=re.height/re.lineHeight,ae=re.scrollBeyondLastLine?Ce-1:0,ke=(re.viewLineCount+ae)/(re.pixelRatio*re.height),Ne=Math.floor(re.viewLineCount/ke);return{typicalViewportLineCount:Ce,extraLinesBeyondLastLine:ae,desiredRatio:ke,minimapLineCount:Ne}}static _computeMinimapLayout(re,Ce){const ae=re.outerWidth,ke=re.outerHeight,Ne=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ke};const He=Ce.stableMinimapLayoutInput,Ge=He&&re.outerHeight===He.outerHeight&&re.lineHeight===He.lineHeight&&re.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&re.pixelRatio===He.pixelRatio&&re.scrollBeyondLastLine===He.scrollBeyondLastLine&&re.minimap.enabled===He.minimap.enabled&&re.minimap.side===He.minimap.side&&re.minimap.size===He.minimap.size&&re.minimap.showSlider===He.minimap.showSlider&&re.minimap.renderCharacters===He.minimap.renderCharacters&&re.minimap.maxColumn===He.minimap.maxColumn&&re.minimap.scale===He.minimap.scale&&re.verticalScrollbarWidth===He.verticalScrollbarWidth&&re.isViewportWrapping===He.isViewportWrapping,qe=re.lineHeight,Ze=re.typicalHalfwidthCharacterWidth,Xe=re.scrollBeyondLastLine,rt=re.minimap.renderCharacters;let tt=Ne>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const st=re.minimap.maxColumn,ot=re.minimap.size,Et=re.minimap.side,Ot=re.verticalScrollbarWidth,kt=re.viewLineCount,mt=re.remainingWidth,Ft=re.isViewportWrapping,Wt=rt?2:3;let Dt=Math.floor(Ne*ke);const Ke=Dt/Ne;let At=!1,Ut=!1,Nt=Wt*tt,pt=tt/Ne,Ct=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Oe,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:Qe}=x.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Xe,height:ke,lineHeight:qe,pixelRatio:Ne});if(kt/Qe>1)At=!0,Ut=!0,tt=1,Nt=1,pt=tt/Ne;else{let ht=!1,wt=tt+1;if(ot==="fit"){const ft=Math.ceil((kt+We)*Nt);Ft&&Ge&&mt<=Ce.stableFitRemainingWidth?(ht=!0,wt=Ce.stableFitMaxMinimapScale):ht=ft>Dt}if(ot==="fill"||ht){At=!0;const ft=tt;Nt=Math.min(qe*Ne,Math.max(1,Math.floor(1/it))),Ft&&Ge&&mt<=Ce.stableFitRemainingWidth&&(wt=Ce.stableFitMaxMinimapScale),tt=Math.min(wt,Math.max(1,Math.floor(Nt/Wt))),tt>ft&&(Ct=Math.min(2,tt/ft)),pt=tt/Ne/Ct,Dt=Math.ceil(Math.max(Oe,kt+We)*Nt),Ft?(Ce.stableMinimapLayoutInput=re,Ce.stableFitRemainingWidth=mt,Ce.stableFitMaxMinimapScale=tt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Tt=Math.floor(st*pt),_t=Math.min(Tt,Math.max(0,Math.floor((mt-Ot-2)*pt/(Ze+pt)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ne*_t);const Fe=Re/Ne;Re=Math.floor(Re*Ct);const be=rt?1:2,Z=Et==="left"?0:ae-_t-Ot;return{renderMinimap:be,minimapLeft:Z,minimapWidth:_t,minimapHeightIsEditorHeight:At,minimapIsSampling:Ut,minimapScale:tt,minimapLineHeight:Nt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Dt,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Ke}}static computeLayout(re,Ce){const ae=Ce.outerWidth|0,ke=Ce.outerHeight|0,Ne=Ce.lineHeight|0,He=Ce.lineNumbersDigitCount|0,Ge=Ce.typicalHalfwidthCharacterWidth,qe=Ce.maxDigitWidth,Ze=Ce.pixelRatio,Xe=Ce.viewLineCount,rt=re.get(124),tt=rt==="inherit"?re.get(123):rt,st=tt==="inherit"?re.get(119):tt,ot=re.get(122),Et=re.get(2),Ot=Ce.isDominatedByLongLines,kt=re.get(51),mt=re.get(61).renderType!==0,Ft=re.get(62),Wt=re.get(95),Dt=re.get(66),Ke=re.get(93),At=Ke.verticalScrollbarSize,Ut=Ke.verticalHasArrows,Nt=Ke.arrowSize,pt=Ke.horizontalScrollbarSize,Ct=re.get(59),Tt=re.get(38);let _t;if(typeof Ct=="string"&&/^\d+(\.\d+)?ch$/.test(Ct)){const vt=parseFloat(Ct.substr(0,Ct.length-2));_t=f.clampedInt(vt*Ge,0,0,1e3)}else _t=f.clampedInt(Ct,0,0,1e3);Tt&&(_t+=16);let Re=0;if(mt){const vt=Math.max(He,Ft);Re=Math.round(vt*qe)}let Fe=0;kt&&(Fe=Ne);let be=0,Z=be+Fe,Oe=Z+Re,We=Oe+_t;const it=ae-Fe-Re-_t;let Qe=!1,ut=!1,ht=-1;Et!==2&&(tt==="inherit"&&Ot?(Qe=!0,ut=!0):st==="on"||st==="bounded"?ut=!0:st==="wordWrapColumn"&&(ht=ot));const wt=x._computeMinimapLayout({outerWidth:ae,outerHeight:ke,lineHeight:Ne,typicalHalfwidthCharacterWidth:Ge,pixelRatio:Ze,scrollBeyondLastLine:Wt,minimap:Dt,verticalScrollbarWidth:At,viewLineCount:Xe,remainingWidth:it,isViewportWrapping:ut},Ce.memory||new L);wt.renderMinimap!==0&&wt.minimapLeft===0&&(be+=wt.minimapWidth,Z+=wt.minimapWidth,Oe+=wt.minimapWidth,We+=wt.minimapWidth);const ft=it-wt.minimapWidth,It=Math.max(1,Math.floor((ft-At-2)/Ge)),Rt=Ut?Nt:0;return ut&&(ht=Math.max(1,It),st==="bounded"&&(ht=Math.min(ht,ot))),{width:ae,height:ke,glyphMarginLeft:be,glyphMarginWidth:Fe,lineNumbersLeft:Z,lineNumbersWidth:Re,decorationsLeft:Oe,decorationsWidth:_t,contentLeft:We,contentWidth:ft,minimap:wt,viewportColumn:It,isWordWrapMinified:Qe,isViewportWrapping:ut,wrappingColumn:ht,verticalScrollbarWidth:At,horizontalScrollbarHeight:pt,overviewRuler:{top:Rt,width:At,height:ke-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=x;class q extends T{constructor(){const re={enabled:!0};super(58,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:u.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:v(re.enabled,this.defaultValue.enabled)}}}class ie extends T{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:u.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(45,null),u.localize(46,null),u.localize(47,null),u.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:u.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:u.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:u.localize(51,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:o(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:v(Ce.padding,this.defaultValue.padding)}}}class Q extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>a.clamp(re,0,150),{markdownDescription:u.localize(52,null)})}compute(re,Ce,ae){return re.fontInfo.lineHeight}}class de extends T{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:u.localize(53,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(54,null),u.localize(55,null),u.localize(56,null)],default:re.size,description:u.localize(57,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:u.localize(58,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:u.localize(59,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(60,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:u.localize(61,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:u.localize(62,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:v(Ce.enabled,this.defaultValue.enabled),size:o(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ce.side,this.defaultValue.side,["right","left"]),showSlider:o(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Ce.scale,1,1,3),maxColumn:f.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(J){return J==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class X extends T{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(63,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(64,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{top:f.clampedInt(Ce.top,0,0,1e3),bottom:f.clampedInt(Ce.bottom,0,0,1e3)}}}class ge extends T{constructor(){const re={enabled:!0,cycle:!1};super(77,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:u.localize(65,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:u.localize(66,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:v(Ce.enabled,this.defaultValue.enabled),cycle:v(Ce.cycle,this.defaultValue.cycle)}}}class Se extends _{constructor(){super(130)}compute(re,Ce,ae){return re.pixelRatio}}class oe extends T{constructor(){const re={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]}];super(80,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:re.strings,description:u.localize(70,null)},comments:{anyOf:Ce,default:re.comments,description:u.localize(71,null)},other:{anyOf:Ce,default:re.other,description:u.localize(72,null)}},default:re,markdownDescription:u.localize(73,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean"){const Ze=re?"on":"off";return{comments:Ze,strings:Ze,other:Ze}}if(!re||typeof re!="object")return this.defaultValue;const{other:Ce,comments:ae,strings:ke}=re,Ne=["on","inline","off"];let He,Ge,qe;return typeof Ce=="boolean"?He=Ce?"on":"off":He=o(Ce,this.defaultValue.other,Ne),typeof ae=="boolean"?Ge=ae?"on":"off":Ge=o(ae,this.defaultValue.comments,Ne),typeof ke=="boolean"?qe=ke?"on":"off":qe=o(ke,this.defaultValue.strings,Ne),{other:He,comments:Ge,strings:qe}}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Pe extends T{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null),u.localize(77,null)],default:"on",description:u.localize(78,null)})}validate(re){let Ce=this.defaultValue.renderType,ae=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Ce=4,ae=re):re==="interval"?Ce=3:re==="relative"?Ce=2:re==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:ae}}}function pe(J){const re=J.get(88);return re==="editable"?J.get(82):re!=="on"}e.filterValidationDecorations=pe;class ve extends T{constructor(){const re=[],Ce={type:"number",description:u.localize(79,null)};super(92,"rulers",re,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:u.localize(80,null),format:"color-hex"}}}]},default:re,description:u.localize(81,null)})}validate(re){if(Array.isArray(re)){const Ce=[];for(let ae of re)if(typeof ae=="number")Ce.push({column:f.clampedInt(ae,0,0,1e4),color:null});else if(ae&&typeof ae=="object"){const ke=ae;Ce.push({column:f.clampedInt(ke.column,0,0,1e4),color:ke.color})}return Ce.sort((ae,ke)=>ae.column-ke.column),Ce}return this.defaultValue}}function Ae(J,re){if(typeof J!="string")return re;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class ce extends T{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(82,null),u.localize(83,null),u.localize(84,null)],default:"auto",description:u.localize(85,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(86,null),u.localize(87,null),u.localize(88,null)],default:"auto",description:u.localize(89,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:u.localize(90,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:u.localize(91,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:u.localize(92,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re,ae=f.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ke=f.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Ce.vertical,this.defaultValue.vertical),horizontal:Ae(Ce.horizontal,this.defaultValue.horizontal),useShadows:v(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ae,horizontalSliderSize:f.clampedInt(Ce.horizontalSliderSize,ae,0,1e3),verticalScrollbarSize:ke,verticalSliderSize:f.clampedInt(Ce.verticalSliderSize,ke,0,1e3),scrollByPage:v(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class me extends T{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:u.localize(93,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:u.localize(94,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:u.localize(98,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:u.localize(99,null)}})}applyUpdate(re,Ce){let ae=!1;Ce.allowedCharacters&&(C.equals(re.allowedCharacters,Ce.allowedCharacters)||(re={...re,allowedCharacters:Ce.allowedCharacters},ae=!0)),Ce.allowedLocales&&(C.equals(re.allowedLocales,Ce.allowedLocales)||(re={...re,allowedLocales:Ce.allowedLocales},ae=!0));const ke=super.applyUpdate(re,Ce);return ae?new S(ke.newValue,!0):ke}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{nonBasicASCII:$(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(re.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(re,Ce){if(typeof re!="object"||!re)return Ce;const ae={};for(const[ke,Ne]of Object.entries(re))Ne===!0&&(ae[ke]=!0);return ae}}class te extends T{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:u.localize(100,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:v(Ce.enabled,this.defaultValue.enabled),mode:o(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ne extends T{constructor(){const re={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:u.localize(101,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:u.localize(102,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{enabled:v(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class U extends T{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(103,null),u.localize(104,null),u.localize(105,null)],default:re.bracketPairs,description:u.localize(106,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(107,null),u.localize(108,null),u.localize(109,null)],default:re.bracketPairsHorizontal,description:u.localize(110,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:u.localize(111,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:u.localize(112,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(113,null),u.localize(114,null),u.localize(115,null)],default:re.highlightActiveIndentation,description:u.localize(116,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{bracketPairs:$(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:$(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $(J,re,Ce){const ae=Ce.indexOf(J);return ae===-1?re:Ce[ae]}class G extends T{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(117,null),u.localize(118,null)],default:re.insertMode,description:u.localize(119,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:u.localize(120,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:u.localize(121,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:u.localize(122,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:u.localize(123,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:u.localize(124,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:u.localize(125,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:u.localize(126,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:u.localize(127,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(128,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(129,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ce=re;return{insertMode:o(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:v(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:v(Ce.preview,this.defaultValue.preview),previewMode:o(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(Ce.showMethods,this.defaultValue.showMethods),showFunctions:v(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:v(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(Ce.showDeprecated,this.defaultValue.showDeprecated),showFields:v(Ce.showFields,this.defaultValue.showFields),showVariables:v(Ce.showVariables,this.defaultValue.showVariables),showClasses:v(Ce.showClasses,this.defaultValue.showClasses),showStructs:v(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:v(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:v(Ce.showModules,this.defaultValue.showModules),showProperties:v(Ce.showProperties,this.defaultValue.showProperties),showEvents:v(Ce.showEvents,this.defaultValue.showEvents),showOperators:v(Ce.showOperators,this.defaultValue.showOperators),showUnits:v(Ce.showUnits,this.defaultValue.showUnits),showValues:v(Ce.showValues,this.defaultValue.showValues),showConstants:v(Ce.showConstants,this.defaultValue.showConstants),showEnums:v(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:v(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(Ce.showKeywords,this.defaultValue.showKeywords),showWords:v(Ce.showWords,this.defaultValue.showWords),showColors:v(Ce.showColors,this.defaultValue.showColors),showFiles:v(Ce.showFiles,this.defaultValue.showFiles),showReferences:v(Ce.showReferences,this.defaultValue.showReferences),showFolders:v(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:v(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:v(Ce.showUsers,this.defaultValue.showUsers),showIssues:v(Ce.showIssues,this.defaultValue.showIssues)}}}class K extends T{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(159,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends _{constructor(){super(131)}compute(re,Ce,ae){return Ce.get(82)?!0:re.tabFocusMode}}var we;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));function se(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends _{constructor(){super(133)}compute(re,Ce,ae){const ke=Ce.get(132);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:ke.isWordWrapMinified,isViewportWrapping:ke.isViewportWrapping,wrappingColumn:ke.wrappingColumn}}}const ye="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?ze:i.isLinux?Ve:ye,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(J){return e.editorOptionsRegistry[J.id]=J,J}var Je;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.enableDropIntoEditor=32]="enableDropIntoEditor",J[J.emptySelectionClipboard=33]="emptySelectionClipboard",J[J.extraEditorClassName=34]="extraEditorClassName",J[J.fastScrollSensitivity=35]="fastScrollSensitivity",J[J.find=36]="find",J[J.fixedOverflowWidgets=37]="fixedOverflowWidgets",J[J.folding=38]="folding",J[J.foldingStrategy=39]="foldingStrategy",J[J.foldingHighlight=40]="foldingHighlight",J[J.foldingImportsByDefault=41]="foldingImportsByDefault",J[J.foldingMaximumRegions=42]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=44]="fontFamily",J[J.fontInfo=45]="fontInfo",J[J.fontLigatures=46]="fontLigatures",J[J.fontSize=47]="fontSize",J[J.fontWeight=48]="fontWeight",J[J.formatOnPaste=49]="formatOnPaste",J[J.formatOnType=50]="formatOnType",J[J.glyphMargin=51]="glyphMargin",J[J.gotoLocation=52]="gotoLocation",J[J.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",J[J.hover=54]="hover",J[J.inDiffEditor=55]="inDiffEditor",J[J.inlineSuggest=56]="inlineSuggest",J[J.letterSpacing=57]="letterSpacing",J[J.lightbulb=58]="lightbulb",J[J.lineDecorationsWidth=59]="lineDecorationsWidth",J[J.lineHeight=60]="lineHeight",J[J.lineNumbers=61]="lineNumbers",J[J.lineNumbersMinChars=62]="lineNumbersMinChars",J[J.linkedEditing=63]="linkedEditing",J[J.links=64]="links",J[J.matchBrackets=65]="matchBrackets",J[J.minimap=66]="minimap",J[J.mouseStyle=67]="mouseStyle",J[J.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=69]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",J[J.multiCursorModifier=71]="multiCursorModifier",J[J.multiCursorPaste=72]="multiCursorPaste",J[J.occurrencesHighlight=73]="occurrencesHighlight",J[J.overviewRulerBorder=74]="overviewRulerBorder",J[J.overviewRulerLanes=75]="overviewRulerLanes",J[J.padding=76]="padding",J[J.parameterHints=77]="parameterHints",J[J.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",J[J.quickSuggestions=80]="quickSuggestions",J[J.quickSuggestionsDelay=81]="quickSuggestionsDelay",J[J.readOnly=82]="readOnly",J[J.renameOnType=83]="renameOnType",J[J.renderControlCharacters=84]="renderControlCharacters",J[J.renderFinalNewline=85]="renderFinalNewline",J[J.renderLineHighlight=86]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=88]="renderValidationDecorations",J[J.renderWhitespace=89]="renderWhitespace",J[J.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",J[J.roundedSelection=91]="roundedSelection",J[J.rulers=92]="rulers",J[J.scrollbar=93]="scrollbar",J[J.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=95]="scrollBeyondLastLine",J[J.scrollPredominantAxis=96]="scrollPredominantAxis",J[J.selectionClipboard=97]="selectionClipboard",J[J.selectionHighlight=98]="selectionHighlight",J[J.selectOnLineNumbers=99]="selectOnLineNumbers",J[J.showFoldingControls=100]="showFoldingControls",J[J.showUnused=101]="showUnused",J[J.snippetSuggestions=102]="snippetSuggestions",J[J.smartSelect=103]="smartSelect",J[J.smoothScrolling=104]="smoothScrolling",J[J.stickyTabStops=105]="stickyTabStops",J[J.stopRenderingLineAfter=106]="stopRenderingLineAfter",J[J.suggest=107]="suggest",J[J.suggestFontSize=108]="suggestFontSize",J[J.suggestLineHeight=109]="suggestLineHeight",J[J.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",J[J.suggestSelection=111]="suggestSelection",J[J.tabCompletion=112]="tabCompletion",J[J.tabIndex=113]="tabIndex",J[J.unicodeHighlighting=114]="unicodeHighlighting",J[J.unusualLineTerminators=115]="unusualLineTerminators",J[J.useShadowDOM=116]="useShadowDOM",J[J.useTabStops=117]="useTabStops",J[J.wordSeparators=118]="wordSeparators",J[J.wordWrap=119]="wordWrap",J[J.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=122]="wordWrapColumn",J[J.wordWrapOverride1=123]="wordWrapOverride1",J[J.wordWrapOverride2=124]="wordWrapOverride2",J[J.wrappingIndent=125]="wrappingIndent",J[J.wrappingStrategy=126]="wrappingStrategy",J[J.showDeprecated=127]="showDeprecated",J[J.inlayHints=128]="inlayHints",J[J.editorClassName=129]="editorClassName",J[J.pixelRatio=130]="pixelRatio",J[J.tabFocusMode=131]="tabFocusMode",J[J.layoutInfo=132]="layoutInfo",J[J.wrappingInfo=133]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(160,null)})),acceptSuggestionOnEnter:Me(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(161,null),""],markdownDescription:u.localize(162,null)})),accessibilitySupport:Me(new n),accessibilityPageSize:Me(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(163,null)})),ariaLabel:Me(new m(4,"ariaLabel",u.localize(164,null))),autoClosingBrackets:Me(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(165,null),u.localize(166,null),""],description:u.localize(167,null)})),autoClosingDelete:Me(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(168,null),""],description:u.localize(169,null)})),autoClosingOvertype:Me(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(170,null),""],description:u.localize(171,null)})),autoClosingQuotes:Me(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(172,null),u.localize(173,null),""],description:u.localize(174,null)})),autoIndent:Me(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[u.localize(175,null),u.localize(176,null),u.localize(177,null),u.localize(178,null),u.localize(179,null)],description:u.localize(180,null)})),automaticLayout:Me(new p(10,"automaticLayout",!1)),autoSurround:Me(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(181,null),u.localize(182,null),u.localize(183,null),""],description:u.localize(184,null)})),bracketPairColorization:Me(new ne),bracketPairGuides:Me(new U),stickyTabStops:Me(new p(105,"stickyTabStops",!1,{description:u.localize(185,null)})),codeLens:Me(new p(14,"codeLens",!0,{description:u.localize(186,null)})),codeLensFontFamily:Me(new m(15,"codeLensFontFamily","",{description:u.localize(187,null)})),codeLensFontSize:Me(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(188,null)})),colorDecorators:Me(new p(17,"colorDecorators",!0,{description:u.localize(189,null)})),columnSelection:Me(new p(18,"columnSelection",!1,{description:u.localize(190,null)})),comments:Me(new t),contextmenu:Me(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new p(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(191,null)})),cursorBlinking:Me(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(192,null)})),cursorSmoothCaretAnimation:Me(new p(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(193,null)})),cursorStyle:Me(new r(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:u.localize(194,null)})),cursorSurroundingLines:Me(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(195,null)})),cursorSurroundingLinesStyle:Me(new h(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(196,null),u.localize(197,null)],description:u.localize(198,null)})),cursorWidth:Me(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(199,null)})),disableLayerHinting:Me(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new p(30,"domReadOnly",!1)),dragAndDrop:Me(new p(31,"dragAndDrop",!0,{description:u.localize(200,null)})),emptySelectionClipboard:Me(new O),enableDropIntoEditor:Me(new p(32,"enableDropIntoEditor",!0)),extraEditorClassName:Me(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Me(new a(35,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:u.localize(201,null)})),find:Me(new k),fixedOverflowWidgets:Me(new p(37,"fixedOverflowWidgets",!1)),folding:Me(new p(38,"folding",!0,{description:u.localize(202,null)})),foldingStrategy:Me(new h(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(203,null),u.localize(204,null)],description:u.localize(205,null)})),foldingHighlight:Me(new p(40,"foldingHighlight",!0,{description:u.localize(206,null)})),foldingImportsByDefault:Me(new p(41,"foldingImportsByDefault",!1,{description:u.localize(207,null)})),foldingMaximumRegions:Me(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(208,null)})),unfoldOnClickAfterEndOfLine:Me(new p(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(209,null)})),fontFamily:Me(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(210,null)})),fontInfo:Me(new M),fontLigatures2:Me(new B),fontSize:Me(new W),fontWeight:Me(new ee),formatOnPaste:Me(new p(49,"formatOnPaste",!1,{description:u.localize(211,null)})),formatOnType:Me(new p(50,"formatOnType",!1,{description:u.localize(212,null)})),glyphMargin:Me(new p(51,"glyphMargin",!0,{description:u.localize(213,null)})),gotoLocation:Me(new H),hideCursorInOverviewRuler:Me(new p(53,"hideCursorInOverviewRuler",!1,{description:u.localize(214,null)})),hover:Me(new N),inDiffEditor:Me(new p(55,"inDiffEditor",!1)),letterSpacing:Me(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>a.clamp(J,-5,20),{description:u.localize(215,null)})),lightbulb:Me(new q),lineDecorationsWidth:Me(new g(59,"lineDecorationsWidth",10)),lineHeight:Me(new Q),lineNumbers:Me(new Pe),lineNumbersMinChars:Me(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new p(63,"linkedEditing",!1,{description:u.localize(216,null)})),links:Me(new p(64,"links",!0,{description:u.localize(217,null)})),matchBrackets:Me(new h(65,"matchBrackets","always",["always","near","never"],{description:u.localize(218,null)})),minimap:Me(new de),mouseStyle:Me(new h(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new a(68,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:u.localize(219,null)})),mouseWheelZoom:Me(new p(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(220,null)})),multiCursorMergeOverlapping:Me(new p(70,"multiCursorMergeOverlapping",!0,{description:u.localize(221,null)})),multiCursorModifier:Me(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[u.localize(222,null),u.localize(223,null)],markdownDescription:u.localize(224,null)})),multiCursorPaste:Me(new h(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(225,null),u.localize(226,null)],markdownDescription:u.localize(227,null)})),occurrencesHighlight:Me(new p(73,"occurrencesHighlight",!0,{description:u.localize(228,null)})),overviewRulerBorder:Me(new p(74,"overviewRulerBorder",!0,{description:u.localize(229,null)})),overviewRulerLanes:Me(new f(75,"overviewRulerLanes",3,0,3)),padding:Me(new X),parameterHints:Me(new ge),peekWidgetDefaultFocus:Me(new h(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(230,null),u.localize(231,null)],description:u.localize(232,null)})),definitionLinkOpensInPeek:Me(new p(79,"definitionLinkOpensInPeek",!1,{description:u.localize(233,null)})),quickSuggestions:Me(new oe),quickSuggestionsDelay:Me(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(234,null)})),readOnly:Me(new p(82,"readOnly",!1)),renameOnType:Me(new p(83,"renameOnType",!1,{description:u.localize(235,null),markdownDeprecationMessage:u.localize(236,null)})),renderControlCharacters:Me(new p(84,"renderControlCharacters",!0,{description:u.localize(237,null),restricted:!0})),renderFinalNewline:Me(new p(85,"renderFinalNewline",!0,{description:u.localize(238,null)})),renderLineHighlight:Me(new h(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(239,null)],description:u.localize(240,null)})),renderLineHighlightOnlyWhenFocus:Me(new p(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(241,null)})),renderValidationDecorations:Me(new h(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new h(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(242,null),u.localize(243,null),u.localize(244,null),""],description:u.localize(245,null)})),revealHorizontalRightPadding:Me(new f(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Me(new p(91,"roundedSelection",!0,{description:u.localize(246,null)})),rulers:Me(new ve),scrollbar:Me(new ce),scrollBeyondLastColumn:Me(new f(94,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(247,null)})),scrollBeyondLastLine:Me(new p(95,"scrollBeyondLastLine",!0,{description:u.localize(248,null)})),scrollPredominantAxis:Me(new p(96,"scrollPredominantAxis",!0,{description:u.localize(249,null)})),selectionClipboard:Me(new p(97,"selectionClipboard",!0,{description:u.localize(250,null),included:i.isLinux})),selectionHighlight:Me(new p(98,"selectionHighlight",!0,{description:u.localize(251,null)})),selectOnLineNumbers:Me(new p(99,"selectOnLineNumbers",!0)),showFoldingControls:Me(new h(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(252,null),u.localize(253,null)],description:u.localize(254,null)})),showUnused:Me(new p(101,"showUnused",!0,{description:u.localize(255,null)})),showDeprecated:Me(new p(127,"showDeprecated",!0,{description:u.localize(256,null)})),inlayHints:Me(new ie),snippetSuggestions:Me(new h(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(257,null),u.localize(258,null),u.localize(259,null),u.localize(260,null)],description:u.localize(261,null)})),smartSelect:Me(new K),smoothScrolling:Me(new p(104,"smoothScrolling",!1,{description:u.localize(262,null)})),stopRenderingLineAfter:Me(new f(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new G),inlineSuggest:Me(new te),suggestFontSize:Me(new f(108,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(263,null)})),suggestLineHeight:Me(new f(109,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(264,null)})),suggestOnTriggerCharacters:Me(new p(110,"suggestOnTriggerCharacters",!0,{description:u.localize(265,null)})),suggestSelection:Me(new h(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null)],description:u.localize(269,null)})),tabCompletion:Me(new h(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(270,null),u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),tabIndex:Me(new f(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new me),unusualLineTerminators:Me(new h(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(274,null),u.localize(275,null),u.localize(276,null)],description:u.localize(277,null)})),useShadowDOM:Me(new p(116,"useShadowDOM",!0)),useTabStops:Me(new p(117,"useTabStops",!0,{description:u.localize(278,null)})),wordSeparators:Me(new m(118,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:u.localize(279,null)})),wordWrap:Me(new h(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(280,null),u.localize(281,null),u.localize(282,null),u.localize(283,null)],description:u.localize(284,null)})),wordWrapBreakAfterCharacters:Me(new m(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new m(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new f(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(285,null)})),wordWrapOverride1:Me(new h(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new h(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Me(new r(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],se,{enumDescriptions:[u.localize(286,null),u.localize(287,null),u.localize(288,null),u.localize(289,null)],description:u.localize(290,null)})),wrappingStrategy:Me(new h(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(291,null),u.localize(292,null)],description:u.localize(293,null)})),editorClassName:Me(new F),pixelRatio:Me(new Se),tabFocusMode:Me(new he),layoutInfo:Me(new x),wrappingInfo:Me(new De)}}),define(Ie[163],Te([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[164],Te([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[165],Te([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[166],Te([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[167],Te([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(Ie[168],Te([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(Ie[169],Te([19,20]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(Ie[170],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[171],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[172],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[173],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[174],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[175],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[176],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[177],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[178],Te([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[179],Te([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(Ie[180],Te([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[181],Te([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[182],Te([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[183],Te([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[184],Te([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[185],Te([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[186],Te([19,20]),function(Y,e){return Y.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[187],Te([19,20]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[188],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var i;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var y;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(y=e.EditorOpenSource||(e.EditorOpenSource={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ie[189],Te([1,0,22,41,165,299]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function E(p){return p=p.trim(),p==="*"||C.test(p)}e.isValidVersionStr=E;function P(p){if(!E(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=p.match(C);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=P;function L(p){if(!p)return null;let b=p.majorBase,f=p.majorMustEqual,a=p.minorBase,m=p.minorMustEqual,o=p.patchBase,h=p.patchMustEqual;p.hasCaret&&(b===0||(m=!1),h=!1);let r=0;if(p.preRelease){const s=D.exec(p.preRelease);if(s){const[,n,t,c]=s;r=Date.UTC(Number(n),Number(t)-1,Number(c))}}return{majorBase:b,majorMustEqual:f,minorBase:a,minorMustEqual:m,patchBase:o,patchMustEqual:h,isMinimum:p.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function T(p,b,f){let a;typeof p=="string"?a=L(P(p)):a=p;let m;b instanceof Date?m=b.getTime():typeof b=="string"&&(m=new Date(b).getTime());let o;if(typeof f=="string"?o=L(P(f)):o=f,!a||!o)return!1;let h=a.majorBase,r=a.minorBase,s=a.patchBase,n=o.majorBase,t=o.minorBase,c=o.patchBase,l=o.notBefore,d=o.majorMustEqual,w=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?h>n?!0:h<n?!1:r>t?!0:r<t||m&&m<l?!1:s>=c:(h===1&&n===0&&(!d||!w||!R)&&(n=1,t=0,c=0,d=!0,w=!1,R=!1),h<n?!1:h>n?!d:r<t?!1:r>t?!w:s<c?!1:s>c?!R:!(m&&m<l))}e.isValidVersion=T;function S(p,b,f,a,m){const o=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return o.push([i.default.Error,y.localize(0,null)]),o;if(typeof a.name!="string")return o.push([i.default.Error,y.localize(1,null,"name")]),o;if(typeof a.version!="string")return o.push([i.default.Error,y.localize(2,null,"version")]),o;if(!a.engines)return o.push([i.default.Error,y.localize(3,null,"engines")]),o;if(typeof a.engines.vscode!="string")return o.push([i.default.Error,y.localize(4,null,"engines.vscode")]),o;if(typeof a.extensionDependencies!="undefined"&&!v(a.extensionDependencies))return o.push([i.default.Error,y.localize(5,null,"extensionDependencies")]),o;if(typeof a.activationEvents!="undefined"){if(!v(a.activationEvents))return o.push([i.default.Error,y.localize(6,null,"activationEvents")]),o;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return o.push([i.default.Error,y.localize(7,null,"activationEvents","main")]),o}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&o.push([i.default.Warning,y.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return o.push([i.default.Error,y.localize(9,null,"main")]),o;{const s=(0,u.joinPath)(f,a.main);(0,u.isEqualOrParent)(s,f)||o.push([i.default.Warning,y.localize(10,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([i.default.Error,y.localize(11,null,"activationEvents","main")]),o}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return o.push([i.default.Error,y.localize(12,null,"browser")]),o;{const s=(0,u.joinPath)(f,a.browser);(0,u.isEqualOrParent)(s,f)||o.push([i.default.Warning,y.localize(13,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([i.default.Error,y.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(a.version))return o.push([i.default.Error,y.localize(15,null)]),o;const h=[];if(!I(p,b,a,m,h))for(const s of h)o.push([i.default.Error,s]);return o}e.validateExtensionManifest=S;function I(p,b,f,a,m){return a||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:g(p,b,f.engines.vscode,m)}e.isValidExtensionVersion=I;function _(p,b,f){return p==="*"||g(b,f,p)}e.isEngineValid=_;function g(p,b,f,a=[]){let m=L(P(f));if(!m)return a.push(y.localize(16,null,f)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return a.push(y.localize(17,null,f)),!1}else if(!m.majorMustEqual)return a.push(y.localize(18,null,f)),!1;return T(p,b,m)?!0:(a.push(y.localize(19,null,p,f)),!1)}function v(p){if(!Array.isArray(p))return!1;for(let b=0,f=p.length;b<f;b++)if(typeof p[b]!="string")return!1;return!0}}),define(Ie[115],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(y,A=[],C=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=u}),define(Ie[83],Te([1,0,115]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function y(C,D,E){D instanceof u.SyncDescriptor||(D=new u.SyncDescriptor(D,[],E)),i.push([C,D])}e.registerSingleton=y;function A(){return i}e.getSingletonServiceDescriptors=A}),define(Ie[190],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=u;class i{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let C of this._nodes.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const D=this.lookupOrInsertNode(A),E=this.lookupOrInsertNode(C);D.outgoing.set(this._hashFn(C),E),E.incoming.set(this._hashFn(A),D)}removeNode(A){const C=this._hashFn(A);this._nodes.delete(C);for(let D of this._nodes.values())D.outgoing.delete(C),D.incoming.delete(C)}lookupOrInsertNode(A){const C=this._hashFn(A);let D=this._nodes.get(C);return D||(D=new u(A),this._nodes.set(C,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[C,D]of this._nodes)A.push(`${C}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,C]of this._nodes){const D=new Set([A]),E=this._findCycle(C,D);if(E)return E}}_findCycle(A,C){for(let[D,E]of A.outgoing){if(C.has(D))return[...C,D].join(" -> ");C.add(D);const P=this._findCycle(E,C);if(P)return P;C.delete(D)}}}e.Graph=i}),define(Ie[4],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(E){return E[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(u=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function i(C,D,E){D[u.DI_TARGET]===D?D[u.DI_DEPENDENCIES].push({id:C,index:E}):(D[u.DI_DEPENDENCIES]=[{id:C,index:E}],D[u.DI_TARGET]=D)}function y(C){if(u.serviceIds.has(C))return u.serviceIds.get(C);const D=function(E,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,E,L)};return D.toString=()=>C,u.serviceIds.set(C,D),D}e.createDecorator=y;function A(C){return C}e.refineServiceDecorator=A}),define(Ie[84],Te([1,0,12,2,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationOverrides=A;function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||u.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=C;var D;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(p,b){const f=Object.create(null);for(let a in p)L(f,a,p[a],b);return f}e.toValuesTree=P;function L(p,b,f,a){const m=b.split("."),o=m.pop();let h=p;for(let r=0;r<m.length;r++){let s=m[r],n=h[s];switch(typeof n){case"undefined":n=h[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${b} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}h=n}if(typeof h=="object"&&h!==null)try{h[o]=f}catch{a(`Ignoring ${b} as ${m.join(".")} is ${JSON.stringify(h)}`)}else a(`Ignoring ${b} as ${m.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=L;function T(p,b){const f=b.split(".");S(p,f)}e.removeFromValueTree=T;function S(p,b){const f=b.shift();if(b.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const a=p[f];typeof a=="object"&&!Array.isArray(a)&&(S(a,b),Object.keys(a).length===0&&delete p[f])}}function I(p,b,f){function a(h,r){let s=h;for(const n of r){if(typeof s!="object"||s===null)return;s=s[n]}return s}const m=b.split("."),o=a(p,m);return typeof o=="undefined"?f:o}e.getConfigurationValue=I;function _(p,b,f){Object.keys(b).forEach(a=>{a!=="__proto__"&&(a in p?u.isObject(p[a])&&u.isObject(b[a])?_(p[a],b[a],f):f&&(p[a]=b[a]):p[a]=b[a])})}e.merge=_;function g(p,b,f){const a=p.inspect(b),m=p.inspect(f);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}e.getMigratedSettingValue=g;function v(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(Ie[52],Te([1,0,13,8,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",u.isMacintosh),A.set("isLinux",u.isLinux),A.set("isWindows",u.isWindows),A.set("isWeb",u.isWeb),A.set("isMacNative",u.isMacintosh&&!u.isWeb),A.set("isEdge",u.isEdge),A.set("isFirefox",u.isFirefox),A.set("isChrome",u.isChrome),A.set("isSafari",u.isSafari);const C=Object.prototype.hasOwnProperty;var D;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return T.INSTANCE}static true(){return S.INSTANCE}static has(k){return I.create(k)}static equals(k,B){return _.create(k,B)}static notEquals(k,B){return p.create(k,B)}static regex(k,B){return r.create(k,B)}static in(k,B){return g.create(k,B)}static not(k){return b.create(k)}static and(...k){return t.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,B){return a.create(k,B)}static greaterEquals(k,B){return m.create(k,B)}static smaller(k,B){return o.create(k,B)}static smallerEquals(k,B){return h.create(k,B)}static deserialize(k,B=!1){if(!!k)return this._deserializeOrExpression(k,B)}static _deserializeOrExpression(k,B){let M=k.split("||");return c.create(M.map(W=>this._deserializeAndExpression(W,B)),null,!0)}static _deserializeAndExpression(k,B){let M=k.split("&&");return t.create(M.map(W=>this._deserializeOne(W,B)),null)}static _deserializeOne(k,B){if(k=k.trim(),k.indexOf("!=")>=0){let M=k.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],B))}if(k.indexOf("==")>=0){let M=k.split("==");return _.create(M[0].trim(),this._deserializeValue(M[1],B))}if(k.indexOf("=~")>=0){let M=k.split("=~");return r.create(M[0].trim(),this._deserializeRegexValue(M[1],B))}if(k.indexOf(" in ")>=0){let M=k.split(" in ");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const M=k.split(">=");return m.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const M=k.split(">");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const M=k.split("<=");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const M=k.split("<");return o.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(k)?b.create(k.substr(1).trim()):I.create(k)}static _deserializeValue(k,B){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let M=/^'([^']*)'$/.exec(k);return M?M[1].trim():k}static _deserializeRegexValue(k,B){if((0,i.isFalsyOrWhitespace)(k)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=k.indexOf("/"),W=k.lastIndexOf("/");if(M===W||M<0){if(B)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let ee=k.slice(M+1,W),H=k[W+1]==="i"?"i":"";try{return new RegExp(ee,H)}catch(N){if(B)throw new Error(`bad regexp-value '${k}', parse error: ${N}`);return console.warn(`bad regexp-value '${k}', parse error: ${N}`),null}}}e.ContextKeyExpr=E;function P(O,k){const B=O?O.substituteConstants():void 0,M=k?k.substituteConstants():void 0;return!B&&!M?!0:!B||!M?!1:B.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function L(O,k){return O.cmp(k)}class T{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class S{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class I{constructor(k,B){this.key=k,this.negated=B,this.type=2}static create(k,B=null){const M=A.get(k);return typeof M=="boolean"?M?S.INSTANCE:T.INSTANCE:new I(k,B)}cmp(k){return k.type!==this.type?this.type-k.type:d(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?S.INSTANCE:T.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class _{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=4}static create(k,B,M=null){if(typeof B=="boolean")return B?I.create(k,M):b.create(k,M);const W=A.get(k);return typeof W=="boolean"?B===(W?"true":"false")?S.INSTANCE:T.INSTANCE:new _(k,B,M)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const B=k?"true":"false";return this.value===B?S.INSTANCE:T.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=_;class g{constructor(k,B){this.key=k,this.valueKey=B,this.type=10,this.negated=null}static create(k,B){return new g(k,B)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const B=k.getValue(this.valueKey),M=k.getValue(this.key);return Array.isArray(B)?B.includes(M):typeof M=="string"&&typeof B=="object"&&B!==null?C.call(B,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=g;class v{constructor(k){this._actual=k,this.type=11}static create(k){return new v(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new v(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class p{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=5}static create(k,B,M=null){if(typeof B=="boolean")return B?b.create(k,M):I.create(k,M);const W=A.get(k);return typeof W=="boolean"?B===(W?"true":"false")?T.INSTANCE:S.INSTANCE:new p(k,B,M)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const B=k?"true":"false";return this.value===B?T.INSTANCE:S.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class b{constructor(k,B){this.key=k,this.negated=B,this.type=3}static create(k,B=null){const M=A.get(k);return typeof M=="boolean"?M?T.INSTANCE:S.INSTANCE:new b(k,B)}cmp(k){return k.type!==this.type?this.type-k.type:d(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?T.INSTANCE:S.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function f(O,k){if(typeof O=="string"){const B=parseFloat(O);isNaN(B)||(O=B)}return typeof O=="string"||typeof O=="number"?k(O):T.INSTANCE}class a{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=12}static create(k,B,M=null){return f(B,W=>new a(k,W,M))}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class m{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=13}static create(k,B,M=null){return f(B,W=>new m(k,W,M))}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class o{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=14}static create(k,B,M=null){return f(B,W=>new o(k,W,M))}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class h{constructor(k,B,M){this.key=k,this.value=B,this.negated=M,this.type=15}static create(k,B,M=null){return f(B,W=>new h(k,W,M))}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class r{constructor(k,B){this.key=k,this.regexp=B,this.type=7,this.negated=null}static create(k,B){return new r(k,B)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const B=this.regexp?this.regexp.source:"",M=k.regexp?k.regexp.source:"";return B<M?-1:B>M?1:0}equals(k){if(k.type===this.type){const B=this.regexp?this.regexp.source:"",M=k.regexp?k.regexp.source:"";return this.key===k.key&&B===M}return!1}substituteConstants(){return this}evaluate(k){let B=k.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(k){this._actual=k,this.type=8}static create(k){return new s(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new s(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(O){let k=null;for(let B=0,M=O.length;B<M;B++){const W=O[B].substituteConstants();if(O[B]!==W&&k===null){k=[];for(let ee=0;ee<B;ee++)k[ee]=O[ee]}k!==null&&(k[B]=W)}return k===null?O:k}class t{constructor(k,B){this.expr=k,this.negated=B,this.type=6}static create(k,B){return t._normalizeArr(k,B)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const W=L(this.expr[B],k.expr[B]);if(W!==0)return W}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(k.expr[B]))return!1;return!0}return!1}substituteConstants(){const k=n(this.expr);return k===this.expr?this:t.create(k,this.negated)}evaluate(k){for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].evaluate(k))return!1;return!0}static _normalizeArr(k,B){const M=[];let W=!1;for(const ee of k)if(!!ee){if(ee.type===1){W=!0;continue}if(ee.type===0)return T.INSTANCE;if(ee.type===6){M.push(...ee.expr);continue}M.push(ee)}if(M.length===0&&W)return S.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(L);for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];for(;M.length>1;){const ee=M[M.length-1];if(ee.type!==9)break;M.pop();const H=M.pop(),N=M.length===0,j=c.create(ee.expr.map(x=>t.create([x,H],null)),null,N);j&&(M.push(j),M.sort(L))}return M.length===1?M[0]:new t(M,B)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let B of this.expr)k.push(...B.keys());return k}map(k){return new t(this.expr.map(B=>B.map(k)),null)}negate(){if(!this.negated){const k=[];for(let B of this.expr)k.push(B.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{constructor(k,B){this.expr=k,this.negated=B,this.type=9}static create(k,B,M){return c._normalizeArr(k,B,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const W=L(this.expr[B],k.expr[B]);if(W!==0)return W}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(k.expr[B]))return!1;return!0}return!1}substituteConstants(){const k=n(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let B=0,M=this.expr.length;B<M;B++)if(this.expr[B].evaluate(k))return!0;return!1}static _normalizeArr(k,B,M){let W=[],ee=!1;if(k){for(let H=0,N=k.length;H<N;H++){const j=k[H];if(!!j){if(j.type===0){ee=!0;continue}if(j.type===1)return S.INSTANCE;if(j.type===9){W=W.concat(j.expr);continue}W.push(j)}}if(W.length===0&&ee)return T.INSTANCE;W.sort(L)}if(W.length!==0){if(W.length===1)return W[0];for(let H=1;H<W.length;H++)W[H-1].equals(W[H])&&(W.splice(H,1),H--);if(W.length===1)return W[0];if(M){for(let H=0;H<W.length;H++)for(let N=H+1;N<W.length;N++)R(W[H],W[N])&&(W.splice(N,1),N--);if(W.length===1)return W[0]}return new c(W,B)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let B of this.expr)k.push(...B.keys());return k}map(k){return new c(this.expr.map(B=>B.map(k)),null)}negate(){if(!this.negated){let k=[];for(let B of this.expr)k.push(B.negate());for(;k.length>1;){const B=k.shift(),M=k.shift(),W=[];for(const H of F(B))for(const N of F(M))W.push(t.create([H,N],null));const ee=k.length===0;k.unshift(c.create(W,null,ee))}this.negated=k[0]}return this.negated}}class l extends I{constructor(k,B,M){super(k,null);this._defaultValue=B,typeof M=="object"?l._info.push({...M,key:k}):M!==!0&&l._info.push({key:k,description:M,type:B!=null?typeof B:void 0})}static all(){return l._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return _.create(this.key,k)}notEqualsTo(k){return p.create(this.key,k)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(O,k){return O<k?-1:O>k?1:0}function w(O,k,B,M){return O<B?-1:O>B?1:k<M?-1:k>M?1:0}function R(O,k){if(k.type===6&&O.type!==9&&O.type!==6){for(const W of k.expr)if(O.equals(W))return!0}const B=O.negate(),M=F(B).concat(F(k));M.sort(L);for(let W=0;W<M.length;W++){const H=M[W].negate();for(let N=W+1;N<M.length;N++){const j=M[N];if(H.equals(j))return!0}}return!1}e.implies=R;function F(O){return O.type===9?O.expr:[O]}}),define(Ie[191],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[85],Te([1,0,164,4]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function A(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(p,b){switch(p){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function D(p,b){return b==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function E(p,b,f){return D(b,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:P(f).includes(p)}e.isTargetPlatformCompatible=E;function P(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=L;var T;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var S;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var I;(function(p){p.Install="install",p.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var _;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var g;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(b,f){super(b);this.code=f,this.name=f}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService")}),define(Ie[192],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(Ie[193],Te([1,0,42,10,9,13,96,29,113,166,192]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=P.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends S{openTerminal(a,m){return this.spawnTerminal(u,a,E.getWindowsShell(),m)}spawnTerminal(a,m,o,h){const r=m.windowsExec||I.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const s=y.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return a.spawn(r,h?[h]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(s==="wt"||s==="wt.exe")&&n.push("-d ."),new Promise((t,c)=>{const l=v(process),d=a.spawn(o,n,{cwd:h,env:l});d.on("error",c),d.on("exit",()=>t())})}runInTerminal(a,m,o,h,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:I.getDefaultTerminalWindows();return new Promise((n,t)=>{const c=`"${m} - ${T}"`,l=`""${o.join('" "')}" & pause"`,d=["/c","start",c,"/wait",s,"/c",l],w=Object.assign({},v(process),h);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const R={cwd:m,env:w,windowsVerbatimArguments:!0};u.spawn(I.CMD,d,R).on("error",O=>{t(p(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!I._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return I._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=I,I.CMD="cmd.exe";class _ extends S{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,h,r){const s=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{if(s===L.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",a||T,"-w",m];for(let F of o)d.push("-a"),d.push(F);if(h){const F=Object.assign({},v(process),h);for(let O in F){const k=F[O];k===null?(d.push("-u"),d.push(O)):(d.push("-e"),d.push(`${O}=${k}`))}}let w="";const R=u.spawn(_.OSASCRIPT,d);R.on("error",F=>{t(p(F))}),R.stderr.on("data",F=>{w+=F.toString()}),R.on("exit",F=>{if(F===0)n(void 0);else if(w){const O=w.split(`
`,1);t(new Error(O[0]))}else t(new Error(P.localize(1,null,c,F)))})}else t(new Error(P.localize(2,null,s)))})}spawnTerminal(a,m,o){const h=m.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const n=["-a",h];o&&n.push(o);const t=v(process),c=a.spawn("/usr/bin/open",n,{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})}}e.MacExternalTerminalService=_,_.OSASCRIPT="/usr/bin/osascript";class g extends S{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,h,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{let c=[];s.then(l=>{l.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const d=`${b(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;c.push(`''${d}''`);const w=Object.assign({},v(process),h);Object.keys(w).filter(k=>w[k]===null).forEach(k=>delete w[k]);const R={cwd:m,env:w};let F="";const O=u.spawn(l,c,R);O.on("error",k=>{t(p(k))}),O.stderr.on("data",k=>{F+=k.toString()}),O.on("exit",k=>{if(k===0)n(void 0);else if(F){const B=F.split(`
`,1);t(new Error(B[0]))}else t(new Error(P.localize(4,null,l,k)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await D.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{a?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,m,o){const h=m.linuxExec?Promise.resolve(m.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{h.then(n=>{const t=v(process),c=a.spawn(n,[],{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=P.localize(3,null);function v(f){const a={...f.env};return(0,C.sanitizeProcessEnvironment)(a),a}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(P.localize(5,null,f.path)):f}function b(f){let a="";for(let m of f)m.indexOf(" ")>=0?a+='"'+m+'"':a+=m,a+=" ";return a}}),define(Ie[43],Te([1,0,11,25,9,8,12,2,167,4]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function L(N){return N.create===!0}e.isFileOpenForWriteOptions=L;var T;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var S;(function(N){N[N.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var I;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=_;function g(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=g;function v(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=v;function p(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function b(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=b;function f(N){return _(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var a;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(j,x){super(j);this.code=x}}e.FileSystemProviderError=m;function o(N,j){const x=new m(N.toString(),j);return r(x,j),x}e.createFileSystemProviderError=o;function h(N){return N||o((0,E.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=h;function r(N,j){return N.name=j?`${j} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=r;function s(N){if(!N)return a.Unknown;if(N instanceof m)return N.code;const j=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!j)return a.Unknown;switch(j[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=s;function n(N){if(N instanceof R)return N.fileOperationResult;switch(s(N)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class c{constructor(j,x,q){this.resource=j,this.operation=x,this.target=q}isOperation(j){return this.operation===j}}e.FileOperationEvent=c;var l;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class d{constructor(j,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const q=new Map;for(const ie of j){const Q=q.get(ie.type);switch(Q?Q.push([ie.resource,ie]):q.set(ie.type,[[ie.resource,ie]]),ie.type){case 1:this.rawAdded.push(ie.resource);break;case 0:this.rawUpdated.push(ie.resource);break;case 2:this.rawDeleted.push(ie.resource);break}}for(const[ie,Q]of q)switch(ie){case 1:this.added=i.TernarySearchTree.forUris(()=>x),this.added.fill(Q);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>x),this.updated.fill(Q);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>x),this.deleted.fill(Q);break}}contains(j,...x){return this.doContains(j,{includeChildren:!1},...x)}affects(j,...x){return this.doContains(j,{includeChildren:!0},...x)}doContains(j,x,...q){if(!j)return!1;const ie=q.length>0;return!!((!ie||q.includes(1))&&(this.added?.get(j)||x.includeChildren&&this.added?.findSuperstr(j))||(!ie||q.includes(0))&&(this.updated?.get(j)||x.includeChildren&&this.updated?.findSuperstr(j))||(!ie||q.includes(2))&&(this.deleted?.findSubstr(j)||x.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function w(N,j,x){return!N||!j||N===j||j.length>N.length?!1:(j.charAt(j.length-1)!==y.sep&&(j+=y.sep),x?(0,A.startsWithIgnoreCase)(N,j):N.indexOf(j)===0)}e.isParent=w;class R extends u.ErrorNoTelemetry{constructor(j,x,q){super(j);this.fileOperationResult=x,this.options=q}}e.FileOperationError=R;class F extends R{constructor(j,x,q){super(j,2,q);this.stat=x}}e.NotModifiedSinceFileOperationError=F;var O;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=B;async function M(N,j){if(!j.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(x=>{const q=j.onDidChangeFileSystemProviderRegistrations(ie=>{ie.scheme===N.scheme&&ie.added&&(q.dispose(),x())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<W.KB?(0,E.localize)(1,null,j.toFixed(0)):j<W.MB?(0,E.localize)(2,null,(j/W.KB).toFixed(2)):j<W.GB?(0,E.localize)(3,null,(j/W.MB).toFixed(2)):j<W.TB?(0,E.localize)(4,null,(j/W.GB).toFixed(2)):(0,E.localize)(5,null,(j/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var ee;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function H(N){return{maxFileSize:N===0?300*W.MB:16*W.GB,maxHeapSize:N===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=H}),define(Ie[86],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...y){this._entries=new Map;for(let[A,C]of y)this.set(A,C)}set(y,A){const C=this._entries.get(y);return this._entries.set(y,A),C}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=u}),define(Ie[194],Te([1,0,17,11,115,190,4,86]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class P extends Error{constructor(_){super("cyclic dependency between services");this.message=_.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${_.toString()}`}}class L{constructor(_=new D.ServiceCollection,g=!1,v){this._activeInstantiations=new Set,this._services=_,this._strict=g,this._parent=v,this._services.set(C.IInstantiationService,this)}createChild(_){return new L(_,this._strict,this)}invokeFunction(_,...g){let v=S.traceInvocation(_),p=!1;try{return _({get:f=>{if(p)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,v);if(!a)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...g)}finally{p=!0,v.stop()}}createInstance(_,...g){let v,p;return _ instanceof y.SyncDescriptor?(v=S.traceCreation(_.ctor),p=this._createInstance(_.ctor,_.staticArguments.concat(g),v)):(v=S.traceCreation(_),p=this._createInstance(_,g,v)),v.stop(),p}_createInstance(_,g=[],v){let p=C._util.getServiceDependencies(_).sort((a,m)=>a.index-m.index),b=[];for(const a of p){let m=this._getOrCreateServiceInstance(a.id,v);m||this._throwIfStrict(`[createInstance] ${_.name} depends on UNKNOWN service ${a.id}.`,!1),b.push(m)}let f=p.length>0?p[0].index:g.length;if(g.length!==f){console.trace(`[createInstance] First service dependency of ${_.name} at position ${f+1} conflicts with ${g.length} static arguments`);let a=f-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,f)}return new _(...[...g,...b])}_setServiceInstance(_,g){if(this._services.get(_)instanceof y.SyncDescriptor)this._services.set(_,g);else if(this._parent)this._parent._setServiceInstance(_,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(_){let g=this._services.get(_);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(_):g}_getOrCreateServiceInstance(_,g){let v=this._getServiceInstanceOrDescriptor(_);return v instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(_,v,g.branch(_,!0)):(g.branch(_,!1),v)}_safeCreateAndCacheServiceInstance(_,g,v){if(this._activeInstantiations.has(_))throw new Error(`illegal state - RECURSIVELY instantiating service '${_}'`);this._activeInstantiations.add(_);try{return this._createAndCacheServiceInstance(_,g,v)}finally{this._activeInstantiations.delete(_)}}_createAndCacheServiceInstance(_,g,v){const p=new A.Graph(a=>a.id.toString());let b=0;const f=[{id:_,desc:g,_trace:v}];for(;f.length;){const a=f.pop();if(p.lookupOrInsertNode(a),b++>1e3)throw new P(p);for(let m of C._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(m.id);if(o||this._throwIfStrict(`[createInstance] ${_} depends on ${m.id} which is NOT registered.`,!0),o instanceof y.SyncDescriptor){const h={id:m.id,desc:o,_trace:a._trace.branch(m.id,!0)};p.insertEdge(a,h),f.push(h)}}}for(;;){const a=p.roots();if(a.length===0){if(!p.isEmpty())throw new P(p);break}for(const{data:m}of a){if(this._getServiceInstanceOrDescriptor(m.id)instanceof y.SyncDescriptor){const h=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,h)}p.removeNode(m)}}return this._getServiceInstanceOrDescriptor(_)}_createServiceInstanceWithOwner(_,g,v=[],p,b){if(this._services.get(_)instanceof y.SyncDescriptor)return this._createServiceInstance(g,v,p,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(_,g,v,p,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(_,g=[],v,p){if(v){const b=new u.IdleValue(()=>this._createInstance(_,g,p));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];let m=b.value,o=m[a];return typeof o!="function"||(o=o.bind(m),f[a]=o),o},set(f,a,m){return b.value[a]=m,!0}})}else return this._createInstance(_,g,p)}_throwIfStrict(_,g){if(g&&console.warn(g),this._strict)throw new Error(_)}}e.InstantiationService=L;var T;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(T||(T={}));class S{constructor(_,g){this.type=_,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(_){return E?new S(1,_.name||_.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(_){return E?new S(0,_.name):S._None}branch(_,g){let v=new S(2,_.toString());return this._dep.push([_,g,v]),v}stop(){let _=Date.now()-this._start;S._totals+=_;let g=!1;function v(b,f){let a=[],m=new Array(b+1).join("	");for(const[o,h,r]of f._dep)if(h&&r){g=!0,a.push(`${m}CREATES -> ${o}`);let s=v(b+1,r);s&&a.push(s)}else a.push(`${m}uses -> ${o}`);return a.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${_.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(_>2||g)&&console.log(p.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Ie[14],Te([1,0,51,3,6,13,4]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function D(){return new Date().toISOString()}var E;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(h,r,s){switch(r){case E.Trace:h.trace(s);break;case E.Debug:h.debug(s);break;case E.Info:h.info(s);break;case E.Warning:h.warn(s);break;case E.Error:h.error(s);break;case E.Critical:h.critical(s);break;default:throw new Error("Invalid log level")}}e.log=P;function L(h){let r="";for(let s=0;s<h.length;s++){let n=h[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(s>0?" ":"")+n}return r}e.format=L;class T extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class S extends T{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(E.Trace)&&this.log(E.Trace,L([r,...s]))}debug(r,...s){this.checkLogLevel(E.Debug)&&this.log(E.Debug,L([r,...s]))}info(r,...s){this.checkLogLevel(E.Info)&&this.log(E.Info,L([r,...s]))}warn(r,...s){this.checkLogLevel(E.Warning)&&this.log(E.Warning,L([r,...s]))}error(r,...s){if(this.checkLogLevel(E.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(E.Error,L(n))}else this.log(E.Error,L([r,...s]))}critical(r,...s){this.checkLogLevel(E.Critical)&&this.log(E.Critical,L([r,...s]))}flush(){}}e.AbstractMessageLogger=S;class I extends T{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...s){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}debug(r,...s){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}info(r,...s){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}warn(r,...s){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,r,...s):console.warn(`[main ${D()}]`,r,...s))}error(r,...s){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}critical(r,...s){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class _ extends T{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=_;class g extends T{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class v extends T{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const n of this.logServices)n.trace(r,...s)}debug(r,...s){for(const n of this.logServices)n.debug(r,...s)}info(r,...s){for(const n of this.logServices)n.info(r,...s)}warn(r,...s){for(const n of this.logServices)n.warn(r,...s)}error(r,...s){for(const n of this.logServices)n.error(r,...s)}critical(r,...s){for(const n of this.logServices)n.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class p extends y.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=p;class b extends y.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,s?.always?E.Trace:this.logLevel,s),this.loggers.set(r.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=f;function a(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const r=m(h.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function m(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=m;function o(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=o}),define(Ie[195],Te([1,0,43,14]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(D,E,P,L,T){try{const S=await new Promise((_,g)=>{Y(["spdlog"],_,g)});S.setFlushOn(i.LogLevel.Trace);const I=await S.createAsyncRotatingLogger(D,E,P,L);return T&&I.clearFormatters(),I}catch(S){console.error(S)}return null}function A(D,E,P){switch(E){case i.LogLevel.Trace:D.trace(P);break;case i.LogLevel.Debug:D.debug(P);break;case i.LogLevel.Info:D.info(P);break;case i.LogLevel.Warning:D.warn(P);break;case i.LogLevel.Error:D.error(P);break;case i.LogLevel.Critical:D.critical(P);break;default:throw new Error("Invalid log level")}}class C extends i.AbstractMessageLogger{constructor(E,P,L,T,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(E,P,L,T),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}async _createSpdLogLogger(E,P,L,T){const S=L?6:1,I=30/S*u.ByteSize.MB,_=await y(E,P,I,S,T);if(_){this._logger=_,this._logger.setLevel(this.getLevel());for(const{level:g,message:v}of this.buffer)A(this._logger,g,v);this.buffer=[]}}log(E,P){this._logger?A(this._logger,E,P):this.getLevel()<=E&&this.buffer.push({level:E,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(Ie[116],Te([1,0,41,168,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var C;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(_,g){return g-_}E.compare=P;const L=Object.create(null);L[E.Error]=(0,i.localize)(0,null),L[E.Warning]=(0,i.localize)(1,null),L[E.Info]=(0,i.localize)(2,null);function T(_){return L[_]||""}E.toString=T;function S(_){switch(_){case u.default.Error:return E.Error;case u.default.Warning:return E.Warning;case u.default.Info:return E.Info;case u.default.Ignore:return E.Hint}}E.fromSeverity=S;function I(_){switch(_){case E.Error:return u.default.Error;case E.Warning:return u.default.Warning;case E.Info:return u.default.Info;case E.Hint:return u.default.Ignore}}E.toSeverity=I}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(E){const P="";function L(S){return T(S,!0)}E.makeKey=L;function T(S,I){let _=[P];return S.source?_.push(S.source.replace("\xA6","\\\xA6")):_.push(P),S.code?typeof S.code=="string"?_.push(S.code.replace("\xA6","\\\xA6")):_.push(S.code.value.replace("\xA6","\\\xA6")):_.push(P),S.severity!==void 0&&S.severity!==null?_.push(C.toString(S.severity)):_.push(P),S.message&&I?_.push(S.message.replace("\xA6","\\\xA6")):_.push(P),S.startLineNumber!==void 0&&S.startLineNumber!==null?_.push(S.startLineNumber.toString()):_.push(P),S.startColumn!==void 0&&S.startColumn!==null?_.push(S.startColumn.toString()):_.push(P),S.endLineNumber!==void 0&&S.endLineNumber!==null?_.push(S.endLineNumber.toString()):_.push(P),S.endColumn!==void 0&&S.endColumn!==null?_.push(S.endColumn.toString()):_.push(P),_.push(P),_.join("\xA6")}E.makeKeyOptionalMessage=T})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[196],Te([1,0,3,41,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,y.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new E,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class E{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=E}),define(Ie[117],Te([1,0,6,8,2,4]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function C(L,T){return y.URI.isUri(L)?(0,i.equalsIgnoreCase)(L.scheme,T):(0,i.startsWithIgnoreCase)(L,T+":")}e.matchesScheme=C;function D(L,...T){return T.some(S=>C(L,S))}e.matchesSomeScheme=D;function E(L,T){return L.with({fragment:`${T.startLineNumber},${T.startColumn}${T.endLineNumber?`-${T.endLineNumber}${T.endColumn?`,${T.endColumn}`:""}`:""}`})}e.withSelection=E;function P(L){let T;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return S&&(T={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},L=L.with({fragment:""})),{selection:T,uri:L}}e.extractSelection=P}),define(Ie[197],Te([1,0,10,13,40,22]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)C=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const D=(0,A.dirname)(u.FileAccess.asFileUri("",Y));C=Y.__$__nodeRequire((0,A.joinPath)(D,"product.json").fsPath);const E=Y.__$__nodeRequire((0,A.joinPath)(D,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:E.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(Ie[198],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(Y,e){return function(u,i){e(u,i,Y)}};define(Ie[118],Te([1,0,17,21,6,4]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let E=class extends y.Disposable{constructor(T,S){super();this.deferred=new u.DeferredPromise,S.withProgress(T,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};E=je([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends y.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(T){this.stop();const S=++this.currentOperationId,I=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:I.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Ie[44],Te([1,0,57,12]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(C,D){u.ok(i.isString(C)),u.ok(i.isObject(D)),u.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new y}),define(Ie[119],Te([1,0,3,44]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[y(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new A;i.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[120],Te([1,0,16,3,12,163,84,119,44]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=E.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,h=!0){this.registerConfigurations([o],h)}registerConfigurations(o,h=!0){const r=this.doRegisterConfigurations(o,h);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const h=this.doDeregisterConfigurations(o);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:o,remove:h}){const r=[];r.push(...this.doDeregisterConfigurations(h)),r.push(...this.doRegisterConfigurations(o,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(r)})}registerDefaultConfigurations(o){const h=[],r=[];for(const{overrides:s,source:n}of o)for(const t in s)if(h.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),l=c?.valuesSources??new Map;if(n)for(const F of Object.keys(s[t]))l.set(F,n);const d={...c?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:d,valuesSources:l});const w=(0,C.getLanguageTagSettingPlainKey)(t),R={type:"object",default:d,description:A.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:y.isString(n)?void 0:n,defaultValueSource:n};r.push(...g(t)),this.configurationProperties[t]=R,this.defaultLanguageConfigurationOverridesNode.properties[t]=R}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const h=[];for(const{overrides:r,source:s}of o)for(const n in r){const t=this.configurationDefaultsOverrides.get(n),c=y.isString(s)?s:s?.id,l=y.isString(t?.source)?t?.source:t?.source?.id;if(c===l)if(h.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const h of o)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,h){const r=[];return o.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(o){const h=[],r=s=>{if(s.properties)for(const n in s.properties){h.push(n);const t=this.configurationProperties[n];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n])}s.allOf&&s.allOf.forEach(n=>r(n))};for(const s of o){r(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return h}validateAndRegisterProperties(o,h=!0,r,s,n=3){n=y.isUndefinedOrNull(o.scope)?n:o.scope;let t=[],c=o.properties;if(c)for(let d in c){const w=c[d];if(h&&f(d,w)){delete c[d];continue}if(w.source=r,w.defaultDefaultValue=c[d].default,this.updatePropertyDefaultValue(d,w),e.OVERRIDE_PROPERTY_REGEX.test(d)?w.scope=void 0:(w.scope=y.isUndefinedOrNull(w.scope)?n:w.scope,w.restricted=y.isUndefinedOrNull(w.restricted)?!!s?.includes(d):w.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.excludedConfigurationProperties[d]=c[d],delete c[d];continue}else this.configurationProperties[d]=c[d],c[d].policy?.name&&this.policyConfigurations.set(c[d].policy.name,d);!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),t.push(d)}let l=o.allOf;if(l)for(let d of l)t.push(...this.validateAndRegisterProperties(d,h,r,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const h=r=>{let s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let n=r.allOf;n&&n.forEach(h)};h(o)}updateSchema(o,h){switch(e.allSettings.properties[o]=h,h.scope){case 1:e.applicationSettings.properties[o]=h;break;case 2:e.machineSettings.properties[o]=h;break;case 6:e.machineOverridableSettings.properties[o]=h;break;case 3:e.windowSettings.properties[o]=h;break;case 4:e.resourceSettings.properties[o]=h;break;case 5:e.resourceSettings.properties[o]=h,this.resourceLanguageSettingsSchema.properties[o]=h;break}}removeFromSchema(o,h){switch(delete e.allSettings.properties[o],h.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const h=`[${o}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,h){const r=this.configurationDefaultsOverrides.get(o);let s=r?.value,n=r?.source;y.isUndefined(s)&&(s=h.defaultDefaultValue,n=void 0),y.isUndefined(s)&&(s=p(h.type)),h.default=s,h.defaultValueSource=n}}const I="\\[([^\\]]+)\\]",_=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(m){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let h=_.exec(m);for(;h?.length;){const r=h[1].trim();r&&o.push(r),h=_.exec(m)}}return(0,u.distinct)(o)}e.overrideIdentifiersFromKey=g;function v(m){return m.reduce((o,h)=>`${o}[${h}]`,"")}e.keyFromOverrideIdentifiers=v;function p(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const b=new S;E.Registry.add(e.Extensions.Configuration,b);function f(m,o){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?A.localize(7,null,m):b.getConfigurationProperties()[m]!==void 0?A.localize(8,null,m):o.policy?.name&&b.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(9,null,m,o.policy?.name,b.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function a(){const m=[],o=b.getConfigurationProperties();for(const h of Object.keys(o))m.push([h,o[h].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=a}),define(Ie[199],Te([1,0,16,3,143,6,25,24,12,2,84,120,44]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(h={},r=[],s=[]){this._contents=h,this._keys=r,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(h){return h?(0,L.getConfigurationValue)(this.contents,h):this.contents}getOverrideValue(h,r){const s=this.getContentsForOverrideIdentifer(r);return s?h?(0,L.getConfigurationValue)(s,h):s:void 0}getKeysForOverrideIdentifier(h){const r=[];for(const s of this.overrides)s.identifiers.includes(h)&&r.push(...s.keys);return u.distinct(r)}getAllOverrideIdentifiers(){const h=[];for(const r of this.overrides)h.push(...r.identifiers);return u.distinct(h)}override(h){let r=this.overrideConfigurations.get(h);return r||(r=this.createOverrideConfigurationModel(h),this.overrideConfigurations.set(h,r)),r}merge(...h){const r=D.deepClone(this.contents),s=D.deepClone(this.overrides),n=[...this.keys];for(const t of h){this.mergeContents(r,t.contents);for(const c of t.overrides){const[l]=s.filter(d=>u.equals(d.identifiers,c.identifiers));l?(this.mergeContents(l.contents,c.contents),l.keys.push(...c.keys),l.keys=u.distinct(l.keys)):s.push(D.deepClone(c))}for(const c of t.keys)n.indexOf(c)===-1&&n.push(c)}return new I(r,n,s)}freeze(){return this.frozen=!0,this}clone(){return new I(D.deepClone(this.contents),[...this.keys],D.deepClone(this.overrides))}createOverrideConfigurationModel(h){const r=this.getContentsForOverrideIdentifer(h);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const n of u.distinct([...Object.keys(this.contents),...Object.keys(r)])){let t=this.contents[n],c=r[n];c&&(typeof t=="object"&&typeof c=="object"?(t=D.deepClone(t),this.mergeContents(t,c)):t=c),s[n]=t}return new I(s,this.keys,this.overrides)}mergeContents(h,r){for(const s of Object.keys(r)){if(s in h&&E.isObject(h[s])&&E.isObject(r[s])){this.mergeContents(h[s],r[s]);continue}h[s]=D.deepClone(r[s])}}checkAndFreeze(h){return this.frozen&&!Object.isFrozen(h)?D.deepFreeze(h):h}getContentsForOverrideIdentifer(h){let r=null,s=null;const n=t=>{t&&(s?this.mergeContents(s,t):s=D.deepClone(t))};for(const t of this.overrides)u.equals(t.identifiers,[h])?r=t.contents:t.identifiers.includes(h)&&n(t.contents);return n(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(h,r){this.addKey(h),(0,L.addToValueTree)(this.contents,h,r,s=>{throw new Error(s)})}removeValue(h){this.removeKey(h)&&(0,L.removeFromValueTree)(this.contents,h)}addKey(h){let r=this.keys.length;for(let s=0;s<r;s++)h.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,h)}removeKey(h){let r=this.keys.indexOf(h);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=I;class _{constructor(h){this._name=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(h,r){if(!E.isUndefinedOrNull(h)){const s=this.doParseContent(h);this.parseRaw(s,r)}}reparse(h){this._raw&&this.parseRaw(this._raw,h)}parseRaw(h,r){this._raw=h;const{contents:s,keys:n,overrides:t,restricted:c}=this.doParseRaw(h,r);this._configurationModel=new I(s,n,t),this._restrictedConfigurations=c||[]}doParseContent(h){let r={},s=null,n=[],t=[],c=[];function l(w){Array.isArray(n)?n.push(w):s!==null&&(n[s]=w)}let d={onObjectBegin:()=>{let w={};l(w),t.push(n),n=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{let w=[];l(w),t.push(n),n=w,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:l,onError:(w,R,F)=>{c.push({error:w,offset:R,length:F})}};if(h)try{y.visit(h,d),r=n[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(h,r){const s=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),n=this.filter(h,s,!0,r);h=n.raw;const t=(0,L.toValuesTree)(h,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),c=Object.keys(h),l=this.toOverrides(h,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:t,keys:c,overrides:l,restricted:n.restricted}}filter(h,r,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:h,restricted:[]};const t={},c=[];for(let l in h)if(T.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const d=this.filter(h[l],r,!1,n);t[l]=d.raw,c.push(...d.restricted)}else{const d=r[l],w=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&c.push(l),(w===void 0||n.scopes===void 0||n.scopes.includes(w))&&(n.skipRestricted&&d?.restricted||(t[l]=h[l]))}return{raw:t,restricted:c}}toOverrides(h,r){const s=[];for(const n of Object.keys(h))if(T.OVERRIDE_PROPERTY_REGEX.test(n)){const t={};for(const c in h[n])t[c]=h[n][c];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(n),keys:Object.keys(t),contents:(0,L.toValuesTree)(t,r)})}return s}}e.ConfigurationModelParser=_;class g extends A.Disposable{constructor(h,r,s,n){super();this.userSettingsResource=h,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new _(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&s.isEqual(t.resource,h)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const h=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(h.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(h,r,s,n=new I,t=new I,c=new C.ResourceMap,l=new I,d=new C.ResourceMap,w=!0){this._defaultConfiguration=h,this._policyConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=d,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(h,r,s){return this.getConsolidatedConfigurationModel(h,r,s).getValue(h)}updateValue(h,r,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new I,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(h):n.setValue(h,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(h,r,s){const n=this.getConsolidatedConfigurationModel(h,r,s),t=this.getFolderConfigurationModelForResource(r.resource,s),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this._defaultConfiguration.freeze().getValue(h),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(h),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.userConfiguration.freeze().getValue(h),R=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.localUserConfiguration.freeze().getValue(h),F=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.remoteUserConfiguration.freeze().getValue(h),O=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this._workspaceConfiguration.freeze().getValue(h):void 0,k=t?r.overrideIdentifier?t.freeze().override(r.overrideIdentifier).getValue(h):t.freeze().getValue(h):void 0,B=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(h):c.getValue(h),M=n.getValue(h),W=u.distinct(n.overrides.map(ee=>ee.identifiers).flat()).filter(ee=>n.getOverrideValue(h,ee)!==void 0);return{defaultValue:l,policyValue:d,userValue:w,userLocalValue:R,userRemoteValue:F,workspaceValue:O,workspaceFolderValue:k,memoryValue:B,value:M,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:t?.freeze().getValue(h),override:r.overrideIdentifier?t?.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:c.getValue(h),override:r.overrideIdentifier?c.getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(h){const r=this.getFolderConfigurationModelForResource(void 0,h);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(h){this._defaultConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(h){this._policyConfiguration=h}updateLocalUserConfiguration(h){this._localUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(h){this._remoteUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(h){this._workspaceConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(h,r){this._folderConfigurations.set(h,r),this._foldersConsolidatedConfigurations.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this._foldersConsolidatedConfigurations.delete(h)}compareAndUpdateDefaultConfiguration(h,r){const s=[];if(!r){const{added:n,updated:t,removed:c}=a(this._defaultConfiguration,h);r=[...n,...t,...c]}for(const n of r)for(const t of(0,T.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),l=h.getKeysForOverrideIdentifier(t),d=[...l.filter(w=>c.indexOf(w)===-1),...c.filter(w=>l.indexOf(w)===-1),...c.filter(w=>!D.equals(this._defaultConfiguration.override(t).getValue(w),h.override(t).getValue(w)))];s.push([t,d])}return this.updateDefaultConfiguration(h),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(h){const{added:r,updated:s,removed:n}=a(this._policyConfiguration,h),t=[...r,...s,...n];return t.length&&this.updatePolicyConfiguration(h),{keys:t,overrides:[]}}compareAndUpdateLocalUserConfiguration(h){const{added:r,updated:s,removed:n,overrides:t}=a(this.localUserConfiguration,h),c=[...r,...s,...n];return c.length&&this.updateLocalUserConfiguration(h),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(h){const{added:r,updated:s,removed:n,overrides:t}=a(this.remoteUserConfiguration,h);let c=[...r,...s,...n];return c.length&&this.updateRemoteUserConfiguration(h),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(h){const{added:r,updated:s,removed:n,overrides:t}=a(this.workspaceConfiguration,h);let c=[...r,...s,...n];return c.length&&this.updateWorkspaceConfiguration(h),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(h,r){const s=this.folderConfigurations.get(h),{added:n,updated:t,removed:c,overrides:l}=a(s,r);let d=[...n,...t,...c];return(d.length||!s)&&this.updateFolderConfiguration(h,r),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(h){const r=this.folderConfigurations.get(h);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:s,updated:n,removed:t,overrides:c}=a(r,void 0);return{keys:[...s,...n,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(h,r,s){let n=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(h)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:h},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&h){const n=r.getFolder(h);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const t=this._memoryConfigurationByResource.get(h);t&&(s=s.merge(t))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(h){let r=this._foldersConsolidatedConfigurations.get(h);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(h);n?(r=s.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(h,r)):r=s}return r}getFolderConfigurationModelForResource(h,r){if(r&&h){const s=r.getFolder(h);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((h,r)=>{const{contents:s,overrides:n,keys:t}=this._folderConfigurations.get(r);return h.push([r,{contents:s,overrides:n,keys:t}]),h},[])}}allKeys(){const h=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>h.add(r)),this.userConfiguration.freeze().keys.forEach(r=>h.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>h.add(s))),[...h.values()]}allOverrideIdentifiers(){const h=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(s=>h.add(s))),[...h.values()]}getAllKeysForOverrideIdentifier(h){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(h).forEach(n=>r.add(n))),[...r.values()]}static parse(h){const r=this.parseConfigurationModel(h.defaults),s=this.parseConfigurationModel(h.policy),n=this.parseConfigurationModel(h.user),t=this.parseConfigurationModel(h.workspace),c=h.folders.reduce((l,d)=>(l.set(P.URI.revive(d[0]),this.parseConfigurationModel(d[1])),l),new C.ResourceMap);return new v(r,s,n,new I,t,c,new I,new C.ResourceMap,!1)}static parseConfigurationModel(h){return new I(h.contents,h.keys,h.overrides).freeze()}}e.Configuration=v;function p(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const h=new Set,r=new Map;for(const n of o)n.keys.forEach(t=>h.add(t)),n.overrides.forEach(([t,c])=>{const l=(0,C.getOrSet)(r,t,new Set);c.forEach(d=>l.add(d))});const s=[];return r.forEach((n,t)=>s.push([t,[...n.values()]])),{keys:[...h.values()],overrides:s}}e.mergeChanges=p;class b{constructor(h,r,s,n){this.change=h,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const t=new Set;h.keys.forEach(l=>t.add(l)),h.overrides.forEach(([,l])=>l.forEach(d=>t.add(d))),this.affectedKeys=[...t.values()];const c=new I;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(h,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,h)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(h,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(h,r,this.currentWorkspace);return!D.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(h,r){let s=(0,L.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(h=h[n],!h)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=b;class f extends b{constructor(h,r,s,n){super({keys:h.allKeys(),overrides:[]},void 0,h,r);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=f;function a(o,h){const{added:r,removed:s,updated:n}=m(h,o),t=[],c=o?.getAllOverrideIdentifiers()||[],l=h?.getAllOverrideIdentifiers()||[];if(h){const d=l.filter(w=>!c.includes(w));for(const w of d)t.push([w,h.getKeysForOverrideIdentifier(w)])}if(o){const d=c.filter(w=>!l.includes(w));for(const w of d)t.push([w,o.getKeysForOverrideIdentifier(w)])}if(h&&o){for(const d of c)if(l.includes(d)){const w=m({contents:o.getOverrideValue(void 0,d)||{},keys:o.getKeysForOverrideIdentifier(d)},{contents:h.getOverrideValue(void 0,d)||{},keys:h.getKeysForOverrideIdentifier(d)});t.push([d,[...w.added,...w.removed,...w.updated]])}}return{added:r,removed:s,updated:n,overrides:t}}function m(o,h){const r=o?h?o.keys.filter(t=>h.keys.indexOf(t)===-1):[...o.keys]:[],s=h?o?h.keys.filter(t=>o.keys.indexOf(t)===-1):[...h.keys]:[],n=[];if(o&&h){for(const t of h.keys)if(o.keys.indexOf(t)!==-1){const c=(0,L.getConfigurationValue)(h.contents,t),l=(0,L.getConfigurationValue)(o.contents,t);D.equals(c,l)||n.push(t)}}return{added:r,removed:s,updated:n}}}),define(Ie[121],Te([1,0,11,4]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends u.ErrorNoTelemetry{constructor(D,E=y.Unknown,P){super(D);this._message=D,this._code=E,this._detail=P,this.isHandled=E===y.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(D){return D instanceof A&&D._code===y.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof A&&D._code===y.NoResolverFound}static isHandled(D){return D instanceof A&&D.isHandled}}e.RemoteAuthorityResolverError=A}),define(Ie[122],Te([1,0,10]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(C){return C.scheme===u.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=i;function y(C){if(!C)return;const D=C.indexOf("+");return D<0?C:C.substr(0,D)}e.getRemoteName=y;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A}),define(Ie[26],Te([1,0,8,4,122]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=A;function C(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var E;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,g){if(typeof _=="undefined"||_===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof _=="string"||typeof g=="string"){let v=typeof _=="string"?_:_.value,p=typeof g=="string"?g:g.value;return u.equalsIgnoreCase(v,p)}return _._lower===g._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=P;function L(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function T(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function S(I,_){if(_){const g=`onResolveRemoteAuthority:${(0,y.getRemoteName)(_)}`;return I.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[200],Te([1,0,8,85,26,13,2,11,40]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,u.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=P;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new T(s.identifier,n,t)}static parse(s){const n=L.exec(s);return n&&n[1]&&n[2]?new T({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof T?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=T;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(r){const s=S.exec(r);return s&&s[1]?[g(s[1]),s[2]]:[g(r),void 0]}e.getIdAndVersion=I;function _(r,s){return`${r}.${s}`}e.getExtensionId=_;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function v(r,s){return g(_(r,s))}e.getGalleryExtensionId=v;function p(r,s){const n=[],t=c=>{for(const l of n)if(l.some(d=>P(s(d),s(c))))return l;return null};for(const c of r){const l=t(c);l?l.push(c):n.push([c])}return n}e.groupByExtension=p;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function a(r){const s=new Set;if(r.malicious)for(const n of r.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=a;function m(r,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const c=t.shift();if(c&&n.every(l=>!P(l.identifier,{id:c}))){const l=r.filter(d=>P(d.identifier,{id:c}));l.length===1&&(n.push(l[0]),t.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=m;async function o(r,s){if(!A.isLinux)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function h(r,s){const n=await o(r,s),t=(0,i.getTargetPlatform)(n?"alpine":A.platform,E.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=h}),define(Ie[201],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((y,A)=>Y(["vsda"],y,A))}async createNewMessage(y){try{const A=await this.vsda(),C=new A.validator;if(C){const D=String(u._nextId++);return this.validators.set(D,C),{id:D,data:C.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,A){if(!y.id)return!0;const C=this.validators.get(y.id);if(!C)return!1;this.validators.delete(y.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(y){try{const A=await this.vsda(),C=new A.signer;if(C)return C.sign(y)}catch{}return y}}e.SignService=u,u._nextId=1}),define(Ie[202],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,A,C=5){let D;return D=A(E=>{const P=typeof E=="string"?E:E.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(P);return}const T=setTimeout(()=>this.flushBuffer(y),C);L={data:[P],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(y),D.dispose()}},this._terminalBufferMap.set(y,L)}),D}stopBuffering(y){const A=this._terminalBufferMap.get(y);A&&A.dispose()}flushBuffer(y){const A=this._terminalBufferMap.get(y);A&&(this._terminalBufferMap.delete(y),this._callback(y,A.data.join("")))}}e.TerminalDataBufferer=u}),define(Ie[203],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===u.HIGH_CONTRAST_DARK||A===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function y(A){return A===u.DARK||A===u.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[87],Te([1,0,78,3,6,4,44,203]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var E;(function(v){function p(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=p})(E=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var L;(function(v){function p(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||E.isThemeColor(s.color))}v.isThemeIcon=p;const b=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const n=b.exec(s);if(!n)return;let[,t]=n;return{id:t}}v.fromString=f;function a(s){return{id:s}}v.fromId=a;function m(s,n){let t=s.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),n&&(t=`${t}~${n}`),{id:t}}v.modify=m;function o(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}v.getModifier=o;function h(s,n){return s.id===n.id&&s.color?.id===n.color?.id}v.isEqual=h;function r(s,n){return{id:s.id,color:n?P(n):void 0}}v.asThemeIcon=r,v.asClassNameArray=u.CSSIcon.asClassNameArray,v.asClassName=u.CSSIcon.asClassName,v.asCSSSelector=u.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function T(v){switch(v){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,y.toDisposable)(()=>{const b=this.themingParticipants.indexOf(p);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let I=new S;C.Registry.add(e.Extensions.ThemingContribution,I);function _(v){return I.onColorThemeChange(v)}e.registerThemingParticipant=_;class g extends y.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,b){let f=this.theme.getColor(p);return f&&b&&(f=b(f,this.theme)),f?f.toString():null}}e.Themable=g}),define(Ie[123],Te([1,0,3,13,4,14]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(_){_.Http="http",_.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(_){_.ConstantPrivate="constantPrivate",_.Private="private",_.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(_){_[_.Notify=1]="Notify",_[_.OpenBrowser=2]="OpenBrowser",_[_.OpenPreview=3]="OpenPreview",_[_.Silent=4]="Silent",_[_.Ignore=5]="Ignore",_[_.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(_){if(_.scheme!=="http"&&_.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(_.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(_){return e.LOCALHOST_ADDRESSES.indexOf(_)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(_){return e.ALL_INTERFACES_ADDRESSES.indexOf(_)>=0}e.isAllInterfaces=T;function S(_,g){return g?g!==1&&_<1024:!i.isWindows&&_<1024}e.isPortPrivileged=S;let I=class{constructor(g){this.logService=g,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],v=Array.from(this._tunnels.values());for(let p of v){const b=Array.from(p.values());for(let f of b){const a=await f.value;a&&g.push(a)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:v}of g.values())await v.then(p=>p?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,v,p,b,f=!1,a,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${p} on local port ${b}.`),!g)return;if(v||(v="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(g,v,p,b,f,a,m);return o?o.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(h);return(h.tunnelRemoteHost!==v||h.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const v=this._tunnels.get(g.tunnelRemoteHost);if(v){const p=v.get(g.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,p))}}}}async tryDisposeTunnel(g,v,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${v}.`);const b=p.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(v),b}}async closeTunnel(g,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${v} `);const p=this._tunnels.get(g);if(p&&p.has(v)){const b=p.get(v);b.refcount=0,await this.tryDisposeTunnel(g,v,b)}}addTunnelToMap(g,v,p){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(v,{refcount:1,value:p})}async removeEmptyTunnelFromMap(g,v){const p=this._tunnels.get(g);p&&(await p.get(v)||p.delete(v),p.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,v){let p=[g];L(g)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):T(g)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(f=>this._tunnels.get(f));for(const f of b){const a=f?.get(v);if(a)return a}}canTunnel(g){return!!P(g)}createWithProvider(g,v,p,b,f,a,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${p} on local port ${b}.`);const o=p;this._factoryInProgress.add(o);const r={elevationRequired:f?S(b===void 0?p:b):!1},s={remoteAddress:{host:v,port:p},localAddressPort:b,privacy:a,public:a?a!==D.Private:void 0,protocol:m},n=g.forwardPort(s,r);return n?(this.addTunnelToMap(v,p,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),n}};I=je([xe(0,A.ILogService)],I),e.AbstractTunnelService=I}),define(Ie[204],Te([1,0,10]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function i(E){return E.scheme!==u.Schemas.file&&E.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=i;function y(E){if(E.folders.length)return E.folders.every(P=>i(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&i(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=y;function A(E){return y(E)?.scheme}e.getVirtualWorkspaceScheme=A;function C(E){return y(E)?.authority}e.getVirtualWorkspaceAuthority=C;function D(E){return y(E)!==void 0}e.isVirtualWorkspace=D}),define(Ie[45],Te([1,0,169,9,25,22,2,4,10]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function P(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=P;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function T(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=T;function S(r){const s=r;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:C.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=S;var I;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function _(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=_;function g(r){const s=r;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=g;class v{constructor(s,n,t,c,l){this._id=s,this._transient=t,this._configuration=c,this._ignorePathCasing=l,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class p{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(r){return new p({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(r,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function m(r){let s;return C.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=m;function o(r,s){return!a(r,s)&&!m(r)}e.isSavedWorkspace=o;function h(r){return(typeof r=="string"?(0,i.extname)(r):(0,A.extname)(r))===f}e.hasWorkspaceFileExtension=h}),define(Ie[88],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const A=this._idPool++;return this._data.set(A,y),this.logDebugInfo(),A}get(y,A){return this._data.has(y)?this._data.get(y)[A]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(Ie[46],Te([1,0,10,22,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(D=>{const E=this._providerInfo.get(D.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(D,E){E===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,E)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(Ie[205],Te([1,0,17]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(C,D,E){this._deferredPromises=new Map,this._id=C,this._shared=D,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const T of P.values())T.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,D){let E=this._value[C];return typeof E=="undefined"&&(E=D),E}update(C,D){this._value[C]=D;let E=this._deferredPromises.get(C);if(E!==void 0)return E.p;const P=new u.DeferredPromise;return this._deferredPromises.set(C,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class y extends i{constructor(C,D){super(C.identifier.value,!0,D);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=y}),define(Ie[206],Te([1,0,3,2]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this._notebooksAndEditors=C,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(C,D,E,P){const T=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C)).acceptModelChanged(D.value,E,P);this._onDidChangeNotebookDocument.fire(T)}$acceptDirtyStateChanged(C,D){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C)).acceptDirty(D)}$acceptModelSaved(C){const D=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(C));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[18],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class i{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[207],Te([1,0,26,3]),function(Y,e,u,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,E){y.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(D.identifier),et(this,y,E,"f"),Ue(this,y,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(D){return Ue(this,y,"f").get(this._id,D)}store(D,E){return Ue(this,y,"f").store(this._id,D,E)}delete(D){return Ue(this,y,"f").delete(this._id,D)}}e.ExtensionSecrets=A,y=new WeakMap}),define(Ie[124],Te([1,0,4,3]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new i.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(C,D){this._level=C,this._productConfig=D||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(Ie[53],Te([1,0,4,123,3,18]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(E){function P(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:T.protocol}}E.fromApiTunnel=P;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==i.TunnelPrivacyId.ConstantPrivate&&T.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}E.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let D=class{constructor(P){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,T,S,I){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([xe(0,A.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[7],Te([1,0,16,11,102,25,95,8,12,2,35,43,121]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";var I,_,g,v,p,b,f,a,m,o,h,r,s,n,t,c,l,d,w,R,F,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(V){function z(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(z,V),Object.setPrototypeOf(z.prototype,V.prototype),z}let B=b=class{constructor(z){I.set(this,void 0),et(this,I,z,"f")}static from(...z){let le=z;return new b(function(){if(le){for(const Le of le)Le&&typeof Le.dispose=="function"&&Le.dispose();le=void 0}})}dispose(){typeof Ue(this,I,"f")=="function"&&(Ue(this,I,"f").call(this),et(this,I,void 0,"f"))}};I=new WeakMap,B=b=je([k],B),e.Disposable=B;let M=f=class{constructor(z,le){if(z<0)throw(0,i.illegalArgument)("line must be non-negative");if(le<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=z,this._character=le}static Min(...z){if(z.length===0)throw new TypeError;let le=z[0];for(let Le=1;Le<z.length;Le++){const Ye=z[Le];Ye.isBefore(le)&&(le=Ye)}return le}static Max(...z){if(z.length===0)throw new TypeError;let le=z[0];for(let Le=1;Le<z.length;Le++){const Ye=z[Le];Ye.isAfter(le)&&(le=Ye)}return le}static isPosition(z){if(!z)return!1;if(z instanceof f)return!0;let{line:le,character:Le}=z;return typeof le=="number"&&typeof Le=="number"}static of(z){if(z instanceof f)return z;if(this.isPosition(z))return new f(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,le=0){if(z===null||le===null)throw(0,i.illegalArgument)();let Le;return typeof z=="undefined"?Le=0:typeof z=="number"?Le=z:(Le=typeof z.lineDelta=="number"?z.lineDelta:0,le=typeof z.characterDelta=="number"?z.characterDelta:0),Le===0&&le===0?this:new f(this.line+Le,this.character+le)}with(z,le=this.character){if(z===null||le===null)throw(0,i.illegalArgument)();let Le;return typeof z=="undefined"?Le=this.line:typeof z=="number"?Le=z:(Le=typeof z.line=="number"?z.line:this.line,le=typeof z.character=="number"?z.character:this.character),Le===this.line&&le===this.character?this:new f(Le,le)}toJSON(){return{line:this.line,character:this.character}}};M=f=je([k],M),e.Position=M;let W=a=class{constructor(z,le,Le,Ye){let nt,ct;if(typeof z=="number"&&typeof le=="number"&&typeof Le=="number"&&typeof Ye=="number"?(nt=new M(z,le),ct=new M(Le,Ye)):M.isPosition(z)&&M.isPosition(le)&&(nt=M.of(z),ct=M.of(le)),!nt||!ct)throw new Error("Invalid arguments");nt.isBefore(ct)?(this._start=nt,this._end=ct):(this._start=ct,this._end=nt)}static isRange(z){return z instanceof a?!0:z?M.isPosition(z.start)&&M.isPosition(z.end):!1}static of(z){if(z instanceof a)return z;if(this.isRange(z))return new a(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(z){return a.isRange(z)?this.contains(z.start)&&this.contains(z.end):M.isPosition(z)?!(M.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const le=M.Max(z.start,this._start),Le=M.Min(z.end,this._end);if(!le.isAfter(Le))return new a(le,Le)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const le=M.Min(z.start,this._start),Le=M.Max(z.end,this.end);return new a(le,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,le=this.end){if(z===null||le===null)throw(0,i.illegalArgument)();let Le;return z?M.isPosition(z)?Le=z:(Le=z.start||this.start,le=z.end||this.end):Le=this.start,Le.isEqual(this._start)&&le.isEqual(this.end)?this:new a(Le,le)}toJSON(){return[this.start,this.end]}};W=a=je([k],W),e.Range=W;let ee=m=class extends W{constructor(z,le,Le,Ye){let nt,ct;if(typeof z=="number"&&typeof le=="number"&&typeof Le=="number"&&typeof Ye=="number"?(nt=new M(z,le),ct=new M(Le,Ye)):M.isPosition(z)&&M.isPosition(le)&&(nt=M.of(z),ct=M.of(le)),!nt||!ct)throw new Error("Invalid arguments");super(nt,ct);this._anchor=nt,this._active=ct}static isSelection(z){return z instanceof m?!0:z?W.isRange(z)&&M.isPosition(z.anchor)&&M.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=m=je([k],ee),e.Selection=ee;class H{constructor(z,le,Le){if(typeof z!="string"||z.length===0)throw(0,i.illegalArgument)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,i.illegalArgument)("port");if(typeof Le!="undefined"&&(typeof Le!="string"||Le.length===0||!/^[0-9A-Za-z\-]+$/.test(Le)))throw(0,i.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(le),this.connectionToken=Le}}e.ResolvedAuthority=H;class N extends Error{constructor(z,le=S.RemoteAuthorityResolverErrorCode.Unknown,Le){super(z);this._message=z,this._code=le,this._detail=Le,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(z,le){return new N(z,S.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(z){return new N(z,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var j;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var x;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=o=class{constructor(z,le){this._range=z,this._newText=le}static isTextEdit(z){return z instanceof o?!0:z?W.isRange(z)&&typeof z.newText=="string":!1}static replace(z,le){return new o(z,le)}static insert(z,le){return o.replace(new W(z,z),le)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const le=new o(new W(new M(0,0),new M(0,0)),"");return le.newEol=z,le}get range(){return this._range}set range(z){if(z&&!W.isRange(z))throw(0,i.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,i.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,i.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=o=je([k],q),e.TextEdit=q;let ie=h=class{constructor(z,le){this.range=z,this.newCells=le}static isNotebookCellEdit(z){return z instanceof h?!0:z?Mt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,le){return new h(z,le)}static insertCells(z,le){return new h(new Mt(z,z),le)}static deleteCells(z){return new h(z,[])}static updateCellMetadata(z,le){const Le=new h(new Mt(z,z),[]);return Le.newCellMetadata=le,Le}static updateNotebookMetadata(z){const le=new h(new Mt(0,0),[]);return le.newNotebookMetadata=z,le}};ie=h=je([k],ie),e.NotebookEdit=ie;class Q{constructor(z,le){this.range=z,this.snippet=le}}e.SnippetTextEdit=Q;var de;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(de=e.FileEditType||(e.FileEditType={}));let ue=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,le,Le,Ye){this._edits.push({_type:1,from:z,to:le,options:Le,metadata:Ye})}createFile(z,le,Le){this._edits.push({_type:1,from:void 0,to:z,options:le,metadata:Le})}deleteFile(z,le,Le){this._edits.push({_type:1,from:z,to:void 0,options:le,metadata:Le})}replaceNotebookMetadata(z,le,Le){this._edits.push({_type:3,metadata:Le,uri:z,edit:{editType:5,metadata:le},notebookMetadata:le})}replaceNotebookCells(z,le,Le,Ye,nt){let ct,lt,yt=[],Lt;if(Mt.isNotebookRange(le)&&qt.isNotebookCellDataArray(Le)&&!qt.isNotebookCellDataArray(Ye)?(ct=le.start,lt=le.end,yt=Le,Lt=Ye):typeof le=="number"&&typeof Le=="number"&&qt.isNotebookCellDataArray(Ye)&&(ct=le,lt=Le,yt=Ye,Lt=nt),ct===void 0||lt===void 0)throw new Error("Invalid arguments");(ct!==lt||yt.length>0)&&this._edits.push({_type:5,uri:z,index:ct,count:lt-ct,cells:yt,metadata:Lt})}replaceNotebookCellMetadata(z,le,Le,Ye){this._edits.push({_type:3,metadata:Ye,uri:z,edit:{editType:8,index:le,metadata:Le}})}replace(z,le,Le,Ye){this._edits.push({_type:2,uri:z,edit:new q(le,Le),metadata:Ye})}insert(z,le,Le,Ye){this.replace(z,new W(le,le),Le,Ye)}delete(z,le,Le){this.replace(z,le,"",Le)}has(z){return this._edits.some(le=>le._type===2&&le.uri.toString()===z.toString())}set(z,le){if(le)for(const Le of le)Le&&(ie.isNotebookCellEdit(Le)?Le.newCellMetadata?this.replaceNotebookCellMetadata(z,Le.range.start,Le.newCellMetadata):Le.newNotebookMetadata?this.replaceNotebookMetadata(z,Le.newNotebookMetadata):this.replaceNotebookCells(z,Le.range,Le.newCells):this._edits.push({_type:2,uri:z,edit:Le}));else{for(let Le=0;Le<this._edits.length;Le++){const Ye=this._edits[Le];Ye._type===2&&Ye.uri.toString()===z.toString()&&(this._edits[Le]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(z){const le=[];for(let Le of this._edits)Le._type===2&&Le.uri.toString()===z.toString()&&le.push(Le.edit);return le}entries(){const z=new A.ResourceMap;for(let le of this._edits)if(le._type===2){let Le=z.get(le.uri);Le||(Le=[le.uri,[]],z.set(le.uri,Le)),Le[1].push(le.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ue=je([k],ue),e.WorkspaceEdit=ue;let X=r=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof r?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=r._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,le=this._tabstop++){if(typeof z=="function"){const Le=new r;Le._tabstop=this._tabstop,z(Le),this._tabstop=Le._tabstop,z=Le.value}else z=r._escape(z);return this.value+="${",this.value+=le,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,le=this._tabstop++){const Le=z.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(z,le){if(typeof le=="function"){const Le=new r;Le._tabstop=this._tabstop,le(Le),this._tabstop=Le._tabstop,le=Le.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,le&&(this.value+=":",this.value+=le),this.value+="}",this}};X=r=je([k],X),e.SnippetString=X;var ge;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(ge=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=s=class{constructor(z,le){if(this.uri=z,le)if(W.isRange(le))this.range=W.of(le);else if(M.isPosition(le))this.range=new W(le,le);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof s?!0:z?W.isRange(z.range)&&P.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=s=je([k],oe),e.Location=oe;let _e=class{constructor(z,le){this.location=z,this.message=le}static is(z){return z?typeof z.message=="string"&&z.location&&W.isRange(z.location.range)&&P.URI.isUri(z.location.uri):!1}static isEqual(z,le){return z===le?!0:!z||!le?!1:z.message===le.message&&z.location.range.isEqual(le.location.range)&&z.location.uri.toString()===le.location.uri.toString()}};_e=je([k],_e),e.DiagnosticRelatedInformation=_e;let Pe=class{constructor(z,le,Le=Se.Error){if(!W.isRange(z))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=z,this.message=le,this.severity=Le}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,le){return z===le?!0:!z||!le?!1:z.message===le.message&&z.severity===le.severity&&z.code===le.code&&z.severity===le.severity&&z.source===le.source&&z.range.isEqual(le.range)&&(0,u.equals)(z.tags,le.tags)&&(0,u.equals)(z.relatedInformation,le.relatedInformation,_e.isEqual)}};Pe=je([k],Pe),e.Diagnostic=Pe;let pe=class{constructor(z,le){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=le}};pe=je([k],pe),e.Hover=pe;var ve;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(z,le=ve.Text){this.range=z,this.kind=le}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Ae=je([k],Ae),e.DocumentHighlight=Ae;var ce;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(ce=e.SymbolKind||(e.SymbolKind={}));var me;(function(V){V[V.Deprecated=1]="Deprecated"})(me=e.SymbolTag||(e.SymbolTag={}));let te=n=class{constructor(z,le,Le,Ye,nt){this.name=z,this.kind=le,this.containerName=nt,typeof Le=="string"&&(this.containerName=Le),Ye instanceof oe?this.location=Ye:Le instanceof W&&(this.location=new oe(Ye,Le)),n.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};te=n=je([k],te),e.SymbolInformation=te;let ne=t=class{constructor(z,le,Le,Ye,nt){this.name=z,this.detail=le,this.kind=Le,this.range=Ye,this.selectionRange=nt,this.children=[],t.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(t.validate)}};ne=t=je([k],ne),e.DocumentSymbol=ne;var U;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(U=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let $=class{constructor(z,le){this.title=z,this.kind=le}};$=je([k],$),e.CodeAction=$;let G=c=class{constructor(z){this.value=z}append(z){return new c(this.value?this.value+c.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+c.sep)}};G.sep=".",G=c=je([k],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let K=class{constructor(z,le){if(this.range=z,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=je([k],K),e.SelectionRange=K;class he{constructor(z,le,Le,Ye,nt,ct){this.kind=z,this.name=le,this.detail=Le,this.uri=Ye,this.range=nt,this.selectionRange=ct}}e.CallHierarchyItem=he;class we{constructor(z,le){this.fromRanges=le,this.from=z}}e.CallHierarchyIncomingCall=we;class se{constructor(z,le){this.fromRanges=le,this.to=z}}e.CallHierarchyOutgoingCall=se;var De;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(De=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ye=class{constructor(z,le){this.range=z,this.command=le}get isResolved(){return!!this.command}};ye=je([k],ye),e.CodeLens=ye;let ze=l=class{constructor(z,le=!1){_.set(this,void 0),et(this,_,new y.MarkdownString(z,{supportThemeIcons:le}),"f")}static isMarkdownString(z){return z instanceof l?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Ue(this,_,"f").value}set value(z){Ue(this,_,"f").value=z}get isTrusted(){return Ue(this,_,"f").isTrusted}set isTrusted(z){Ue(this,_,"f").isTrusted=z}get supportThemeIcons(){return Ue(this,_,"f").supportThemeIcons}set supportThemeIcons(z){Ue(this,_,"f").supportThemeIcons=z}get supportHtml(){return Ue(this,_,"f").supportHtml}set supportHtml(z){Ue(this,_,"f").supportHtml=z}get baseUri(){return Ue(this,_,"f").baseUri}set baseUri(z){Ue(this,_,"f").baseUri=z}appendText(z){return Ue(this,_,"f").appendText(z),this}appendMarkdown(z){return Ue(this,_,"f").appendMarkdown(z),this}appendCodeblock(z,le){return Ue(this,_,"f").appendCodeblock(le??"",z),this}};_=new WeakMap,ze=l=je([k],ze),e.MarkdownString=ze;let Ve=class{constructor(z,le){this.label=z,this.documentation=le}};Ve=je([k],Ve),e.ParameterInformation=Ve;let Me=class{constructor(z,le){this.label=z,this.documentation=le,this.parameters=[]}};Me=je([k],Me),e.SignatureInformation=Me;let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Je=je([k],Je),e.SignatureHelp=Je;var J;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var re;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(re=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor(z){this.value=z}};Ce=je([k],Ce),e.InlayHintLabelPart=Ce;let ae=class{constructor(z,le,Le){this.position=z,this.label=le,this.kind=Le}};ae=je([k],ae),e.InlayHint=ae;var ke;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(V){V[V.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor(z,le){this.label=z,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=je([k],Ge),e.CompletionItem=Ge;let qe=class{constructor(z=[],le=!1){this.items=z,this.isIncomplete=le}};qe=je([k],qe),e.CompletionList=qe;let Ze=class{constructor(z,le,Le){this.insertText=z,this.range=le,this.command=Le}};Ze=je([k],Ze),e.InlineSuggestion=Ze;let Xe=class{constructor(z){this.commands=void 0,this.items=z}};Xe=je([k],Xe),e.InlineSuggestionList=Xe;let rt=class{constructor(z,le,Le){this.insertText=z,this.range=le,this.command=Le}};rt=je([k],rt),e.InlineSuggestionNew=rt;let tt=class{constructor(z,le){this.items=z,this.commands=le}};tt=je([k],tt),e.InlineSuggestionsNew=tt;var st;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var ot;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var mt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ft;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Wt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Wt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function z(le){switch(le){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=z}(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Dt=class{constructor(z,le){if(le&&!P.URI.isUri(le))throw(0,i.illegalArgument)("target");if(!W.isRange(z)||z.isEmpty)throw(0,i.illegalArgument)("range");this.range=z,this.target=le}};Dt=je([k],Dt),e.DocumentLink=Dt;let Ke=class{constructor(z,le,Le,Ye){this.red=z,this.green=le,this.blue=Le,this.alpha=Ye}};Ke=je([k],Ke),e.Color=Ke;let At=class{constructor(z,le){if(le&&!(le instanceof Ke))throw(0,i.illegalArgument)("color");if(!W.isRange(z)||z.isEmpty)throw(0,i.illegalArgument)("range");this.range=z,this.color=le}};At=je([k],At),e.ColorInformation=At;let Ut=class{constructor(z){if(!z||typeof z!="string")throw(0,i.illegalArgument)("label");this.label=z}};Ut=je([k],Ut),e.ColorPresentation=Ut;var Nt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ct{constructor(z,le,Le){if(this.startIndex=z,this.length=le,this.tooltip=Le,typeof z!="number"||z<0)throw(0,i.illegalArgument)("startIndex");if(typeof le!="number"||le<1)throw(0,i.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=Ct;var Tt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Tt=e.TerminalLocation||(e.TerminalLocation={}));class _t{constructor(z){if(this.options=z,typeof z!="object")throw(0,i.illegalArgument)("options")}}e.TerminalProfile=_t;var Re;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Re=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let be=d=class{constructor(z,le){if(this.label=le,typeof z!="string"||typeof le!="string")throw(0,i.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};be.Clean=new d("clean","Clean"),be.Build=new d("build","Build"),be.Rebuild=new d("rebuild","Rebuild"),be.Test=new d("test","Test"),be=d=je([k],be),e.TaskGroup=be;function Z(V){let z="";for(let le=0;le<V.length;le++)z+=V[le].replace(/,/g,",,")+",";return z}let Oe=class{constructor(z,le,Le){if(typeof z!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=z,le!==void 0&&(Array.isArray(le)?(this._args=le,this._options=Le):this._options=le)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,i.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let le of this._args)z.push(le);return Z(z)}};Oe=je([k],Oe),e.ProcessExecution=Oe;let We=class{constructor(z,le,Le){if(this._args=[],Array.isArray(le)){if(!z)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,i.illegalArgument)("command");this._command=z,this._args=le,this._options=Le}else{if(typeof z!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=z,this._options=le}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,i.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let le of this._args)z.push(typeof le=="string"?le:le.value);return Z(z)}};We=je([k],We),e.ShellExecution=We;var it;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var Qe;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Qe=e.TaskScope||(e.TaskScope={}));class ut{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=ut;let ht=w=class{constructor(z,le,Le,Ye,nt,ct){this.__deprecated=!1,this._definition=this.definition=z;let lt;typeof le=="string"?(this._name=this.name=le,this._source=this.source=Le,this.execution=Ye,lt=nt,this.__deprecated=!0):le===Qe.Global||le===Qe.Workspace?(this.target=le,this._name=this.name=Le,this._source=this.source=Ye,this.execution=nt,lt=ct):(this.target=le,this._name=this.name=Le,this._source=this.source=Ye,this.execution=nt,lt=ct),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Oe?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const le=this._definition.type;(w.EmptyType===le||w.ProcessType===le||w.ShellType===le||w.ExtensionCallbackType===le)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=w=je([k],ht),e.Task=ht;var wt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(z,le=It.None){this.collapsibleState=le,P.URI.isUri(z)?this.resourceUri=z:this.label=z}};ft=je([k],ft),e.TreeItem=ft;var It;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(It=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Rt=class{constructor(z){this.value=z}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Rt=je([k],Rt),e.DataTransferItem=Rt;let vt=class{constructor(z){g.set(this,new Map);for(const[le,Le]of z??[]){const Ye=Ue(this,g,"f").get(le);Ye?Ye.push(Le):Ue(this,g,"f").set(le,[Le])}}get(z){return Ue(this,g,"f").get(z)?.[0]}set(z,le){Ue(this,g,"f").set(z,[le])}forEach(z){for(const[le,Le]of Ue(this,g,"f"))Le.forEach(Ye=>z(Ye,le))}};g=new WeakMap,vt=je([k],vt),e.DataTransfer=vt;let $t=class{constructor(z,le){this.id=z,this.color=le}};$t=je([k],$t),e.ThemeIcon=$t,$t.File=new $t("file"),$t.Folder=new $t("folder");let Jt=class{constructor(z){this.id=z}};Jt=je([k],Jt),e.ThemeColor=Jt;var vi;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(vi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ui=class{constructor(z,le){if(typeof z!="string"&&(!z||!P.URI.isUri(z)&&!P.URI.isUri(z.uri)))throw(0,i.illegalArgument)("base");if(typeof le!="string")throw(0,i.illegalArgument)("pattern");typeof z=="string"?this.baseUri=P.URI.file(z):P.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=le}get base(){return this._base}set base(z){this._base=z,this._baseUri=P.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ui=je([k],ui),e.RelativePattern=ui;let St=class{constructor(z,le,Le,Ye){this.enabled=typeof z=="boolean"?z:!0,typeof le=="string"&&(this.condition=le),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};St=je([k],St),e.Breakpoint=St;let ri=class extends St{constructor(z,le,Le,Ye,nt){super(le,Le,Ye,nt);if(z===null)throw(0,i.illegalArgument)("location");this.location=z}};ri=je([k],ri),e.SourceBreakpoint=ri;let di=class extends St{constructor(z,le,Le,Ye,nt){super(le,Le,Ye,nt);this.functionName=z}};di=je([k],di),e.FunctionBreakpoint=di;let Xt=class extends St{constructor(z,le,Le,Ye,nt,ct,lt){super(Ye,nt,ct,lt);if(!le)throw(0,i.illegalArgument)("dataId");this.label=z,this.dataId=le,this.canPersist=Le}};Xt=je([k],Xt),e.DataBreakpoint=Xt;let Qt=class{constructor(z,le,Le){this.command=z,this.args=le||[],this.options=Le}};Qt=je([k],Qt),e.DebugAdapterExecutable=Qt;let dt=class{constructor(z,le){this.port=z,this.host=le}};dt=je([k],dt),e.DebugAdapterServer=dt;let hi=class{constructor(z){this.path=z}};hi=je([k],hi),e.DebugAdapterNamedPipeServer=hi;let Ht=class{constructor(z){this.implementation=z}};Ht=je([k],Ht),e.DebugAdapterInlineImplementation=Ht;let jt=class{constructor(z,le){this.range=z,this.expression=le}};jt=je([k],jt),e.EvaluatableExpression=jt;var wi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Ci;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let si=class{constructor(z,le){this.range=z,this.text=le}};si=je([k],si),e.InlineValueText=si;let fi=class{constructor(z,le,Le=!0){this.range=z,this.variableName=le,this.caseSensitiveLookup=Le}};fi=je([k],fi),e.InlineValueVariableLookup=fi;let oi=class{constructor(z,le){this.range=z,this.expression=le}};oi=je([k],oi),e.InlineValueEvaluatableExpression=oi;let Yt=class{constructor(z,le){this.frameId=z,this.stoppedLocation=le}};Yt=je([k],Yt),e.InlineValueContext=Yt;var Di;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Di=e.FileChangeType||(e.FileChangeType={}));let Zt=R=class extends Error{constructor(z,le=T.FileSystemProviderErrorCode.Unknown,Le){super(P.URI.isUri(z)?z.toString(!0):z);this.code=Le?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,le),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}static FileExists(z){return new R(z,T.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(z){return new R(z,T.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(z){return new R(z,T.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(z){return new R(z,T.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(z){return new R(z,T.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(z){return new R(z,T.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}};Zt=R=je([k],Zt),e.FileSystemError=Zt;let ei=class{constructor(z,le,Le){this.start=z,this.end=le,this.kind=Le}};ei=je([k],ei),e.FoldingRange=ei;var Ii;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Ii=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ki;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(ki=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));var Ti;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(Ti=e.CommentThreadState||(e.CommentThreadState={}));class Pi{constructor(z,le=[]){this.tokenTypes=z,this.tokenModifiers=le}}e.SemanticTokensLegend=Pi;function Ai(V){return typeof V=="undefined"||(0,E.isStringArray)(V)}class mi{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let le=0,Le=z.tokenTypes.length;le<Le;le++)this._tokenTypeStrToInt.set(z.tokenTypes[le],le);for(let le=0,Le=z.tokenModifiers.length;le<Le;le++)this._tokenModifierStrToInt.set(z.tokenModifiers[le],le)}}push(z,le,Le,Ye,nt){if(typeof z=="number"&&typeof le=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(z,le,Le,Ye,nt);if(W.isRange(z)&&typeof le=="string"&&Ai(Le))return this._push(z,le,Le);throw(0,i.illegalArgument)()}_push(z,le,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(le))throw new Error("`tokenType` is not in the provided legend");const Ye=z.start.line,nt=z.start.character,ct=z.end.character-z.start.character,lt=this._tokenTypeStrToInt.get(le);let yt=0;if(Le)for(const Lt of Le){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Lt);yt|=1<<xt>>>0}this._pushEncoded(Ye,nt,ct,lt,yt)}_pushEncoded(z,le,Le,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&le<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Lt=0,xt=0;for(let Vt=0;Vt<yt;Vt++){let Gt=this._data[5*Vt],gi=this._data[5*Vt+1];Gt===0?(Gt=Lt,gi+=xt):Gt+=Lt,this._data[5*Vt]=Gt,this._data[5*Vt+1]=gi,Lt=Gt,xt=gi}}let ct=z,lt=le;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=z,this._prevChar=le}static _sortAndDeltaEncode(z){let le=[];const Le=z.length/5|0;for(let lt=0;lt<Le;lt++)le[lt]=lt;le.sort((lt,yt)=>{const Lt=z[5*lt],xt=z[5*yt];if(Lt===xt){const Vt=z[5*lt+1],Gt=z[5*yt+1];return Vt-Gt}return Lt-xt});const Ye=new Uint32Array(z.length);let nt=0,ct=0;for(let lt=0;lt<Le;lt++){const yt=5*le[lt],Lt=z[yt+0],xt=z[yt+1],Vt=z[yt+2],Gt=z[yt+3],gi=z[yt+4],Ki=Lt-nt,mn=Ki===0?xt-ct:xt,pi=5*lt;Ye[pi+0]=Ki,Ye[pi+1]=mn,Ye[pi+2]=Vt,Ye[pi+3]=Gt,Ye[pi+4]=gi,nt=Lt,ct=xt}return Ye}build(z){return this._dataIsSortedAndDeltaEncoded?new ii(new Uint32Array(this._data),z):new ii(mi._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=mi;class ii{constructor(z,le){this.resultId=le,this.data=z}}e.SemanticTokens=ii;class bi{constructor(z,le,Le){this.start=z,this.deleteCount=le,this.data=Le}}e.SemanticTokensEdit=bi;class Ei{constructor(z,le){this.resultId=le,this.edits=z}}e.SemanticTokensEdits=Ei;var $e;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})($e=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new $t("arrow-left")},Bt=je([k],Bt),e.QuickInputButtons=Bt;var _i;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(_i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var gt;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(gt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ri;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Ri=e.ExtensionKind||(e.ExtensionKind={}));class Li{constructor(z,le,Le){this.badge=z,this.tooltip=le,this.color=Le}static validate(z){if(z.badge){let le=(0,D.nextCharLength)(z.badge,0);if(le<z.badge.length&&(le+=(0,D.nextCharLength)(z.badge,le)),z.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Li;let ai=class{constructor(z){this.kind=z}};ai=je([k],ai),e.ColorTheme=ai;var Oi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Oi=e.ColorThemeKind||(e.ColorThemeKind={}));class Mt{constructor(z,le){if(z<0)throw(0,i.illegalArgument)("start must be positive");if(le<0)throw(0,i.illegalArgument)("end must be positive");z<=le?(this._start=z,this._end=le):(this._start=le,this._end=z)}static isNotebookRange(z){return z instanceof Mt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let le=this._start,Le=this._end;return z.start!==void 0&&(le=z.start),z.end!==void 0&&(Le=z.end),le===this._start&&Le===this._end?this:new Mt(le,Le)}}e.NotebookRange=Mt;class qt{constructor(z,le,Le,Ye,nt,ct,lt){this.kind=z,this.value=le,this.languageId=Le,this.mime=Ye,this.outputs=nt??[],this.metadata=ct,this.executionSummary=lt,qt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(le=>qt.isNotebookCellData(le))}static isNotebookCellData(z){return!0}}e.NotebookCellData=qt;class Fi{constructor(z){this.cells=z}}e.NotebookData=Fi;class zt{constructor(z,le){this.data=z,this.mime=le;const Le=(0,C.normalizeMimeType)(le,!0);if(!Le)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}static isNotebookCellOutputItem(z){return z instanceof zt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const le={name:z.name,message:z.message,stack:z.stack};return zt.json(le,"application/vnd.code.notebook.error")}static stdout(z){return zt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return zt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,le="application/octet-stream"){return new zt(z,le)}static text(z,le=C.Mimes.text){const Le=Ue(zt,v,"f",p).encode(String(z));return new zt(Le,le)}static json(z,le="text/x-json"){const Le=JSON.stringify(z,void 0,"	");return zt.text(Le,le)}}e.NotebookCellOutputItem=zt,v=zt,p={value:new TextEncoder};class ni{constructor(z,le,Le){this.items=ni.ensureUniqueMimeTypes(z,!0),typeof le=="string"?(this.id=le,this.metadata=Le):(this.id=(0,L.generateUuid)(),this.metadata=le??Le)}static isNotebookCellOutput(z){return z instanceof ni?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,E.isArray)(z.items)}static ensureUniqueMimeTypes(z,le=!1){const Le=new Set,Ye=new Set;for(let nt=0;nt<z.length;nt++){const ct=z[nt],lt=(0,C.normalizeMimeType)(ct.mime);if(!Le.has(lt)){Le.add(lt);continue}Ye.add(nt),le&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ye.size===0?z:z.filter((nt,ct)=>!Ye.has(ct))}}e.NotebookCellOutput=ni;var Ni;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Ni=e.NotebookCellKind||(e.NotebookCellKind={}));var Mi;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Mi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ui;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ui=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Bi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Bi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class zi{constructor(z,le){this.text=z,this.alignment=le}}e.NotebookCellStatusBarItem=zi;var fe;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(fe=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ee{constructor(z,le=[]){this.uri=z,this.provides=(0,u.asArray)(le)}}e.NotebookRendererScript=Ee;let Be=class{constructor(z,le){this.label=z,this.timestamp=le}};Be=je([k],Be),e.TimelineItem=Be;var at;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(at=e.ExtensionMode||(e.ExtensionMode={}));var bt;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(bt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Pt=e.StandardTokenType||(e.StandardTokenType={}));class Ji{constructor(z,le){this.ranges=z,this.wordPattern=le}}e.LinkedEditingRanges=Ji;class Zi{constructor(z,le){this._port=z,this._autoForwardAction=le}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Zi;var en;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(en=e.TestResultState||(e.TestResultState={}));var tn;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(tn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(z=void 0,le=void 0,Le=void 0){this.include=z,this.exclude=le,this.profile=Le}};Wi=je([k],Wi),e.TestRunRequest=Wi;let $i=F=class{constructor(z){this.message=z}static diff(z,le,Le){const Ye=new F(z);return Ye.expectedOutput=le,Ye.actualOutput=Le,Ye}};$i=F=je([k],$i),e.TestMessage=$i;let Hi=class{constructor(z){this.id=z}};Hi=je([k],Hi),e.TestTag=Hi;let ci=class{constructor(z,le){this.covered=z,this.total=le}};ci=je([k],ci),e.CoveredCount=ci;let xi=O=class{constructor(z,le,Le,Ye){this.uri=z,this.statementCoverage=le,this.branchCoverage=Le,this.functionCoverage=Ye}static fromDetails(z,le){const Le=new ci(0,0),Ye=new ci(0,0),nt=new ci(0,0);for(const lt of le)if("branches"in lt){Le.total+=1,Le.covered+=lt.executionCount>0?1:0;for(const yt of lt.branches)Ye.total+=1,Ye.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const ct=new O(z,Le,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return ct.detailedCoverage=le,ct}};xi=O=je([k],xi),e.FileCoverage=xi;let Vi=class{constructor(z,le,Le=[]){this.executionCount=z,this.location=le,this.branches=Le}};Vi=je([k],Vi),e.StatementCoverage=Vi;let ji=class{constructor(z,le){this.executionCount=z,this.location=le}};ji=je([k],ji),e.BranchCoverage=ji;let qi=class{constructor(z,le){this.executionCount=z,this.location=le}};qi=je([k],qi),e.FunctionCoverage=qi;var nn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(nn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(rn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var sn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class on{constructor(z,le,Le,Ye,nt,ct){this.kind=z,this.name=le,this.detail=Le,this.uri=Ye,this.range=nt,this.selectionRange=ct}}e.TypeHierarchyItem=on;class an{constructor(z){this.uri=z}}e.TextTabInput=an;class cn{constructor(z,le){this.original=z,this.modified=le}}e.TextDiffTabInput=cn;class ln{constructor(z,le){this.uri=z,this.viewType=le}}e.CustomEditorTabInput=ln;class un{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=un;class dn{constructor(z,le){this.uri=z,this.notebookType=le}}e.NotebookEditorTabInput=dn;class hn{constructor(z,le,Le){this.original=z,this.modified=le,this.notebookType=Le}}e.NotebookDiffEditorTabInput=hn;class fn{constructor(){}}e.TerminalEditorTabInput=fn}),define(Ie[125],Te([1,0,57,10,8,155,110,7,16]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(_,g){g?P.set(_,g):P.delete(_)}e.setWordDefinitionFor=L;function T(_){return P.get(_)}e.getWordDefinitionFor=T;class S extends A.MirrorTextModel{constructor(g,v,p,b,f,a,m,o){super(v,p,b,f);this._proxy=g,this._languageId=a,this._isDirty=m,this.notebook=o,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,E.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===i.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},save(){return g._save()},getText(v){return v?g._getTextInRange(v):g.getText()},get eol(){return g._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(v){return g._lineAt(v)},offsetAt(v){return g._offsetAt(v)},positionAt(v){return g._positionAt(v)},validateRange(v){return g._validateRange(v)},validatePosition(v){return g._validatePosition(v)},getWordRangeAtPosition(v,p){return g._getWordRangeAtPosition(v,p)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,u.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,u.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const v=this._validateRange(g);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const p=this._eol,b=v.start.line,f=v.end.line,a=[];a.push(this._lines[b].substring(v.start.character));for(let m=b+1;m<f;m++)a.push(this._lines[m]);return a.push(this._lines[f].substring(0,v.end.character)),a.join(p)}_lineAt(g){let v;if(g instanceof D.Position?v=g.line:typeof g=="number"&&(v=g),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new I(v,this._lines[v],v===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(g),p=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,p))}_validateRange(g){if(!(g instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(g.start),p=this._validatePosition(g.end);return v===g.start&&p===g.end?g:new D.Range(v.line,v.character,p.line,p.character)}_validatePosition(g){if(!(g instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:v,character:p}=g,b=!1;if(v<0)v=0,p=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,p=this._lines[v].length,b=!0;else{const f=this._lines[v].length;p<0?(p=0,b=!0):p>f&&(p=f,b=!0)}return b?new D.Position(v,p):g}_getWordRangeAtPosition(g,v){const p=this._validatePosition(g);if(!v)v=T(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(p.character+1,(0,C.ensureValidWordDefinition)(v),this._lines[p.line],0);if(b)return new D.Range(p.line,b.startColumn-1,p.line,b.endColumn-1)}}e.ExtHostDocumentData=S;class I{constructor(g,v,p){this._line=g,this._text=v,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(Ie[208],Te([1,0,7,18,3]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let E;switch(D){case"light":E=u.ColorThemeKind.Light;break;case"hcDark":E=u.ColorThemeKind.HighContrast;break;case"hcLight":E=u.ColorThemeKind.HighContrastLight;break;default:E=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Ie[66],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class i{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=i}),define(Ie[209],Te([1,0,23]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function y(D,E){if(E.serializeBuffersForPostMessage){const P=new i,L=(I,_)=>{if(_ instanceof ArrayBuffer){const g=P.add(_);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(_)){const g=A(_);if(g){const v=P.add(_.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:g,byteLength:_.byteLength,byteOffset:_.byteOffset}}}}return _},T=JSON.stringify(D,L),S=P.buffers.map(I=>{const _=new Uint8Array(I);return u.VSBuffer.wrap(_)});return{message:T,buffers:S}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=y;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(D,E){const P=E.map(S=>{const I=new ArrayBuffer(S.byteLength);return new Uint8Array(I).set(S.buffer),I}),L=E.length?(S,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const _=I,{index:g}=_,v=P[g];if(_.view)switch(_.view.type){case 1:return new Int8Array(v,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return I}:void 0;return{message:JSON.parse(D,L),arrayBuffers:P}}e.deserializeWebviewMessage=C}),define(Ie[210],Te([1,0,104]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function i(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function y(A){return new u.URITransformer(i(A))}e.createURITransformer=y}),define(Ie[211],Te([1,0,179,12,2,6,4,44,43,16,10]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(T=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function I(H){const N=H;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=I;function _(H,N,j){for(const x of j.visibleEditorPanes)if(x.group.id===N&&H.matches(x.input))return x.getViewState()}e.findViewStateForEditor=_;function g(H){if(r(H))return!1;const N=H;return y.URI.isUri(N?.resource)}e.isResourceEditorInput=g;function v(H){if(r(H))return!1;const N=H;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=v;function p(H){if(r(H)||v(H))return!1;const N=H;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function b(H){if(r(H))return!1;const N=H;return N?N.resource===void 0||N.resource.scheme===L.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;var f;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var a;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(N,j){let x=this.mapIdToSaveSource.get(N);return x||(x={source:N,label:j},this.mapIdToSaveSource.set(N,x)),x.source}getSourceLabel(N){return this.mapIdToSaveSource.get(N)?.label??N}}e.SaveSourceRegistry=new m;var o;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends A.Disposable{}e.AbstractEditorInput=h;function r(H){return H instanceof h}e.isEditorInput=r;function s(H){const N=H;return y.URI.isUri(N?.preferredResource)}function n(H){const N=H;return r(N?.primary)&&r(N?.secondary)}e.isSideBySideEditorInput=n;function t(H){const N=H;return r(N?.modified)&&r(N?.original)}e.isDiffEditorInput=t;function c(H){return r(H?.editor)}e.isEditorInputWithOptions=c;function l(H){const N=H;return c(H)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function d(H){const N=H;return typeof N?.groupId=="number"&&r(N.editor)}e.isEditorIdentifier=d;var w;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(w=e.EditorCloseContext||(e.EditorCloseContext={}));var R;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(N,j){if(!N)return;if(j?.supportSideBySide){const{primary:q,secondary:ie}=this.getSideEditors(N);if(q&&ie){if(j?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===F.ANY)return this.getOriginalUri(q,{filterByScheme:j.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:j.filterByScheme});N=j.supportSideBySide===F.PRIMARY?q:ie}}if(v(N)||p(N))return;const x=s(N)?N.preferredResource:N.resource;return!x||!j||!j.filterByScheme?x:this.filterUri(x,j.filterByScheme)}getSideEditors(N){return n(N)||p(N)?{primary:N.primary,secondary:N.secondary}:t(N)||v(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,j){if(!N)return;if(j?.supportSideBySide){const{primary:q,secondary:ie}=this.getSideEditors(N);if(q&&ie){if(j?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===F.ANY)return this.getCanonicalUri(q,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:j.filterByScheme});N=j.supportSideBySide===F.PRIMARY?q:ie}}if(v(N)||p(N))return;const x=N.resource;return!x||!j||!j.filterByScheme?x:this.filterUri(x,j.filterByScheme)}filterUri(N,j){if(Array.isArray(j)){if(j.some(x=>N.scheme===x))return N}else if(j===N.scheme)return N}}e.EditorResourceAccessor=new O;var k;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(k=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const j=this.instantiationService=N.get(C.IInstantiationService);for(const[x,q]of this.editorSerializerConstructors)this.createEditorSerializer(x,q,j);this.editorSerializerConstructors.clear()}createEditorSerializer(N,j,x){const q=x.createInstance(j);this.editorSerializerInstances.set(N,q)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,j){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,j,this.instantiationService):this.editorSerializerConstructors.set(N,j),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new B);async function M(H,N){if(!H||!H.length)return[];const j=await Promise.all(H.map(async x=>{const q=y.URI.revive(x.fileUri);if(!q||!await N.canHandleResource(q))return;let Q=x.exists,de=x.type;if(typeof Q!="boolean"||typeof de!="number")try{de=(await N.stat(q)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Q=!0}catch{Q=!1}if(!Q&&x.openOnlyIfExists||de===E.FileType.Directory)return;const ue={...x.options,pinned:!0};let X;return Q?X={resource:q,options:ue}:X={resource:q,options:ue,forceUntitled:!0},X}));return(0,P.coalesce)(j)}e.pathsToEditors=M;var W;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function ee(H){const N=H;if(!N)return!1;const j=N;if(j.modified)return ee(j.modified);const x=N;return!!(x.contributionsState&&x.viewState&&Array.isArray(x.cursorState))}e.isTextEditorViewState=ee}),define(Ie[89],Te([1,0,10,2]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(D,E){return D.scheme===u.Schemas.http||D.scheme===u.Schemas.https?D:(E&&E.authority&&E.isRemote&&D.scheme===u.Schemas.file&&(D=i.URI.from({scheme:u.Schemas.vscodeRemote,authority:E.authority,path:D.path})),i.URI.from({scheme:u.Schemas.https,authority:`${D.scheme}+${A(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=y;function A(D){return D.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function C(D){return D.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=C}),define(Ie[212],Te([1,0,3,6,89]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(D,E,P){this._proxy=D,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const T of this._insets.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,E,P,L,T){let S;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===D){S=f;break}if(!S)throw new Error("not a visible editor");const I=this,_=this._handlePool++,g=new u.Emitter,v=new u.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,y.asWebviewUri)(f,I._remoteInfo)}get cspSource(){return y.webviewGenericCspSource}set options(f){this._options=f,I._proxy.$setOptions(_,f)}get options(){return this._options}set html(f){this._html=f,I._proxy.$setHtml(_,f)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(f){return I._proxy.$postMessage(_,f)}},b=new class{constructor(){this.editor=D,this.line=E,this.height=P,this.webview=p,this.onDidDispose=v.event}dispose(){I._insets.has(_)&&(I._insets.delete(_),I._proxy.$disposeEditorInset(_),v.fire(),v.dispose(),g.dispose())}};return this._proxy.$createEditorInset(_,S.id,S.value.document.uri,E+1,P,L||{},T.identifier,T.extensionLocation),this._insets.set(_,{editor:D,inset:b,onDidReceiveMessage:g}),b}$onDidDispose(D){const E=this._insets.get(D);E&&E.inset.dispose()}$onDidReceiveMessage(D,E){const P=this._insets.get(D);P&&P.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=A}),define(Ie[126],Te([1,0,3,17,180]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,E,P,L){const T={command:D};if(E&&Object.keys(E).length>0&&(T.arguments=E),this.internalSend("request",T),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const I=this.pendingRequests.get(T.seq);if(I){this.pendingRequests.delete(T.seq);const _={type:"response",seq:0,request_seq:T.seq,success:!1,command:D,message:(0,y.localize)(0,null,L,D)};I(_)}},L)}return P&&this.pendingRequests.set(T.seq,P),T.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,E){return D.type!=="event"||E.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,i.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":{const E=D,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(D,E){E.type=D,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((E,P)=>D.set(P,E)),await(0,i.timeout)(500),D.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Ie[213],Te([1,0,181,52,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new i.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new i.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new i.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new i.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new i.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new i.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new i.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new i.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new i.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new i.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new i.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new i.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new i.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new i.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new i.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new i.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new i.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new i.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new i.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new i.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new i.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new i.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new i.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new i.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new i.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new i.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new i.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new i.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new i.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new i.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new i.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new i.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new i.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new i.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new i.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new i.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new i.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new i.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new i.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new i.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new i.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new i.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new i.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new i.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new i.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new i.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new i.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new i.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new i.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new i.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new i.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const A=S=>u.localize(51,null,S);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var C;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(C=e.State||(e.State={}));function D(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var E;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,y.createDecorator)(e.DEBUG_SERVICE_ID);var T;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[214],Te([1,0,8,2,9,24,10]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function E(r,s,n){return r.replace(D,function(t,c){return s&&c.length>0&&c[0]!=="_"?t:n&&n.hasOwnProperty(c)?n[c]:t})}e.formatPII=E;function P(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=P;function L(r){return r.configuration.request==="attach"&&!T(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function T(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(s,"extensionhost")||(0,u.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?T(r.parentSession):void 0}e.getExtensionHostDebugSession=T;function S(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=S;function I(r,s,n){let t,c=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=l.exec(r);){const w=d.index+1,R=w+d[0].length;if(w<=s&&R>=n){t=d[0],c=w;break}}if(t){const w=/\w+/g;let R=null;for(;(R=w.exec(t))&&!(R.index+1+c+R[0].length>=n););R&&(t=t.substring(0,w.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const _=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(_))}e.isUri=g;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return i.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function p(r){if(typeof r.path=="object"){const s=i.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function b(r,s){const n=s?v:p,t=(0,A.deepClone)(r);return a(t,(c,l)=>{c&&l&&(l.path=n(l))}),t}e.convertToDAPaths=b;function f(r,s){const n=s?v:p,t=(0,A.deepClone)(r);return a(t,(c,l)=>{!c&&l&&(l.path=n(l))}),t}e.convertToVSCPaths=f;function a(r,s){switch(r.type){case"event":{const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(c=>s(!1,c.location))}break;default:break}break}}}function m(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):o(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=m;function o(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function h(r,s){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[215],Te([1,0,29,42,182,127,9,8,24,13,85,126]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",a=>this.handleData(a))}sendMessage(b){if(this.outputStream){const f=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.TWO_CRLF}${f}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+f))}continue}}else{const f=this.rawData.indexOf(S.TWO_CRLF);if(f!==-1){const m=this.rawData.toString("utf8",0,f).split(S.HEADER_LINESEPARATOR);for(const o of m){const h=o.split(S.HEADER_FIELDSEPARATOR);h[0]==="Content-Length"&&(this.contentLength=Number(h[1]))}this.rawData=this.rawData.slice(f+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class I extends S{startSession(){return new Promise((b,f)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",m=>{a?this._onError.fire(m):f(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=I;class _ extends I{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=_;class g extends I{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=g;class v extends S{constructor(b,f,a){super();this.adapterExecutable=b,this.debugType=f,this.outputService=a}async startSession(){const b=this.adapterExecutable.command,f=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(b)if(C.isAbsolute(b)){if(!await u.Promises.exists(b))throw new Error(y.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let m=process.env;if(a.env&&Object.keys(a.env).length>0&&(m=E.mixin(E.deepClone(process.env),a.env)),b==="node")if(Array.isArray(f)&&f.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const s=i.fork(f[0],f.slice(1),r);if(!s.pid)throw new Error(y.localize(2,null,f[0]));this.serverProcess=s}else throw new Error(y.localize(3,null));else{const h={env:m};a.cwd&&(h.cwd=a.cwd),this.serverProcess=i.spawn(b,f,h)}this.serverProcess.on("error",h=>{this._onError.fire(h)}),this.serverProcess.on("exit",(h,r)=>{this._onExit.fire(h)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",h=>{this._onError.fire(h)}),this.serverProcess.stdin.on("error",h=>{this._onError.fire(h)});const o=this.outputService;if(o){const h=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const s=o.getChannel(L.ExtensionsChannelId);s&&s.append(h(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((b,f)=>{const a=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,o,h){if(m)return f(m)});a.on("exit",b),a.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,f){if(!b)return;const a=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?a.runtime=C.join(f,b.runtime):a.runtime=b.runtime),b.runtimeArgs&&(a.runtimeArgs=b.runtimeArgs),b.program&&(C.isAbsolute(b.program)?a.program=b.program:a.program=C.join(f,b.program)),b.args&&(a.args=b.args);const m=b;return m.win&&(a.win=v.extract(m.win,f)),m.winx86&&(a.winx86=v.extract(m.winx86,f)),m.windows&&(a.windows=v.extract(m.windows,f)),m.osx&&(a.osx=v.extract(m.osx,f)),m.linux&&(a.linux=v.extract(m.linux,f)),a}static platformAdapterExecutable(b,f){let a=Object.create(null);f=f.toLowerCase();for(const n of b)if(n.contributes){const t=n.contributes.debuggers;t&&t.length>0&&t.filter(c=>typeof c.type=="string"&&D.equalsIgnoreCase(c.type,f)).forEach(c=>{const l=v.extract(c,n.extensionLocation.fsPath);a=E.mixin(a,l,n.isBuiltin)})}let m;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=a.winx86||a.win||a.windows:P.isWindows?m=a.win||a.windows:P.isMacintosh?m=a.osx:P.isLinux&&(m=a.linux),m=m||a;const o=m.program||a.program,h=m.args||a.args,r=m.runtime||a.runtime,s=m.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(h||[])};if(o)return{type:"executable",command:o,args:h||[]}}}e.ExecutableDebugAdapter=v}),define(Ie[216],Te([1,0,42,30,13]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(P,L){return new Promise((T,S)=>{let I="";const _=u.spawn(P,L);_.pid&&_.stdout.on("data",g=>{I+=g.toString()}),_.on("error",g=>{S(g)}),_.on("close",g=>{T(I)})})}async function C(P){if(P)if(y.isWindows){const L=await new Promise((T,S)=>{Y(["windows-process-tree"],T,S)});return new Promise(T=>{L.getProcessTree(P,S=>{T(!!S&&S.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(P)]).then(L=>{const T=L.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var D;(function(P){P[P.cmd=0]="cmd",P[P.powershell=1]="powershell",P[P.bash=2]="bash"})(D||(D={}));function E(P,L,T,S){P=P.trim().toLowerCase();let I;P.indexOf("powershell")>=0||P.indexOf("pwsh")>=0?I=1:P.indexOf("cmd.exe")>=0?I=0:P.indexOf("bash")>=0?I=2:y.isWindows?I=0:I=2;let _,g=" ";switch(I){case 1:if(_=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),T){const v=(0,i.getDriveLetter)(T);v&&(g+=`${v}:; `),g+=`cd ${_(T)}; `}if(S)for(const v in S){const p=S[v];p===null?g+=`Remove-Item env:${v}; `:g+=`\${env:${v}}='${p}'; `}if(L.length>0){const v=_(L.shift());g+=v[0]==="'"?`& ${v} `:`${v} `;for(const p of L)g+=p==="<"||p===">"?p:_(p),g+=" "}break;case 0:if(_=v=>(v=v.replace(/\"/g,'""'),v=v.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>v.includes(p))||v.length===0?`"${v}"`:v),T){const v=(0,i.getDriveLetter)(T);v&&(g+=`${v}: && `),g+=`cd ${_(T)} && `}if(S){g+='cmd /C "';for(const v in S){let p=S[v];p===null?g+=`set "${v}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),g+=`set "${v}=${p}" && `)}}for(const v of L)g+=v==="<"||v===">"?v:_(v),g+=" ";S&&(g+='"');break;case 2:{_=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const v=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(T&&(g+=`cd ${_(T)} ; `),S){g+="/usr/bin/env";for(const p in S){const b=S[p];b===null?g+=` -u ${v(p)}`:g+=` ${v(`${p}=${b}`)}`}g+=" "}for(const p of L)g+=p==="<"||p===">"?p:_(p),g+=" ";break}}return g}e.prepareCommand=E}),define(Ie[128],Te([1,0,34,60,95,10,9,13,52]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var T;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(T=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var S;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(S=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(I=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var _;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(_=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var p;(function(n){n.scheme=A.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function c(O,k){return O.with({scheme:n.scheme,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generate=c;function l(O){if(O.scheme!==n.scheme)return;const k=t.exec(O.fragment);return k?{handle:Number(k[1]),notebook:O.with({scheme:O.fragment.substring(k[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parse=l;function d(O,k){return O.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${k??""},${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generateCellOutputUri=d;function w(O){if(O.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const k=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(O.fragment);if(!k)return;const B=k[1]&&k[1]!==""?k[1]:void 0,M=k[2];return{outputId:B,notebook:O.with({scheme:M||A.Schemas.file,fragment:null})}}n.parseCellOutputUri=w;function R(O,k,B){return O.with({scheme:B,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}n.generateCellUri=R;function F(O,k){if(O.scheme!==k)return;const B=t.exec(O.fragment);return B?{handle:Number(B[1]),notebook:O.with({scheme:O.fragment.substring(B[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parseCellUri=F})(p=e.CellUri||(e.CellUri={}));const b=n=>D.isWindows?n.replace(/\//g,"\\"):n;class f{constructor(t=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(t)].map(l=>({pattern:l,matches:u.parse(b(l))}))}sort(t){const c=new Map(i.Iterable.map(t,d=>[d,b(d)]));let l=[];for(const{matches:d}of this.order)for(const[w,R]of c)if(d(R)){l.push(w),c.delete(w);break}return c.size&&(l=l.concat([...c.keys()].sort((d,w)=>this.defaultOrder.indexOf(d)-this.defaultOrder.indexOf(w)))),l}prioritize(t,c){const l=this.findIndex(t);if(l===-1){this.order.unshift({pattern:t,matches:u.parse(b(t))});return}const d=new Set(c.map(R=>this.findIndex(R,l)));d.delete(-1);const w=Array.from(d).sort();this.order.splice(l+1,0,...w.map(R=>this.order[R]));for(let R=w.length-1;R>=0;R--)this.order.splice(w[R],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,c=this.order.length){const l=b(t);for(let d=0;d<c;d++)if(this.order[d].matches(l))return d;return-1}}e.MimeTypeDisplayOrder=f;function a(n,t,c,l=(d,w)=>d===w){const d=[];function w(O,k,B){if(k===0&&B.length===0)return;const M=d[d.length-1];M&&M.start+M.deleteCount===O?(M.deleteCount+=k,M.toInsert.push(...B)):d.push({start:O,deleteCount:k,toInsert:B})}let R=0,F=0;for(;;){if(R===n.length){w(R,0,t.slice(F));break}if(F===t.length){w(R,n.length-R,[]);break}const O=n[R],k=t[F];if(l(O,k)){R+=1,F+=1;continue}c(k)?(w(R,1,[]),R+=1):(w(R,0,[k]),F+=1)}return d}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(n){n.default="default",n.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(n){const t=n;return!!((typeof t.include=="string"||u.isRelativePattern(t.include))&&(typeof t.exclude=="string"||u.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=o;function h(n,t,c){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const l=o(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,d=o(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(u.match(l,(0,C.basename)(c.fsPath).toLowerCase()))return!(d&&u.match(d,(0,C.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var r;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ie[217],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(Ie[218],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=u;function i(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=i}),define(Ie[67],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class y{constructor(C,D=C.length){if(this.path=C,this.viewEnd=D,C.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,D,E=C.parent){if(C.id===D)return new y([D]);let P=[C.id];for(let L=E;L&&L.id!==D;L=L.parent)P.push(L.id);return P.push(D),new y(P.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const D=C.indexOf("\0");return D===-1?C:C.slice(0,D)}static fromString(C){return new y(C.split("\0"))}static join(C,D){return new y([...C.path,D])}static joinToString(C,D){return C.toString()+"\0"+D}static compare(C,D){return C===D?0:D.startsWith(C+"\0")?2:C.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let D=0;D<C.viewEnd&&D<this.viewEnd;D++)if(C.path[D]!==this.path[D])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=y}),define(Ie[68],Te([1,0,2,36]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var y;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(y=e.TestResultState||(e.TestResultState={}));var A;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:i.Range.lift(t.range),uri:u.URI.revive(t.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var D;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var E;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(n){n.serialize=t=>t.type===0?E.serialize(t):P.serialize(t),n.deserialize=t=>t.type===0?E.deserialize(t):P.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var T;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",I=(n,t)=>n+S+t;e.namespaceTestTag=I;const _=n=>{const t=n.indexOf(S);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=_;var g;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?u.URI.revive(t.uri):void 0,range:t.range?i.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var p;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:g.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:g.deserialize(t.item)})})(p=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(n){n.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},n.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?i.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=f;var a;(function(n){n.serialize=(t,c)=>({...p.serialize(t),children:c,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(T.serialize)})})(a=e.TestResultItem||(e.TestResultItem={}));var m;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var h;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:p.deserialize(t.item)}:t.op===1?{op:t.op,item:b.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:p.serialize(t.item)}:t.op===1?{op:t.op,item:b.serialize(t.item)}:t})(h=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const l of t)switch(l.op){case 0:{const d=p.deserialize(l.item);if(d.parent){if(this.items.has(d.parent)){const w=this.items.get(d.parent);w.children.add(d.item.extId);const R=this.createItem(d,w);this.items.set(d.item.extId,R),c.add(R)}}else{const w=this.createItem(d);this.roots.add(w),this.items.set(d.item.extId,w),c.add(w)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=b.deserialize(l.item),w=this.items.get(d.extId);if(!w)break;d.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,d),c.update(w);break}case 2:{const d=this.items.get(l.itemId);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const w=[[l.itemId]];for(;w.length;)for(const R of w.pop()){const F=this.items.get(R);F&&(w.push(F.children),this.items.delete(R),c.remove(F,F!==d),F.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(Ie[90],Te([1,0,17,3,6,12,68,67]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(p,b)=>p===b,L={range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:P,label:P,description:P,error:P,tags:(p,b)=>!(p.length!==b.length||p.some(f=>!b.includes(f)))},T=(p,b)=>{let f;for(const[a,m]of Object.entries(L))m(p[a],b[a])||(f?f[a]=b[a]:f={[a]:b[a]});return f};class S extends y.Disposable{constructor(b){super();this.options=b,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(b){this._resolveHandler=b;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const f=this.diff[this.diff.length-1];if(f&&b.op===1){if(f.op===1&&f.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(f.item,b.item);return}if(f.op===0&&f.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(f.item,b.item);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,f){const a=this.tree.get(b);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const m=this.resolveChildren(a);return m.isOpen()?this.expandChildren(a,f-1):m.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,f){switch(f.op){case 3:this.removeItem(D.TestId.joinToString(b.fullId,f.id));break;case 0:this.upsertItem(f.item,b);break;case 5:for(const a of f.ops)this.onTestItemEvent(b,a);break;case 1:this.diffTagRefs(f.new,f.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:f.update}});break;default:(0,A.assertNever)(f)}}upsertItem(b,f){const a=D.TestId.fromExtHostTestItem(b,this.root.id,f?.actual),m=this.options.getApiFor(b);m.parent&&m.parent!==f?.actual&&this.options.getChildren(m.parent).delete(b.id);let o=this.tree.get(a.toString());if(!o){o={fullId:a,actual:b,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(b,f),this.pushDiff({op:0,item:{parent:o.parent&&o.parent.toString(),controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,o,f);return}if(o.actual===b){this.connectItem(b,o,f);return}const h=this.options.getChildren(o.actual),r=o.actual,s=T(this.options.toITestItem(r),this.options.toITestItem(b));this.options.getApiFor(r).listener=void 0,o.actual=b,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,r.tags,a.toString()),delete s.tags),this.onTestItemEvent(o,{op:4,update:s})),this.connectItemAndChildren(b,o,f);for(const n of h)this.options.getChildren(b).get(n.id)||this.removeItem(D.TestId.joinToString(a,n.id))}diffTagRefs(b,f,a){const m=new Set(f.map(o=>o.id));for(const o of b)m.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:a,item:{tags:b.map(o=>(0,C.namespaceTestTag)(this.options.controllerId,o.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const f=this.tags.get(b.id);f?f.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,C.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const f=this.tags.get(b);f&&!--f.refCount&&(this.tags.delete(b),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,f){this.options.getApiFor(b).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(b,f,a){this.setItemParent(b,a);const m=this.options.getApiFor(b);m.parent=a?.actual,m.listener=o=>this.onTestItemEvent(f,o),this.updateExpandability(f)}connectItemAndChildren(b,f,a){this.connectItem(b,f,a);for(const m of this.options.getChildren(b))this.upsertItem(m,f)}updateExpandability(b){let f;this._resolveHandler?b.resolveBarrier?f=b.resolveBarrier.isOpen()?3:2:f=b.actual.canResolveChildren?1:0:f=0,f!==b.expand&&(b.expand=f,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:f}}),f===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,f){if(f<0)return;const a=[];for(const m of this.options.getChildren(b.actual)){const o=this.expand(D.TestId.joinToString(b.fullId,m.id),f);(0,u.isThenable)(o)&&a.push(o)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const o=new u.Barrier;return o.open(),o}b.expand=2,this.pushExpandStateUpdate(b);const f=b.resolveBarrier=new u.Barrier,a=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let m;try{m=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(o){a(o)}return(0,u.isThenable)(m)?m.catch(a).then(()=>{f.open(),this.updateExpandability(b)}):(f.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const f=this.tree.get(b);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:b});const a=[f];for(;a.length;){const m=a.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const o of m.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(m.fullId.toString());for(const o of this.options.getChildren(m.actual))a.push(this.tree.get(D.TestId.joinToString(m.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=S;class I extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=I;class _ extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=_;class g extends Error{constructor(b,f,a){super(`TestItem with ID "${b}" is from controller "${f}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=g;const v=(p,b,f)=>{let a=new Map;return{get size(){return a.size},forEach(m,o){for(const h of a.values())m.call(o,h,this)},replace(m){const o=new Map,h=new Set(a.keys()),r={op:5,ops:[]};for(const s of m){if(!(s instanceof f))throw new _(s.id);const n=b(s).controllerId;if(n!==p.controllerId)throw new g(s.id,n,p.controllerId);if(o.has(s.id))throw new I(s.id);o.set(s.id,s),h.delete(s.id),r.ops.push({op:0,item:s})}for(const s of h.keys())r.ops.push({op:3,id:s});p.listener?.(r),a=o},add(m){if(!(m instanceof f))throw new _(m.id);a.set(m.id,m),p.listener?.({op:0,item:m})},delete(m){a.delete(m)&&p.listener?.({op:3,id:m})},get(m){return a.get(m)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};e.createTestItemChildren=v}),define(Ie[129],Te([1,0,90]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const i=new WeakMap,y=(C,D)=>{const E={controllerId:D};return i.set(C,E),E};e.createPrivateApiFor=y;const A=C=>{const D=i.get(C);if(!D)throw new u.InvalidTestItemError(C?.id||"<unknown>");return D};e.getPrivateApiFor=A}),define(Ie[219],Te([1,0,9,40,12,24,13,103,185,8]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(S,I,_,g){this._contributedVariables=new Map,this._context=S,this._labelService=I,this._userHomePromise=_,g&&(this._envVariablesPromise=g.then(v=>this.prepareEnv(v)))}prepareEnv(S){if(C.isWindows){const I=Object.create(null);return Object.keys(S).forEach(_=>{I[_.toLowerCase()]=S[_]}),I}return S}resolveWithEnvironment(S,I,_){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},I?I.uri:void 0,_)}async resolveAsync(S,I){const _={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(_,S?S.uri:void 0,I)}async resolveAnyBase(S,I,_,g){const v=A.deepClone(I);C.isWindows&&v.windows?Object.keys(v.windows).forEach(b=>v[b]=v.windows[b]):C.isMacintosh&&v.osx?Object.keys(v.osx).forEach(b=>v[b]=v.osx[b]):C.isLinux&&v.linux&&Object.keys(v.linux).forEach(b=>v[b]=v.linux[b]),delete v.windows,delete v.osx,delete v.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,S?S.uri:void 0,v,_,g)}async resolveAnyAsync(S,I,_){return this.resolveAnyBase(S,I,_)}async resolveAnyMap(S,I,_){const g=new Map;return{newConfig:await this.resolveAnyBase(S,I,_,g),resolvedVariables:g}}resolveWithInteractionReplace(S,I,_,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,I,_,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,I){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,I)}async recursiveResolve(S,I,_,g,v){if(y.isString(_))return this.resolveString(S,I,_,g,v);if(y.isArray(_))return Promise.all(_.map(p=>this.recursiveResolve(S,I,p,g,v)));if(y.isObject(_)){let p=Object.create(null);const b=await Promise.all(Object.keys(_).map(async f=>[await this.resolveString(S,I,f,g,v),await this.recursiveResolve(S,I,_[f],g,v)]));for(const[f,a]of b)p[f]=a;return p}return _}resolveString(S,I,_,g,v){return(0,P.replaceAsync)(_,L.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(L.VARIABLE_LHS))return p;let f=await this.evaluateSingleVariable(S,p,b,I,g);return v&&v.set(b,f),f!==p&&y.isString(f)&&f.match(L.VARIABLE_REGEXP)&&(f=await this.resolveString(S,I,f,g,v)),f})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,I,_,g,v){let p;const b=_.split(":");b.length>1&&(_=b[0],p=b[1]);const f=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error((0,E.localize)(0,null,I))},a=()=>{const o=f();if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return h}throw new Error((0,E.localize)(1,null,I,u.basename(o)))},m=()=>{if(p){const o=this._context.getFolderUri(p);if(o)return o;throw new Error((0,E.localize)(2,null,I,p))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,I)):new Error((0,E.localize)(4,null,I))};switch(_){case"env":if(p){if(S.env){const o=S.env[C.isWindows?p.toLowerCase():p];if(y.isString(o))return o}return""}throw new Error((0,E.localize)(5,null,I));case"config":if(p){const o=this._context.getConfigurationValue(g,p);if(y.isUndefinedOrNull(o))throw new Error((0,E.localize)(6,null,I,p));if(y.isObject(o))throw new Error((0,E.localize)(7,null,I,p));return o}throw new Error((0,E.localize)(8,null,I));case"command":return this.resolveFromMap(I,p,v,"command");case"input":return this.resolveFromMap(I,p,v,"input");case"extensionInstallFolder":if(p){const o=await this._context.getExtension(p);if(!o)throw new Error((0,E.localize)(9,null,I,p));return this.fsPath(o.extensionLocation)}throw new Error((0,E.localize)(10,null,I));default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return g||p?(0,D.normalizeDriveLetter)(this.fsPath(m())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(S.userHome)return S.userHome;throw new Error((0,E.localize)(11,null,I))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new Error((0,E.localize)(12,null,I))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new Error((0,E.localize)(13,null,I))}case"file":return f();case"fileWorkspaceFolder":return a();case"relativeFile":return g||p?u.relative(this.fsPath(m()),f()):f();case"relativeFileDirname":{const o=u.dirname(f());if(g||p){const h=u.relative(this.fsPath(m()),o);return h.length===0?".":h}return o}case"fileDirname":return u.dirname(f());case"fileExtname":return u.extname(f());case"fileBasename":return u.basename(f());case"fileBasenameNoExtension":{const o=u.basename(f());return o.slice(0,o.length-u.extname(o).length)}case"fileDirnameBasename":return u.basename(u.dirname(f()));case"execPath":{const o=this._context.getExecPath();return o||I}case"execInstallFolder":{const o=this._context.getAppRoot();return o||I}case"pathSeparator":return u.sep;default:try{const o=p?`${_}:${p}`:_;return this.resolveFromMap(I,o,v,void 0)}catch{return I}}}}resolveFromMap(S,I,_,g){if(I&&_){const v=g===void 0?_[I]:_[g+":"+I];if(typeof v=="string")return v;throw new Error((0,E.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],Te([1,0,4,211]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var y;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var A;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var D;(function(_){_[_.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(_){const g=_;return(0,i.isEditorInput)(g?.editor)&&(0,i.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var L;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function S(_){const g=_;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=S;function I(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Ie[220],Te([1,0,4,130]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(A){const C=A;return typeof A=="number"||(0,i.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ie[15],Te([1,0,16,23,102,25,144,62,24,12,2,36,65,188,116,129,128,67,68,220,7,59]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Re){function Fe(Z){const{selectionStartLineNumber:Oe,selectionStartColumn:We,positionLineNumber:it,positionColumn:Qe}=Z,ut=new a.Position(Oe-1,We-1),ht=new a.Position(it-1,Qe-1);return new a.Selection(ut,ht)}Re.to=Fe;function be(Z){const{anchor:Oe,active:We}=Z;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Re.from=be})(o=e.Selection||(e.Selection={}));var h;(function(Re){function Fe(Z){if(!Z)return;const{start:Oe,end:We}=Z;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Re.from=Fe;function be(Z){if(!Z)return;const{startLineNumber:Oe,startColumn:We,endLineNumber:it,endColumn:Qe}=Z;return new a.Range(Oe-1,We-1,it-1,Qe-1)}Re.to=be})(h=e.Range||(e.Range={}));var r;(function(Re){function Fe(be){switch(be){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Re.to=Fe})(r=e.TokenType||(e.TokenType={}));var s;(function(Re){function Fe(Z){return new a.Position(Z.lineNumber-1,Z.column-1)}Re.to=Fe;function be(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Re.from=be})(s=e.Position||(e.Position={}));var n;(function(Re){function Fe(Oe,We){return(0,u.coalesce)((0,u.asArray)(Oe).map(it=>be(it,We)))}Re.from=Fe;function be(Oe,We){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:Z(Oe.scheme,We),pattern:Ne.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function Z(Oe,We){return We&&typeof Oe=="string"?We.transformOutgoingScheme(Oe):Oe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Re){function Fe(Z){switch(Z){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function be(Z){switch(Z){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Re.to=be})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Re){function Fe(Z){let Oe;return Z.code&&((0,P.isString)(Z.code)||(0,P.isNumber)(Z.code)?Oe=String(Z.code):Oe={value:String(Z.code.value),target:Z.code.target}),{...h.from(Z.range),message:Z.message,source:Z.source,code:Oe,severity:d.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(l.from),tags:Array.isArray(Z.tags)?(0,u.coalesce)(Z.tags.map(t.from)):void 0}}Re.from=Fe;function be(Z){const Oe=new a.Diagnostic(h.to(Z),Z.message,d.to(Z.severity));return Oe.source=Z.source,Oe.code=(0,P.isString)(Z.code)?Z.code:Z.code?.value,Oe.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(l.to),Oe.tags=Z.tags&&(0,u.coalesce)(Z.tags.map(t.to)),Oe}Re.to=be})(c=e.Diagnostic||(e.Diagnostic={}));var l;(function(Re){function Fe(Z){return{...h.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Re.from=Fe;function be(Z){return new a.DiagnosticRelatedInformation(new a.Location(Z.resource,h.to(Z)),Z.message)}Re.to=be})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(Re){function Fe(Z){switch(Z){case a.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Re.from=Fe;function be(Z){switch(Z){case _.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Re.to=be})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var w;(function(Re){function Fe(Z){return typeof Z=="number"&&Z>=a.ViewColumn.One?Z-1:Z===a.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Re.from=Fe;function be(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=be})(w=e.ViewColumn||(e.ViewColumn={}));function R(Re){return typeof Re.range!="undefined"}function F(Re){return Re.length===0?!0:!!R(Re[0])}e.isDecorationOptionsArr=F;var O;(function(Re){function Fe(Qe){return Qe.map(Re.from)}Re.fromMany=Fe;function be(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Z(Qe){let ut;if(be(Qe)){const{language:It,value:Rt}=Qe;ut={value:"```"+It+`
`+Rt+"\n```\n"}}else a.MarkdownString.isMarkdownString(Qe)?ut={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ut={value:Qe}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const wt=It=>{try{let Rt=L.URI.parse(It,!0);Rt=Rt.with({query:Oe(Rt.query,ht)}),ht[It]=Rt}catch{}return""},ft=new C.marked.Renderer;return ft.link=wt,ft.image=It=>typeof It=="string"?wt(y.parseHrefAndDimensions(It).href):"",(0,C.marked)(ut.value,{renderer:ft}),ut}Re.from=Z;function Oe(Qe,ut){if(!Qe)return Qe;let ht;try{ht=(0,D.parse)(Qe)}catch{}if(!ht)return Qe;let wt=!1;return ht=(0,E.cloneAndChange)(ht,ft=>{if(L.URI.isUri(ft)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[It]=ft,wt=!0,It}else return}),wt?JSON.stringify(ht):Qe}function We(Qe){const ut=new a.MarkdownString(Qe.value,Qe.supportThemeIcons);return ut.isTrusted=Qe.isTrusted,ut.supportHtml=Qe.supportHtml,ut.baseUri=Qe.baseUri?L.URI.from(Qe.baseUri):void 0,ut}Re.to=We;function it(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=it})(O=e.MarkdownString||(e.MarkdownString={}));function k(Re){return F(Re)?Re.map(Fe=>({range:h.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?O.fromMany(Fe.hoverMessage):Fe.hoverMessage?O.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:h.from(Fe)}))}e.fromRangeOrRangeWithMessage=k;function B(Re){return typeof Re=="undefined"?Re:typeof Re=="string"?L.URI.file(Re):Re}e.pathOrURIToURI=B;var M;(function(Re){function Fe(be){return typeof be=="undefined"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?B(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Re.from=Fe})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var W;(function(Re){function Fe(be){return typeof be=="undefined"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?B(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?M.from(be.before):void 0,after:be.after?M.from(be.after):void 0}}Re.from=Fe})(W=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ee;(function(Re){function Fe(be){if(typeof be=="undefined")return be;switch(be){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(Re){function Fe(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?ee.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?W.from(be.light):void 0,dark:be.dark?W.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?B(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?M.from(be.before):void 0,after:be.after?M.from(be.after):void 0}}Re.from=Fe})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(Re){function Fe(Z){return{text:Z.newText,eol:Z.newEol&&J.from(Z.newEol),range:h.from(Z.range)}}Re.from=Fe;function be(Z){const Oe=new a.TextEdit(h.to(Z.range),Z.text);return Oe.newEol=typeof Z.eol=="undefined"?void 0:J.to(Z.eol),Oe}Re.to=be})(N=e.TextEdit||(e.TextEdit={}));var j;(function(Re){function Fe(be){return{range:h.from(be.range),snippet:be.snippet.value}}Re.from=Fe})(j=e.SnippetTextEdit||(e.SnippetTextEdit={}));var x;(function(Re){function Fe(Z,Oe){const We={edits:[]};if(Z instanceof a.WorkspaceEdit){const it=new A.ResourceSet;for(const Qe of Z._allEntries())Qe._type===1&&L.URI.isUri(Qe.to)&&Qe.from===void 0&&it.add(Qe.to);for(const Qe of Z._allEntries())Qe._type===1?We.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata}):Qe._type===2?We.edits.push({_type:2,resource:Qe.uri,edit:N.from(Qe.edit),modelVersionId:it.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?We.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&We.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(tt.from)}})}return We}Re.from=Fe;function be(Z){const Oe=new a.WorkspaceEdit;for(const We of Z.edits)We.edit?Oe.replace(L.URI.revive(We.resource),h.to(We.edit.range),We.edit.text):Oe.renameFile(L.URI.revive(We.oldUri),L.URI.revive(We.newUri),We.options);return Oe}Re.to=be})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var q;(function(Re){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function be(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=be;function Z(Oe){for(const We in Fe)if(Fe[We]===Oe)return Number(We);return a.SymbolKind.Property}Re.to=Z})(q=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Re){function Fe(Z){switch(Z){case a.SymbolTag.Deprecated:return 1}}Re.from=Fe;function be(Z){switch(Z){case 1:return a.SymbolTag.Deprecated}}Re.to=be})(ie=e.SymbolTag||(e.SymbolTag={}));var Q;(function(Re){function Fe(Z){return{name:Z.name,kind:q.from(Z.kind),tags:Z.tags&&Z.tags.map(ie.from),containerName:Z.containerName,location:Se.from(Z.location)}}Re.from=Fe;function be(Z){const Oe=new a.SymbolInformation(Z.name,q.to(Z.kind),Z.containerName,Se.to(Z.location));return Oe.tags=Z.tags&&Z.tags.map(ie.to),Oe}Re.to=be})(Q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Re){function Fe(Z){const Oe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:h.from(Z.range),selectionRange:h.from(Z.selectionRange),kind:q.from(Z.kind),tags:Z.tags?.map(ie.from)??[]};return Z.children&&(Oe.children=Z.children.map(Fe)),Oe}Re.from=Fe;function be(Z){const Oe=new a.DocumentSymbol(Z.name,Z.detail,q.to(Z.kind),h.to(Z.range),h.to(Z.selectionRange));return(0,u.isNonEmptyArray)(Z.tags)&&(Oe.tags=Z.tags.map(ie.to)),Z.children&&(Oe.children=Z.children.map(be)),Oe}Re.to=be})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(Re){function Fe(Z){const Oe=new a.CallHierarchyItem(q.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),h.to(Z.range),h.to(Z.selectionRange));return Oe._sessionId=Z._sessionId,Oe._itemId=Z._itemId,Oe}Re.to=Fe;function be(Z,Oe,We){if(Oe=Oe??Z._sessionId,We=We??Z._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,name:Z.name,detail:Z.detail,kind:q.from(Z.kind),uri:Z.uri,range:h.from(Z.range),selectionRange:h.from(Z.selectionRange),tags:Z.tags?.map(ie.from)}}Re.from=be})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var X;(function(Re){function Fe(be){return new a.CallHierarchyIncomingCall(ue.to(be.from),be.fromRanges.map(Z=>h.to(Z)))}Re.to=Fe})(X=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ge;(function(Re){function Fe(be){return new a.CallHierarchyOutgoingCall(ue.to(be.to),be.fromRanges.map(Z=>h.to(Z)))}Re.to=Fe})(ge=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Se;(function(Re){function Fe(Z){return{range:Z.range&&h.from(Z.range),uri:Z.uri}}Re.from=Fe;function be(Z){return new a.Location(L.URI.revive(Z.uri),h.to(Z.range))}Re.to=be})(Se=e.location||(e.location={}));var oe;(function(Re){function Fe(Z){const Oe=Z,We=Z;return{originSelectionRange:Oe.originSelectionRange?h.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:We.uri,range:h.from(Oe.targetRange?Oe.targetRange:We.range),targetSelectionRange:Oe.targetSelectionRange?h.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function be(Z){return{targetUri:L.URI.revive(Z.uri),targetRange:h.to(Z.range),targetSelectionRange:Z.targetSelectionRange?h.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?h.to(Z.originSelectionRange):void 0}}Re.to=be})(oe=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(Re){function Fe(Z){return{range:h.from(Z.range),contents:O.fromMany(Z.contents)}}Re.from=Fe;function be(Z){return new a.Hover(Z.contents.map(O.to),h.to(Z.range))}Re.to=be})(_e=e.Hover||(e.Hover={}));var Pe;(function(Re){function Fe(Z){return{range:h.from(Z.range),expression:Z.expression}}Re.from=Fe;function be(Z){return new a.EvaluatableExpression(h.to(Z.range),Z.expression)}Re.to=be})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(Re){function Fe(Z){if(Z instanceof a.InlineValueText)return{type:"text",range:h.from(Z.range),text:Z.text};if(Z instanceof a.InlineValueVariableLookup)return{type:"variable",range:h.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function be(Z){switch(Z.type){case"text":return{range:h.to(Z.range),text:Z.text};case"variable":return{range:h.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:h.to(Z.range),expression:Z.expression}}}Re.to=be})(pe=e.InlineValue||(e.InlineValue={}));var ve;(function(Re){function Fe(Z){return{frameId:Z.frameId,stoppedLocation:h.from(Z.stoppedLocation)}}Re.from=Fe;function be(Z){return new a.InlineValueContext(Z.frameId,h.to(Z.stoppedLocation))}Re.to=be})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(Re){function Fe(Z){return{range:h.from(Z.range),kind:Z.kind}}Re.from=Fe;function be(Z){return new a.DocumentHighlight(h.to(Z.range),Z.kind)}Re.to=be})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Fe(be){switch(be){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Re.to=Fe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var me;(function(Re){function Fe(be){return{triggerKind:ce.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Re.to=Fe})(me=e.CompletionContext||(e.CompletionContext={}));var te;(function(Re){function Fe(Z){switch(Z){case a.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function be(Z){switch(Z){case 1:return a.CompletionItemTag.Deprecated}}Re.to=be})(te=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Re){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function be(We){return Fe.get(We)??9}Re.from=be;const Z=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(We){return Z.get(We)??a.CompletionItemKind.Property}Re.to=Oe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var U;(function(Re){function Fe(be,Z){const Oe=new a.CompletionItem(be.label);return Oe.insertText=be.insertText,Oe.kind=ne.to(be.kind),Oe.tags=be.tags?.map(te.to),Oe.detail=be.detail,Oe.documentation=y.isMarkdownString(be.documentation)?O.to(be.documentation):be.documentation,Oe.sortText=be.sortText,Oe.filterText=be.filterText,Oe.preselect=be.preselect,Oe.commitCharacters=be.commitCharacters,T.Range.isIRange(be.range)?Oe.range=h.to(be.range):typeof be.range=="object"&&(Oe.range={inserting:h.to(be.range.insert),replacing:h.to(be.range.replace)}),Oe.keepWhitespace=typeof be.insertTextRules=="undefined"?!1:Boolean(be.insertTextRules&1),typeof be.insertTextRules!="undefined"&&be.insertTextRules&4?Oe.insertText=new a.SnippetString(be.insertText):(Oe.insertText=be.insertText,Oe.textEdit=Oe.range instanceof a.Range?new a.TextEdit(Oe.range,Oe.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Oe.additionalTextEdits=be.additionalTextEdits.map(We=>N.to(We))),Oe.command=Z&&be.command?Z.fromInternal(be.command):void 0,Oe}Re.to=Fe})(U=e.CompletionItem||(e.CompletionItem={}));var $;(function(Re){function Fe(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation)}}Re.from=Fe;function be(Z){return{label:Z.label,documentation:y.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation}}Re.to=be})($=e.ParameterInformation||(e.ParameterInformation={}));var G;(function(Re){function Fe(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map($.from):[],activeParameter:Z.activeParameter}}Re.from=Fe;function be(Z){return{label:Z.label,documentation:y.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map($.to):[],activeParameter:Z.activeParameter}}Re.to=be})(G=e.SignatureInformation||(e.SignatureInformation={}));var K;(function(Re){function Fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(G.from):[]}}Re.from=Fe;function be(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(G.to):[]}}Re.to=be})(K=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(Re){function Fe(be,Z){const Oe=new a.InlayHint(s.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(we.to.bind(void 0,be)),Z.kind&&se.to(Z.kind));return Oe.textEdits=Z.textEdits&&Z.textEdits.map(N.to),Oe.tooltip=y.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,Oe.paddingLeft=Z.paddingLeft,Oe.paddingRight=Z.paddingRight,Oe}Re.to=Fe})(he=e.InlayHint||(e.InlayHint={}));var we;(function(Re){function Fe(be,Z){const Oe=new a.InlayHintLabelPart(Z.label);return Oe.tooltip=y.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,S.Command.is(Z.command)&&(Oe.command=be.fromInternal(Z.command)),Z.location&&(Oe.location=Se.to(Z.location)),Oe}Re.to=Fe})(we=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var se;(function(Re){function Fe(Z){return Z}Re.from=Fe;function be(Z){return Z}Re.to=be})(se=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(Re){function Fe(Z){return{range:h.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Re.from=Fe;function be(Z){let Oe;if(Z.url)try{Oe=typeof Z.url=="string"?L.URI.parse(Z.url,!0):L.URI.revive(Z.url)}catch{}return new a.DocumentLink(h.to(Z.range),Oe)}Re.to=be})(De=e.DocumentLink||(e.DocumentLink={}));var ye;(function(Re){function Fe(Z){const Oe=new a.ColorPresentation(Z.label);return Z.textEdit&&(Oe.textEdit=N.to(Z.textEdit)),Z.additionalTextEdits&&(Oe.additionalTextEdits=Z.additionalTextEdits.map(We=>N.to(We))),Oe}Re.to=Fe;function be(Z){return{label:Z.label,textEdit:Z.textEdit?N.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Oe=>N.from(Oe)):void 0}}Re.from=be})(ye=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(Re){function Fe(Z){return new a.Color(Z[0],Z[1],Z[2],Z[3])}Re.to=Fe;function be(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Re.from=be})(ze=e.Color||(e.Color={}));var Ve;(function(Re){function Fe(Z){return{range:h.from(Z.range)}}Re.from=Fe;function be(Z){return new a.SelectionRange(h.to(Z.range))}Re.to=be})(Ve=e.SelectionRange||(e.SelectionRange={}));var Me;(function(Re){function Fe(be){switch(be){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Me=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Re){function Fe(Z){switch(Z){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function be(Z){switch(Z){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Re.to=be})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(Re){function Fe(Z){if(Z===a.EndOfLine.CRLF)return 1;if(Z===a.EndOfLine.LF)return 0}Re.from=Fe;function be(Z){if(Z===1)return a.EndOfLine.CRLF;if(Z===0)return a.EndOfLine.LF}Re.to=be})(J=e.EndOfLine||(e.EndOfLine={}));var re;(function(Re){function Fe(be){if(typeof be=="object")return be.viewId;switch(be){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(re=e.ProgressLocation||(e.ProgressLocation={}));var Ce;(function(Re){function Fe(be){const Z={start:be.start+1,end:be.end+1};return be.kind&&(Z.kind=ae.from(be.kind)),Z}Re.from=Fe})(Ce=e.FoldingRange||(e.FoldingRange={}));var ae;(function(Re){function Fe(be){if(be)switch(be){case a.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Re.from=Fe})(ae=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ke;(function(Re){function Fe(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?h.from(be.selection):void 0,override:typeof be.override=="boolean"?I.EditorResolution.DISABLED:void 0}}Re.from=Fe})(ke=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ne;(function(Re){function Fe(We){return We instanceof a.RelativePattern?We.toJSON():typeof We=="string"?We:be(We)||Z(We)?new a.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Re.from=Fe;function be(We){const it=We;return it?L.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function Z(We){const it=We;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Oe(We){return typeof We=="string"?We:new a.RelativePattern(L.URI.revive(We.baseUri),We.pattern)}Re.to=Oe})(Ne=e.GlobPattern||(e.GlobPattern={}));var He;(function(Re){function Fe(be){if(be){if(Array.isArray(be))return be.map(Fe);if(typeof be=="string")return be;{const Z=be;return{language:Z.language,scheme:Z.scheme,pattern:Ne.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Re.from=Fe})(He=e.LanguageSelector||(e.LanguageSelector={}));var Ge;(function(Re){function Fe(Z){return{start:Z.start,end:Z.end}}Re.from=Fe;function be(Z){return new a.NotebookRange(Z.start,Z.end)}Re.to=be})(Ge=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Re){function Fe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Re.to=Fe;function be(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Re.from=be})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ze;(function(Re){function Fe(be){if(be===v.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(be===v.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(be===v.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${be}`)}Re.to=Fe})(Ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Fe(Z){switch(Z){case a.NotebookCellKind.Markup:return v.CellKind.Markup;case a.NotebookCellKind.Code:default:return v.CellKind.Code}}Re.from=Fe;function be(Z){switch(Z){case v.CellKind.Markup:return a.NotebookCellKind.Markup;case v.CellKind.Code:default:return a.NotebookCellKind.Code}}Re.to=be})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var rt;(function(Re){function Fe(Z){const Oe={metadata:Z.metadata??Object.create(null),cells:[]};for(let We of Z.cells)a.NotebookCellData.validate(We),Oe.cells.push(tt.from(We));return Oe}Re.from=Fe;function be(Z){const Oe=new a.NotebookData(Z.cells.map(tt.to));return(0,P.isEmptyObject)(Z.metadata)||(Oe.metadata=Z.metadata),Oe}Re.to=be})(rt=e.NotebookData||(e.NotebookData={}));var tt;(function(Re){function Fe(Z){return{cellKind:Xe.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:qe.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(ot.from):[]}}Re.from=Fe;function be(Z){return new a.NotebookCellData(Xe.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(ot.to):void 0,Z.metadata,Z.internalMetadata?qe.to(Z.internalMetadata):void 0)}Re.to=be})(tt=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Re){function Fe(Z){return{mime:Z.mime,valueBytes:i.VSBuffer.wrap(Z.data)}}Re.from=Fe;function be(Z){return new a.NotebookCellOutputItem(Z.valueBytes.buffer,Z.mime)}Re.to=be})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(Re){function Fe(Z){return{outputId:Z.id,items:Z.items.map(st.from),metadata:Z.metadata}}Re.from=Fe;function be(Z){const Oe=Z.items.map(st.to);return new a.NotebookCellOutput(Oe,Z.outputId,Z.metadata)}Re.to=be})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Fe(Oe){return Z(Oe)?{include:(0,P.withNullAsUndefined)(Ne.from(Oe.include)),exclude:(0,P.withNullAsUndefined)(Ne.from(Oe.exclude))}:(0,P.withNullAsUndefined)(Ne.from(Oe))}Re.from=Fe;function be(Oe){return Z(Oe)?{include:Ne.to(Oe.include),exclude:Ne.to(Oe.exclude)}:Ne.to(Oe)}Re.to=be;function Z(Oe){const We=Oe;return We?!(0,P.isUndefinedOrNull)(We.include)&&!(0,P.isUndefinedOrNull)(We.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ot;(function(Re){function Fe(be){return{backgroundColor:be.backgroundColor,borderColor:be.borderColor,top:be.top?M.from(be.top):void 0}}Re.from=Fe})(Ot=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var kt;(function(Re){function Fe(be,Z,Oe){const We=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(We,Oe),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Re.from=Fe})(kt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(Re){function Fe(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{}}}Re.from=Fe})(mt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Re){function Fe(Z){return{uri:Z.uri,provides:Z.provides}}Re.from=Fe;function be(Z){return new a.NotebookRendererScript(L.URI.revive(Z.uri),Z.provides)}Re.to=be})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Wt;(function(Re){function Fe(Z){return{message:O.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:h.from(Z.location.range),uri:Z.location.uri}}}Re.from=Fe;function be(Z){const Oe=new a.TestMessage(typeof Z.message=="string"?Z.message:O.to(Z.message));return Oe.actualOutput=Z.actual,Oe.expectedOutput=Z.expected,Oe.location=Z.location?Se.to(Z.location):void 0,Oe}Re.to=be})(Wt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=b.namespaceTestTag,Re.denamespace=b.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ke;(function(Re){function Fe(Z){const Oe=(0,g.getPrivateApiFor)(Z).controllerId;return{extId:p.TestId.fromExtHostTestItem(Z,Oe).toString(),label:Z.label,uri:L.URI.revive(Z.uri),busy:!1,tags:Z.tags.map(We=>Dt.namespace(Oe,We.id)),range:T.Range.lift(h.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&O.fromStrict(Z.error)||null}}Re.from=Fe;function be(Z){return{parent:void 0,error:void 0,id:p.TestId.fromString(Z.extId).localId,label:Z.label,uri:L.URI.revive(Z.uri),tags:(Z.tags||[]).map(Oe=>{const{tagId:We}=Dt.denamespace(Oe);return new a.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:h.to(Z.range||void 0),canResolveChildren:!1,busy:!1,description:Z.description||void 0,sortText:Z.sortText||void 0}}Re.toPlain=be})(Ke=e.TestItem||(e.TestItem={})),function(Re){function Fe(Z){return{id:Z.id}}Re.from=Fe;function be(Z){return new a.TestTag(Z.id)}Re.to=be}(Dt=e.TestTag||(e.TestTag={}));var At;(function(Re){const Fe=(Z,Oe)=>{const We={...Ke.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Qe=>Qe.type===0).map(Wt.to)})),children:Z.children.map(it=>Oe.get(it)).filter(P.isDefined).map(it=>Fe(it,Oe))};for(const it of We.children)it.parent=We;return We};function be(Z){const Oe=[],We=new Map;for(const it of Z.items)We.set(it.item.extId,it),Z.request.targets.some(Qe=>Qe.controllerId===it.controllerId&&Qe.testIds.includes(it.item.extId))&&Oe.push(it);return{completedAt:Z.completedAt,results:Oe.map(it=>Fe(it,We))}}Re.to=be})(At=e.TestResults||(e.TestResults={}));var Ut;(function(Re){function Fe(We){return{covered:We.covered,total:We.covered}}function be(We){return"line"in We?s.from(We):h.from(We)}function Z(We){return"branches"in We?{count:We.executionCount,location:be(We.location),type:1,branches:We.branches.length?We.branches.map(it=>({count:it.executionCount,location:it.location&&be(it.location)})):void 0}:{type:0,count:We.executionCount,location:be(We.location)}}Re.fromDetailed=Z;function Oe(We){return{uri:We.uri,statement:Fe(We.statementCoverage),branch:We.branchCoverage&&Fe(We.branchCoverage),function:We.functionCoverage&&Fe(We.functionCoverage),details:We.detailedCoverage?.map(Z)}}Re.fromFile=Oe})(Ut=e.TestCoverage||(e.TestCoverage={}));var Nt;(function(Re){function Fe(be){switch(be){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Re.to=Fe})(Nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var pt;(function(Re){function Fe(Z){const Oe=new a.TypeHierarchyItem(q.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),h.to(Z.range),h.to(Z.selectionRange));return Oe._sessionId=Z._sessionId,Oe._itemId=Z._itemId,Oe}Re.to=Fe;function be(Z,Oe,We){if(Oe=Oe??Z._sessionId,We=We??Z._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,kind:q.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:h.from(Z.range),selectionRange:h.from(Z.selectionRange),tags:Z.tags?.map(ie.from)}}Re.from=be})(pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ct;(function(Re){function Fe(be){if(!!be)return{value:be.value,tooltip:be.tooltip}}Re.from=Fe})(Ct=e.ViewBadge||(e.ViewBadge={}));var Tt;(function(Re){function Fe(be,Z){const Oe=be.fileData;return Oe?new class extends a.DataTransferItem{asFile(){return{name:Oe.name,uri:L.URI.revive(Oe.uri),data:(0,m.once)(()=>Z())}}}(""):new a.DataTransferItem(be.asString)}Re.toDataTransferItem=Fe})(Tt=e.DataTransferItem||(e.DataTransferItem={}));var _t;(function(Re){function Fe(Z,Oe){const We=Z.items.map(([it,Qe],ut)=>[it,Tt.toDataTransferItem(Qe,()=>Oe(ut))]);return new a.DataTransfer(We)}Re.toDataTransfer=Fe;async function be(Z){const Oe={items:[]},We=[];return Z.forEach((it,Qe)=>{We.push((async()=>{const ut=await it.asString(),ht=it.asFile();Oe.items.push([Qe,{asString:ut,fileData:ht?{name:ht.name,uri:ht.uri}:void 0}])})())}),await Promise.all(We),Oe}Re.toDataTransferDTO=be})(_t=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[221],Te([1,0,2,11,7,15,81]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(P,L,T,S={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=T,this._thresholds=S,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,T,S)=>{const _={dispose:this._callbacks.push([L,T,P])};return Array.isArray(S)&&S.push(_),_}}async $participateInSave(P,L){const T=u.URI.revive(P);let S=!1;const I=setTimeout(()=>S=!0,this._thresholds.timeout),_=[];try{for(let g of[...this._callbacks]){if(S)break;const v=this._documents.getDocument(T),p=await this._deliverEventAsyncAndBlameBadListeners(g,{document:v,reason:A.TextDocumentSaveReason.to(L)});_.push(p)}}finally{clearTimeout(I)}return _}_deliverEventAsyncAndBlameBadListeners([P,L,T],S){const I=this._badListeners.get(P);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,P,L,S).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const g=this._badListeners.get(P);this._badListeners.set(P,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,T,S){const I=[],_=Date.now(),{document:g,reason:v}=S,{version:p}=g,b=Object.freeze({document:g,reason:v,waitUntil(f){if(Object.isFrozen(I))throw(0,i.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(f))}});try{L.apply(T,[b])}catch(f){return Promise.reject(f)}return Object.freeze(I),new Promise((f,a)=>{const m=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(m),f(o)}).catch(o=>{clearTimeout(m),a(o)})}).then(f=>{const a={edits:[]};for(const m of f)if(Array.isArray(m)&&m.every(o=>o instanceof y.TextEdit))for(const{newText:o,newEol:h,range:r}of m)a.edits.push({_type:2,resource:g.uri,edit:{range:r&&A.Range.from(r),text:o,eol:h&&A.EndOfLine.from(h)}});if(a.edits.length!==0)return p===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(Ie[222],Te([1,0,10,2,15,7,128]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(T,S,I,_){this.start=T,this.deletedCount=S,this.deletedItems=I,this.items=_}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class E{constructor(T,S,I){this.notebook=T,this._extHostDocument=S,this._cellData=I,this.handle=I.handle,this.uri=i.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}static asModelAddData(T,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:T}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const T=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return T._mime},set mime(_){T._mime=_},get outputs(){return T._outputs.slice(0)},get metadata(){return T._metadata},get executionSummary(){return T._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(T){this._outputs=T.map(y.NotebookCellOutput.to)}setOutputItems(T,S,I){const _=I.map(y.NotebookCellOutputItem.to),g=this._outputs.find(v=>v.id===T);g&&(S||(g.items.length=0),g.items.push(..._))}setMetadata(T){this._metadata=Object.freeze(T)}setInternalMetadata(T){this._internalMetadata=T,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=E;class P{constructor(T,S,I,_,g){this._proxy=T,this._textDocumentsAndEditors=S,this._textDocuments=I,this.uri=_,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=g.viewType,this._metadata=Object.freeze(g.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,g.cells]],!0,void 0),this._versionId=g.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const T=this,S={get uri(){return T.uri},get version(){return T._versionId},get notebookType(){return T._notebookType},get isDirty(){return T._isDirty},get isUntitled(){return T.uri.scheme===u.Schemas.untitled},get isClosed(){return T._disposed},get metadata(){return T._metadata},get cellCount(){return T._cells.length},cellAt(I){return I=T._validateIndex(I),T._cells[I].apiCell},getCells(I){return(I?T._getCells(I):T._cells).map(g=>g.apiCell)},save(){return T._save()}};this._notebook=Object.freeze(S)}return this._notebook}updateBackup(T){this._backup?.delete(),this._backup=T}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(T){T.metadata&&(this._metadata=Object.freeze({...this._metadata,...T.metadata}))}acceptDirty(T){this._isDirty=T}acceptModelChanged(T,S,I){this._versionId=T.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:I});const _={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},g=[];for(const p of T.rawEvents)p.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1,_.contentChanges):p.kind===C.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx,_.contentChanges):p.kind===C.NotebookCellsChangeType.Output?(this._setCellOutputs(p.index,p.outputs),g.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===C.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems),g.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(p.index,p.language),g.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document})):p.kind===C.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document}):p.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(p.index,p.metadata),g.push({cell:this._cells[p.index].apiCell,metadata:this._cells[p.index].apiCell.metadata})):p.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(p.index,p.internalMetadata),g.push({cell:this._cells[p.index].apiCell,executionSummary:this._cells[p.index].apiCell.executionSummary}));const v=new Map;for(let p=0;p<g.length;p++){const b=g[p],f=v.get(b.cell);if(f===void 0){const a=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});v.set(b.cell,a-1)}else _.cellChanges[f]={..._.cellChanges[f],...b}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(T){return T=T|0,T<0?0:T>=this._cells.length?this._cells.length-1:T}_validateRange(T){let S=T.start|0,I=T.end|0;return S<0&&(S=0),I>this._cells.length&&(I=this._cells.length),T.with({start:S,end:I})}_getCells(T){T=this._validateRange(T);const S=[];for(let I=T.start;I<T.end;I++)S.push(this._cells[I]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(T,S,I){if(this._disposed)return;const _=[],g=[],v=[];if(T.reverse().forEach(p=>{const f=p[2].map(o=>{const h=new E(this,this._textDocumentsAndEditors,o);return S||g.push(E.asModelAddData(this.apiNotebook,o)),h}),a=new D(p[0],p[1],[],f),m=this._cells.splice(p[0],p[1],...f);for(const o of m)v.push(o.uri),a.deletedItems.push(o.apiCell);_.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:v}),I)for(let p of _)I.push(p.asApiEvent())}_moveCell(T,S,I){const _=this._cells.splice(T,1);this._cells.splice(S,0,..._);const g=[new D(T,1,_.map(v=>v.apiCell),[]),new D(S,0,[],_)];for(const v of g)I.push(v.asApiEvent())}_setCellOutputs(T,S){this._cells[T].setOutputs(S)}_setCellOutputItems(T,S,I,_){this._cells[T].setOutputItems(S,I,_)}_changeCellLanguage(T,S){const I=this._cells[T];I.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(I.uri,S)}_changeCellMime(T,S){const I=this._cells[T];I.apiCell.mime=S}_changeCellMetadata(T,S){this._cells[T].setMetadata(S)}_changeCellInternalMetadata(T,S){this._cells[T].setInternalMetadata(S)}getCellFromApiCell(T){return this._cells.find(S=>S.apiCell===T)}getCellFromIndex(T){return this._cells[T]}getCell(T){return this._cells.find(S=>S.handle===T)}getCellIndex(T){return this._cells.indexOf(T)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ie[131],Te([1,0,7,15,11]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:P})}replaceCells(E,P,L){this._throwIfFinalized(),!(E===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:E,count:P-E,cells:L.map(i.NotebookCellData.from)})}}class C{constructor(E,P,L,T,S,I){this.id=E,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._visibleRanges=T,this._viewColumn=I}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(P){this.selections=[P]},get selections(){return E._selections},set selections(P){if(!Array.isArray(P)||!P.every(u.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");E._selections=P,E._trySetSelections(P)},get visibleRanges(){return E._visibleRanges},revealRange(P,L){E._proxy.$tryRevealRange(E.id,i.NotebookRange.from(P),L??u.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(P){const L=new A(this.document.version);return P(L),E._applyEdit(L.finalize())},setDecorations(P,L){return E.setDecorations(P,L)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(i.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let T=0;T<E.cellEdits.length;T++){if(L<0){P.push(E.cellEdits[T]),L++;continue}const I=P[L],_=E.cellEdits[T];if(I.editType===1&&_.editType===1&&I.index===_.index){I.cells.push(...E.cellEdits[T].cells),I.count+=E.cellEdits[T].count;continue}P.push(E.cellEdits[T]),L++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,P)}setDecorations(E,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return P.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(P),E.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(Ie[223],Te([1,0,15,118,172,21,58,11]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,I,_){const g=this._handles++,{title:v,location:p,cancellable:b}=I,f={label:(0,y.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(g,{location:u.ProgressLocation.from(p),title:v,source:f,cancellable:b},S.isUnderDevelopment?void 0:S.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(g,_,!!b)}_withProgress(S,I,_){let g;_&&(g=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,g));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),g&&g.dispose()};let p;try{p=I(new L(this._proxy,S),_&&g?g.token:A.CancellationToken.None)}catch(b){throw v(S),b}return p.then(b=>v(S),b=>v(S)),p}$acceptProgressCanceled(S){const I=this._mapHandleToCancellationSource.get(S);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=E;function P(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class L extends i.Progress{constructor(S,I){super(_=>this.throttledReport(_));this._proxy=S,this._handle=I}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}je([(0,C.throttle)(100,(T,S)=>P(T,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ie[132],Te([1,0,36,129,67,90,68,15,2]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(f,a,m,o)=>{let h=a;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!m(h,r)){const s=h;h=r,f.listener?.(o(r,s))}}}},L=(f,a)=>f===a,T={range:(f,a)=>f===a?!0:!f||!a?!1:f.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(f,a)=>!(f.length!==a.length||f.some(m=>!a.find(o=>m.id===o.id)))},S=f=>a=>({op:4,update:f(a)}),I=(f,a)=>({range:P(f,void 0,T.range,S(m=>({range:u.Range.lift(D.Range.from(m))}))),label:P(f,a,T.label,S(m=>({label:m}))),description:P(f,void 0,T.description,S(m=>({description:m}))),sortText:P(f,void 0,T.sortText,S(m=>({sortText:m}))),canResolveChildren:P(f,!1,T.canResolveChildren,m=>({op:2,state:m})),busy:P(f,!1,T.busy,S(m=>({busy:m}))),error:P(f,void 0,T.error,S(m=>({error:D.MarkdownString.fromStrict(m)||null}))),tags:P(f,[],T.tags,(m,o)=>({op:1,new:m.map(D.TestTag.from),old:o.map(D.TestTag.from)}))}),_=f=>{const a=y.TestId.fromString(f.extId),m=new v(a.controllerId,a.localId,f.label,E.URI.revive(f.uri)||void 0);return m.range=D.Range.to(f.range||void 0),m.description=f.description||void 0,m.sortText=f.sortText||void 0,m.tags=f.tags.map(o=>D.TestTag.to({id:(0,C.denamespaceTestTag)(o).tagId})),m},g=f=>{let a;for(const m of f.tests){const o=_(m.item);(0,i.getPrivateApiFor)(o).parent=a,a=o}return a};e.toItemFromContext=g;class v{constructor(a,m,o,h){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,i.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof p?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,i.getPrivateApiFor,v),enumerable:!0,writable:!1},...I(r,o)})}}e.TestItemImpl=v;class p extends v{constructor(a,m){super(a,a,m,void 0)}}e.TestItemRootImpl=p;class b extends A.TestItemCollection{constructor(a,m){super({controllerId:a,getApiFor:i.getPrivateApiFor,getChildren:o=>o.children,root:new p(a,m),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(Ie[133],Te([1,0,57,11,79,15,7]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(S,I,_){const g=D._Keys.nextId();S.$registerTextEditorDecorationType(I.identifier,g,A.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:g,dispose(){S.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=D,D._Keys=new y.IdGenerator("TextEditorDecorationType");class E{constructor(S,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,I){this._throwIfFinalized();let _=null;if(S instanceof C.Position)_=new C.Range(S,S);else if(S instanceof C.Range)_=S;else throw new Error("Unrecognized location");this._pushEdit(_,I,!1)}insert(S,I){this._throwIfFinalized(),this._pushEdit(new C.Range(S,S),I,!0)}delete(S){this._throwIfFinalized();let I=null;if(S instanceof C.Range)I=S;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(S,I,_){const g=this._document.validateRange(S);this._collectedEdits.push({range:g,text:I,forceMoveMarkers:_})}setEndOfLine(S){if(this._throwIfFinalized(),S!==C.EndOfLine.LF&&S!==C.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=E;class P{constructor(S,I,_,g){this._proxy=S,this._id=I,this._accept(_),this._logService=g;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(p){v._setTabSize(p)},get insertSpaces(){return v._insertSpaces},set insertSpaces(p){v._setInsertSpaces(p)},get cursorStyle(){return v._cursorStyle},set cursorStyle(p){v._setCursorStyle(p)},get lineNumbers(){return v._lineNumbers},set lineNumbers(p){v._setLineNumbers(p)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(S){const I=this._validateTabSize(S);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const I=this._validateInsertSpaces(S);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(S)})))}assign(S){const I={};let _=!1;if(typeof S.tabSize!="undefined"){const g=this._validateTabSize(S.tabSize);g==="auto"?(_=!0,I.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,_=!0,I.tabSize=g)}if(typeof S.insertSpaces!="undefined"){const g=this._validateInsertSpaces(S.insertSpaces);g==="auto"?(_=!0,I.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,_=!0,I.insertSpaces=g)}typeof S.cursorStyle!="undefined"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,_=!0,I.cursorStyle=S.cursorStyle),typeof S.lineNumbers!="undefined"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,_=!0,I.lineNumbers=A.TextEditorLineNumbersStyle.from(S.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(S,I){I.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=P;class L{constructor(S,I,_,g,v,p,b,f){this.id=S,this._proxy=I,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,p,_),this._visibleRanges=b,this._viewColumn=f;const a=this;this.value=Object.freeze({get document(){return g.getValue()},set document(m){throw(0,i.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(m){if(!(m instanceof C.Selection))throw(0,i.illegalArgument)("selection");a._selections=[m],a._trySetSelection()},get selections(){return a._selections},set selections(m){if(!Array.isArray(m)||m.some(o=>!(o instanceof C.Selection)))throw(0,i.illegalArgument)("selections");a._selections=m,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(m){throw(0,i.readonly)("visibleRanges")},get options(){return a._options.value},set options(m){a._disposed||a._options.assign(m)},get viewColumn(){return a._viewColumn},set viewColumn(m){throw(0,i.readonly)("viewColumn")},edit(m,o={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new E(g.getValue(),o);return m(h),a._applyEdit(h)},insertSnippet(m,o,h={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=a._selections.map(s=>A.Range.from(s));else if(o instanceof C.Position){const{lineNumber:s,column:n}=A.Position.from(o);r=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(o instanceof C.Range)r=[A.Range.from(o)];else{r=[];for(const s of o)if(s instanceof C.Range)r.push(A.Range.from(s));else{const{lineNumber:n,column:t}=A.Position.from(s);r.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return I.$tryInsertSnippet(S,g.getValue().version,m.value,r,h)},setDecorations(m,o){const h=o.length===0;h&&!a._hasDecorationsForKey.has(m.key)||(h?a._hasDecorationsForKey.delete(m.key):a._hasDecorationsForKey.add(m.key),a._runOnProxy(()=>{if(A.isDecorationOptionsArr(o))return I.$trySetDecorations(S,m.key,A.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let s=0,n=o.length;s<n;s++){const t=o[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return I.$trySetDecorationsFast(S,m.key,r)}}))},revealRange(m,o){a._runOnProxy(()=>I.$tryRevealRange(S,A.Range.from(m),o||C.TextEditorRevealType.Default))},show(m){I.$tryShowEditor(S,A.ViewColumn.from(m))},hide(){I.$tryHideEditor(S)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,u.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,u.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,u.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,u.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const I=S.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const _=I.edits.map(v=>v.range);_.sort((v,p)=>v.end.line===p.end.line?v.end.character===p.end.character?v.start.line===p.start.line?v.start.character-p.start.character:v.start.line-p.start.line:v.end.character-p.end.character:v.end.line-p.end.line);for(let v=0,p=_.length-1;v<p;v++){const b=_[v].end;if(_[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=I.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,g,{setEndOfLine:typeof I.setEndOfLine=="number"?A.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=L}),define(Ie[224],Te([1,0,4,191]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(i.IEnvironmentService)}),define(Ie[225],Te([1,0,26,3,9]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=A;class C{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let T of L.activationEvents)T==="onUri"&&(T=`onUri:${u.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(L)}}set(L){this._extensionDescriptions=L,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,T){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const S=C._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(S.map(I=>I.identifier)),T.length>0){const I=new Set;T.forEach(_=>I.add(u.ExtensionIdentifier.toKey(_))),this._extensionDescriptions=this._extensionDescriptions.filter(_=>!I.has(u.ExtensionIdentifier.toKey(_.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(S)}static _findLoopingExtensions(L){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,p){this.addNode(v),this.addNode(p),this._arcs.has(v)?this._arcs.get(v).push(p):this._arcs.set(v,[p])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,p){const b=T.getArcs(v);for(let f=0;f<b.length;f++)if(!p.has(b[f]))return!1;return!0}getNodes(){return this._nodesArr}};let S=new Map;for(let v of L){const p=u.ExtensionIdentifier.toKey(v.identifier);if(S.set(p,v),v.extensionDependencies)for(let b of v.extensionDependencies){const f=u.ExtensionIdentifier.toKey(b);T.addArc(p,f)}}let I=new Set;T.getNodes().filter(v=>T.getArcs(v).length===0).forEach(v=>I.add(v));let _=T.getNodes().filter(v=>!I.has(v)),g;do{g=!1;for(let v=0;v<_.length;v++){const p=_[v];T.hasOnlyGoodArcs(p,I)&&(_.splice(v,1),v--,I.add(p),g=!0)}}while(g);return _.map(v=>S.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const T=this._activationMap.get(L);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const T=this._extensionsMap.get(u.ExtensionIdentifier.toKey(L));return T||void 0}}e.ExtensionDescriptionRegistry=C;var D;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(D||(D={}));function E(P,L){const T=P.isBuiltin?0:P.isUnderDevelopment?2:1,S=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(T!==S)return T-S;const I=y.posix.basename(P.extensionLocation.path),_=y.posix.basename(L.extensionLocation.path);return I<_?-1:I>_?1:0}}),define(Ie[134],Te([1,0,23]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var i;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(i=e.UIKind||(e.UIKind={}));var y;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function C(E){const P=u.VSBuffer.alloc(1);switch(E){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=C;function D(E,P){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=D}),define(Ie[28],Te([1,0,3,2,4,26,200]),function(Y,e,u,i,y,A,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class E{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class L{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class T{constructor(t){this.dependency=t}}e.MissingExtensionDependency=T;var S;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class _{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const l=[],d=[],w=[],R=[],F=p(this._allExtensions),O=p(t),k=(ee,H)=>ee.extensionLocation.toString()===H.extensionLocation.toString()||ee.isBuiltin===H.isBuiltin||ee.isUserBuiltin===H.isUserBuiltin||ee.isUnderDevelopment===H.isUnderDevelopment;for(const ee of this._allExtensions){const H=O.get(A.ExtensionIdentifier.toKey(ee.identifier));if(!H){l.push(ee.identifier),F.delete(A.ExtensionIdentifier.toKey(ee.identifier));continue}if(!k(ee,H)){l.push(ee.identifier),F.delete(A.ExtensionIdentifier.toKey(ee.identifier));continue}}for(const ee of t){const H=F.get(A.ExtensionIdentifier.toKey(ee.identifier));if(!H){d.push(ee);continue}if(!k(H,ee)){l.push(H.identifier),F.delete(A.ExtensionIdentifier.toKey(H.identifier));continue}}const B=v(this._myExtensions),M=v(c);for(const ee of this._myExtensions)M.has(A.ExtensionIdentifier.toKey(ee))||w.push(ee);for(const ee of c)B.has(A.ExtensionIdentifier.toKey(ee))||R.push(ee);const W={toRemove:l,toAdd:d,myToRemove:w,myToAdd:R};return this.delta(W),W}delta(t){const{toRemove:c,toAdd:l,myToRemove:d,myToAdd:w}=t,R=v(c),F=v(d);for(let O=0;O<this._allExtensions.length;O++)R.has(A.ExtensionIdentifier.toKey(this._allExtensions[O].identifier))&&(this._allExtensions.splice(O,1),O--);for(let O=0;O<this._myExtensions.length;O++)F.has(A.ExtensionIdentifier.toKey(this._myExtensions[O]))&&(this._myExtensions.splice(O,1),O--);for(const O of l)this._allExtensions.push(O);for(const O of w)this._myExtensions.push(O)}containsExtension(t){for(const c of this._myExtensions)if(A.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=_;class g{constructor(t){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(l=>t.call(c,l,l,this))}*entries(){for(let[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function v(n){const t=new Set;for(const c of n)t.add(A.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=v;function p(n){const t=new Map;for(const c of n)t.set(A.ExtensionIdentifier.toKey(c.identifier),c);return t}function b(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=b;function f(n,t){if(!b(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=f;class a{constructor(t,c,l,d){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=d}}e.ActivationTimes=a;class m{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var o;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function h(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(n,t){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=s}),define(Ie[226],Te([1,0,11,26,28,14,17]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(v,p,b,f){this.startup=v,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=f}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class E{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,p){return v===-1||p===-1?-1:p-v}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(v,p,b,f,a,m){this.activationFailed=v,this.activationFailedError=p,this.activationTimes=b,this.module=f,this.exports=a,this.subscriptions=m}}e.ActivatedExtension=P;class L extends P{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class T extends P{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class S extends P{constructor(v){super(!0,v,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let I=class{constructor(v,p,b,f,a){this._logService=a,this._registry=v,this._resolvedExtensionsSet=new Set,p.forEach(m=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,b.forEach(m=>this._externalExtensionsMap.set(i.ExtensionIdentifier.toKey(m),m)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,p]of this._operations)p.dispose()}isActivated(v){const p=this._operations.get(i.ExtensionIdentifier.toKey(v));return Boolean(p&&p.value)}getActivatedExtension(v){const p=this._operations.get(i.ExtensionIdentifier.toKey(v));if(!p||!p.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return p.value}async activateByEvent(v,p){if(this._alreadyActivatedEvents[v])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(b.map(f=>({id:f.identifier,reason:{startup:p,extensionId:f.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,p){const b=this._registry.getExtensionDescription(v);if(!b)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:b.identifier,reason:p}])}async _activateExtensions(v){const p=v.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(p.map(b=>b.wait()))}_handleActivationRequest(v){if(this._operations.has(i.ExtensionIdentifier.toKey(v.id)))return this._operations.get(i.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const p=this._registry.getExtensionDescription(v.id);if(!p){const a=new Error(`Cannot activate unknown extension '${v.id.value}'`),m=this._createAndSaveOperation(v,null,[],new S(a));return this._host.onExtensionActivationError(v.id,a,new y.MissingExtensionDependency(v.id.value)),m}const b=[],f=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;for(const a of f){if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(a)))continue;const m=this._operations.get(i.ExtensionIdentifier.toKey(a));if(m){b.push(m);continue}if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(a))){b.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(i.ExtensionIdentifier.toKey(a)),reason:v.reason}));continue}const o=this._registry.getExtensionDescription(a);if(o){if(!o.main&&!o.browser)continue;b.push(this._handleActivationRequest({id:o.identifier,reason:v.reason}));continue}const h=p.displayName||p.identifier.value,r=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),s=this._createAndSaveOperation(v,p.displayName,[],new S(r));return this._host.onExtensionActivationError(p.identifier,r,new y.MissingExtensionDependency(a)),s}return this._createAndSaveOperation(v,p.displayName,b,null)}_createAndSaveOperation(v,p,b,f){const a=new _(v.id,p,v.reason,b,f,this._host,this._logService);return this._operations.set(i.ExtensionIdentifier.toKey(v.id),a),a}};I=je([xe(4,A.ILogService)],I),e.ExtensionsActivator=I;let _=class{constructor(v,p,b,f,a,m,o){this._id=v,this._displayName=p,this._reason=b,this._deps=f,this._value=a,this._host=m,this._logService=o,this._barrier=new C.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const p=this._deps[v];if(p.value&&!p.value.activationFailed){this._deps.splice(v,1),v--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this._value=new S(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const p=new Error;if(v&&v.name&&(p.name=v.name),v&&v.message?p.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:p.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(p.stack=v.stack),this._value=new S(p),this._isDisposed&&u.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,p,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};_=je([xe(6,A.ILogService)],_)}),define(Ie[227],Te([1,0,14,27,28]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends u.LogService{constructor(D,E){super(D.createLogger(E.logFile,{name:y.ExtensionHostLogFileName}))}};A=je([xe(0,u.ILoggerService),xe(1,i.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Ie[228],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",dataTransferFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dataTransferFiles.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorDecorationType:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorDecorationType.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmInput:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInput.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[229],Te([1,0,186,11,41,85,119,44,26,228,48,198]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=D.Registry.as(C.Extensions.JSONContribution);class I{constructor(m,o,h){this._messageHandler=m,this._extension=o,this._extensionPointId=h}_msg(m,o){this._messageHandler({type:m,message:o,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(m){this._msg(y.default.Error,m)}warn(m){this._msg(y.default.Warning,m)}info(m){this._msg(y.default.Info,m)}}e.ExtensionMessageCollector=I;class _{constructor(m,o){this.added=m,this.removed=o}static _toSet(m){const o=new Set;for(let h=0,r=m.length;h<r;h++)o.add(E.ExtensionIdentifier.toKey(m[h].description.identifier));return o}static compute(m,o){if(!m||!m.length)return new _(o,[]);if(!o||!o.length)return new _([],m);const h=this._toSet(m),r=this._toSet(o);let s=o.filter(t=>!h.has(E.ExtensionIdentifier.toKey(t.description.identifier))),n=m.filter(t=>!r.has(E.ExtensionIdentifier.toKey(t.description.identifier)));return new _(s,n)}}e.ExtensionPointUserDelta=_;class g{constructor(m,o){this.name=m,this.defaultExtensionKind=o,this._handler=null,this._users=null,this._delta=null}setHandler(m){if(this._handler!==null)throw new Error("Handler already set!");this._handler=m,this._handle()}acceptUsers(m){this._delta=_.compute(this._users,m),this._users=m,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(m){(0,i.onUnexpectedError)(m)}}}e.ExtensionPoint=g;const v={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:(0,L.values)(P.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:v,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class b{constructor(){this._extensionPoints=new Map}registerExtensionPoint(m){if(this._extensionPoints.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const o=new g(m.extensionPoint,m.defaultExtensionKind);return this._extensionPoints.set(m.extensionPoint,o),e.schema.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,S.registerSchema(p,e.schema),o}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=b;const f={ExtensionsRegistry:"ExtensionsRegistry"};D.Registry.add(f.ExtensionsRegistry,new b),e.ExtensionsRegistry=D.Registry.as(f.ExtensionsRegistry),S.registerSchema(p,e.schema),S.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:(0,L.values)(P.allApiProposals)}}]}}}})}),define(Ie[230],Te([1,0,183,12,24,229,52,3]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var P;(function(S){function I(_,g,v){if(!_)return;let p=i.isString(_.type)?_.type:void 0;if(!p||p.length===0){v.error(u.localize(3,null));return}let b=[];if(Array.isArray(_.required))for(let f of _.required)i.isString(f)&&b.push(f);return{extensionId:g.value,taskType:p,required:b,properties:_.properties?y.deepClone(_.properties):{},when:_.when?C.ContextKeyExpr.deserialize(_.when):void 0}}S.from=I})(P||(P={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:E}});class T{constructor(){this._onDefinitionsChanged=new D.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,_)=>{L.setHandler((g,v)=>{try{for(let p of v.removed){let b=p.value;for(let f of b)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(let p of v.added){let b=p.value;for(let f of b){let a=P.from(f,p.description.identifier,p.collector);a&&(this.taskTypes[a.taskType]=a)}}(v.removed.length>0||v.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){let I=[];for(let _ of this.all()){let g={type:"object",additionalProperties:!1};_.required.length>0&&(g.required=_.required.slice(0)),_.properties!==void 0?g.properties=y.deepClone(_.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[_.taskType]},I.push(g)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=T,e.TaskDefinitionRegistry=new T}),define(Ie[231],Te([1,0,184,12,22,24,52,230]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var E;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function M(W){if(!W)return B.Strong;switch(W.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=M}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var L;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(B){function M(W){switch(W.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=M}(L=e.RevealKind||(e.RevealKind={}));var T;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(B){function M(W){switch(W.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=M}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(B){function M(W){switch(W.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=M}(S=e.PanelKind||(e.PanelKind={}));var I;(function(B){B.defaults={echo:!0,reveal:L.Always,revealProblems:T.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var _;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(_=e.RuntimeType||(e.RuntimeType={})),function(B){function M(ee){switch(ee.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=M;function W(ee){switch(ee){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=W}(_=e.RuntimeType||(e.RuntimeType={}));var g;(function(B){function M(W){return i.isString(W)?W:W.value}B.value=M})(g=e.CommandString||(e.CommandString={}));var v;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function M(ee){return ee===B.Clean._id||ee===B.Build._id||ee===B.Rebuild._id||ee===B.Test._id}B.is=M;function W(ee){if(ee!==void 0)return i.isString(ee)?M(ee)?{_id:ee,isDefault:!1}:void 0:ee}B.from=W})(v=e.TaskGroup||(e.TaskGroup={}));var p;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(p=e.TaskScope||(e.TaskScope={}));var b;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function M(W){switch(W){case B.User:return 1;case B.WorkspaceFile:return 4;default:return 5}}B.toConfigurationTarget=M})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(B){B.parallel="parallel",B.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var a;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class o{constructor(M,W,ee,H,N,j){this._label="",this._id=M,W&&(this._label=W),ee&&(this.type=ee),this.runOptions=H,this.configurationProperties=N,this._source=j}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,W=!1){if(M===void 0)return!1;if(i.isString(M))return M===this._label||M===this.configurationProperties.identifier||W&&M===this._id;let ee=this.getDefinition(!0);return ee!==void 0&&ee._key===M._key}getQualifiedLabel(){let M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=o;class h extends o{constructor(M,W,ee,H,N,j,x,q){super(M,ee,void 0,x,q,W);this.command={},this._source=W,this.hasDefinedMatchers=j,N&&(this.command=N)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case _.Shell:W="shell";break;case _.Process:W="process";break;case _.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(M){return M instanceof h}getMapKey(){let M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){let M=this.getFolderId();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(W+=this._source.kind);let ee={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:W};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new h(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=h;class r extends o{constructor(M,W,ee,H,N,j,x){super(M,ee,H,j,x,W);this._source=W,this.configures=N}static is(M){return M instanceof r}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){let M=this.getFolderId();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(W+=this._source.kind);let ee={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:W};return JSON.stringify(ee)}}e.ConfiguringTask=r;class s extends o{constructor(M,W,ee,H,N,j,x,q,ie){super(M,ee,H,q,ie,W);this.defines=N,this.hasDefinedMatchers=x,this.command=j}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof s}getMapKey(){let M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){let M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new s(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=s;class n extends o{constructor(M,W,ee,H,N,j){super(M,ee,H,N,j,W);this._source=W}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new n(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=n;var t;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(B){B._default=B.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(M){this._order=new Map;for(let W=0;W<M.length;W++)this._order.set(M[W].uri.toString(),W)}compare(M,W){let ee=M.getWorkspaceFolder(),H=W.getWorkspaceFolder();if(ee&&H){let N=this._order.get(ee.uri.toString());N=N===void 0?0:N+1;let j=this._order.get(H.uri.toString());return j=j===void 0?0:j+1,N===j?M._label.localeCompare(W._label):N-j}else return!ee&&H?-1:ee&&!H?1:0}}e.TaskSorter=l;var d;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(B){B.SingleRun="singleRun",B.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var R;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange"})(R=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(B){function M(W,ee,H,N){if(ee){let j={kind:W,taskId:ee._id,taskName:ee.configurationProperties.name,runType:ee.configurationProperties.isBackground?"background":"singleRun",group:ee.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:ee};return W==="start"?(j.terminalId=H,j.resolvedVariables=N):W==="processStarted"?j.processId=H:W==="processEnded"&&(j.exitCode=H),Object.freeze(j)}else return Object.freeze({kind:"changed"})}B.create=M})(F=e.TaskEvent||(e.TaskEvent={}));var O;(function(B){function M(ee){const H=Object.keys(ee).sort();let N="";for(const j of H){let x=ee[j];x instanceof Object?x=M(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),N+=j+","+x+","}return N}function W(ee){let N={_key:M(ee),type:ee.taskType};return Object.assign(N,ee),N}B.create=W})(O=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var k;(function(B){function M(W,ee){let H=D.TaskDefinitionRegistry.get(W.type);if(H===void 0){let q=A.deepClone(W);return delete q._key,O.create(q)}let N=Object.create(null);N.type=H.taskType;let j=new Set;H.required.forEach(q=>j.add(q));let x=H.properties;for(let q of Object.keys(x)){let ie=W[q];if(ie!=null)N[q]=ie;else if(j.has(q)){let Q=x[q];if(Q.default!==void 0)N[q]=A.deepClone(Q.default);else switch(Q.type){case"boolean":N[q]=!1;break;case"number":case"integer":N[q]=0;break;case"string":N[q]="";break;default:ee.error(u.localize(2,null,JSON.stringify(W,void 0,0),q));return}}}return O.create(N)}B.createTaskIdentifier=M})(k=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[232],Te([1,0,11]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,C)=>{this._actualOk=A,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,u.onUnexpectedError)(A))}then(A,C){return this._ensureActual().then(A,C)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=i}),define(Ie[54],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const i=[];function y(D){const E=new u(D);return i[E.nid]=E,E}e.createProxyIdentifier=y;function A(D){return i[D].sid}e.getStringIdentifierForProxy=A;class C{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=C}),define(Ie[5],Te([1,0,62,2,54]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.NotebookInput=3]="NotebookInput",f[f.NotebookDiffInput=4]="NotebookDiffInput",f[f.CustomEditorInput=5]="CustomEditorInput",f[f.WebviewEditorInput=6]="WebviewEditorInput",f[f.TerminalEditorInput=7]="TerminalEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var D;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(S=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(a){return a._id=I._n++,a}}e.IdObject=I,I._n=0;var _;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(_=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(f){if(f&&f.edits)for(const a of f.edits)typeof a.resource=="object"?a.resource=i.URI.revive(a.resource):(a.newUri=i.URI.revive(a.newUri),a.oldUri=i.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,u.revive)(a.metadata));return f}e.reviveWorkspaceEditDto=p;var b;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[91],Te([1,0,5,3,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,E){return this._proxy.$getPassword(D,E)}store(D,E,P){return this._proxy.$setPassword(D,E,P)}delete(D,E){return this._proxy.$deletePassword(D,E)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(Ie[69],Te([1,0,4,14,5,18]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(y.MainContext.MainThreadTelemetry)}report(E,P,L){const T=this.getUsageKey(E,P);this._reportedUsages.has(T)||(this._reportedUsages.add(T),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};C=je([xe(0,A.IExtHostRpcService),xe(1,i.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(D,E,P){}})}),define(Ie[233],Te([1,0,3,5,7,26]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,L,T={}){const S=A.ExtensionIdentifier.toKey(E.identifier),I=this._inFlightRequests.get(S)||[],_=[...L].sort().join(" ");let g=I.find(v=>v.providerId===P&&v.scopes===_);if(g)return g.result;{const v=this._getSession(E,S,P,L,T);g={providerId:P,scopes:_,result:v},I.push(g),this._inFlightRequests.set(S,I);try{await v}finally{const p=I.findIndex(b=>b.providerId===P&&b.scopes===_);p>-1&&(I.splice(p),this._inFlightRequests.set(S,I))}return v}}async _getSession(E,P,L,T,S={}){await this._proxy.$ensureProvider(L);const I=E.displayName||E.name;return this._proxy.$getSession(L,T,P,I,S)}async removeSession(E,P){const L=this._authenticationProviders.get(E);return L?L.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,L,T){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:L,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===E)||this._providers.push({id:E,label:P});const S=L.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(E,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,T?.supportsMultipleAccounts??!1),new y.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(E);const I=this._providers.findIndex(_=>_.id===E);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const L=this._authenticationProviders.get(E);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const L=this._authenticationProviders.get(E);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const L=this._authenticationProviders.get(E);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[234],Te([1,0,5,18,15]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,E){this._proxy=D.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>E.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(D){const E=y.WorkspaceEdit.from(D,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(E)}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Ie[235],Te([1,0,5]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(A){const C=A.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(D){return C.$writeText(D)}})}}e.ExtHostClipboard=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[37],Te([1,0,12,7,15,24,5,16,14,62,36,50,2,6,4,18,132,23,54,51]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(c,l){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),et(this,a,c.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=l,et(this,m,c.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new h(this,d=>{const w=this._apiCommands.get(d);return w?.result===s.Void?w:void 0},l),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,A.cloneAndChange)(d,function(w){if(L.Range.isIRange(w))return y.Range.to(w);if(T.Position.isIPosition(w))return y.Position.to(w);if(L.Range.isIRange(w.range)&&S.URI.isUri(w.uri))return y.location.to(w);if(w instanceof p.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const l=this.registerCommand(!1,c.id,async(...d)=>{const w=c.args.map((F,O)=>{if(!F.validate(d[O]))throw new Error(`Invalid argument '${F.name}' when running '${c.id}', received: ${d[O]}`);return F.convert(d[O])}),R=await this.executeCommand(c.internalId,...w);return c.result.convert(R,d,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new i.Disposable(()=>{l.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,l,d,w,R,F){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:d,thisArg:w,description:R,extension:F}),c&&Ue(this,a,"f").$registerCommand(l),new i.Disposable(()=>{this._commands.delete(l)&&c&&Ue(this,a,"f").$unregisterCommand(l)})}executeCommand(c,...l){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,l,!0)}async _doExecuteCommand(c,l,d){if(this._commands.has(c))return this._executeContributedCommand(c,l,!1);{let w=!1;const R=(0,A.cloneAndChange)(l,function(F){if(F instanceof i.Position)return y.Position.from(F);if(F instanceof i.Range)return y.Range.from(F);if(F instanceof i.Location)return y.location.from(F);if(i.NotebookRange.isNotebookRange(F))return y.NotebookRange.from(F);if(F instanceof ArrayBuffer)return w=!0,p.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return w=!0,p.VSBuffer.wrap(F);if(F instanceof p.VSBuffer)return w=!0,F;if(!Array.isArray(F))return F});try{const F=await Ue(this,a,"f").$executeCommand(c,w?new b.SerializableObjectWithBuffers(R):R,d);return(0,P.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(c,l,!1);throw F}}}async _executeContributedCommand(c,l,d){const w=this._commands.get(c);if(!w)throw new Error("Unknown command");this._reportTelemetry(w,c);let{callback:R,thisArg:F,description:O}=w;if(O)for(let k=0;k<O.args.length;k++)try{(0,u.validateConstraint)(l[k],O.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${O.args[k].name}' - ${O.args[k].description}`)}try{return await R.apply(F,l)}catch(k){if(c===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(c=B.command)}throw this._logService.error(k,c,w.extension?.identifier),d?new class extends Error{constructor(){super((0,f.toErrorMessage)(k));this.id=c,this.source=w.extension?.displayName??w.extension?.name}}:k}}_reportTelemetry(c,l){!c.extension||c.extension.isBuiltin||Ue(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:l})}$executeContributedCommand(c,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(l=l.map(d=>this._argumentProcessors.reduce((w,R)=>R.processArgument(w),d)),this._executeContributedCommand(c,l,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ue(this,a,"f").$getCommands().then(l=>(c&&(l=l.filter(d=>d[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[l,d]of this._commands){let{description:w}=d;w&&(c[l]=w)}return Promise.resolve(c)}};a=new WeakMap,m=new WeakMap,o=je([xe(0,g.IExtHostRpcService),xe(1,E.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class h{constructor(c,l,d){this._commands=c,this._lookupApiCommand=l,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,l){if(!c)return;const d={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return d;const w=this._lookupApiCommand(c.command);if(w)d.id=w.internalId,d.arguments=w.args.map((R,F)=>R.convert(c.arguments&&c.arguments[F]));else if((0,D.isNonEmptyArray)(c.arguments)){const R=++this._cachIdPool;this._cache.set(R,c),l.add((0,I.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this._logService.trace("CommandsConverter#CREATE",c.command,R)}return d}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const l=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class r{constructor(c,l,d,w){this.name=c,this.description=l,this.validate=d,this.convert=w}optional(){return new r(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,l){return new r(c??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>S.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>i.Position.isPosition(t),y.Position.from),r.Range=new r("range","A range in a text document",t=>i.Range.isRange(t),y.Range.from),r.Selection=new r("selection","A selection in a text document",t=>i.Selection.isSelection(t),y.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,y.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,y.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,y.TestItem.from);class s{constructor(c,l){this.description=c,this.convert=l}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(c,l,d,w,R){this.id=c,this.internalId=l,this.description=d,this.args=w,this.result=R}}e.ApiCommand=n}),define(Ie[236],Te([1,0,2,15,7,65,37,16,112,117,10]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(i.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(g,v)=>{if((0,D.isFalsyOrEmpty)(g))return;class p extends y.SymbolInformation{static to(f){const a=new p(f.name,i.SymbolKind.to(f.kind),f.containerName||"",new y.Location(v[0],i.Range.to(f.range)));return a.detail=f.detail,a.range=a.location.range,a.selectionRange=i.Range.to(f.selectionRange),a.children=f.children?f.children.map(p.to):[],a}}return g.map(p.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",g=>typeof g=="string",g=>g),new C.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(i.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(i.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(i.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",g=>Array.isArray(g)&&g.every(v=>y.Position.isPosition(v)),g=>g.map(i.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",g=>g.map(v=>{let p;for(const b of v.reverse())p=new y.SelectionRange(i.Range.to(b),p);return p}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",g=>g.map(i.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(i.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(i.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(i.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",g=>{if(!!g)return{range:i.Range.to(g.range),placeholder:g.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",g=>{if(!!g){if(g.rejectReason)throw new Error(g.rejectReason);return i.WorkspaceEdit.to(g)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",g=>g.map(i.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new y.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const v=(0,E.decodeSemanticTokensDto)(g);if(v.type==="full")return new y.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new y.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const v=(0,E.decodeSemanticTokensDto)(g);if(v.type==="full")return new y.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(g,v,p)=>{if(!g)return new y.CompletionList([]);const b=g.suggestions.map(f=>i.CompletionItem.to(f,p));return new y.CompletionList(b,g.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",g=>{if(g)return i.SignatureHelp.to(g)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(g,v,p)=>I(b=>new y.CodeLens(i.Range.to(b.range),b.command&&p.fromInternal(b.command)))(g))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",g=>y.Range.isRange(g),g=>y.Selection.isSelection(g)?i.Selection.from(g):i.Range.from(g)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(g,v,p)=>I(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(b.command)}else{const f=new y.CodeAction(b.title,b.kind?new y.CodeActionKind(b.kind):void 0);return b.edit&&(f.edit=i.WorkspaceEdit.to(b.edit)),b.command&&(f.command=p.fromInternal(b.command)),f.isPreferred=b.isPreferred,f}})(g))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",g=>g?g.map(v=>new y.ColorInformation(i.Range.to(v.range),i.Color.to(v.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",g=>g instanceof y.Color,i.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",g=>!0,g=>({uri:g.uri,range:i.Range.from(g.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",g=>g?g.map(i.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(g,v,p)=>g.map(i.InlayHint.to.bind(void 0,p)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(g=>({viewType:g.viewType,displayName:g.displayName,options:{transientOutputs:g.options.transientOutputs,transientCellMetadata:g.options.transientCellMetadata,transientDocumentMetadata:g.options.transientDocumentMetadata},filenamePattern:g.filenamePattern.map(v=>i.NotebookExclusiveDocumentPattern.to(v))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",g=>g.map(i.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",g=>u.URI.isUri(g)||typeof g=="string"&&(0,P.matchesSomeScheme)(g,L.Schemas.http,L.Schemas.https),g=>g),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[i.ViewColumn.from(g),void 0]:[i.ViewColumn.from(g.viewColumn),i.TextEditorOpenOptions.from(g)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[i.ViewColumn.from(g),void 0]:[i.ViewColumn.from(g.viewColumn),i.TextEditorOpenOptions.from(g)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="object",g=>g&&[i.ViewColumn.from(g.viewColumn),i.TextEditorOpenOptions.from(g)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class S{static register(v){T.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=S;function I(g){return v=>{if(Array.isArray(v))return v.map(g)}}function _(g){if(!Array.isArray(g))return;const v=[];for(const p of g)A.isLocationLink(p)?v.push(i.DefinitionLink.to(p)):v.push(i.location.to(p));return v}}),define(Ie[237],Te([1,0,17,58,3,6,2,65,26,15,7,28,5]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(_,g,v){const p=_.getProxy(S.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.commentThreadHandle);return l?l.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let d=t.commentUniqueId,w=l.getCommentByUniqueId(d);return w||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let d=t.text,w=t.commentUniqueId,R=l.getCommentByUniqueId(w);return R?(R.body=d,R):t}return t}})}createCommentController(t,c,l){const d=b.handlePool++,w=new a(t,d,c,l);this._commentControllers.set(w.handle,w);const R=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(w),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),R),w.value}$createCommentThreadTemplate(t,c,l){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(c,l)}async $updateCommentThreadTemplate(t,c,l){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(c,l)}$deleteCommentThread(t,c){const l=this._commentControllers.get(t);l&&l.$deleteCommentThread(c)}$provideCommentingRanges(t,c,l){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(C.URI.revive(c));return(0,u.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(w,l)).then(R=>R?R.map(F=>P.Range.from(F)):void 0)}$toggleReaction(t,c,l,d,w){const R=this._commentControllers.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const F=R.getCommentThread(c);if(F){const O=F.getCommentByUniqueId(d.uniqueIdInThread);if(R!==void 0&&O&&R.reactionHandler)return R.reactionHandler(O,h(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class f{constructor(t,c,l,d,w,R,F,O){this._commentControllerHandle=c,this._id=l,this._uri=d,this._range=w,this._comments=R,this.extensionDescription=F,this._isTemplate=O,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),p.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),F.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(c,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(B){k.range=B},get comments(){return k.comments},set comments(B){k.comments=B},get collapsibleState(){return k.collapsibleState},set collapsibleState(B){k.collapsibleState=B},get canReply(){return k.canReply},set canReply(B){k.canReply=B},get contextValue(){return k.contextValue},set contextValue(B){k.contextValue=B},get label(){return k.label},set label(B){k.label=B},get state(){return k.state},set state(B){k.state=B},dispose:()=>{k.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),c={};t("range")&&(c.range=P.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(l=>m(this,l,this._commentsMap))),t("collapsibleState")&&(c.collapseState=r(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=s(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(let c of this._commentsMap){let l=c[0],d=c[1];if(t===d)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}f._handlePool=0,je([(0,i.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,c,l,d){this._extension=t,this._handle=c,this._id=l,this._label=d,this._threads=new Map,p.$registerCommentController(this.handle,l,d);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(R){w.options=R},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(R){w.commentingRangeProvider=R},get reactionHandler(){return w.reactionHandler},set reactionHandler(R){w.reactionHandler=R},createCommentThread(R,F,O){return w.createCommentThread(R,F,O).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,l,d){if(typeof t=="string"){const w=new f(this.id,this.handle,t,c,l,d,this._extension,!1);return this._threads.set(w.handle,w),w}else{const w=new f(this.id,this.handle,void 0,t,c,l,this._extension,!1);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(t,c){const l=new f(this.id,this.handle,void 0,C.URI.revive(t),P.Range.to(c),[],this._extension,!0);return l.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,c){let l=this._threads.get(t);l&&(l.range=P.Range.to(c))}$deleteCommentThread(t){let c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function m(n,t,c){let l=c.get(t);l||(l=++n.commentHandle,c.set(t,l));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(w=>o(w)):void 0,timestamp:t.timestamp?.toJSON()}}function o(n){return{label:n.label,iconPath:n.iconPath?P.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function h(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?C.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function r(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case L.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new b}e.createExtHostComments=I}),define(Ie[135],Te([1,0,2,5,7,4,18,14,16,8,9]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class Si{constructor(I,_){this._logService=_,this._provider=new Map,this._proxy=I.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,_){const g=Si._handlePool++;this._provider.set(g,{provider:I,extensionId:_}),this._proxy.$registerDecorationProvider(g,_.value);const v=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(g,null);return}let b=(0,E.asArray)(p);if(b.length<=Si._maxEventSize){this._proxy.$onDidChange(g,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",_.value,b.length);const f=b.map(o=>({uri:o,rank:(0,P.count)(o.path,"/")})),a=(0,E.groupBy)(f,(o,h)=>o.rank-h.rank||(0,P.compare)(o.uri.path,h.uri.path));let m=[];e:for(let o of a){let h;for(let r of o){let s=(0,L.dirname)(r.uri.path);if(h!==s&&(h=s,m.push(r.uri)>=Si._maxEventSize))break e}}this._proxy.$onDidChange(g,m)});return new y.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(I,_,g){if(!this._provider.has(I))return Object.create(null);const v=Object.create(null),{provider:p,extensionId:b}=this._provider.get(I);return await Promise.all(_.map(async f=>{try{const{uri:a,id:m}=f,o=await Promise.resolve(p.provideFileDecoration(u.URI.revive(a),g));if(!o)return;try{y.FileDecoration.validate(o),v[m]=[o.propagate,o.tooltip,o.badge,o.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${b.value}': ${h}`)}}catch(a){this._logService.error(a)}})),v}};T._handlePool=0,T._maxEventSize=250,T=je([xe(0,C.IExtHostRpcService),xe(1,D.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[238],Te([1,0,170,116,2,5,7,15,3,14,25,46]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";var S,I,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(b,f,a,m,o,h){this._name=b,this._owner=f,this._maxDiagnosticsPerFile=a,S.set(this,void 0),I.set(this,void 0),_.set(this,void 0),this._isDisposed=!1,et(this,_,new L.ResourceMap(r=>m.getComparisonKey(r)),"f"),et(this,S,o,"f"),et(this,I,h,"f")}dispose(){this._isDisposed||(Ue(this,I,"f").fire([...Ue(this,_,"f").keys()]),Ue(this,S,"f")&&Ue(this,S,"f").$clear(this._owner),Ue(this,_,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,f){if(!b){this.clear();return}this._checkDisposed();let a=[];if(y.URI.isUri(b)){if(!f){this.delete(b);return}Ue(this,_,"f").set(b,f.slice()),a=[b]}else if(Array.isArray(b)){a=[];let o;b=[...b].sort(g._compareIndexedTuplesByUri);for(const h of b){const[r,s]=h;if((!o||r.toString()!==o.toString())&&(o&&Ue(this,_,"f").get(o).length===0&&Ue(this,_,"f").delete(o),o=r,a.push(r),Ue(this,_,"f").set(r,[])),s){const n=Ue(this,_,"f").get(r);n&&n.push(...s)}else{const n=Ue(this,_,"f").get(r);n&&(n.length=0)}}}if(Ue(this,I,"f").fire(a),!Ue(this,S,"f"))return;const m=[];for(let o of a){let h=[];const r=Ue(this,_,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const s=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of r)if(t.severity===s[n]&&h.push(D.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;h.push({severity:i.MarkerSeverity.Info,message:(0,u.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(s=>D.Diagnostic.from(s));m.push([o,h])}Ue(this,S,"f").$changeMany(this._owner,m)}delete(b){this._checkDisposed(),Ue(this,I,"f").fire([b]),Ue(this,_,"f").delete(b),Ue(this,S,"f")&&Ue(this,S,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ue(this,I,"f").fire([...Ue(this,_,"f").keys()]),Ue(this,_,"f").clear(),Ue(this,S,"f")&&Ue(this,S,"f").$clear(this._owner)}forEach(b,f){this._checkDisposed();for(let a of Ue(this,_,"f").keys())b.apply(f,[a,this.get(a),this])}get(b){this._checkDisposed();const f=Ue(this,_,"f").get(b);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ue(this,_,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,f){return b[0].toString()<f[0].toString()?-1:b[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=g,S=new WeakMap,I=new WeakMap,_=new WeakMap;let v=class li{constructor(b,f,a){this._logService=f,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=b.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(b){const f=new L.ResourceMap;for(const a of b)f.set(a,a);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(b,f){const{_collections:a,_proxy:m,_onDidChangeDiagnostics:o,_logService:h,_fileSystemInfoService:r}=this,s=new class{$changeMany(c,l){m.$changeMany(c,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,c,l.length===0?"CLEARING":l)}$clear(c){m.$clear(c),h.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,c)}dispose(){m.dispose()}};let n;if(!f)f="_generated_diagnostic_collection_name_#"+li._idPool++,n=f;else if(!a.has(f))n=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do n=f+li._idPool++;while(a.has(n))}return new class extends g{constructor(){super(f,n,li._maxDiagnosticsPerFile,r.extUri,s,o);a.set(n,this)}dispose(){super.dispose(),a.delete(n)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const f=new Map,a=[];for(const m of this._collections.values())m.forEach((o,h)=>{let r=f.get(o.toString());typeof r=="undefined"&&(r=a.length,f.set(o.toString(),r),a.push([o,[]])),a[r][1]=a[r][1].concat(...h)});return a}}_getDiagnostics(b){let f=[];for(let a of this._collections.values())a.has(b)&&(f=f.concat(a.get(b)));return f}$acceptMarkersChange(b){if(!this._mirrorCollection){const f="_generated_mirror",a=new g(f,f,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,a),this._mirrorCollection=a}for(const[f,a]of b)this._mirrorCollection.set(y.URI.revive(f),a.map(D.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([xe(1,P.ILogService),xe(2,T.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(Ie[239],Te([1,0,2,5]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this._proxy=C.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(D=>D?D.map(E=>u.URI.revive(E)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(D=>D?u.URI.revive(D):void 0)}}e.ExtHostDialogs=y}),define(Ie[240],Te([1,0,11,2,7,5,10,21,8]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(T,S,I){this._documentsAndEditors=S,this._logService=I,this._documentContentProviders=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,S){if(Object.keys(C.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const I=P._handlePool++;this._documentContentProviders.set(I,S),this._proxy.$registerTextContentProvider(I,T);let _;return typeof S.onDidChange=="function"&&(_=S.onDidChange(g=>{if(g.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(I,g).then(v=>{if(!v&&typeof v!="string")return;const p=this._documentsAndEditors.getDocument(g);if(!p)return;const b=(0,E.splitLines)(v);if(!p.equalLines(b))return this._proxy.$onVirtualDocumentChange(g,v)},u.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(T,S){const I=this._documentContentProviders.get(T);return I?Promise.resolve(I.provideTextDocumentContent(i.URI.revive(S),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ie[241],Te([1,0,3,6,2,5,125,15,12,24,7]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(I,_){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=_,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const v of g)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const v of g)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const _=this._documentsAndEditors.getDocument(I);if(_)return _}getDocument(I){const _=this.getDocumentData(I);if(!_?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return _.document}ensureDocumentData(I){const _=this._documentsAndEditors.getDocument(I);if(_)return Promise.resolve(_);let g=this._documentLoader.get(I.toString());return g||(g=this._proxy.$tryOpenDocument(I).then(v=>{this._documentLoader.delete(I.toString());const p=y.URI.revive(v);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(p))},v=>(this._documentLoader.delete(I.toString()),Promise.reject(v))),this._documentLoader.set(I.toString(),g)),g}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(_=>y.URI.revive(_))}$acceptModelLanguageChanged(I,_){const g=y.URI.revive(I),v=this._documentsAndEditors.getDocument(g);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(_),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(I){const _=y.URI.revive(I),g=this._documentsAndEditors.getDocument(_);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(I,_){const g=y.URI.revive(I),v=this._documentsAndEditors.getDocument(g);if(!v)throw new Error("unknown document");v._acceptIsDirty(_),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,_,g){const v=y.URI.revive(I),p=this._documentsAndEditors.getDocument(v);if(!p)throw new Error("unknown document");p._acceptIsDirty(g),p.onEvents(_);let b;_.isUndoing?b=L.TextDocumentChangeReason.Undo:_.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:p.document,contentChanges:_.changes.map(f=>({range:D.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:b}))}setWordDefinitionFor(I,_){(0,C.setWordDefinitionFor)(I,_)}}e.ExtHostDocuments=T}),define(Ie[55],Te([1,0,57,3,6,2,4,5,125,18,133,15,14,25,10,60,80]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(a,m){this._extHostRpc=a,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const m=[],o=[],h=[];if(a.removedDocuments)for(const r of a.removedDocuments){const s=A.URI.revive(r),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),m.push(n.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const s=A.URI.revive(r.uri);let n=this._documents.get(s);if(n&&s.scheme!==_.Schemas.vscodeNotebookCell&&s.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new p(new E.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,n),o.push(n.value)),n.ref()}if(a.removedEditors)for(const r of a.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&h.push(s)}if(a.addedEditors)for(const r of a.addedEditors){const s=A.URI.revive(r.documentUri);u.ok(this._documents.has(s),`document '${s}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(s).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>n.document),r.selections.map(T.Selection.to),r.options,r.visibleRanges.map(c=>T.Range.to(c)),typeof r.editorPosition=="number"?T.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}a.newActiveEditor!==void 0&&(u.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,y.dispose)(m),(0,y.dispose)(h),a.removedDocuments&&this._onDidRemoveDocuments.fire(m),a.addedDocuments&&this._onDidAddDocuments.fire(o),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return a?m:m?.value}allEditors(){return[...this._editors.values()]}};b=je([xe(0,P.IExtHostRpcService),xe(1,S.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[56],Te([1,0,15,5,2,3,4,7,18,12,48]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(v,p,b){this._activeTabIdGetter=b,this._parentGroup=p,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,p={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(p)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(y.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified));case 5:return new D.CustomEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new D.NotebookEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new D.NotebookDiffEditorTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new D.TerminalEditorTabInput;default:return}}}class S{constructor(v,p,b){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=b;for(const f of v.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new T(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,p={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(b=>b.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(b=>b.apiObject))}};this._apiObject=Object.freeze(p)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const b=new T(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,b),v.tabDto.isActive&&(this._activeTabId=b.tabId),b}else if(v.kind===1){const b=this._tabs.splice(v.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return b.tabId===this._activeTabId&&(this._activeTabId=""),b}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this._tabs.splice(v.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,b),b}const p=this._tabs.find(b=>b.tabId===v.tabDto.id);if(!p)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),p.acceptDtoUpdate(v.tabDto),p}activeTabId(){return this._activeTabId}}let I=class{constructor(v){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(i.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,p={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(b=>b.apiObject))},get activeTabGroup(){const b=v._activeGroupId;return(0,P.assertIsDefined)(v._extHostTabGroups.find(a=>a.groupId===b)?.apiObject)},close:async(b,f)=>{const a=Array.isArray(b)?b:[b];return a.length?_(a[0])?this._closeGroups(a,f):this._closeTabs(a,f):!0}};this._apiObject=Object.freeze(p)}return this._apiObject}$acceptEditorTabModel(v){const p=new Set(this._extHostTabGroups.map(r=>r.groupId)),b=new Set(v.map(r=>r.groupId)),f=(0,L.diffSets)(p,b),a=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),m=[],o=[];this._extHostTabGroups=v.map(r=>{const s=new S(r,this._proxy,()=>this._activeGroupId);return f.added.includes(s.groupId)?m.push(s.apiObject):o.push(s.apiObject),s});const h=(0,P.assertIsDefined)(v.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:a,changed:o}))}$acceptTabGroupUpdate(v){const p=this._extHostTabGroups.find(b=>b.groupId===v.groupId);if(!p)throw new Error("Update Group IPC call received before group creation.");p.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[p.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const p=this._extHostTabGroups.find(f=>f.groupId===v.groupId);if(!p)throw new Error("Update Tabs IPC call received before group creation.");const b=p.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}_findExtHostTabFromApi(v){for(const p of this._extHostTabGroups)for(const b of p.tabs)if(b.apiObject===v)return b}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(p=>p.apiObject===v)}async _closeTabs(v,p){const b=[];for(const f of v){const a=this._findExtHostTabFromApi(f);if(!a)throw new Error("Tab close: Invalid tab not found!");b.push(a.tabId)}return this._proxy.$closeTab(b,p)}async _closeGroups(v,p){const b=[];for(const f of v){const a=this._findExtHostTabGroupFromApi(f);if(!a)throw new Error("Group close: Invalid group not found!");b.push(a.groupId)}return this._proxy.$closeGroup(b,p)}};I=je([xe(0,E.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function _(g){return g.tabs!==void 0}}),define(Ie[242],Te([1,0,2,5,6,7,15,153,8,23,28]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(_){this._stateMachine=void 0,this._schemes.push(_)}delete(_){const g=this._schemes.indexOf(_);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const _=this._schemes.sort(),g=[];let v,p,b=14,f=14;for(const a of _){let m=v?(0,E.commonPrefixLength)(v,a):0;for(m===0?p=1:p=f;m<a.length;m++)m+1===a.length?(b=f,f=9):f+=1,g.push([p,a.toUpperCase().charCodeAt(m),f]),g.push([p,a.toLowerCase().charCodeAt(m),f]),p=f;v=a,f=b}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new D.StateMachine(g)}}provideDocumentLinks(_){this._initStateMachine();const g=[],v=D.LinkComputer.computeLinks({getLineContent(p){return _.lineAt(p-1).text},getLineCount(){return _.lineCount}},this._stateMachine);for(const p of v){const b=C.DocumentLink.to(p);b.target&&g.push(b)}return g}}class S{constructor(_,g){this._extHostLanguageFeatures=g,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=_.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(_,g,v,p={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(_,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(b,v);let f=2;p.isCaseSensitive&&(f+=1024),p.isReadonly&&(f+=2048),typeof v.copy=="function"&&(f+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(_,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(b,g,f).catch(m=>{console.error(`FAILED to register filesystem provider of ${_.identifier.value}-extension for the scheme ${g}`),console.error(m)});const a=v.onDidChangeFile(m=>{const o=[];for(const h of m){let{uri:r,type:s}=h;if(r.scheme!==g)continue;let n;switch(s){case A.FileChangeType.Changed:n=0;break;case A.FileChangeType.Created:n=1;break;case A.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(b,o)});return(0,y.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(_){const{type:g,ctime:v,mtime:p,size:b,permissions:f}=_;return{type:g,ctime:v,mtime:p,size:b,permissions:f}}$stat(_,g){return Promise.resolve(this._getFsProvider(_).stat(u.URI.revive(g))).then(v=>S._asIStat(v))}$readdir(_,g){return Promise.resolve(this._getFsProvider(_).readDirectory(u.URI.revive(g)))}$readFile(_,g){return Promise.resolve(this._getFsProvider(_).readFile(u.URI.revive(g))).then(v=>P.VSBuffer.wrap(v))}$writeFile(_,g,v,p){return Promise.resolve(this._getFsProvider(_).writeFile(u.URI.revive(g),v.buffer,p))}$delete(_,g,v){return Promise.resolve(this._getFsProvider(_).delete(u.URI.revive(g),v))}$rename(_,g,v,p){return Promise.resolve(this._getFsProvider(_).rename(u.URI.revive(g),u.URI.revive(v),p))}$copy(_,g,v,p){const b=this._getFsProvider(_);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(u.URI.revive(g),u.URI.revive(v),p))}$mkdir(_,g){return Promise.resolve(this._getFsProvider(_).createDirectory(u.URI.revive(g)))}$watch(_,g,v,p){const b=this._getFsProvider(_).watch(u.URI.revive(v),p);this._watches.set(g,b)}$unwatch(_,g){const v=this._watches.get(g);v&&(v.dispose(),this._watches.delete(g))}$open(_,g,v){const p=this._getFsProvider(_);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(u.URI.revive(g),v))}$close(_,g){const v=this._getFsProvider(_);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(g))}$read(_,g,v,p){const b=this._getFsProvider(_);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const f=P.VSBuffer.alloc(p);return Promise.resolve(b.read(g,v,f.buffer,0,p)).then(a=>f.slice(0,a))}$write(_,g,v,p){const b=this._getFsProvider(_);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(g,v,p.buffer,0,p.byteLength))}_getFsProvider(_){const g=this._fsProvider.get(_);if(!g){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return g}}e.ExtHostFileSystem=S}),define(Ie[70],Te([1,0,5,43,7,23,4,18,46,6]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Kt{constructor(S,I){this._fileSystemProvider=new Map,this._proxy=S.getProxy(u.MainContext.MainThreadFileSystem);const _=this;this.value=Object.freeze({async stat(g){try{const v=_._fileSystemProvider.get(g.scheme);if(!v)return await _._proxy.$stat(g);await _._proxy.$ensureActivation(g.scheme);const p=await v.stat(g);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions}}catch(v){Kt._handleError(v)}},async readDirectory(g){try{const v=_._fileSystemProvider.get(g.scheme);return v?(await _._proxy.$ensureActivation(g.scheme),(await v.readDirectory(g)).slice()):await _._proxy.$readdir(g)}catch(v){return Kt._handleError(v)}},async createDirectory(g){try{return await _._proxy.$mkdir(g)}catch(v){return Kt._handleError(v)}},async readFile(g){try{const v=_._fileSystemProvider.get(g.scheme);return v?(await _._proxy.$ensureActivation(g.scheme),(await v.readFile(g)).slice()):(await _._proxy.$readFile(g)).buffer}catch(v){return Kt._handleError(v)}},async writeFile(g,v){try{return await _._proxy.$writeFile(g,A.VSBuffer.wrap(v))}catch(p){return Kt._handleError(p)}},async delete(g,v){try{const p=_._fileSystemProvider.get(g.scheme);return p?(await _._proxy.$ensureActivation(g.scheme),await p.delete(g,{recursive:!1,...v})):await _._proxy.$delete(g,{recursive:!1,useTrash:!1,...v})}catch(p){return Kt._handleError(p)}},async rename(g,v,p){try{return await _._proxy.$rename(g,v,{overwrite:!1,...p})}catch(b){return Kt._handleError(b)}},async copy(g,v,p){try{return await _._proxy.$copy(g,v,{overwrite:!1,...p})}catch(b){return Kt._handleError(b)}},isWritableFileSystem(g){const v=I.getCapabilities(g);if(typeof v=="number")return!(v&2048)}})}static _handleError(S){if(S instanceof y.FileSystemError)throw S;if(!(S instanceof Error))throw new y.FileSystemError(String(S));if(S.name==="ENOPRO")throw y.FileSystemError.Unavailable(S.message);switch(S.name){case i.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(S.message);case i.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(S.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(S.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(S.message);case i.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(S.message);case i.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(S.message);default:throw new y.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,I){return this._fileSystemProvider.set(S,I),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(S))}};L=je([xe(0,D.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[243],Te([1,0,3,34,2,5,15,7]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(T,S,I,_,g,v,p,b){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const f=this.ensureWatching(T,I,g);this._config=0,v&&(this._config+=1),p&&(this._config+=2),b&&(this._config+=4);const a=(0,i.parse)(g),m=typeof g=="string",o=_(h=>{if(!v)for(let r of h.created){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!p)for(let r of h.changed){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!b)for(let r of h.deleted){const s=y.URI.revive(r);a(s.fsPath)&&(!m||S.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=D.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(T,S,I){let _=D.Disposable.from();if(typeof I=="string")return _;const g=T.getProxy(A.MainContext.MainThreadFileSystem);let v=!1;(I.pattern.includes(i.GLOBSTAR)||I.pattern.includes(i.GLOB_SPLIT))&&(v=!0);const p=Math.random();return g.$watch(S.identifier.value,p,I.baseUri,{recursive:v,excludes:[]}),D.Disposable.from({dispose:()=>g.$unwatch(p)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(T,S,I){this._mainContext=T,this._logService=S,this._extHostDocumentsAndEditors=I,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(T,S,I,_,g,v){return new E(this._mainContext,T,S,this._onFileSystemEvent.event,C.GlobPattern.from(I),_,g,v)}$onFileEvent(T){this._onFileSystemEvent.fire(T)}$onDidRunFileOperation(T,S){switch(T){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(I=>({oldUri:y.URI.revive(I.source),newUri:y.URI.revive(I.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(I=>y.URI.revive(I.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:S.map(I=>y.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(T){return this._createWillExecuteEvent(T,this._onWillRenameFile)}getOnWillCreateFileEvent(T){return this._createWillExecuteEvent(T,this._onWillCreateFile)}getOnWillDeleteFileEvent(T){return this._createWillExecuteEvent(T,this._onWillDeleteFile)}_createWillExecuteEvent(T,S){return(I,_,g)=>{const v=function(b){I.call(_,b)};return v.extension=T,S.event(v,void 0,g)}}async $onWillRunFileOperation(T,S,I,_){switch(T){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(g=>({oldUri:y.URI.revive(g.source),newUri:y.URI.revive(g.target)}))},I,_);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(g=>y.URI.revive(g.target))},I,_);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(g=>y.URI.revive(g.target))},I,_)}}async _fireWillEvent(T,S,I,_){const g=new Set,v=[];if(await T.fireAsync(S,_,async(b,f)=>{const a=Date.now(),m=await Promise.resolve(b);m instanceof D.WorkspaceEdit&&(v.push(m),g.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-a>I&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),_.isCancellationRequested||v.length===0)return;const p={edits:[]};for(let b of v){let{edits:f}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});p.edits=p.edits.concat(f)}return{edit:p,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=P}),define(Ie[244],Te([1,0,2,37]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,D,E,P){this._extHostNotebooks=D,this._textDocumentsAndEditors=E,this._commands=P;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new i.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new i.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new i.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new i.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:u.URI.revive(T.notebookUri),inputUri:u.URI.revive(T.inputUri),notebookEditor:S.apiEditor}}return{notebookUri:u.URI.revive(T.notebookUri),inputUri:u.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(C,D,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:E,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ie[245],Te([1,0,6,5]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this._handlePool=0,this._proxy=C.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,C),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=y}),define(Ie[246],Te([1,0,2,24,15,7,65,5,8,36,16,12,148,21,6,112,79,88,49,11,17,28]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentSymbols(U,$){const G=this._documents.getDocument(U),K=await this._provider.provideDocumentSymbols(G,$);if(!(0,L.isFalsyOrEmpty)(K))return K[0]instanceof A.DocumentSymbol?K.map(y.DocumentSymbol.from):o._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((K,he)=>{let we=K.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(K.location.range.end)),we});const $=[],G=[];for(const K of U){const he={name:K.name||"!!MISSING: name!!",kind:y.SymbolKind.from(K.kind),tags:K.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:y.Range.from(K.location.range),selectionRange:y.Range.from(K.location.range),children:[]};for(;;){if(G.length===0){G.push(he),$.push(he);break}const we=G[G.length-1];if(P.Range.containsRange(we.range,he.range)&&!P.Range.equalsRange(we.range,he.range)){we.children&&we.children.push(he),G.push(he);break}G.pop()}}return $}}class h{constructor(U,$,G){this._documents=U,this._commands=$,this._provider=G,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,$){const G=this._documents.getDocument(U),K=await this._provider.provideCodeLenses(G,$);if(!K||$.isCancellationRequested)return;const he=this._cache.add(K),we=new _.DisposableStore;this._disposables.set(he,we);const se={cacheId:he,lenses:[]};for(let De=0;De<K.length;De++)se.lenses.push({cacheId:[he,De],range:y.Range.from(K[De].range),command:this._commands.toInternal(K[De].command,we)});return se}async resolveCodeLens(U,$){const G=U.cacheId&&this._cache.get(...U.cacheId);if(!G)return;let K;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?K=G:K=await this._provider.resolveCodeLens(G,$),K||(K=G),$.isCancellationRequested)return;const he=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!he)return U.command=this._commands.toInternal(K.command??h._badCmd,he),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ne){return Array.isArray(ne)?ne.map(y.DefinitionLink.from):ne?[y.DefinitionLink.from(ne)]:[]}class s{constructor(U,$){this._documents=U,this._provider=$}async provideDefinition(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideDefinition(K,he,G);return r(we)}}class n{constructor(U,$){this._documents=U,this._provider=$}async provideDeclaration(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideDeclaration(K,he,G);return r(we)}}class t{constructor(U,$){this._documents=U,this._provider=$}async provideImplementation(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideImplementation(K,he,G);return r(we)}}class c{constructor(U,$){this._documents=U,this._provider=$}async provideTypeDefinition(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideTypeDefinition(K,he,G);return r(we)}}class l{constructor(U,$){this._documents=U,this._provider=$}async provideHover(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideHover(K,he,G);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=K.getWordRangeAtPosition(he)),we.range||(we.range=new A.Range(he,he)),y.Hover.from(we)}}class d{constructor(U,$){this._documents=U,this._provider=$}async provideEvaluatableExpression(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideEvaluatableExpression(K,he,G);if(we)return y.EvaluatableExpression.from(we)}}class w{constructor(U,$){this._documents=U,this._provider=$}async provideInlineValues(U,$,G,K){const he=this._documents.getDocument(U),we=await this._provider.provideInlineValues(he,y.Range.to($),y.InlineValueContext.to(G),K);if(Array.isArray(we))return we.map(se=>y.InlineValue.from(se))}}class R{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentHighlights(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideDocumentHighlights(K,he,G);if(Array.isArray(we))return we.map(y.DocumentHighlight.from)}}class F{constructor(U,$){this._documents=U,this._provider=$}async provideLinkedEditingRanges(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.provideLinkedEditingRanges(K,he,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(y.Range.from)),wordPattern:we.wordPattern}}}class O{constructor(U,$){this._documents=U,this._provider=$}async provideReferences(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($),se=await this._provider.provideReferences(he,we,G,K);if(Array.isArray(se))return se.map(y.location.from)}}class k{constructor(U,$,G,K,he,we,se){this._documents=U,this._commands=$,this._diagnostics=G,this._provider=K,this._logService=he,this._extension=we,this._apiDeprecation=se,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,$,G,K){const he=this._documents.getDocument(U),we=S.Selection.isISelection($)?y.Selection.to($):y.Range.to($),se=[];for(const Je of this._diagnostics.getDiagnostics(U))if(we.intersection(Je.range)&&se.push(Je)>k._maxCodeActionsPerFile)break;const De={diagnostics:se,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:y.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(he,we,De,K);if(!(0,L.isNonEmptyArray)(ye)||K.isCancellationRequested)return;const ze=this._cache.add(ye),Ve=new _.DisposableStore;this._disposables.set(ze,Ve);const Me=[];for(let Je=0;Je<ye.length;Je++){const J=ye[Je];!J||(k._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Me.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,Ve)})):(De.only&&(J.kind?De.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Me.push({cacheId:[ze,Je],title:J.title,command:J.command&&this._commands.toInternal(J.command,Ve),diagnostics:J.diagnostics&&J.diagnostics.map(y.Diagnostic.from),edit:J.edit&&y.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:ze,actions:Me}}async resolveCodeAction(U,$){const[G,K]=U,he=this._cache.get(G,K);if(!he||k._isCommand(he)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(he,$)??he;return we?.edit?y.WorkspaceEdit.from(we.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}k._maxCodeActionsPerFile=1e3;class B{constructor(U,$,G,K){this._proxy=U,this._documents=$,this._provider=G,this._handle=K}async prepareDocumentPaste(U,$,G,K){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(U),we=y.Range.to($),se=y.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(he,we,se,K),y.DataTransfer.toDataTransferDTO(se)}async providePasteEdits(U,$,G,K,he){const we=this._documents.getDocument($),se=y.Range.to(G),De=y.DataTransfer.toDataTransfer(K,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,U,ze)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,se,De,he);if(!!ye)return ye instanceof A.WorkspaceEdit?y.WorkspaceEdit.from(ye):y.SnippetTextEdit.from(ye)}}class M{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentFormattingEdits(U,$,G){const K=this._documents.getDocument(U),he=await this._provider.provideDocumentFormattingEdits(K,$,G);if(Array.isArray(he))return he.map(y.TextEdit.from)}}class W{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentRangeFormattingEdits(U,$,G,K){const he=this._documents.getDocument(U),we=y.Range.to($),se=await this._provider.provideDocumentRangeFormattingEdits(he,we,G,K);if(Array.isArray(se))return se.map(y.TextEdit.from)}}class ee{constructor(U,$){this._documents=U,this._provider=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,$,G,K,he){const we=this._documents.getDocument(U),se=y.Position.to($),De=await this._provider.provideOnTypeFormattingEdits(we,se,G,K,he);if(Array.isArray(De))return De.map(y.TextEdit.from)}}class H{constructor(U,$){this._provider=U,this._logService=$,this._cache=new p.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(U,$){const G=await this._provider.provideWorkspaceSymbols(U,$);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const K=this._cache.add(G),he={cacheId:K,symbols:[]};for(let we=0;we<G.length;we++){const se=G[we];if(!se||!se.name){this._logService.warn("INVALID SymbolInformation",se);continue}he.symbols.push({...y.WorkspaceSymbol.from(se),cacheId:[K,we]})}return he}async resolveWorkspaceSymbol(U,$){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this._cache.get(...U.cacheId);if(G){const K=await this._provider.resolveWorkspaceSymbol(G,$);return K&&(0,i.mixin)(U,y.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(U){this._cache.delete(U)}}class N{constructor(U,$,G){this._documents=U,this._provider=$,this._logService=G}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($);try{const se=await this._provider.provideRenameEdits(he,we,G,K);return se?y.WorkspaceEdit.from(se):void 0}catch(se){const De=N._asMessage(se);return De?{rejectReason:De,edits:void 0}:Promise.reject(se)}}async resolveRenameLocation(U,$,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(U),he=y.Position.to($);try{const we=await this._provider.prepareRename(K,he,G);let se,De;if(A.Range.isRange(we)?(se=we,De=K.getText(we)):(0,T.isObject)(we)&&(se=we.range,De=we.placeholder),!se||!De)return;if(se.start.line>he.line||se.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(se),text:De}}catch(we){const se=N._asMessage(we);return se?{rejectReason:se,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class j{constructor(U,$){this.resultId=U,this.tokens=$}}class x{constructor(U,$){this._documents=U,this._provider=$,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,$,G){const K=this._documents.getDocument(U),he=$!==0?this._previousResults.get($):null;let we=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,he.resultId,G):await this._provider.provideDocumentSemanticTokens(K,G);return he&&this._previousResults.delete($),we?(we=x._fixProvidedSemanticTokens(we),this._send(x._convertToEdits(he,we),we)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return x._isSemanticTokens(U)?x._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):x._isSemanticTokensEdits(U)?x._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map($=>new A.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const $ of U.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,$){if(!x._isSemanticTokens($)||!U||!U.tokens)return $;const G=U.tokens,K=G.length,he=$.data,we=he.length;let se=0;const De=Math.min(K,we);for(;se<De&&G[se]===he[se];)se++;if(se===K&&se===we)return new A.SemanticTokensEdits([],$.resultId);let ye=0;const ze=De-se;for(;ye<ze&&G[K-ye-1]===he[we-ye-1];)ye++;return new A.SemanticTokensEdits([{start:se,deleteCount:K-se-ye,data:he.subarray(se,we-ye)}],$.resultId)}_send(U,$){if(x._isSemanticTokens(U)){const G=this._nextResultId++;return this._previousResults.set(G,new j(U.resultId,U.data)),(0,g.encodeSemanticTokensDto)({id:G,type:"full",data:U.data})}if(x._isSemanticTokensEdits(U)){const G=this._nextResultId++;return x._isSemanticTokens($)?this._previousResults.set(G,new j($.resultId,$.data)):this._previousResults.set(G,new j(U.resultId)),(0,g.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(U.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class q{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentRangeSemanticTokens(U,$,G){const K=this._documents.getDocument(U),he=await this._provider.provideDocumentRangeSemanticTokens(K,y.Range.to($),G);return he?this._send(he):null}_send(U){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=q;class ie{constructor(U,$,G,K,he){this._documents=U,this._commands=$,this._provider=G,this._apiDeprecation=K,this._extension=he,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($),se=he.getWordRangeAtPosition(we)||new A.Range(we,we),De=se.with({end:we}),ye=new b.StopWatch(!0),ze=await this._provider.provideCompletionItems(he,we,K,y.CompletionContext.to(G));if(!ze||K.isCancellationRequested)return;const Ve=Array.isArray(ze)?new A.CompletionList(ze):ze,Me=ie.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),Je=new _.DisposableStore;this._disposables.set(Me,Je);const J=[],re={x:Me,b:J,a:{replace:y.Range.from(se),insert:y.Range.from(De)},c:Ve.isIncomplete||void 0,d:ye.elapsed()};for(let Ce=0;Ce<Ve.items.length;Ce++){const ae=Ve.items[Ce],ke=this._convertCompletionItem(ae,[Me,Ce],De,se);J.push(ke)}return re}async resolveCompletionItem(U,$){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...U);if(!G)return;const K=await this._provider.resolveCompletionItem(G,$);if(!!K)return this._convertCompletionItem(K,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,$,G,K){const he=this._disposables.get($[0]);if(!he)throw Error("DisposableStore is missing...");const we={x:$,a:U.label,b:U.kind!==void 0?y.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(y.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(U.command,he)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=U.textEdit.newText):typeof U.insertText=="string"?we.h=U.insertText:U.insertText instanceof A.SnippetString&&(we.h=U.insertText.value,we.i|=4);let se;return U.textEdit?se=U.textEdit.range:U.range&&(se=U.range),A.Range.isRange(se)?we.j=y.Range.from(se):se&&(!G?.isEqual(se.inserting)||!K?.isEqual(se.replacing))&&(we.j={insert:y.Range.from(se.inserting),replace:y.Range.from(se.replacing)}),we}}class Q{async provideInlineCompletions(U,$,G,K){}disposeCompletions(U){}handleDidShowCompletionItem(U,$){}}class de extends Q{constructor(U,$,G,K){super();this._extension=U,this._documents=$,this._provider=G,this._commands=K,this._references=new X,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($),se=await this._provider.provideInlineCompletionItems(he,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},K);if(!se||K.isCancellationRequested)return;const De=(0,T.isArray)(se)?se:se.items,ye=this._isAdditionsProposedApiEnabled?(0,T.isArray)(se)?[]:se.commands||[]:[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Me,Je)=>{let J;Me.command&&(ze||(ze=new _.DisposableStore),J=this._commands.toInternal(Me.command,ze));const re=Me.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Me.filterText,range:Me.range?y.Range.from(Me.range):void 0,command:J,idx:Je,completeBracketPairs:this._isAdditionsProposedApiEnabled?Me.completeBracketPairs:!1}}),commands:ye.map(Me=>(ze||(ze=new _.DisposableStore),this._commands.toInternal(Me,ze)))}}disposeCompletions(U){this._references.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,$){const G=this._references.get(U)?.items[$];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ue extends Q{constructor(U,$,G,K){super();this.extension=U,this._documents=$,this._provider=G,this._commands=K,this._references=new X,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKindNew.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($),se=await this._provider.provideInlineCompletionItems(he,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},K);if(!se||K.isCancellationRequested)return;const De=(0,T.isArray)(se)?se:se.items,ye=(0,T.isArray)(se)?[]:se.commands||[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Me,Je)=>{let J;Me.command&&(ze||(ze=new _.DisposableStore),J=this._commands.toInternal(Me.command,ze));const re=Me.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Me.filterText,range:Me.range?y.Range.from(Me.range):void 0,command:J,idx:Je,completeBracketPairs:this.isAdditionProposedApiEnabled?Me.completeBracketPairs:!1}}),commands:ye.map(Me=>(ze||(ze=new _.DisposableStore),this._commands.toInternal(Me,ze)))}}disposeCompletions(U){this._references.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,$){const G=this._references.get(U)?.items[$];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class X{constructor(){this._references=new Map,this._idPool=1}createReferenceId(U){const $=this._idPool++;return this._references.set($,U),$}disposeReferenceId(U){const $=this._references.get(U);return this._references.delete(U),$}get(U){return this._references.get(U)}}class ge{constructor(U,$){this._documents=U,this._provider=$,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(U,$,G,K){const he=this._documents.getDocument(U),we=y.Position.to($),se=this.reviveContext(G),De=await this._provider.provideSignatureHelp(he,we,K,se);if(De){const ye=this._cache.add([De]);return{...y.SignatureHelp.from(De),id:ye}}}reviveContext(U){let $;if(U.activeSignatureHelp){const G=y.SignatureHelp.to(U.activeSignatureHelp),K=this._cache.get(U.activeSignatureHelp.id,0);K?($=K,$.activeSignature=G.activeSignature,$.activeParameter=G.activeParameter):$=G}return{...U,activeSignatureHelp:$}}releaseSignatureHelp(U){this._cache.delete(U)}}class Se{constructor(U,$,G,K,he){this._documents=U,this._commands=$,this._provider=G,this._logService=K,this._extension=he,this._cache=new p.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(U,$,G){const K=this._documents.getDocument(U),he=y.Range.to($),we=await this._provider.provideInlayHints(K,he,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${$}`);return}if(G.isCancellationRequested)return;const se=this._cache.add(we);this._disposables.set(se,new _.DisposableStore);const De={hints:[],cacheId:se};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],he)&&De.hints.push(this._convertInlayHint(we[ye],[se,ye]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${$}`),De}async resolveInlayHint(U,$){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...U);if(!G)return;const K=await this._provider.resolveInlayHint(G,$);if(!!K&&!!this._isValidInlayHint(K))return this._convertInlayHint(K,U)}releaseHints(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_isValidInlayHint(U,$){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!($&&!$.contains(U.position))}_convertInlayHint(U,$){const G=this._disposables.get($[0]);if(!G)throw Error("DisposableStore is missing...");const K={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(U.tooltip),position:y.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(y.TextEdit.from),kind:U.kind&&y.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?K.label=U.label:K.label=U.label.map(he=>{let we={label:he.value};return we.tooltip=y.MarkdownString.fromStrict(he.tooltip),A.Location.isLocation(he.location)&&(we.location=y.location.from(he.location)),he.command&&(we.command=this._commands.toInternal(he.command,G)),we}),K}}class oe{constructor(U,$){this._documents=U,this._provider=$,this._cache=new p.Cache("DocumentLink")}async provideLinks(U,$){const G=this._documents.getDocument(U),K=await this._provider.provideDocumentLinks(G,$);if(!(!Array.isArray(K)||K.length===0)&&!$.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(oe._validateLink).map(y.DocumentLink.from)};{const he=this._cache.add(K),we={links:[],cacheId:he};for(let se=0;se<K.length;se++){if(!oe._validateLink(K[se]))continue;const De=y.DocumentLink.from(K[se]);De.cacheId=[he,se],we.links.push(De)}return we}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,$){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...U);if(!G)return;const K=await this._provider.resolveDocumentLink(G,$);if(!(!K||!oe._validateLink(K)))return y.DocumentLink.from(K)}releaseLinks(U){this._cache.delete(U)}}class _e{constructor(U,$){this._documents=U,this._provider=$}async provideColors(U,$){const G=this._documents.getDocument(U),K=await this._provider.provideDocumentColors(G,$);return Array.isArray(K)?K.map(we=>({color:y.Color.from(we.color),range:y.Range.from(we.range)})):[]}async provideColorPresentations(U,$,G){const K=this._documents.getDocument(U),he=y.Range.to($.range),we=y.Color.to($.color),se=await this._provider.provideColorPresentations(we,{document:K,range:he},G);if(!!Array.isArray(se))return se.map(y.ColorPresentation.from)}}class Pe{constructor(U,$){this._documents=U,this._provider=$}async provideFoldingRanges(U,$,G){const K=this._documents.getDocument(U),he=await this._provider.provideFoldingRanges(K,$,G);if(!!Array.isArray(he))return he.map(y.FoldingRange.from)}}class pe{constructor(U,$,G){this._documents=U,this._provider=$,this._logService=G}async provideSelectionRanges(U,$,G){const K=this._documents.getDocument(U),he=$.map(y.Position.to),we=await this._provider.provideSelectionRanges(K,he,G);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const se=[];for(let De=0;De<he.length;De++){const ye=[];se.push(ye);let ze=he[De],Ve=we[De];for(;;){if(!Ve.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(y.SelectionRange.from(Ve)),!Ve.parent)break;ze=Ve.range,Ve=Ve.parent}}return se}}class ve{constructor(U,$){this._documents=U,this._provider=$,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.prepareCallHierarchy(K,he,G);if(!we)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(we)?we.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,we)]}async provideCallsTo(U,$,G){const K=this._itemFromCache(U,$);if(!K)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(K,G);if(!!he)return he.map(we=>({from:this._cacheAndConvertItem(U,we.from),fromRanges:we.fromRanges.map(se=>y.Range.from(se))}))}async provideCallsFrom(U,$,G){const K=this._itemFromCache(U,$);if(!K)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(K,G);if(!!he)return he.map(we=>({to:this._cacheAndConvertItem(U,we.to),fromRanges:we.fromRanges.map(se=>y.Range.from(se))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,$){const G=this._cache.get(U),K=y.CallHierarchyItem.from($,U,G.size.toString(36));return G.set(K._itemId,$),K}_itemFromCache(U,$){return this._cache.get(U)?.get($)}}class Ae{constructor(U,$){this._documents=U,this._provider=$,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(U,$,G){const K=this._documents.getDocument(U),he=y.Position.to($),we=await this._provider.prepareTypeHierarchy(K,he,G);if(!we)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(we)?we.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,we)]}async provideSupertypes(U,$,G){const K=this._itemFromCache(U,$);if(!K)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(K,G);if(!!he)return he.map(we=>this._cacheAndConvertItem(U,we))}async provideSubtypes(U,$,G){const K=this._itemFromCache(U,$);if(!K)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(K,G);if(!!he)return he.map(we=>this._cacheAndConvertItem(U,we))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,$){const G=this._cache.get(U),K=y.TypeHierarchyItem.from($,U,G.size.toString(36));return G.set(K._itemId,$),K}_itemFromCache(U,$){return this._cache.get(U)?.get($)}}class ce{constructor(U,$,G,K){this._proxy=U,this._documents=$,this._provider=G,this._handle=K}async provideDocumentOnDropEdits(U,$,G,K,he){const we=this._documents.getDocument($),se=y.Position.to(G),De=y.DataTransfer.toDataTransfer(K,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,U,ze)).buffer),ye=await this._provider.provideDocumentOnDropEdits(we,se,De,he);if(!!ye)return y.SnippetTextEdit.from(ye)}}class me{constructor(U,$){this.adapter=U,this.extension=$}}class te{constructor(U,$,G,K,he,we,se){this._adapter=new Map,this._uriTransformer=$,this._proxy=U.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=K,this._diagnostics=he,this._logService=we,this._apiDeprecation=se}_transformDocumentSelector(U){return y.DocumentSelector.from(U,this._uriTransformer)}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return te._handlePool++}async _withAdapter(U,$,G,K,he,we=!1){const se=this._adapter.get(U);if(!se||!(se.adapter instanceof $))return K;const De=Date.now();we||this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(se.adapter,se.extension);return Promise.resolve(ye).catch(ze=>{(0,f.isCancellationError)(ze)||(this._logService.error(`[${se.extension.identifier.value}] provider FAILED`),this._logService.error(ze))}).finally(()=>{we||this._logService.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),I.CancellationToken.isCancellationToken(he)?(0,a.raceCancellationError)(ye,he):ye}_addNewAdapter(U,$){const G=this._nextHandle();return this._adapter.set(G,new me(U,$)),G}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,$,G,K){const he=this._addNewAdapter(new o(this._documents,G),U),we=K&&K.label||te._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector($),we),this._createDisposable(he)}$provideDocumentSymbols(U,$,G){return this._withAdapter(U,o,K=>K.provideDocumentSymbols(u.URI.revive($),G),void 0,G)}registerCodeLensProvider(U,$,G){const K=this._nextHandle(),he=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new me(new h(this._documents,this._commands.converter,G),U)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector($),he);let we=this._createDisposable(K);if(he!==void 0){const se=G.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(he));we=A.Disposable.from(we,se)}return we}$provideCodeLenses(U,$,G){return this._withAdapter(U,h,K=>K.provideCodeLenses(u.URI.revive($),G),void 0,G)}$resolveCodeLens(U,$,G){return this._withAdapter(U,h,K=>K.resolveCodeLens($,G),void 0,void 0)}$releaseCodeLenses(U,$){this._withAdapter(U,h,G=>Promise.resolve(G.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(U,$,G){const K=this._addNewAdapter(new s(this._documents,G),U);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDefinition(U,$,G,K){return this._withAdapter(U,s,he=>he.provideDefinition(u.URI.revive($),G,K),[],K)}registerDeclarationProvider(U,$,G){const K=this._addNewAdapter(new n(this._documents,G),U);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDeclaration(U,$,G,K){return this._withAdapter(U,n,he=>he.provideDeclaration(u.URI.revive($),G,K),[],K)}registerImplementationProvider(U,$,G){const K=this._addNewAdapter(new t(this._documents,G),U);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideImplementation(U,$,G,K){return this._withAdapter(U,t,he=>he.provideImplementation(u.URI.revive($),G,K),[],K)}registerTypeDefinitionProvider(U,$,G){const K=this._addNewAdapter(new c(this._documents,G),U);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideTypeDefinition(U,$,G,K){return this._withAdapter(U,c,he=>he.provideTypeDefinition(u.URI.revive($),G,K),[],K)}registerHoverProvider(U,$,G,K){const he=this._addNewAdapter(new l(this._documents,G),U);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector($)),this._createDisposable(he)}$provideHover(U,$,G,K){return this._withAdapter(U,l,he=>he.provideHover(u.URI.revive($),G,K),void 0,K)}registerEvaluatableExpressionProvider(U,$,G,K){const he=this._addNewAdapter(new d(this._documents,G),U);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector($)),this._createDisposable(he)}$provideEvaluatableExpression(U,$,G,K){return this._withAdapter(U,d,he=>he.provideEvaluatableExpression(u.URI.revive($),G,K),void 0,K)}registerInlineValuesProvider(U,$,G,K){const he=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new w(this._documents,G),U);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector($),he);let se=this._createDisposable(we);if(he!==void 0){const De=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(he));se=A.Disposable.from(se,De)}return se}$provideInlineValues(U,$,G,K,he){return this._withAdapter(U,w,we=>we.provideInlineValues(u.URI.revive($),G,K,he),void 0,he)}registerDocumentHighlightProvider(U,$,G){const K=this._addNewAdapter(new R(this._documents,G),U);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentHighlights(U,$,G,K){return this._withAdapter(U,R,he=>he.provideDocumentHighlights(u.URI.revive($),G,K),void 0,K)}registerLinkedEditingRangeProvider(U,$,G){const K=this._addNewAdapter(new F(this._documents,G),U);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideLinkedEditingRanges(U,$,G,K){return this._withAdapter(U,F,async he=>{const we=await he.provideLinkedEditingRanges(u.URI.revive($),G,K);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?te._serializeRegExp(we.wordPattern):void 0}},void 0,K)}registerReferenceProvider(U,$,G){const K=this._addNewAdapter(new O(this._documents,G),U);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideReferences(U,$,G,K,he){return this._withAdapter(U,O,we=>we.provideReferences(u.URI.revive($),G,K,he),void 0,he)}registerCodeActionProvider(U,$,G,K){const he=new _.DisposableStore,we=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,G,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector($),{providedKinds:K?.providedCodeActionKinds?.map(se=>se.value),documentation:K?.documentation?.map(se=>({kind:se.kind.value,command:this._commands.converter.toInternal(se.command,he)}))},te._extLabel(U),Boolean(G.resolveCodeAction)),he.add(this._createDisposable(we)),he}$provideCodeActions(U,$,G,K,he){return this._withAdapter(U,k,we=>we.provideCodeActions(u.URI.revive($),G,K,he),void 0,he)}$resolveCodeAction(U,$,G){return this._withAdapter(U,k,K=>K.resolveCodeAction($,G),void 0,void 0)}$releaseCodeActions(U,$){this._withAdapter(U,k,G=>Promise.resolve(G.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(U,$,G){const K=this._addNewAdapter(new M(this._documents,G),U);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector($),U.identifier,U.displayName||U.name),this._createDisposable(K)}$provideDocumentFormattingEdits(U,$,G,K){return this._withAdapter(U,M,he=>he.provideDocumentFormattingEdits(u.URI.revive($),G,K),void 0,K)}registerDocumentRangeFormattingEditProvider(U,$,G){const K=this._addNewAdapter(new W(this._documents,G),U);return this._proxy.$registerRangeFormattingSupport(K,this._transformDocumentSelector($),U.identifier,U.displayName||U.name),this._createDisposable(K)}$provideDocumentRangeFormattingEdits(U,$,G,K,he){return this._withAdapter(U,W,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive($),G,K,he),void 0,he)}registerOnTypeFormattingEditProvider(U,$,G,K){const he=this._addNewAdapter(new ee(this._documents,G),U);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector($),K,U.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(U,$,G,K,he,we){return this._withAdapter(U,ee,se=>se.provideOnTypeFormattingEdits(u.URI.revive($),G,K,he,we),void 0,we)}registerWorkspaceSymbolProvider(U,$){const G=this._addNewAdapter(new H($,this._logService),U);return this._proxy.$registerNavigateTypeSupport(G,typeof $.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(U,$,G){return this._withAdapter(U,H,K=>K.provideWorkspaceSymbols($,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,$,G){return this._withAdapter(U,H,K=>K.resolveWorkspaceSymbol($,G),void 0,void 0)}$releaseWorkspaceSymbols(U,$){this._withAdapter(U,H,G=>G.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(U,$,G){const K=this._addNewAdapter(new N(this._documents,G,this._logService),U);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector($),N.supportsResolving(G)),this._createDisposable(K)}$provideRenameEdits(U,$,G,K,he){return this._withAdapter(U,N,we=>we.provideRenameEdits(u.URI.revive($),G,K,he),void 0,he)}$resolveRenameLocation(U,$,G,K){return this._withAdapter(U,N,he=>he.resolveRenameLocation(u.URI.revive($),G,K),void 0,K)}registerDocumentSemanticTokensProvider(U,$,G,K){const he=this._addNewAdapter(new x(this._documents,G),U),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector($),K,we);let se=this._createDisposable(he);if(we){const De=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));se=A.Disposable.from(se,De)}return se}$provideDocumentSemanticTokens(U,$,G,K){return this._withAdapter(U,x,he=>he.provideDocumentSemanticTokens(u.URI.revive($),G,K),null,K)}$releaseDocumentSemanticTokens(U,$){this._withAdapter(U,x,G=>G.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,$,G,K){const he=this._addNewAdapter(new q(this._documents,G),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector($),K),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(U,$,G,K){return this._withAdapter(U,q,he=>he.provideDocumentRangeSemanticTokens(u.URI.revive($),G,K),null,K)}registerCompletionItemProvider(U,$,G,K){const he=this._addNewAdapter(new ie(this._documents,this._commands.converter,G,this._apiDeprecation,U),U);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector($),K,ie.supportsResolving(G),`${U.identifier.value}(${K.join("")})`),this._createDisposable(he)}$provideCompletionItems(U,$,G,K,he){return this._withAdapter(U,ie,we=>we.provideCompletionItems(u.URI.revive($),G,K,he),void 0,he)}$resolveCompletionItem(U,$,G){return this._withAdapter(U,ie,K=>K.resolveCompletionItem($,G),void 0,G)}$releaseCompletionItems(U,$){this._withAdapter(U,ie,G=>G.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(U,$,G){const K=new de(U,this._documents,G,this._commands.converter),he=this._addNewAdapter(K,U);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector($),K.supportsHandleDidShowCompletionItem),this._createDisposable(he)}registerInlineCompletionsProviderNew(U,$,G){const K=this._addNewAdapter(new ue(U,this._documents,G,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(K,this._transformDocumentSelector($),!0),this._createDisposable(K)}$provideInlineCompletions(U,$,G,K,he){return this._withAdapter(U,Q,we=>we.provideInlineCompletions(u.URI.revive($),G,K,he),void 0,he)}$handleInlineCompletionDidShow(U,$,G){this._withAdapter(U,Q,async K=>{K.handleDidShowCompletionItem($,G)},void 0,void 0)}$freeInlineCompletionsList(U,$){this._withAdapter(U,Q,async G=>{G.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(U,$,G,K){const he=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,we=this._addNewAdapter(new ge(this._documents,G),U);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector($),he),this._createDisposable(we)}$provideSignatureHelp(U,$,G,K,he){return this._withAdapter(U,ge,we=>we.provideSignatureHelp(u.URI.revive($),G,K,he),void 0,he)}$releaseSignatureHelp(U,$){this._withAdapter(U,ge,G=>G.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(U,$,G){const K=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new Se(this._documents,this._commands.converter,G,this._logService,U),U);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector($),typeof G.resolveInlayHint=="function",K,te._extLabel(U));let we=this._createDisposable(he);if(K!==void 0){const se=G.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(K));we=A.Disposable.from(we,se)}return we}$provideInlayHints(U,$,G,K){return this._withAdapter(U,Se,he=>he.provideInlayHints(u.URI.revive($),G,K),void 0,K)}$resolveInlayHint(U,$,G){return this._withAdapter(U,Se,K=>K.resolveInlayHint($,G),void 0,G)}$releaseInlayHints(U,$){this._withAdapter(U,Se,G=>G.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(U,$,G){const K=this._addNewAdapter(new oe(this._documents,G),U);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector($),typeof G.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(U,$,G){return this._withAdapter(U,oe,K=>K.provideLinks(u.URI.revive($),G),void 0,G,$.scheme==="output")}$resolveDocumentLink(U,$,G){return this._withAdapter(U,oe,K=>K.resolveLink($,G),void 0,void 0,!0)}$releaseDocumentLinks(U,$){this._withAdapter(U,oe,G=>G.releaseLinks($),void 0,void 0,!0)}registerColorProvider(U,$,G){const K=this._addNewAdapter(new _e(this._documents,G),U);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentColors(U,$,G){return this._withAdapter(U,_e,K=>K.provideColors(u.URI.revive($),G),[],G)}$provideColorPresentations(U,$,G,K){return this._withAdapter(U,_e,he=>he.provideColorPresentations(u.URI.revive($),G,K),void 0,K)}registerFoldingRangeProvider(U,$,G){const K=this._nextHandle(),he=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new me(new Pe(this._documents,G),U)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector($),he);let we=this._createDisposable(K);if(he!==void 0){const se=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));we=A.Disposable.from(we,se)}return we}$provideFoldingRanges(U,$,G,K){return this._withAdapter(U,Pe,he=>he.provideFoldingRanges(u.URI.revive($),G,K),void 0,K)}registerSelectionRangeProvider(U,$,G){const K=this._addNewAdapter(new pe(this._documents,G,this._logService),U);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideSelectionRanges(U,$,G,K){return this._withAdapter(U,pe,he=>he.provideSelectionRanges(u.URI.revive($),G,K),[],K)}registerCallHierarchyProvider(U,$,G){const K=this._addNewAdapter(new ve(this._documents,G),U);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$prepareCallHierarchy(U,$,G,K){return this._withAdapter(U,ve,he=>Promise.resolve(he.prepareSession(u.URI.revive($),G,K)),void 0,K)}$provideCallHierarchyIncomingCalls(U,$,G,K){return this._withAdapter(U,ve,he=>he.provideCallsTo($,G,K),void 0,K)}$provideCallHierarchyOutgoingCalls(U,$,G,K){return this._withAdapter(U,ve,he=>he.provideCallsFrom($,G,K),void 0,K)}$releaseCallHierarchy(U,$){this._withAdapter(U,ve,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(U,$,G){const K=this._addNewAdapter(new Ae(this._documents,G),U);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$prepareTypeHierarchy(U,$,G,K){return this._withAdapter(U,Ae,he=>Promise.resolve(he.prepareSession(u.URI.revive($),G,K)),void 0,K)}$provideTypeHierarchySupertypes(U,$,G,K){return this._withAdapter(U,Ae,he=>he.provideSupertypes($,G,K),void 0,K)}$provideTypeHierarchySubtypes(U,$,G,K){return this._withAdapter(U,Ae,he=>he.provideSubtypes($,G,K),void 0,K)}$releaseTypeHierarchy(U,$){this._withAdapter(U,Ae,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(U,$,G){const K=this._nextHandle();return this._adapter.set(K,new me(new ce(this._proxy,this._documents,G,K),U)),this._proxy.$registerDocumentOnDropEditProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentOnDropEdits(U,$,G,K,he,we){return this._withAdapter(U,ce,se=>Promise.resolve(se.provideDocumentOnDropEdits($,u.URI.revive(G),K,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(U,$,G){const K=this._nextHandle();return this._adapter.set(K,new me(new B(this._proxy,this._documents,G,K),U)),this._proxy.$registerPasteEditProvider(K,this._transformDocumentSelector($),!!G.prepareDocumentPaste),this._createDisposable(K)}$prepareDocumentPaste(U,$,G,K,he){return this._withAdapter(U,B,we=>we.prepareDocumentPaste(u.URI.revive($),G,K,he),void 0,he)}$providePasteEdits(U,$,G,K,he){return this._withAdapter(U,B,we=>we.providePasteEdits(0,u.URI.revive($),G,K,he),void 0,he)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,E.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:te._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:te._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?te._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?te._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:te._serializeRegExp(U.beforeText),afterText:U.afterText?te._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?te._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(te._serializeOnEnterRule)}setLanguageConfiguration(U,$,G){let{wordPattern:K}=G;if(K&&(0,E.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor($,K):this._documents.setWordDefinitionFor($,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const he=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?te._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?te._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?te._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,$,we),this._createDisposable(he)}$setWordDefinitions(U){for(const $ of U)this._documents.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=te,te._handlePool=0}),define(Ie[247],Te([1,0,5,15,7,41,17,6]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(L,T,S,I){this._documents=T,this._commands=S,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,T){await this._proxy.$changeLanguage(L,T);const S=this._documents.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,T){const S=L.version,I=i.Position.from(T),_=await this._proxy.$tokensAtPosition(L.uri,I),g={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new y.Range(T.line,T.character,T.line,T.character)};if(!_)return g;const v={range:i.Range.to(_.range),type:i.TokenType.to(_.type)};return!v.range.contains(T)||S!==L.version?g:v}createLanguageStatusItem(L,T,S){const I=this._handlePool++,_=this._proxy,g=this._ids,v=`${L.identifier.value}/${T}`;if(g.has(v))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);g.add(v);const p={selector:S,id:T,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,f=new D.DisposableStore;const a=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(I,{id:v,name:p.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(p.selector,this._uriTransformer),label:p.text,detail:p.detail??"",severity:p.severity===y.LanguageStatusSeverity.Error?A.default.Error:p.severity===y.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:p.command&&this._commands.toInternal(p.command,f),accessibilityInfo:p.accessibilityInformation,busy:p.busy})},0)},m={dispose(){f.dispose(),b?.dispose(),_.$removeLanguageStatus(I),g.delete(v)},get id(){return p.id},get name(){return p.name},set name(o){p.name=o,a()},get selector(){return p.selector},set selector(o){p.selector=o,a()},get text(){return p.text},set text(o){p.text=o,a()},get detail(){return p.detail},set detail(o){p.detail=o,a()},get severity(){return p.severity},set severity(o){p.severity=o,a()},get accessibilityInformation(){return p.accessibilityInformation},set accessibilityInformation(o){p.accessibilityInformation=o,a()},get command(){return p.command},set command(o){p.command=o,a()},get busy(){return p.busy},set busy(o){p.busy=o,a()}};return a(),m}}e.ExtHostLanguages=E}),define(Ie[136],Te([1,0,14,5,27,18,3]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends u.AbstractLoggerService{constructor(L,T){const S=new C.Emitter;super(T.logLevel,S.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,T,S){return new E(this._proxy,L,T,S)}};D=je([xe(0,A.IExtHostRpcService),xe(1,y.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class E extends u.AbstractMessageLogger{constructor(L,T,S,I){super(I?.always);this.proxy=L,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(T,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,T){const S=[[L,T]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ie[248],Te([1,0,5,14,28]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let C=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(u.MainContext.MainThreadMessageService)}showMessage(E,P,L,T,S){const I={source:{identifier:E.identifier,label:E.displayName||E.name}};let _;typeof T=="string"||A(T)?_=[T,...S]:(I.modal=T?.modal,I.useCustom=T?.useCustom,I.detail=T?.detail,_=S),I.useCustom&&(0,y.checkProposedApiEnabled)(E,"resolvers");const g=[];for(let v=0;v<_.length;v++){const p=_[v];if(typeof p=="string")g.push({title:p,handle:v,isCloseAffordance:!1});else if(typeof p=="object"){let{title:b,isCloseAffordance:f}=p;g.push({title:b,isCloseAffordance:!!f,handle:v})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(P,L,I,g).then(v=>{if(typeof v=="number")return _[v]})}};C=je([xe(1,i.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[249],Te([1,0,23,3,61,6,25,8,12,2,88,5,37,15,7,54,222,131]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(a,m,o,h,r){this._textDocumentsAndEditors=o,this._textDocuments=h,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,l=this._documents.get(n)?.getCell(t);if(l)return l.apiCell}return s}}),b._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const m=this._editors.get(a);if(!m)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(a){for(const[m,o]of this._editors)if(o.apiEditor===a)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,m){const o=this._documents.get(a);if(!o&&!m)throw new Error(`NO notebook document for '${a}'`);return o}_getProviderData(a){const m=this._notebookContentProviders.get(a);if(!m)throw new Error(`NO provider for '${a}'`);return m}registerNotebookContentProvider(a,m,o,h,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:a,provider:o});let s;return o.onDidChangeNotebookContentOptions&&(s=o.onDidChangeNotebookContentOptions(()=>{const n=I.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(m,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},m,I.NotebookDocumentContentOptions.from(h),b._convertNotebookRegistrationData(a,r)),new _.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(a,m){if(!m)return;const o=m.filenamePattern.map(h=>I.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(m.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:m.displayName,filenamePattern:o,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,m,o){const h=b._notebookStatusBarItemProviderHandlePool++,r=typeof o.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,r,m);let s;return r!==void 0&&(s=o.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(r))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,r),s&&s.dispose()})}async createNotebookDocument(a){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&I.NotebookData.from(a.content)});return P.URI.revive(m)}async openNotebookDocument(a){const m=this._documents.get(a);if(m)return m.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(a),h=this._documents.get(P.URI.revive(o));return(0,E.assertIsDefined)(h?.apiNotebook)}async showNotebookDocument(a,m){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let o;typeof m=="object"?o={position:I.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(I.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:o={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,o),r=h&&this._editors.get(h)?.apiEditor;if(r)return r;throw h?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,m,o,h){const r=this._notebookStatusBarItemProviders.get(a),s=P.URI.revive(m),n=this._documents.get(s);if(!n||!r)return;const t=n.getCellFromIndex(o);if(!t)return;const c=await r.provideCellStatusBarItems(t.apiCell,h);if(!c)return;const l=new A.DisposableStore,d=this._statusBarCache.add([l]),R=(Array.isArray(c)?c:[c]).map(F=>I.NotebookStatusBarItem.from(F,this._commandsConverter,l));return{cacheId:d,items:R}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,m,o,h,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,o),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},m,I.NotebookDocumentContentOptions.from(h),b._convertNotebookRegistrationData(a,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,m,o){const h=this._notebookSerializer.get(a);if(!h)throw new Error("NO serializer found");const r=await h.deserializeNotebook(m.buffer,o);return new g.SerializableObjectWithBuffers(I.NotebookData.from(r))}async $notebookToData(a,m,o){const h=this._notebookSerializer.get(a);if(!h)throw new Error("NO serializer found");const r=await h.serializeNotebook(I.NotebookData.to(m.value),o);return u.VSBuffer.wrap(r)}async $openNotebook(a,m,o,h,r){const{provider:s}=this._getProviderData(a),n=await s.openNotebook(P.URI.revive(m),{backupId:o,untitledDocumentData:h?.buffer},r);return new g.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(I.NotebookCellData.from)})}async $saveNotebook(a,m,o){const h=this.getNotebookDocument(P.URI.revive(m)),{provider:r}=this._getProviderData(a);return await r.saveNotebook(h.apiNotebook,o),!0}async $saveNotebookAs(a,m,o,h){const r=this.getNotebookDocument(P.URI.revive(m)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(P.URI.revive(o),r.apiNotebook,h),!0}async $backupNotebook(a,m,o){const h=this.getNotebookDocument(P.URI.revive(m)),r=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),n=String((0,y.hash)([h.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(s,n),c=await r.provider.backupNotebook(h.apiNotebook,{destination:t},o);return h.updateBackup(c),c.id}_createExtHostEditor(a,m,o){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const h=new p.ExtHostNotebookEditor(m,this._notebookEditorsProxy,a,o.visibleRanges.map(I.NotebookRange.to),o.selections.map(I.NotebookRange.to),typeof o.viewColumn=="number"?I.ViewColumn.to(o.viewColumn):void 0);this._editors.set(m,h)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const o of a.value.removedDocuments){const h=P.URI.revive(o),r=this._documents.get(h);r&&(r.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===h.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const o=[];for(const h of a.value.addedDocuments){const r=P.URI.revive(h.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,h);o.push(...h.cells.map(n=>v.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const o of a.value.addedEditors){if(this._editors.has(o.id))return;const h=P.URI.revive(o.documentUri),r=this._documents.get(h);r&&this._createExtHostEditor(r,o.id,o)}const m=[];if(a.value.removedEditors)for(const o of a.value.removedEditors){const h=this._editors.get(o);h&&(this._editors.delete(o),this._activeNotebookEditor?.id===h.id&&(this._activeNotebookEditor=void 0),m.push(h))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const o=new Set;this._visibleNotebookEditors.forEach(h=>o.add(h.id));for(const h of this._editors.values()){const r=o.has(h.id);h._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const m=S.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new S.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>u.VSBuffer.wrap(r))],new S.ApiCommandResult("Notebook Data",r=>I.NotebookData.to(r.value))),h=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new g.SerializableObjectWithBuffers(I.NotebookData.from(r)))],new S.ApiCommandResult("Bytes",r=>r.buffer));a.registerApiCommand(o),a.registerApiCommand(h)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(Ie[250],Te([1,0,3,79,14,5,18,15]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(T,S){const I=E._Keys.nextId();T.$registerNotebookEditorDecorationType(I,D.NotebookDecorationRenderOptions.from(S)),this.value={key:I,dispose(){T.$removeNotebookEditorDecorationType(I)}}}}E._Keys=new i.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(T,S,I){this._logService=T,this._extHostRpc=S,this._notebooksAndEditors=I,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new E(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const I=this._notebooksAndEditors.getEditorById(T);S.visibleRanges&&I._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&I._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(T[S]))}};P=je([xe(0,y.ILogService),xe(1,C.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(Ie[251],Te([1,0,16,17,21,3,6,25,2,26,14,5,37,15,7,89,217,28,54]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(s,n,t,c,l){this._initData=n,this._extHostNotebook=t,this._commands=c,this._logService=l,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(T.MainContext.MainThreadNotebookKernels);const d=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const R=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:R}}else if(w&&"notebookEditor"in w){const R=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return w})],S.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(s,n,t,c,l,d){for(const ie of this._kernelData.values())if(ie.controller.id===n&&P.ExtensionIdentifier.equals(s.identifier,ie.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const w=this._handlePool++,R=this;this._logService.trace(`NotebookController[${w}], CREATED by ${s.identifier.value}, ${n}`);const F=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${s.identifier}'`);let O=!1;const k=new C.DisposableStore,B=new A.Emitter,M=new A.Emitter,W={id:h(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:d?d.map(I.NotebookRendererScript.from):[]};let ee=l??F,H;this._proxy.$addKernel(w,W).catch(ie=>{console.log(ie),O=!0});let N=0;const j=()=>{if(O)return;const ie=++N;Promise.resolve().then(()=>{ie===N&&this._proxy.$updateKernel(w,W)})},x=new D.ResourceMap,q={get id(){return n},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return W.label},set label(ie){W.label=ie??s.displayName??s.name,j()},get detail(){return W.detail??""},set detail(ie){W.detail=ie,j()},get description(){return W.description??""},set description(ie){W.description=ie,j()},get kind(){return(0,p.checkProposedApiEnabled)(s,"notebookControllerKind"),W.kind??""},set kind(ie){(0,p.checkProposedApiEnabled)(s,"notebookControllerKind"),W.kind=ie,j()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(ie){W.supportedLanguages=ie,j()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){W.supportsExecutionOrder=ie,j()},get rendererScripts(){return W.preloads?W.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(ie){ee=ie??F},get interruptHandler(){return H},set interruptHandler(ie){H=ie,W.supportsInterrupt=Boolean(ie),j()},createNotebookCellExecution(ie){if(O)throw new Error("notebook controller is DISPOSED");if(!x.has(ie.notebook.uri))throw R._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return R._createNotebookCellExecution(ie,h(s.identifier,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${w}], DISPOSED`),O=!0,this._kernelData.delete(w),k.dispose(),B.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(ie,Q){R._proxy.$updateNotebookPriority(w,ie.uri,Q)},onDidReceiveMessage:M.event,postMessage(ie,Q){return(0,p.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(w,Q&&R._extHostNotebook.getIdByEditor(Q),ie)},asWebviewUri(ie){return(0,p.checkProposedApiEnabled)(s,"notebookMessaging"),(0,g.asWebviewUri)(ie,R._initData.remote)}};return this._kernelData.set(w,{extensionId:s.identifier,controller:q,onDidReceiveMessage:M,onDidChangeSelection:B,associatedNotebooks:x}),q}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return h(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const c=this._kernelData.get(s);if(c){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(n));t?c.associatedNotebooks.set(l.uri,!0):c.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:l.apiNotebook})}}async $executeCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(n)),d=[];for(const w of t){const R=l.getCell(w);R&&d.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),d.length),await c.controller.executeHandler.call(c.controller,d,l.apiNotebook,c.controller)}catch(w){this._logService.error(`NotebookController[${s}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(n));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,l.apiNotebook);else for(const d of t){const w=l.getCell(d);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getEditorById(n);c.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)).getCell(n);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:t?I.NotebookCellExecutionState.to(t):_.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const l=new m(n,c,this._proxy);this._activeExecutions.set(c.uri,l);const d=l.onDidChangeState(()=>{l.state===a.Resolved&&(l.dispose(),d.dispose(),this._activeExecutions.delete(c.uri))});return l.asApiObject()}};f=je([xe(4,L.ILogService)],f),e.ExtHostNotebookKernels=f;var a;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(a||(a={}));class m extends C.Disposable{constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new o(10,c=>this.update(c)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(s){return s.map(n=>{const t=_.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?I.NotebookCellOutput.from(n):I.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const c=this.validateAndConvertOutputs((0,u.asArray)(s));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:t,outputs:c})}async updateOutputItems(s,n,t){return s=_.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(s),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:s.map(I.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===a.Resolved||s._state===a.Started)throw new Error("Cannot call start again");s._state=a.Started,s._onDidChangeState.fire(),s.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(s._state===a.Resolved)throw new Error("Cannot call resolve twice");s._state=a.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new b.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!0)},replaceOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!1)},appendOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!1)}})}}m.HANDLE=0;class o{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function h(r,s){return`${r.value}/${s}`}e.createKernelId=h}),define(Ie[252],Te([1,0,3,5,131]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,E,P){const L=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(E)?.fire({editor:L.apiEditor,message:P})}createRendererMessaging(D,E){if(!D.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,T,S)=>this.getOrCreateEmitterFor(E).event(L,T,S),postMessage:(L,T)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,T]=[T,L]);const S=T&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.proxy.$postMessage(S?.id,E,L)}}}getOrCreateEmitterFor(D){let E=this._rendererMessageEmitters.get(D);return E||(E=new u.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,E),E)}}e.ExtHostNotebookRenderers=A}),define(Ie[253],Te([1,0,21,3,6,5,2,7,11,16,41,87]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(I,_,g){const v=I.getProxy(A.MainContext.MainThreadQuickOpen);class p{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,c=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(n),d=++this._instances,w=v.$show(d,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),R={},F=w.then(()=>R);return Promise.race([F,l]).then(O=>{if(O!==R)return l.then(k=>{const B=[];for(let M=0;M<k.length;M++){const W=k[M];typeof W=="string"?B.push({label:W,handle:M}):W.kind===D.QuickPickItemKind.Separator?B.push({type:"separator",label:W.label}):B.push({label:W.label,description:W.description,detail:W.detail,picked:W.picked,alwaysShow:W.alwaysShow,handle:M})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{t.onDidSelectItem(k[M])}),v.$setItems(d,B),w.then(M=>{if(typeof M=="number")return k[M];if(Array.isArray(M))return M.map(W=>k[W])})})}).then(void 0,O=>{if(!(0,E.isCancellationError)(O))return v.$setError(d,O),Promise.reject(O)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=u.CancellationToken.None){return this._validateInput=n?.validateInput,v.$input(n,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,E.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let c;switch(t.severity){case D.InputBoxValidationSeverity.Info:c=L.default.Info;break;case D.InputBoxValidationSeverity.Warning:c=L.default.Warning;break;case D.InputBoxValidationSeverity.Error:c=L.default.Error;break;default:c=t.message?L.default.Error:L.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(n,t=u.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!c)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(d=>d.uri.toString()===c.uri.toString())}createQuickPick(n){const t=new h(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new r(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const c=this._sessions.get(n);c&&c._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const c=this._sessions.get(n);c instanceof h&&c._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const c=this._sessions.get(n);c instanceof h&&c._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const c=this._sessions.get(n);c&&c._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,c){const l=this._sessions.get(n);l instanceof h&&l._fireDidTriggerItemButton(t,c)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class b{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new i.Emitter,this._onDidChangeValueEmitter=new i.Emitter,this._onDidTriggerButtonEmitter=new i.Emitter,this._onDidHideEmitter=new i.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,c)=>{const l=t===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(l,t)}),this.update({buttons:n.map((t,c)=>({...o(t),tooltip:t.tooltip,handle:t===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const c=n[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function f(s){if(s instanceof D.ThemeIcon)return{id:s.id};const n=m(s),t=a(s);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof t=="string"?C.URI.file(t):t}}function a(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}function o(s){const n=f(s.iconPath);let t,c;return"id"in n?c=T.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:c}}class h extends b{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new i.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new i.Emitter,this._onDidTriggerItemButtonEmitter=new i.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((c,l)=>{this._handlesToItems.set(l,c),this._itemsToHandles.set(c,l)});const t=[];for(let c=0;c<n.length;c++){const l=n[c];l.kind===D.QuickPickItemKind.Separator?t.push({type:"separator",label:l.label}):t.push({handle:c,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((d,w)=>({...o(d),tooltip:d.tooltip,handle:w}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,P.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,P.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const c=this._handlesToItems.get(n);if(!c||!c.buttons||!c.buttons.length)return;const l=c.buttons[t];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:c})}}class r extends b{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:L.default.Error}):this.update({validationMessage:n.message,severity:n.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new p(_,g)}e.createExtHostQuickOpen=S});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[254],Te([1,0,2,3,58,6,17,5,16,100,14,26,87,15,28]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_){"use strict";var g,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||S.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function b(l,d){if(!l.iconPath&&!d.iconPath)return 0;if(l.iconPath){if(!d.iconPath)return 1}else return-1;const w=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,R=typeof d.iconPath=="string"?d.iconPath:u.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,P.comparePaths)(w,R)}function f(l,d){let w=0;if(l.strikeThrough!==d.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==d.faded)return l.faded?1:-1;if(l.tooltip!==d.tooltip)return(l.tooltip||"").localeCompare(d.tooltip||"");if(w=b(l,d),w!==0)return w;if(l.light&&d.light)w=b(l.light,d.light);else{if(l.light)return 1;if(d.light)return-1}if(w!==0)return w;if(l.dark&&d.dark)w=b(l.dark,d.dark);else{if(l.dark)return 1;if(d.dark)return-1}return w}function a(l,d){if(l.command!==d.command)return l.command<d.command?-1:1;if(l.title!==d.title)return l.title<d.title?-1:1;if(l.tooltip!==d.tooltip){if(l.tooltip!==void 0&&d.tooltip!==void 0)return l.tooltip<d.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(l.arguments===d.arguments)return 0;if(l.arguments)if(d.arguments){if(l.arguments.length!==d.arguments.length)return l.arguments.length-d.arguments.length}else return 1;else return-1;for(let w=0;w<l.arguments.length;w++){const R=l.arguments[w],F=d.arguments[w];if(R!==F)return R<F?-1:1}return 0}function m(l,d){let w=(0,P.comparePaths)(l.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(w!==0)return w;if(l.command&&d.command)w=a(l.command,d.command);else{if(l.command)return 1;if(d.command)return-1}if(w!==0)return w;if(l.decorations&&d.decorations)w=f(l.decorations,d.decorations);else{if(l.decorations)return 1;if(d.decorations)return-1}return w}function o(l,d){for(let w=0;w<l.length;w++)if(l[w]!==d[w])return!1;return!0}function h(l,d){return l.command===d.command&&l.title===d.title&&l.tooltip===d.tooltip&&(l.arguments&&d.arguments?o(l.arguments,d.arguments):l.arguments===d.arguments)}function r(l,d){return(0,E.equals)(l,d,h)}class s{constructor(d,w,R){this._extension=d,this._sourceControlHandle=R,g.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,et(this,g,w,"f")}get value(){return this._value}set value(d){d=d??"",Ue(this,g,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Ue(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Ue(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get enabled(){return(0,_.checkProposedApiEnabled)(this._extension,"scmInput"),this._enabled}set enabled(d){(0,_.checkProposedApiEnabled)(this._extension,"scmInput"),d=!!d,this._enabled!==d&&(this._enabled=d,Ue(this,g,"f").$setInputBoxEnablement(this._sourceControlHandle,d))}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Ue(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,w){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,g,"f").$showValidationMessage(this._sourceControlHandle,d,w)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=s,g=new WeakMap;class n{constructor(d,w,R,F,O){this._proxy=d,this._commands=w,this._sourceControlHandle=R,this._id=F,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,w){const R=this._resourceStatesCommandsMap.get(d);return R?(0,C.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(m),R=(0,E.sortedDiff)(this._resourceSnapshot,d,m).map(k=>{const B=k.toInsert.map(M=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,M);const ee=M.resourceUri;let H;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ge=new A.DisposableStore;H=this._commands.converter.toInternal(M.command,ge),this._resourceStatesDisposablesMap.set(W,ge)}else this._resourceStatesCommandsMap.set(W,M.command);const N=p(M.decorations),j=M.decorations&&p(M.decorations.light)||N,x=M.decorations&&p(M.decorations.dark)||N,q=[j,x],ie=M.decorations&&M.decorations.tooltip||"",Q=M.decorations&&!!M.decorations.strikeThrough,de=M.decorations&&!!M.decorations.faded,ue=M.contextValue||"";return{rawResource:[W,ee,q,ie,Q,de,ue,H],handle:W}});return{start:k.start,deleteCount:k.deleteCount,toInsert:B}}),F=R.map(({start:k,deleteCount:B,toInsert:M})=>[k,B,M.map(W=>W.rawResource)]),O=R.reverse();for(const{start:k,deleteCount:B,toInsert:M}of O){const W=M.map(H=>H.handle),ee=this._handlesSnapshot.splice(k,B,...W);for(const H of ee)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=d,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(d,w,R,F,O,k){this._extension=d,this._commands=R,this._id=F,this._label=O,this._rootUri=k,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,et(this,v,w,"f"),this._inputBox=new s(d,Ue(this,v,"f"),this.handle),Ue(this,v,"f").$registerSourceControl(this.handle,F,O,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Ue(this,v,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Ue(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Ue(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=d;const w=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Ue(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=d;const w=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),description:d.description}:void 0;Ue(this,v,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&r(this._statusBarCommands,d))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=d;const w=(d||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(d,w){const R=new n(Ue(this,v,"f"),this._commands,this.handle,d,w),F=i.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,F),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const d=[],w=[];for(const[R,F]of this.createdResourceGroups){F.dispose();const O=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});i.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),O.dispose(),this._groups.delete(R.handle),Ue(this,v,"f").$unregisterGroup(this.handle,R.handle)}),d.push([R.handle,R.id,R.label,R.features]);const k=R._takeResourceStateSnapshot();k.length>0&&w.push([R.handle,k]),this._groups.set(R.handle,R)}Ue(this,v,"f").$registerGroups(this.handle,d,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(w=>{const R=w._takeResourceStateSnapshot();R.length!==0&&d.push([w.handle,R])}),d.length>0&&Ue(this,v,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Ue(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Xi{constructor(d,w,R){this._commands=w,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=d.getProxy(D.MainContext.MainThreadSCM),this._telemetry=d.getProxy(D.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const O=this._sourceControls.get(F.sourceControlHandle);if(!O)return F;const k=O.getResourceGroup(F.groupHandle);return k?k.getResourceState(F.handle):F}else if(F&&F.$mid===4){const O=this._sourceControls.get(F.sourceControlHandle);return O?O.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const O=this._sourceControls.get(F.handle);return O||F}return F}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,w,R,F){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,w,R,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const O=Xi._handlePool++,k=new t(d,this._proxy,this._commands,w,R,F);this._sourceControls.set(O,k);const B=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier))||[];return B.push(k),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(d.identifier),B),k}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const w=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier)),R=w&&w[w.length-1];return R&&R.inputBox}$provideOriginalResource(d,w,R){const F=u.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,F.toString());const O=this._sourceControls.get(d);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(F,R)).then(k=>k||null)}$onInputBoxValueChange(d,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const R=this._sourceControls.get(d);return R&&R.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(d,w,R,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,w,R);const O=this._sourceControls.get(d);if(!O)return Promise.resolve(void 0);const k=O.getResourceGroup(w);return k?k.$executeResourceCommand(R,F):Promise.resolve(void 0)}$validateInput(d,w,R){this.logService.trace("ExtHostSCM#$validateInput",d);const F=this._sourceControls.get(d);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(w,R)).then(O=>{if(!O)return Promise.resolve(void 0);const k=I.MarkdownString.fromStrict(O.message);return k?Promise.resolve([k,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};c._handlePool=0,c=je([xe(2,L.ILogService)],c),e.ExtHostSCM=c});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[255],Te([1,0,7,5,173,6,15,12]),function(Y,e,u,i,y,A,C,D){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(_,g,v,p,b=u.StatusBarAlignment.Left,f){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,E,_,"f"),et(this,P,g,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=p,this._alignment=b,this._priority=this.validatePriority(f)}validatePriority(_){if(!!(0,D.isNumber)(_))return _===Number.POSITIVE_INFINITY?Number.MAX_VALUE:_===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:_}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set name(_){this._name=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!L.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){this._command?.fromApi!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:Ue(this,P,"f").toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:Ue(this,P,"f").toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let _;this._extension?this._id?_=`${this._extension.identifier.value}.${this._id}`:_=this._extension.identifier.value:_=this._id;let g;this._name?g=this._name:g=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const p=C.MarkdownString.fromStrict(this._tooltip);Ue(this,E,"f").$setEntry(this._entryId,_,g,this._text,p,this._command?.internal,v,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,E=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(_){this._messages=[],this._item=_.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const g={message:_};return this._messages.unshift(g),this._update(),new u.Disposable(()=>{const v=this._messages.indexOf(g);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(_,g){this._proxy=_.getProxy(i.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new T(this)}createStatusBarEntry(_,g,v,p){return new L(this._proxy,this._commands,_,g,v,p)}setStatusBarMessage(_,g){const v=this._statusMessage.setMessage(_);let p;return typeof g=="number"?p=setTimeout(()=>v.dispose(),g):typeof g!="undefined"&&g.then(()=>v.dispose(),()=>v.dispose()),new u.Disposable(()=>{v.dispose(),clearTimeout(p)})}}e.ExtHostStatusBar=S}),define(Ie[92],Te([1,0,5,3,4]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,E){this._proxy.$registerExtensionStorageKeysToSync(D,E)}initializeExtensionStorage(D,E,P){return this._proxy.$initializeExtensionStorage(D,E).then(L=>L||P)}setValue(D,E,P){return this._proxy.$setValue(D,E,P)}$acceptValue(D,E,P){this._onDidChangeStorage.fire({shared:D,key:E,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[71],Te([1,0,4,27,14,70,2]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let D=class{constructor(P,L,T){this._logService=L,this._extHostFileSystem=T,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(P){return C.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(P){if(this._value)return C.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return C.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=je([xe(0,i.IExtHostInitDataService),xe(1,y.ILogService),xe(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(Ie[38],Te([1,0,3,5,4,2,18,6,7,174,11,218,21,35,202,87,12,17]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(t,c,l,d){this._proxy=t,this._id=c,this._creationOptions=l,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(R,F=!0){w._checkDisposed(),w._proxy.$sendText(w._id,R,F)},show(R){w._checkDisposed(),w._proxy.$show(w._id,R)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,v.withNullAsUndefined)(t.shellPath),shellArgs:(0,v.withNullAsUndefined)(t.shellArgs),cwd:(0,v.withNullAsUndefined)(t.cwd),env:(0,v.withNullAsUndefined)(t.env),icon:(0,v.withNullAsUndefined)(r(t.iconPath)),color:g.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,v.withNullAsUndefined)(t.message),strictEnv:(0,v.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,l,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:g.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=b;class f{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let a=1,m=class extends D.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const l=new b(this._proxy,(0,I.generateUuid)(),t,t.name),d=new f(t.pty);return l.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(w=>{const R=this._setupExtHostProcessListeners(w,d);this._terminalProcessDisposables[w]=R}),this._terminals.push(l),l.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const l=t.location.parentTerminal;if(l){const d=this._terminals.find(w=>w.value===l);d&&(c.resolvedExtHostIdentifier=d._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const d=new f(c),w=this._setupExtHostProcessListeners(t,d);this._terminalProcessDisposables[t]=w}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:c})}async $acceptTerminalDimensions(t,c,l){const d=this._getTerminalById(t);d&&d.setDimensions(c,l)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,l){this._terminalProcesses.get(t)?.resize(c,l)}async $acceptTerminalTitleChange(t,c){const l=this._getTerminalById(t);l&&(l.name=c)}async $acceptTerminalClosed(t,c){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const d=this._terminals.splice(l,1)[0];d.setExitCode(c),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(t,c,l,d){if(c){const F=this._getTerminalObjectIndexById(this._terminals,c);if(F!==null){this._terminals[F]._id=t,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const w={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:A.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},R=new b(this._proxy,t,w,l);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(t,c){const l=this._getTerminalById(t);l&&l._setProcessId(c)}async $startExtensionTerminal(t,c){const l=this._getTerminalById(t);if(!l)return{message:(0,P.localize)(0,null,t)};l.isOpen||await new Promise(w=>{const R=this.onDidOpenTerminal(async F=>{F===l.value&&(R.dispose(),w())})});const d=this._terminalProcesses.get(t);d?d.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const l=new D.DisposableStore;l.add(c.onProcessReady(w=>this._proxy.$sendProcessReady(t,w.pid,w.cwd))),l.add(c.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(t,w))),this._bufferer.startBuffering(t,c.onProcessData),l.add(c.onProcessExit(w=>this._onProcessExit(t,w))),this._terminalProcesses.set(t,c);const d=this._extensionTerminalAwaitingStart[t];return d&&c instanceof f&&(c.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,l){try{this._terminalProcesses.get(t)?.resize(c,l)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,l){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,l),this._proxy.$registerProfileProvider(c,t.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const l=new S.CancellationTokenSource().token;let d=await this._profileProviders.get(t)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,c);return}this.createTerminalFromOptions(d.options,c)}}async $provideLinks(t,c){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const d=this._terminalLinkCancellationSource.get(t);d&&d.dispose(!0);const w=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,w);const R=[],F={terminal:l.value,line:c},O=[];for(const M of this._linkProviders)O.push(p.Promises.withAsyncBody(async W=>{w.token.onCancellationRequested(()=>W({provider:M,links:[]}));const ee=await M.provideTerminalLinks(F,w.token)||[];w.token.isCancellationRequested||W({provider:M,links:ee})}));const k=await Promise.all(O);if(w.token.isCancellationRequested)return[];const B=new Map;for(const M of k)M&&M.links.length>0&&R.push(...M.links.map(W=>{const ee={id:a++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return B.set(ee.id,{provider:M.provider,link:W}),ee}));return this._terminalLinkCache.set(t,B),R}$activateLink(t,c){const l=this._terminalLinkCache.get(t)?.get(c);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const l=this._getTerminalObjectIndexById(t,c);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,c){let l=null;return t.some((d,w)=>d._id===c?(l=w,!0):!1),l}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const l=(0,T.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const l=c[0],d=new o(c[1]);this._setEnvironmentVariableCollection(l,d)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};m=je([xe(1,C.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const l=this.map.get(t);(!l||l.value!==c.value||l.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((l,d)=>t.call(c,d,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let h=class extends m{constructor(t){super(!1,t)}createTerminal(t,c,l){throw new L.NotSupportedError}createTerminalFromOptions(t,c){throw new L.NotSupportedError}};h=je([xe(0,C.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return g.ThemeColor.isThemeColor(n)?n:void 0}});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[256],Te([1,0,16,23,21,3,59,61,6,24,12,35,5,18,132,15,7,67,90,68]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(O,k){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(S.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new r(this.proxy),k.registerArgumentProcessor({processArgument:B=>B?.$mid===13?(0,_.toItemFromContext)(B):B})}createTestController(O,k,B){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const M=new E.DisposableStore,W=M.add(new _.ExtHostTestItemCollection(O,k));W.root.label=k;const ee=new Map,H=this.proxy,N={items:W.root.children,get label(){return k},set label(x){k=x,W.root.label=x,H.$updateController(O,{label:k})},get refreshHandler(){return B},set refreshHandler(x){B=x,H.$updateController(O,{canRefresh:!!x})},get id(){return O},createRunProfile:(x,q,ie,Q,de)=>{let ue=(0,D.hash)(x);for(;ee.has(ue);)ue++;return new w(this.proxy,ee,O,ue,x,q,ie,Q,de)},createTestItem(x,q,ie){return new _.TestItemImpl(O,x,q,ie)},createTestRun:(x,q,ie=!0)=>this.runTracker.createTestRun(O,W,x,q,ie),set resolveHandler(x){W.resolveHandler=x},get resolveHandler(){return W.resolveHandler},dispose:()=>{M.dispose()}};H.$registerTestController(O,k,!!B),M.add((0,E.toDisposable)(()=>H.$unregisterTestController(O)));const j={controller:N,collection:W,profiles:ee};return this.controllers.set(O,j),M.add((0,E.toDisposable)(()=>this.controllers.delete(O))),M.add(W.onDidGenerateDiff(x=>H.$publishDiff(O,x.map(f.TestsDiffOp.serialize)))),N}createTestObserver(){return this.observer.checkout()}async runTests(O,k=y.CancellationToken.None){const B=s(O);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(B.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(W=>p.TestId.fromExtHostTestItem(W,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:R[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:O.exclude?.map(W=>W.id)},k)}$provideFileCoverage(O,k,B){return(0,u.mapFind)(this.runTracker.trackers,W=>W.id===O?W.getCoverage(k):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(O,k,B,M){return(0,u.mapFind)(this.runTracker.trackers,ee=>ee.id===O?ee.getCoverage(k):void 0)?.resolveFileCoverage(B,M)??Promise.resolve([])}$configureRunProfile(O,k){this.controllers.get(O)?.profiles.get(k)?.configureHandler?.()}async $refreshTests(O,k){await this.controllers.get(O)?.controller.refreshHandler?.(k)}$publishTestResults(O){this.results=Object.freeze(O.map(k=>(0,P.deepFreeze)(g.TestResults.to(k))).concat(this.results).sort((k,B)=>B.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,k){const B=this.controllers.get(p.TestId.fromString(O).controllerId)?.collection;B&&(await B.expand(O,k<0?1/0:k),B.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O.map(f.TestsDiffOp.deserialize))}async $runControllerTests(O,k){const B=this.controllers.get(O.controllerId);if(!B)return;const{collection:M,profiles:W}=B,ee=W.get(O.profileId);if(!ee)return;const H=O.testIds.map(q=>M.tree.get(q)).filter(L.isDefined),N=O.excludeExtIds.map(q=>B.collection.tree.get(q)).filter(L.isDefined).filter(q=>H.some(ie=>ie.fullId.compare(q.fullId)===2));if(!H.length)return;const j=new v.TestRunRequest(H.some(q=>q.actual instanceof _.TestItemRootImpl)?void 0:H.map(q=>q.actual),N.map(q=>q.actual),ee),x=this.runTracker.prepareForMainThreadTestRun(j,n.fromInternal(O,B.collection),k);try{await ee.runHandler(j,k)}finally{x.isRunning&&!k.isCancellationRequested&&await A.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};o=je([xe(0,I.IExtHostRpcService)],o),e.ExtHostTesting=o;class h extends E.Disposable{constructor(O,k,B){super();this.dto=O,this.proxy=k,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const k=this.dto.id,B=this.dto.controllerId,M=(0,T.generateUuid)(),W=new t(this.proxy,k,M),ee=x=>(q,...ie)=>{if(N){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),x(q,...ie))},H=(x,q)=>{const ie=q instanceof Array?q.map(g.TestMessage.from):[g.TestMessage.from(q)];if(x.uri&&x.range){const Q={range:g.Range.from(x.range),uri:x.uri};for(const de of ie)de.location=de.location||Q}this.proxy.$appendTestMessagesInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),ie)};let N=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return W.coverageProvider},set coverageProvider(x){W.coverageProvider=x},enqueued:ee(x=>{this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),1)}),skipped:ee(x=>{this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),5)}),started:ee(x=>{this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),2)}),errored:ee((x,q,ie)=>{H(x,q),this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),6,ie)}),failed:ee((x,q,ie)=>{H(x,q),this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,B).toString(),4,ie)}),passed:ee((x,q)=>{this.proxy.$updateTestStateInRun(k,M,p.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,q)}),appendOutput:(x,q,ie)=>{N||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(k,M,i.VSBuffer.fromString(x),q&&g.location.from(q),ie&&p.TestId.fromExtHostTestItem(ie,B).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(k,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:j,coverage:W}),this.proxy.$startedTestRunTask(k,{id:M,name:O,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof _.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.sharedTestIds.has(p.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const k=[],B=this.dto.colllection.root;for(;;){const M=g.TestItem.from(O);if(k.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),O===B))break;O=O.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}}class r{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,k,B){return this.getTracker(O,k,B)}cancelRunById(O){for(const k of this.tracked.values())if(k.id===O){k.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,k,B,M,W){const ee=this.tracked.get(B);if(ee)return ee.createRun(M);const H=n.fromPublic(O,k,B,W),N=s(B);this.proxy.$startedExtensionTestRun({controllerId:O,profile:N&&{group:R[N.kind],id:N.profileId},exclude:B.exclude?.map(x=>p.TestId.fromExtHostTestItem(x,k.root.id).toString())??[],id:H.id,include:B.include?.map(x=>p.TestId.fromExtHostTestItem(x,k.root.id).toString())??[k.root.id],persist:W});const j=this.getTracker(B,H);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),j.createRun(M)}getTracker(O,k,B){const M=new h(k,this.proxy,B);return this.tracked.set(O,M),M.onEnd(()=>this.tracked.delete(O)),M}}e.TestRunCoordinator=r;const s=F=>{if(!!F.profile){if(!(F.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class n{constructor(O,k,B,M,W,ee){this.controllerId=O,this.id=k,this.isPersisted=W,this.colllection=ee,this.includePrefix=B.map(H=>H+"\0"),this.excludePrefix=M.map(H=>H+"\0")}static fromPublic(O,k,B,M){return new n(O,(0,T.generateUuid)(),B.include?.map(W=>p.TestId.fromExtHostTestItem(W,O).toString())??[O],B.exclude?.map(W=>p.TestId.fromExtHostTestItem(W,O).toString())??[],M,k)}static fromInternal(O,k){return new n(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,k)}isIncluded(O){const k=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(k===B||k.startsWith(B))return!1;for(const B of this.includePrefix)if(k===B||k.startsWith(B))return!0;return!1}}e.TestRunDto=n;class t{constructor(O,k,B){this.proxy=O,this.runId=k,this.taskId=B}set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(O,k){const B=await this.fileCoverage;let M=B?.[O];return!this._coverageProvider||!B||!M?[]:(M.detailedCoverage||(M=B[O]=await this._coverageProvider.resolveFileCoverage?.(M,k)??M),M.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class c extends f.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,g.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:k,removed:B}=this;return{get added(){return[...O].map(M=>M.revived)},get updated(){return[...k].map(M=>M.revived)},get removed(){return[...B].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,k){return{...O,revived:g.TestItem.toPlain(O.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=l;class d{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(k=>k.revived)},dispose:(0,C.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class w{constructor(O,k,B,M,W,ee,H,N=!1,j=void 0){this.controllerId=B,this.profileId=M,this._label=W,this.kind=ee,this.runHandler=H,this._isDefault=N,this._tag=j,a.set(this,void 0),m.set(this,void 0),et(this,a,O,"f"),et(this,m,k,"f"),k.set(M,this);const x=R[ee];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${ee}`);Ue(this,a,"f").$publishTestRunProfile({profileId:M,controllerId:B,tag:j?g.TestTag.namespace(this.controllerId,j.id):null,label:W,group:x,isDefault:N,hasConfigurationHandler:!1})}get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?g.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}dispose(){Ue(this,m,"f")?.delete(this.profileId)&&(et(this,m,void 0,"f"),Ue(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=w,a=new WeakMap,m=new WeakMap;const R={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(Ie[257],Te([1,0,16,3,5,133,15,7]),function(Y,e,u,i,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(L,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const T=this._extHostDocumentsAndEditors.allEditors();return L?T:T.map(S=>S.value)}async showTextDocument(L,T,S){let I;typeof T=="number"?I={position:C.ViewColumn.from(T),preserveFocus:S}:typeof T=="object"?I={position:C.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?C.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:I={preserveFocus:!1};const _=await this._proxy.$tryShowTextDocument(L.uri,I),g=_&&this._extHostDocumentsAndEditors.getEditor(_);if(g)return g.value;throw _?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new A.TextEditorDecorationType(this._proxy,L,T).value}$acceptEditorPropertiesChanged(L,T){const S=this._extHostDocumentsAndEditors.getEditor(L);if(!S)throw new Error("unknown text editor");if(T.options&&S._acceptOptions(T.options),T.selections){const I=T.selections.selections.map(C.Selection.to);S._acceptSelections(I)}if(T.visibleRanges){const I=u.coalesce(T.visibleRanges.map(C.Range.to));S._acceptVisibleRanges(I)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...T.options,lineNumbers:C.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const I=D.TextEditorSelectionChangeKind.fromValue(T.selections.source),_=T.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:_,kind:I})}if(T.visibleRanges){const I=u.coalesce(T.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const T in L){const S=this._extHostDocumentsAndEditors.getEditor(T);if(!S)throw new Error("Unknown text editor");const I=C.ViewColumn.to(L[T]);S.value.viewColumn!==I&&(S._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=E}),define(Ie[258],Te([1,0,2,4,5,6,7,15,12]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class P{constructor(S,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===11){const g=_.uri===void 0?void 0:u.URI.revive(_.uri);return this._itemsBySourceAndUriMap.get(_.source)?.get(L(g))?.get(_.handle)}return _}})}async $getTimeline(S,I,_,g){return this._providers.get(S)?.provideTimeline(u.URI.revive(I),_,g)}registerTimelineProvider(S,I,_,g){const v=new A.DisposableStore,p=this.convertTimelineItem(I.id,g,v).bind(this);let b;I.onDidChange&&(b=I.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:I.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:S,onDidChange:void 0,async provideTimeline(a,m,o){m?.resetCache&&(v.clear(),f.get(I.id)?.clear());const h=await I.provideTimeline(a,m,o);if(h==null)return;const r=p(a,m);return{...h,source:I.id,items:h.items.map(r)}},dispose(){for(const a of f.values())a.get(I.id)?.clear();b?.dispose(),v.dispose()}})}convertTimelineItem(S,I,_){return(g,v)=>{let p;if(v?.cacheResults){let b=this._itemsBySourceAndUriMap.get(S);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(S,b));const f=L(g);p=b.get(f),p===void 0&&(p=new Map,b.set(f,p))}return b=>{const{iconPath:f,...a}=b,m=`${S}|${b.id??b.timestamp}`;p?.set(m,b);let o,h,r;b.iconPath&&(f instanceof C.ThemeIcon?r={id:f.id,color:f.color}:u.URI.isUri(f)?(o=f,h=f):{light:o,dark:h}=f);let s;return C.MarkdownString.isMarkdownString(a.tooltip)?s=D.MarkdownString.from(a.tooltip):(0,E.isString)(a.tooltip)?s=a.tooltip:C.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=D.MarkdownString.from(a.detail)):(0,E.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=a.detail),{...a,id:a.id??void 0,handle:m,source:S,command:b.command?I.toInternal(b.command,_):void 0,icon:o,iconDark:h,themeIcon:r,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,A.toDisposable)(()=>{for(const _ of this._itemsBySourceAndUriMap.values())_.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=P;function L(T){return T?.toString()}}),define(Ie[259],Te([1,0,6,10,2,5]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(E){this._openers=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,L,T){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const S=T.schemes.find(I=>!C.supportedSchemes.has(I));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,T.schemes,E,T.label),(0,u.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,L){const T=this._openers.get(E);if(!T)throw new Error(`Unknown opener with id: ${E}`);const S=y.URI.revive(P);return T.canOpenExternalUri(S,L)}async $openUri(E,P,L){const T=this._openers.get(E);if(!T)throw new Error(`Unknown opener id: '${E}'`);return T.openExternalUri(y.URI.revive(P.resolvedUri),{sourceUri:y.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(Ie[260],Te([1,0,5,2,6,11,26]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(C.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const T=D.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(P)),this.handlers.set(T,L),this._proxy.$registerUriHandler(T,P),(0,y.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(P)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(P,L){const T=this.handlers.get(P);if(!T)return Promise.resolve(void 0);try{T.handleUri(i.URI.revive(L))}catch(S){(0,A.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(P){return i.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=D,D.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[72],Te([1,0,3,10,2,189,209,89,5]),function(Y,e,u,i,y,A,C,D,E){"use strict";var P,L,T,S,I,_,g,v,p,b,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,d,w,R,F,O,k){P.set(this,void 0),L.set(this,void 0),T.set(this,void 0),S.set(this,void 0),I.set(this,void 0),_.set(this,void 0),g.set(this,""),v.set(this,void 0),p.set(this,!1),b.set(this,!1),f.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new u.Emitter),this._onDidDispose=Ue(this,a,"f").event,et(this,P,l,"f"),et(this,L,d,"f"),et(this,v,w,"f"),et(this,S,R,"f"),et(this,I,F,"f"),et(this,_,O,"f"),et(this,f,o(O),"f"),et(this,T,k,"f")}dispose(){et(this,p,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return et(this,b,!0,"f"),(0,D.asWebviewUri)(l,Ue(this,S,"f"))}get cspSource(){const l=Ue(this,_,"f").extensionLocation;if(l.scheme===i.Schemas.https||l.scheme===i.Schemas.http){let d=l.toString();return d.endsWith("/")||(d+="/"),d+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,g,"f")}set html(l){this.assertNotDisposed(),Ue(this,g,"f")!==l&&(et(this,g,l,"f"),!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(et(this,b,!0,"f"),Ue(this,T,"f").report("Webview vscode-resource: uris",Ue(this,_,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,P,"f"),l))}get options(){return this.assertNotDisposed(),Ue(this,v,"f")}set options(l){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,P,"f"),s(Ue(this,_,"f"),Ue(this,I,"f"),l)),et(this,v,l,"f")}async postMessage(l){if(Ue(this,p,"f"))return!1;const d=(0,C.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Ue(this,f,"f")});return Ue(this,L,"f").$postMessage(Ue(this,P,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,P=new WeakMap,L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,_=new WeakMap,g=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap;function o(c){try{const l=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class h{constructor(l,d,w,R,F){this.remoteInfo=d,this.workspace=w,this._logService=R,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=l.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(l,d,w){const R=this.getWebview(l);if(R){const{message:F}=(0,C.deserializeWebviewMessage)(d,w.value);R._onMessageEmitter.fire(F)}}$onMissingCsp(l,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,d,w){const R=new m(l,this._webviewProxy,n(d),this.remoteInfo,this.workspace,w,this._deprecationService);return this._webviews.set(l,R),R._onDidDispose(()=>{this._webviews.delete(l)}),R}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=h;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function s(c,l,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||t(c,l)}}e.serializeWebviewOptions=s;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(l=>y.URI.from(l))}}e.reviveOptions=n;function t(c,l){return[...(l?.getWorkspaceFolders()||[]).map(d=>d.uri),c.extensionLocation]}}),define(Ie[261],Te([1,0,21,61,6,10,22,2,15,72,88,5,7]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,h){this.document=o,this._storagePath=h,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,h){await this.getEdit(o).undo(),h||this.disposeBackup()}async redo(o,h){await this.getEdit(o).redo(),h||this.disposeBackup()}disposeEdits(o){for(const h of o)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=a(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const h=this._edits.get(o,0);if(!h)throw new Error("No edit found");return h}}class _{constructor(){this._documents=new Map}get(o,h){return this._documents.get(this.key(o,h))}add(o,h,r){const s=this.key(o,h.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${o} resource:${h.uri}`);const n=new I(h,r);return this._documents.set(s,n),n}delete(o,h){const r=this.key(o,h.uri);this._documents.delete(r)}key(o,h){return`${o}@@@${h}`}}var g;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(g||(g={}));class v{constructor(){this._providers=new Map}addTextProvider(o,h,r){return this.add(0,o,h,r)}addCustomProvider(o,h,r){return this.add(1,o,h,r)}get(o){return this._providers.get(o)}add(o,h,r,s){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:o,extension:r,provider:s}),new S.Disposable(()=>this._providers.delete(h))}}class p{constructor(o,h,r,s,n){this._extHostDocuments=h,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new v,this._documents=new _,this._proxy=o.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,h,r,s){const n=new y.DisposableStore;return b(r)?(n.add(this._editorProviders.addTextProvider(h,o,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(o),h,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(h,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(h,t.document.uri);if(f(t)){const l=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,h,l,t.label)}else this._proxy.$onContentChange(t.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(o),h,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(n,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(o,h,r,s,n){const t=this._editorProviders.get(h);if(!t)throw new Error(`No provider found for '${h}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${h}'`);const c=D.URI.revive(o),l=await t.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:s?.buffer},n);let d;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(h,l,d),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,h){const r=this._editorProviders.get(h);if(!r)throw new Error(`No provider found for '${h}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${h}'`);const s=D.URI.revive(o),{document:n}=this.getCustomDocumentEntry(h,s);this._documents.delete(h,n),n.dispose()}async $resolveWebviewEditor(o,h,r,s,n,t){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const l=E.ViewColumn.to(n),d=this._extHostWebview.createNewWebview(h,s.webviewOptions,c.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(h,r,s.title,l,s.panelOptions,d,!0),R=D.URI.revive(o);switch(c.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,R);return c.provider.resolveCustomEditor(F,w,t)}case 0:{const F=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(F,w,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,h,r){this.getCustomDocumentEntry(h,o).disposeEdits(r)}async $onMoveCustomEditor(o,h,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const t=D.URI.revive(h),c=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(c,n,u.CancellationToken.None)}async $undo(o,h,r,s){return this.getCustomDocumentEntry(h,o).undo(r,s)}async $redo(o,h,r,s){return this.getCustomDocumentEntry(h,o).redo(r,s)}async $revert(o,h,r){const s=this.getCustomDocumentEntry(h,o);await this.getCustomEditorProvider(h).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(o,h,r){const s=this.getCustomDocumentEntry(h,o);await this.getCustomEditorProvider(h).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(o,h,r,s){const n=this.getCustomDocumentEntry(h,o);return this.getCustomEditorProvider(h).saveCustomDocumentAs(n.document,D.URI.revive(r),s)}async $backup(o,h,r){const s=this.getCustomDocumentEntry(h,o),t=await this.getCustomEditorProvider(h).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(o,h){const r=this._documents.get(o,D.URI.revive(h));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function b(m){return typeof m.resolveCustomTextEditor=="function"}function f(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function a(m){const o=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,i.hash)(o)+""}});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[262],Te([1,0,3,6,2,35,15,72,5,7]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";var L,T,S,I,_,g,v,p,b,f,a,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends i.Disposable{constructor(t,c,l,d){super();L.set(this,void 0),T.set(this,void 0),S.set(this,void 0),I.set(this,void 0),_.set(this,void 0),g.set(this,void 0),v.set(this,void 0),p.set(this,void 0),b.set(this,!0),f.set(this,void 0),a.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Ue(this,m,"f").event,o.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Ue(this,o,"f").event,et(this,L,t,"f"),et(this,T,c,"f"),et(this,I,l,"f"),et(this,S,d.viewType,"f"),et(this,_,d.panelOptions,"f"),et(this,p,d.viewColumn,"f"),et(this,g,d.title,"f"),et(this,f,d.active,"f")}dispose(){Ue(this,a,"f")||(et(this,a,!0,"f"),Ue(this,m,"f").fire(),Ue(this,T,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,I,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(t){this.assertNotDisposed(),Ue(this,g,"f")!==t&&(et(this,g,t,"f"),Ue(this,T,"f").$setTitle(Ue(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(t){this.assertNotDisposed(),Ue(this,v,"f")!==t&&(et(this,v,t,"f"),Ue(this,T,"f").$setIconPath(Ue(this,L,"f"),y.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ue(this,_,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,p,"f")=="number"&&Ue(this,p,"f")<0))return Ue(this,p,"f")}get active(){return this.assertNotDisposed(),Ue(this,f,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(t){Ue(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(et(this,f,t.active,"f"),et(this,b,t.visible,"f"),et(this,p,t.viewColumn,"f"),Ue(this,o,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Ue(this,T,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,_=new WeakMap,g=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap,m=new WeakMap,o=new WeakMap;class r{constructor(t,c,l){this.webviews=c,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(t,c,l,d,w={}){const R=typeof d=="object"?d.viewColumn:d,F={viewColumn:C.ViewColumn.from(R),preserveFocus:typeof d=="object"&&!!d.preserveFocus},O=(0,D.shouldSerializeBuffersForPostMessage)(t),k=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(t),k,c,{title:l,panelOptions:s(w),webviewOptions:(0,D.serializeWebviewOptions)(t,this.workspace,w),serializeBuffersForPostMessage:O},F);const B=this.webviews.createNewWebview(k,w,t);return this.createNewWebviewPanel(k,c,l,R,w,B,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((l,d)=>{const w=t[l],R=t[d];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const l of c){const d=this.getWebviewPanel(l);if(!d)continue;const w=t[l];d._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,l){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:l,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,l,d){const w=this._serializers.get(c);if(!w)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:F}=w,O=this.webviews.createNewWebview(t,l.webviewOptions,F),k=this.createNewWebviewPanel(t,c,l.title,d,l.panelOptions,O,l.active);await R.deserializeWebviewPanel(k,l.state)}createNewWebviewPanel(t,c,l,d,w,R,F){const O=new h(t,this._proxy,R,{viewType:c,title:l,viewColumn:d,panelOptions:w,active:F});return this._webviewPanels.set(t,O),O}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[263],Te([1,0,3,6,72,28,15,5,7]),function(Y,e,u,i,y,A,C,D,E){"use strict";var P,L,T,S,I,_,g,v,p,b,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends i.Disposable{constructor(r,s,n,t,c,l,d){super();P.set(this,void 0),L.set(this,void 0),T.set(this,void 0),S.set(this,void 0),I.set(this,void 0),_.set(this,!1),g.set(this,void 0),v.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidDispose=Ue(this,a,"f").event,et(this,T,n,"f"),et(this,v,t,"f"),et(this,P,r,"f"),et(this,L,s,"f"),et(this,S,c,"f"),et(this,I,l,"f"),et(this,g,d,"f")}dispose(){Ue(this,_,"f")||(et(this,_,!0,"f"),Ue(this,a,"f").fire(),Ue(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,v,"f")}set title(r){this.assertNotDisposed(),Ue(this,v,"f")!==r&&(et(this,v,r,"f"),Ue(this,L,"f").$setWebviewViewTitle(Ue(this,P,"f"),r))}get description(){return this.assertNotDisposed(),Ue(this,p,"f")}set description(r){this.assertNotDisposed(),Ue(this,p,"f")!==r&&(et(this,p,r,"f"),Ue(this,L,"f").$setWebviewViewDescription(Ue(this,P,"f"),r))}get visible(){return Ue(this,g,"f")}get webview(){return Ue(this,S,"f")}get viewType(){return Ue(this,T,"f")}_setVisible(r){r===Ue(this,g,"f")||Ue(this,_,"f")||(et(this,g,r,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,I,"f"),"badges"),Ue(this,b,"f")}set badge(r){this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,I,"f"),"badges"),!(r?.value===Ue(this,b,"f")?.value&&r?.tooltip===Ue(this,b,"f")?.tooltip)&&(et(this,b,C.ViewBadge.from(r),"f"),Ue(this,L,"f").$setWebviewViewBadge(Ue(this,P,"f"),r))}show(r){this.assertNotDisposed(),Ue(this,L,"f").$show(Ue(this,P,"f"),!!r)}assertNotDisposed(){if(Ue(this,_,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,_=new WeakMap,g=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,a=new WeakMap;class o{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new E.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,n,t,c){const l=this._viewProviders.get(s);if(!l)throw new Error(`No view provider found for '${s}'`);const{provider:d,extension:w}=l,R=this._extHostWebview.createNewWebview(r,{},w),F=new m(r,this._proxy,s,n,R,w,!0);this._webviewViews.set(r,F),await d.resolveWebviewView(F,{state:t},c)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=o}),define(Ie[137],Te([1,0,3,5,2,10,8,4,18]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Qi{constructor(T){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Qi.InitialState,this._proxy=T.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,S){let I;if(typeof T=="string"){I=T;try{T=y.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,C.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,I,S)}async asExternalUri(T,S){if((0,C.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(T,S);return y.URI.from(I)}};P.InitialState={focused:!0},P=je([xe(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(Ie[264],Te([1,0,9,64,35,37,6,5,2,18]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(S,I){super();const _=S.getProxy(D.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async g=>{const v=E.URI.file((0,u.join)((0,i.tmpdir)(),(0,y.generateUuid)()));return await _.$download(g,v),v})}};L=je([xe(0,P.IExtHostRpcService),xe(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ie[265],Te([1,0,136,10,195,35]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends u.ExtHostLoggerService{doCreateLogger(E,P,L){return E.scheme===i.Schemas.file?new y.SpdLogLogger(L?.name||(0,A.generateUuid)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(E,P,L)}}e.ExtHostLoggerService=C}),define(Ie[266],Te([1,0,63,9,2,71,6,10,17,29]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const h=await super._getWorkspaceStorageURI(o);if(h.scheme!==D.Schemas.file)return h;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const r=h.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await T(n);const t=i.join(n,"vscode.lock"),c=await g(this._logService,t,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(n);s++}while(s<10);return h}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(m){try{await P.Promises.stat(m);return}catch{}try{await P.Promises.mkdir(m,{recursive:!0})}catch{}}const S=1e3,I=10*60*1e3;class _ extends C.Disposable{constructor(o,h){super();this.logService=o,this.filename=h,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(o,h);(!r||r.pid!==process.pid)&&(o.info(`Lock '${h}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(h,new Date,new Date)}catch(s){o.error(s),o.info(`Lock '${h}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+o};await P.Promises.writeFile(this.filename,JSON.stringify(h),{flag:"w"})}catch(h){this.logService.error(h)}}}async function g(m,o,h){try{const s={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(o,JSON.stringify(s),{flag:"wx"})}catch(s){m.error(s)}const r=await v(m,o);return!r||r.pid!==process.pid?h?(m.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),f(m,o)):(m.info(`Lock '${o}': Lock acquired.`),new _(m,o))}async function v(m,o){let h;try{h=await P.Promises.readFile(o)}catch(r){return m.error(r),null}try{return JSON.parse(String(h))}catch(r){return m.error(r),null}}async function p(m,o){let h;try{h=await P.Promises.stat(o)}catch(r){return m.error(r),0}return h.mtime.getTime()}function b(m){try{return process.kill(m,0),!0}catch{return!1}}async function f(m,o){const h=await v(m,o);if(!h)return m.info(`Lock '${o}': Could not read pid of lock holder.`),a(m,o);if(h.willReleaseAt){let c=h.willReleaseAt-Date.now();if(c<5e3){for(c>0?m.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):m.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,E.timeout)(Math.min(100,c)),await p(m,o)===0)return a(m,o);c=h.willReleaseAt-Date.now()}return a(m,o)}}if(!b(h.pid))return m.info(`Lock '${o}': The pid ${h.pid} appears to be gone.`),a(m,o);const r=await p(m,o),s=Date.now()-r;if(s<=I)return m.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;m.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const n=await p(m,o),t=Date.now()-n;return t<=I?(m.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),a(m,o))}async function a(m,o){m.info(`Lock '${o}': Deleting a stale lock.`);try{await P.Promises.unlink(o)}catch{}return g(m,o,!0)}}),define(Ie[267],Te([1,0,35,18,38]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends y.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,E,P){return this.createTerminalFromOptions({name:D,shellPath:E,shellArgs:P})}createTerminalFromOptions(D,E){const P=new y.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),D,D.name);return this._terminals.push(P),P.create(D,this._serializeParentTerminal(D,E)),P.value}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Ie[268],Te([1,0,5,18,178,6,27,2,42,22,29,7,13,53,3,123,94,14]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(l,d,w){this.remoteAddress=l,this.localAddress=d,this._dispose=w,this._onDispose=new _.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function f(c){const l=c.trim().split(`
`),d=[];return l.forEach(R=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);F&&F.length>=3&&d.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),d.reduce((R,F)=>(R[F.socket]=F,R),{})}e.getSockets=f;function a(...c){const l=[].concat(...c.map(o));return[...new Map(l.filter(d=>d.st==="0A").map(d=>{const w=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:m(w[0]),port:parseInt(w[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=a;function m(c){let l="";if(c.length===8)for(let d=c.length-2;d>=0;d-=2)l+=parseInt(c.substr(d,2),16),d!==0&&(l+=".");else for(let d=c.length-4;d>=0;d-=4)l+=parseInt(c.substr(d,4),16).toString(16),d!==0&&(l+=":");return l}e.parseIpAddress=m;function o(c){const l=c.trim().split(`
`),d=l.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return l.map(R=>R.trim().split(/\s+/).reduce((F,O,k)=>(F[d[k]||k]=O,F),{}))}e.loadConnectionTable=o;function h(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const l=c.trim().split(`
`),d=[];return l.forEach(w=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);R&&R.length>=4&&d.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),d}e.getRootProcesses=r;async function s(c,l,d){const w=d.reduce((F,O)=>(F[O.pid]=O,F),{}),R=[];return c.forEach(({socket:F,ip:O,port:k})=>{const B=l[F]?l[F].pid:void 0,M=B?w[B]?.cmd:void 0;B&&M&&!h(M)&&R.push({host:O,port:k,detail:M,pid:B})}),R}e.findPorts=s;function n(c,l,d){const w=new Map,R=r(l);for(const F of c){const O=d.get(F.port);if(O){w.set(F.port,O);continue}const k=R.find(B=>B.cmd.includes(`${F.port}`));if(k){let B=k,M;do M=R.find(W=>W.ppid===B.pid),M&&(B=M);while(M);w.set(F.port,{host:F.ip,port:F.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=n;let t=class extends A.Disposable{constructor(l,d,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new _.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),S.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(d,l.displayName);if(w){const R=new b(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,d){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:l,provider:d}),this._proxy.$registerPortsAttributesProvider(l,w),new T.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(l,d,w,R,F){const O=[];for(const B of l){const M=this._portAttributesProviders.get(B);if(!M)return[];O.push(...await Promise.all(d.map(async W=>M.provider.providePortAttributes(W,w,R,F))))}const k=O.filter(B=>!!B);return k.length>0?k.map(B=>({autoForwardAction:B.autoForwardAction,port:B.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;let d=new v.MovingAverage,w;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),F=(await this.findCandidatePorts()).filter(k=>(0,g.isLocalhost)(k.host)||(0,g.isAllInterfaces)(k.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(k=>k.port).join(", ")}`);const O=new Date().getTime()-R;d.update(O),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this._proxy.$onFoundNewCandidates(w)),await new Promise(k=>setTimeout(()=>k(),this.calculateDelay(d.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let d=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]);const w=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:d}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,d){if(this._extensionTunnels.has(l.host)){const w=this._extensionTunnels.get(l.host);w.has(l.port)&&(d&&w.get(l.port).disposeListener.dispose(),await w.get(l.port).tunnel.dispose(),w.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(l,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const R=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const F=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:R,disposeListener:F}),I.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const d=await Promise.all(l.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),w=l.filter((R,F)=>d[F]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(R=>R.port).join(", ")} to ${w.map(R=>R.port).join(", ")}`),w}async findCandidatePorts(){let l="",d="";try{l=await L.Promises.readFile("/proc/net/tcp","utf8"),d=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=a(l,d),R=await new Promise(H=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,j,x)=>{H(j)})}),F=f(R),O=await L.Promises.readdir("/proc"),k=[];for(let H of O)try{const N=Number(H),j=P.joinPath(D.URI.file("/proc"),H);if((await L.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(N)){const q=await L.Promises.readlink(P.joinPath(j,"cwd").fsPath),ie=await L.Promises.readFile(P.joinPath(j,"cmdline").fsPath,"utf8");k.push({pid:N,cwd:q,cmd:ie})}}catch{}const B=[],M=w.filter(H=>{const N=F[H.socket];return N||B.push(H),N}),W=s(M,F,k);let ee;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const H=await new Promise(N=>{(0,E.exec)("ps -F -A -l | grep root",(j,x,q)=>{N(x)})});this._foundRootPorts=n(B,H,this._foundRootPorts),ee=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ee.join(", ")}`)}return W.then(H=>ee?H.concat(ee):H)}};t=je([xe(0,i.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,p.ILogService)],t),e.ExtHostTunnelService=t}),define(Ie[269],Te([1,0,17,23,21,11,3,6,104,232,54]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(w,R){try{return JSON.stringify(w,R)}catch{return"null"}}const I="$$ref$$",_={[I]:-1};class g{constructor(R,F){this.jsonString=R,this.referencedBuffers=F}}function v(w,R=null,F=!1){const O=[];return{jsonString:(F?S:JSON.stringify)(w,(B,M)=>{if(typeof M=="undefined")return _;if(typeof M=="object"){if(M instanceof i.VSBuffer){const W=O.push(M)-1;return{[I]:W}}if(R)return R(B,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=v;function p(w,R,F){return JSON.parse(w,(O,k)=>{if(k){const B=k[I];if(typeof B=="number")return R[B];if(F&&k.$mid===1)return F.transformIncoming(k)}return k})}e.parseJsonAndRestoreBufferRefs=p;function b(w,R){return JSON.stringify(w,R)}function f(w){return w?(R,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var a;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends D.Disposable{constructor(R,F=null,O=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=F,this._uriTransformer=O,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let k=0,B=L.ProxyIdentifier.count;k<B;k++)this._locals[k]=null,this._proxies[k]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(k=>this._receiveOneMessage(k))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,E.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:F,sid:O}=R;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,O)),this._proxies[F]}_createProxy(R,F){let O={get:(k,B)=>(typeof B=="string"&&!k[B]&&B.charCodeAt(0)===36&&(k[B]=(...M)=>this._remoteCall(R,B,M)),B===r?F:k[B])};return new Proxy(Object.create(null),O)}set(R,F){return this._locals[R.nid]=F,F}assertRegistered(R){for(let F=0,O=R.length;F<O;F++){const k=R[F];if(!this._locals[k.nid])throw new Error(`Missing proxy instance ${k.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const F=R.byteLength,O=n.read(R,0),k=O.readUInt8(),B=O.readUInt32();switch(k){case 1:case 2:{let{rpcId:M,method:W,args:ee}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&(ee=(0,E.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(F,B,M,W,ee,k===2);break}case 3:case 4:{let{rpcId:M,method:W,args:ee}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&(ee=(0,E.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(F,B,M,W,ee,k===4);break}case 5:{this._logger&&this._logger.logIncoming(F,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(F,B);break}case 7:{this._receiveReply(F,B,void 0);break}case 9:{let M=c.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,E.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(F,B,M);break}case 10:{const M=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(F,B,M);break}case 8:{let M=c.deserializeReplyOKVSBuffer(O);this._receiveReply(F,B,M);break}case 11:{let M=c.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,E.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(F,B,M);break}case 12:{this._receiveReplyErr(F,B,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,F,O,k,B,M){this._logger&&this._logger.logIncoming(R,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(O)}.${k}(`,B);const W=String(F);let ee,H;if(M){const j=new y.CancellationTokenSource;B.push(j.token),ee=this._invokeHandler(O,k,B),H=()=>j.cancel()}else ee=this._invokeHandler(O,k,B),H=o;this._cancelInvokedHandlers[W]=H;const N=c.serializeAcknowledged(F);this._logger&&this._logger.logOutgoing(N.byteLength,F,1,"ack"),this._protocol.send(N),ee.then(j=>{delete this._cancelInvokedHandlers[W];const x=c.serializeReplyOK(F,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,F,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[W];const x=c.serializeReplyErr(F,j);this._logger&&this._logger.logOutgoing(x.byteLength,F,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(R,F){this._logger&&this._logger.logIncoming(R,F,1,"receiveCancel");const O=String(F);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(R,F,O){this._logger&&this._logger.logIncoming(R,F,0,"receiveReply:",O);const k=String(F);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const B=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],B.resolveOk(O)}_receiveReplyErr(R,F,O){this._logger&&this._logger.logIncoming(R,F,0,"receiveReplyErr:",O);const k=String(F);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const B=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),B.resolveErr(M)}_invokeHandler(R,F,O){try{return Promise.resolve(this._doInvokeHandler(R,F,O))}catch(k){return Promise.reject(k)}}_doInvokeHandler(R,F,O){const k=this._locals[R];if(!k)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));let B=k[F];if(typeof B!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(R));return B.apply(k,O)}_remoteCall(R,F,O){if(this._isDisposed)return Promise.reject(A.canceled());let k=null;if(O.length>0&&y.CancellationToken.isCancellationToken(O[O.length-1])&&(k=O.pop()),k&&k.isCancellationRequested)return Promise.reject(A.canceled());const B=c.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,W=String(M),ee=new P.LazyPromise;k&&k.onCancellationRequested(()=>{const N=c.serializeCancel(M);this._logger&&this._logger.logOutgoing(N.byteLength,M,0,"cancel"),this._protocol.send(c.serializeCancel(M))}),this._pendingRPCReplies[W]=ee,this._onWillSendRequest(M);const H=c.serializeRequest(M,R,F,B,!!k);return this._logger&&this._logger.logOutgoing(H.byteLength,M,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${F}(`,O),this._protocol.send(H),ee}}e.RPCProtocol=s,T=h,s.UNRESPONSIVE_TIME=3*1e3;class n{constructor(R,F){this._buff=R,this._offset=F}static alloc(R,F,O){let k=new n(i.VSBuffer.alloc(O+1+4),0);return k.writeUInt8(R),k.writeUInt32(F),k}static read(R,F){return new n(R,F)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,F}static sizeMixedArray(R){let F=0;F+=1;for(let O=0,k=R.length;O<k;O++){const B=R[O];switch(F+=1,B.type){case 1:F+=this.sizeLongString(B.value);break;case 2:F+=this.sizeVSBuffer(B.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(B.value);for(let M=0;M<B.buffers.length;++M)F+=this.sizeVSBuffer(B.buffers[M]);break;case 4:break}}return F}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let F=0,O=R.length;F<O;F++){const k=R[F];switch(k.type){case 1:this.writeUInt8(1),this.writeLongString(k.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(k.value);break;case 3:this.writeUInt8(3),this.writeUInt32(k.buffers.length),this.writeLongString(k.value);for(let B=0;B<k.buffers.length;++B)this.writeBuffer(k.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let F=new Array(R);for(let O=0;O<R;O++)switch(this.readUInt8()){case 1:F[O]=this.readLongString();break;case 2:F[O]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),M=this.readLongString(),W=[];for(let ee=0;ee<B;++ee)W.push(this.readVSBuffer());F[O]=new L.SerializableObjectWithBuffers(p(M,W,null));break}case 4:F[O]=void 0;break}return F}}n.sizeUInt32=4;var t;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(R){for(let F=0,O=R.length;F<O;F++)if(R[F]instanceof i.VSBuffer||R[F]instanceof L.SerializableObjectWithBuffers||typeof R[F]=="undefined")return!0;return!1}static serializeRequestArguments(R,F){if(this._useMixedArgSerialization(R)){const O=[];for(let k=0,B=R.length;k<B;k++){const M=R[k];if(M instanceof i.VSBuffer)O[k]={type:2,value:M};else if(typeof M=="undefined")O[k]={type:4};else if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:ee}=v(M.value,F);O[k]={type:3,value:i.VSBuffer.fromString(W),buffers:ee}}else O[k]={type:1,value:i.VSBuffer.fromString(b(M,F))}}return{type:1,args:O}}return{type:0,args:b(R,F)}}static serializeRequest(R,F,O,k,B){switch(k.type){case 0:return this._requestJSONArgs(R,F,O,k.args,B);case 1:return this._requestMixedArgs(R,F,O,k.args,B)}}static _requestJSONArgs(R,F,O,k,B){const M=i.VSBuffer.fromString(O),W=i.VSBuffer.fromString(k);let ee=0;ee+=n.sizeUInt8(),ee+=n.sizeShortString(M),ee+=n.sizeLongString(W);let H=n.alloc(B?2:1,R,ee);return H.writeUInt8(F),H.writeShortString(M),H.writeLongString(W),H.buffer}static deserializeRequestJSONArgs(R){const F=R.readUInt8(),O=R.readShortString(),k=R.readLongString();return{rpcId:F,method:O,args:JSON.parse(k)}}static _requestMixedArgs(R,F,O,k,B){const M=i.VSBuffer.fromString(O);let W=0;W+=n.sizeUInt8(),W+=n.sizeShortString(M),W+=n.sizeMixedArray(k);let ee=n.alloc(B?4:3,R,W);return ee.writeUInt8(F),ee.writeShortString(M),ee.writeMixedArray(k),ee.buffer}static deserializeRequestMixedArgs(R){const F=R.readUInt8(),O=R.readShortString(),k=R.readMixedArray(),B=new Array(k.length);for(let M=0,W=k.length;M<W;M++){const ee=k[M];typeof ee=="string"?B[M]=JSON.parse(ee):B[M]=ee}return{rpcId:F,method:O,args:B}}static serializeAcknowledged(R){return n.alloc(5,R,0).buffer}static serializeCancel(R){return n.alloc(6,R,0).buffer}static serializeReplyOK(R,F,O){if(typeof F=="undefined")return this._serializeReplyOKEmpty(R);if(F instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(R,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:k,referencedBuffers:B}=v(F.value,O,!0);return this._serializeReplyOKJSONWithBuffers(R,k,B)}else return this._serializeReplyOKJSON(R,S(F,O))}static _serializeReplyOKEmpty(R){return n.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,F){let O=0;O+=n.sizeVSBuffer(F);let k=n.alloc(8,R,O);return k.writeVSBuffer(F),k.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,F){const O=i.VSBuffer.fromString(F);let k=0;k+=n.sizeLongString(O);let B=n.alloc(9,R,k);return B.writeLongString(O),B.buffer}static _serializeReplyOKJSONWithBuffers(R,F,O){const k=i.VSBuffer.fromString(F);let B=0;B+=n.sizeUInt32,B+=n.sizeLongString(k);for(const W of O)B+=n.sizeVSBuffer(W);let M=n.alloc(10,R,B);M.writeUInt32(O.length),M.writeLongString(k);for(const W of O)M.writeBuffer(W);return M.buffer}static deserializeReplyOKJSON(R){const F=R.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(R,F){const O=R.readUInt32(),k=R.readLongString(),B=[];for(let M=0;M<O;++M)B.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(p(k,B,F))}static serializeReplyErr(R,F){const O=F?S(A.transformErrorForSerialization(F),null):void 0;if(typeof O!="string")return this._serializeReplyErrEmpty(R);const k=i.VSBuffer.fromString(O);let B=0;B+=n.sizeLongString(k);let M=n.alloc(11,R,B);return M.writeLongString(k),M.buffer}static deserializeReplyErrError(R){const F=R.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(R){return n.alloc(12,R,0).buffer}}var l;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var d;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(d||(d={}))}),define(Ie[270],Te([1,0,3,44,52,4,43,11,17]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(_){this.channels.has(_.id)||(this.channels.set(_.id,_),this._onDidRegisterChannel.fire(_.id))}getChannels(){const _=[];return this.channels.forEach(g=>_.push(g)),_}getChannel(_){return this.channels.get(_)}removeChannel(_){this.channels.delete(_),this._onDidRemoveChannel.fire(_)}}i.Registry.add(e.Extensions.OutputChannels,new L);function T(I,_,g,v,p){return(0,E.createCancelablePromise)(async b=>{await(0,C.whenProviderRegistered)(g,v);const f=i.Registry.as(e.Extensions.OutputChannels);try{await S(g,1,v,p,b),f.registerChannel({id:I,label:_,file:g,log:!0})}catch(a){(0,D.isCancellationError)(a)||p.error("Error while registering log channel",g.toString(),(0,D.getErrorMessage)(a))}})}e.registerLogChannel=T;async function S(I,_,g,v,p){if(!await g.exists(I)){if(p.isCancellationRequested)throw new D.CancellationError;if(_>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,E.timeout)(1e3,p),await S(I,_+1,g,v,p)}}}),define(Ie[138],Te([1,0,5,6,4,18,14,270,70,27,46,159,23,12]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class _ extends i.Disposable{constructor(p,b,f,a){super();this.id=p,this.name=b,this.logger=f,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,p)}replace(p){const b=this.offset;this.write(p),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,b),this.visible&&this.logger.flush()}show(p,b){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:b))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=S.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=_;let g=class{constructor(p,b,f,a,m){this.extHostFileSystem=f,this.extHostFileSystemInfo=a,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(b.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[b,f]of this.channels)f.visible=b===this.visibleChannelId}createOutputChannel(p,b,f){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");if((0,I.isString)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(p,b,f);return a.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,a)}async doCreateOutputChannel(p,b,f){const a=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.proxy.$register(p,!1,m,b,f.identifier.value);return new _(h,p,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,b){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return p},append(m){a(),b.then(o=>o.append(m))},appendLine(m){a(),b.then(o=>o.appendLine(m))},clear(){a(),b.then(m=>m.clear())},replace(m){a(),b.then(o=>o.replace(m))},show(m,o){a(),b.then(h=>h.show(m,o))},hide(){a(),b.then(m=>m.hide())},dispose(){f=!0,b.then(m=>m.dispose())}}}};g=je([xe(0,A.IExtHostRpcService),xe(1,P.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,L.IExtHostFileSystemInfo),xe(4,C.ILoggerService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(Ie[271],Te([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(Ie[272],Te([1,0,30,10,9,13,22,2,4,204,45,224,271]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let I=class Yi{constructor(g,v,p,b){this.localUserHome=g,this.remoteAgentService=v,this.environmentService=p,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??g})()}hasValidBasename(g,v,p){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(b=>this.doHasValidBasename(g,b,v)):this.doHasValidBasename(g,v,p)}doHasValidBasename(g,v,p){return g.scheme===i.Schemas.file||g.scheme===i.Schemas.vscodeRemote?(0,u.isValidBasename)(p??(0,C.basename)(g),v===1):!0}get defaultUriScheme(){return Yi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,v){if(g.remoteAuthority)return i.Schemas.vscodeRemote;const p=(0,P.getVirtualWorkspaceScheme)(v.getWorkspace());if(p)return p;const b=v.getWorkspace().folders[0];if(b)return b.uri.scheme;const f=v.getWorkspace().configuration;return f?f.scheme:i.Schemas.file}userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?y.win32:y.posix)}async fileURI(g){let v="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const b=g.indexOf("/",2);b===-1?(v=g.substring(2),g="/"):(v=g.substring(2,b),g=g.substring(b)||"/")}return D.URI.from({scheme:i.Schemas.file,authority:v,path:g,query:"",fragment:""})}};I=je([xe(1,S.IRemoteAgentService),xe(2,T.IWorkbenchEnvironmentService),xe(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Ie[73],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(C,D){this.line=C,this.character=D}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,D){return new u(0,0)}with(C){return new u(0,0)}}e.Position=u;class i{constructor(C,D,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(C,D),this.end=new u(E,P)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new i(0,0,0,0)}with(C){return new i(0,0,0,0)}}e.Range=i;var y;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],Te([1,0,16,34,24,30,8,4,9,11,73,17]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",I=" characters skipped \u27EB",_=(S.length+I.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var g;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function p(q){return!!q.preview}e.resultIsMatch=p;function b(q){return!!q.resource}e.isFileMatch=b;function f(q){return!!q.message}e.isProgressMessage=f;var a;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=m;class o{constructor(ie,Q,de){this.ranges=Q;const ue=Array.isArray(Q)?Q:[Q];if(de&&de.matchLines===1&&h(ue)){ie=(0,C.getNLines)(ie,de.matchLines);let X="",ge=0,Se=0;const oe=Math.floor(de.charsPerLine/5),_e=[];for(const Pe of ue){const pe=Math.max(Pe.startColumn-oe,0),ve=Pe.startColumn+de.charsPerLine;if(pe>Se+oe+_){const Ae=S+(pe-Se)+I;X+=Ae+ie.slice(pe,ve),ge+=pe-(Se+Ae.length)}else X+=ie.slice(Se,ve);_e.push(new s(0,Pe.startColumn-ge,Pe.endColumn-ge)),Se=ve}this.preview={text:X,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const X=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:ie,matches:(0,u.mapArrayOrNot)(Q,ge=>new r(ge.startLineNumber-X,ge.startColumn,ge.endLineNumber-X,ge.endColumn))}}}}e.TextSearchMatch=o;function h(q){const ie=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==ie||Q.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,Q,de,ue){this.startLineNumber=ie,this.startColumn=Q,this.endLineNumber=de,this.endColumn=ue}}e.SearchRange=r;class s extends r{constructor(ie,Q,de){super(ie,Q,ie,de)}}e.OneLineRange=s;var n;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(q,ie=!0){const Q=q&&q.files&&q.files.exclude,de=ie&&q&&q.search&&q.search.exclude;if(!Q&&!de)return;if(!Q||!de)return Q||de;let ue=Object.create(null);return ue=y.mixin(ue,y.deepClone(Q)),ue=y.mixin(ue,y.deepClone(de),!0),ue}e.getExcludes=t;function c(q,ie){return q.excludePattern&&i.match(q.excludePattern,ie)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&i.match(q.includePattern,ie)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const de=Q.folder.fsPath;if(A.isEqualOrParent(ie,de)){const ue=E.relative(de,ie);return!Q.includePattern||!!i.match(Q.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var l;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(ie,Q){super(ie);this.code=Q}}e.SearchError=d;function w(q){const ie=q.message;if((0,P.isCancellationError)(q))return new d(ie,l.canceled);try{const Q=JSON.parse(ie);return new d(Q.message,Q.code)}catch{return new d(ie,l.other)}}e.deserializeSearchError=w;function R(q){const ie={message:q.message,code:q.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=R;function F(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=F;function O(q){return q.type==="success"}e.isSerializedSearchSuccess=O;function k(q){return!!q.path}e.isSerializedFileMatch=k;function B(q,ie){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,C.fuzzyContains)(Q,ie)}e.isFilePatternMatch=B;class M{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function W(q,ie){const Q={...q||{},...ie||{}};return Object.keys(Q).filter(de=>{const ue=Q[de];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=W;class ee{constructor(ie,Q){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let de=ie.includePattern;Q.includePattern&&(de?de={...de,...Q.includePattern}:de=Q.includePattern),de&&(this._parsedIncludeExpression=i.parse(de))}matchesExcludesSync(ie,Q,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,de))}includedInQuerySync(ie,Q,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,Q,de))}includedInQuery(ie,Q,de){const ue=this._parsedExcludeExpression(ie,Q,de),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,Q,de):!0;return(0,T.isThenable)(ue)?ue.then(ge=>ge?!1:X()):X()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=ee;function H(q){for(const ie in q)if(typeof q[ie]!="boolean")return!0;return!1}function N(q){if(!q)return;let ie;return Q=>(ie||(ie=(q()||Promise.resolve([])).then(de=>de?x(de):{})),ie.then(de=>!!de[Q]))}e.hasSiblingPromiseFn=N;function j(q){if(!q)return;let ie;return Q=>{if(!ie){const de=q();ie=de?x(de):{}}return!!ie[Q]}}e.hasSiblingFn=j;function x(q){const ie={};for(const Q of q)ie[Q]=!0;return ie}}),define(Ie[32],Te([1,0,16,17,21,3,25,10,94,22,8,12,2,176,4,14,196,45,46,27,18,15,7,31,5]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m,o,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,O,k){return new P.ExtUri(B=>l(B,k)).isEqual(F,O)}function n(F,O,k){return s(F.uri,O.uri,k)?0:(0,L.compare)(F.uri.toString(),O.uri.toString())}function t(F,O,k){return F.index!==O.index?F.index<O.index?-1:1:s(F.uri,O.uri,k)?(0,L.compare)(F.name,O.name):(0,L.compare)(F.uri.toString(),O.uri.toString())}function c(F,O,k,B){const M=F.slice(0).sort((ee,H)=>k(ee,H,B)),W=O.slice(0).sort((ee,H)=>k(ee,H,B));return(0,u.delta)(M,W,(ee,H)=>k(ee,H,B))}function l(F,O){const k=O.getCapabilities(F.scheme);return!(k&&k&1024)}class d extends p.Workspace{constructor(O,k,B,M,W,ee,H){super(O,B.map(N=>new p.WorkspaceFolder(N)),M,W,H);this._name=k,this._isUntitled=ee,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(H),B.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(O,k,B,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:W,name:ee,folders:H,configuration:N,transient:j,isUntitled:x}=O,q=[],ie=k;k?H.forEach((X,ge)=>{const Se=S.URI.revive(X.uri),oe=d._findFolder(B||k,Se,M);oe?(oe.name=X.name,oe.index=X.index,q.push(oe)):q.push({uri:Se,name:X.name,index:ge})}):q.push(...H.map(({uri:X,name:ge,index:Se})=>({uri:S.URI.revive(X),name:ge,index:Se}))),q.sort((X,ge)=>X.index<ge.index?-1:1);const Q=new d(W,ee,q,!!j,N?S.URI.revive(N):null,!!x,X=>l(X,M)),{added:de,removed:ue}=c(ie?ie.workspaceFolders:[],Q.workspaceFolders,n,M);return{workspace:Q,added:de,removed:ue}}static _findFolder(O,k,B){for(let M=0;M<O.folders.length;M++){const W=O.workspaceFolders[M];if(s(W.uri,k,B))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,k){return k&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let w=class{constructor(O,k,B,M){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=B,this._requestIdProvider=new E.Counter,this._barrier=new i.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const W=k.workspace;this._confirmedWorkspace=W?new d(W.id,W.name,[],!!W.transient,W.configuration?S.URI.revive(W.configuration):null,!!W.isUntitled,ee=>l(ee,B)):void 0}$initializeWorkspace(O,k){this._trusted=k,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?S.URI.from({scheme:D.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,k,B,...M){const W=[];if(Array.isArray(M)&&M.forEach(x=>{S.URI.isUri(x.uri)&&!W.some(q=>s(q.uri,x.uri,this._extHostFileSystemInfo))&&W.push({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[k,B].some(x=>typeof x!="number"||x<0)||B===0&&W.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(k+B>ee.length)return!1;const H=ee.slice(0);H.splice(k,B,...W.map(x=>({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<H.length;x++){const q=H[x];if(H.some((ie,Q)=>Q!==x&&s(q.uri,ie.uri,this._extHostFileSystemInfo)))return!1}H.forEach((x,q)=>x.index=q);const{added:N,removed:j}=c(ee,H,t,this._extHostFileSystemInfo);if(N.length===0&&j.length===0)return!1;if(this._proxy){const x=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(x,k,B,W).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(v.Severity.Error,(0,I.localize)(0,null,x,q.toString()),ie,[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(O,k){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async getWorkspaceFolder2(O,k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,k){let B,M="";if(typeof O=="string"?(B=S.URI.file(O),M=O):typeof O!="undefined"&&(B=O,M=O.fsPath),!B)return M;const W=this.getWorkspaceFolder(B,!0);if(!W)return M;typeof k=="undefined"&&this._actualWorkspace&&(k=this._actualWorkspace.folders.length>1);let ee=(0,P.relativePath)(W.uri,B);return k&&W.name&&(ee=`${W.name}/${ee}`),ee}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:k,added:B,removed:M}=d.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=k||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:M}))}findFiles(O,k,B,M,W=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let ee;if(k===null?ee=!1:k&&(typeof k=="string"?ee=k:ee=k.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:N}=R(m.GlobPattern.from(O));return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(H),(0,T.withUndefinedAsNull)(N),(0,T.withUndefinedAsNull)(ee),(0,T.withUndefinedAsNull)(B),W).then(j=>Array.isArray(j)?j.map(x=>S.URI.revive(x)):[])}async findTextInFiles(O,k,B,M,W=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),H=typeof k.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:k.previewOptions,{includePattern:N,folder:j}=R(m.GlobPattern.from(k.include)),x=typeof k.exclude=="string"?k.exclude:k.exclude?k.exclude.pattern:void 0,q={ignoreSymlinks:typeof k.followSymlinks=="boolean"?!k.followSymlinks:void 0,disregardIgnoreFiles:typeof k.useIgnoreFiles=="boolean"?!k.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof k.useGlobalIgnoreFiles=="boolean"?!k.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof k.useParentIgnoreFiles=="boolean"?!k.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof k.useDefaultExcludes=="boolean"?!k.useDefaultExcludes:!0,fileEncoding:k.encoding,maxResults:k.maxResults,previewOptions:H,afterContext:k.afterContext,beforeContext:k.beforeContext,includePattern:N,excludePattern:x},ie=!1;if(this._activeSearchCallbacks[ee]=Q=>{if(ie)return;const de=S.URI.revive(Q.resource);Q.results.forEach(ue=>{(0,h.resultIsMatch)(ue)?B({uri:de,preview:{text:ue.preview.text,matches:(0,u.mapArrayOrNot)(ue.preview.matches,X=>new o.Range(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))},ranges:(0,u.mapArrayOrNot)(ue.ranges,X=>new o.Range(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))}):B({uri:de,text:ue.text,lineNumber:ue.lineNumber})})},W.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(O,(0,T.withUndefinedAsNull)(j),q,ee,W);return delete this._activeSearchCallbacks[ee],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[ee],Q}}$handleTextSearchResult(O,k){this._activeSearchCallbacks[k]&&this._activeSearchCallbacks[k](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=je([xe(0,a.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,b.IExtHostFileSystemInfo),xe(3,g.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,_.createDecorator)("IExtHostWorkspace");function R(F){let O,k;return F&&(typeof F=="string"?O=F:(O=F.pattern,k=S.URI.revive(F.baseUri))),{includePattern:O,folder:k}}}),define(Ie[33],Te([1,0,24,3,32,5,7,199,120,12,17,4,18,14,2]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(h,r){if(r){const s=r.split(".");let n=h;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function v(h){return h instanceof _.URI}function p(h){return h&&h.uri instanceof _.URI&&h.languageId&&typeof h.languageId=="string"}function b(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function f(h){return h&&h.uri instanceof _.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function a(h){if(v(h))return{resource:h};if(p(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(b(h))return{overrideIdentifier:h.languageId};if(f(h))return{resource:h.uri};if(h===null)return{resource:null}}let m=class{constructor(r,s,n){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,s))}};m=je([xe(0,S.IExtHostRpcService),xe(1,y.IExtHostWorkspace),xe(2,I.ILogService)],m),e.ExtHostConfiguration=m;class o{constructor(r,s,n,t){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(r,s,n){const t=a(s)||{},c=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,n?.identifier);function l(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(w){return typeof g(c,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(r?`${r}.${w}`:w,t,n?.identifier);let F=g(c,w);if(typeof F=="undefined")F=R;else{let O;const k=(B,M)=>{let W;const ee=()=>{O=O||(0,u.deepClone)(c),W=W||g(O,M)};return(0,P.isObject)(B)?new Proxy(B,{get:(H,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return ee(),()=>W;if(O)return W=W||g(O,M),W[N];const j=H[N];return typeof N=="string"?k(j,`${M}.${N}`):j},set:(H,N,j)=>(ee(),W&&(W[N]=j),!0),deleteProperty:(H,N)=>(ee(),W&&delete W[N],!0),defineProperty:(H,N,j)=>(ee(),W&&Object.defineProperty(W,N,j),!0)}):B};F=k(F,w)}return F},update:(w,R,F,O)=>{w=r?`${r}.${w}`:w;const k=l(F);return R!==void 0?this._proxy.$updateConfigurationOption(k,w,R,t,O):this._proxy.$removeConfigurationOption(k,w,t,O)},inspect:w=>{w=r?`${r}.${w}`:w;const R=(0,u.deepClone)(this._configuration.inspect(w,t,this._extHostWorkspace.workspace));if(R)return{key:w,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,u.mixin)(d,c,!1),Object.freeze(d)}_toReadonlyValue(r){const s=n=>(0,P.isObject)(n)?new Proxy(n,{get:(t,c)=>s(t[c]),set:(t,c,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(r)}_validateConfigurationAccess(r,s,n){const t=E.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const n=new D.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>n.affectsConfiguration(t,a(c))})}_toMap(r){return r.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[74],Te([1,0,2,17,3,5,7,32,55,33,21,38,18,27,4,10,13,14,69,231,11]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(M){function W(H){if(H!=null)return H}M.from=W;function ee(H){if(H!=null)return H}M.to=ee})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(M){function W(H){if(H!=null)return H}M.from=W;function ee(H){if(H!=null)return H}M.to=ee})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(M){function W(H){if(H!=null)return H}M.from=W;function ee(H){if(H!=null)return H}M.to=ee})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(M){function W(N){if(N){const j=N;return j&&!!j.process}else return!1}M.is=W;function ee(N){if(N==null)return;const j={process:N.process,args:N.args};return N.options&&(j.options=r.from(N.options)),j}M.from=ee;function H(N){if(N!=null)return new C.ProcessExecution(N.process,N.args,N.options)}M.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(M){function W(H){if(H!=null)return H}M.from=W;function ee(H){if(H!=null)return H}M.to=ee})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(M){function W(N){if(N){const j=N;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=W;function ee(N){if(N==null)return;const j={};return N.commandLine!==void 0?j.commandLine=N.commandLine:(j.command=N.command,j.args=N.args),N.options&&(j.options=n.from(N.options)),j}M.from=ee;function H(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new C.ShellExecution(N.commandLine,N.options):new C.ShellExecution(N.command,N.args?N.args:[],N.options)}M.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(M){function W(N){if(N){let j=N;return j&&j.customExecution==="customExecution"}else return!1}M.is=W;function ee(N){return{customExecution:"customExecution"}}M.from=ee;function H(N,j){return j.get(N)}M.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(M){function W(ee,H){let N;return ee.scope!==void 0&&typeof ee.scope!="number"?N=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===C.TaskScope.Workspace&&H&&H.workspaceFile?N=H.workspaceFile:N=f.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:N}}M.from=W})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(M){function W(ee){if(ee!=null)return{_id:ee.id,isDefault:ee.isDefault}}M.from=W})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function W(N,j){if(N==null)return[];const x=[];for(let q of N){const ie=ee(q,j);ie&&x.push(ie)}return x}M.fromMany=W;function ee(N,j){if(N==null)return;let x;N.execution instanceof C.ProcessExecution?x=s.from(N.execution):N.execution instanceof C.ShellExecution?x=t.from(N.execution):N.execution&&N.execution instanceof C.CustomExecution&&(x=c.from(N.execution));const q=o.from(N.definition);let ie;return N.scope?typeof N.scope=="number"?ie=N.scope:ie=N.scope.uri:ie=C.TaskScope.Workspace,!q||!ie?void 0:{_id:N._id,definition:q,name:N.name,source:{extensionId:j.identifier.value,label:N.source,scope:ie},execution:x,isBackground:N.isBackground,group:d.from(N.group),presentationOptions:h.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}M.from=ee;async function H(N,j,x){if(N==null)return;let q;s.is(N.execution)?q=s.to(N.execution):t.is(N.execution)?q=t.to(N.execution):c.is(N.execution)&&(q=c.to(N._id,x));const ie=o.to(N.definition);let Q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Q=N.source.scope:Q=await j.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):Q=C.TaskScope.Workspace),!ie||!Q)return;const de=new C.Task(ie,Q,N.name,N.source.label,q,N.problemMatchers);return N.isBackground!==void 0&&(de.isBackground=N.isBackground),N.group!==void 0&&(de.group=C.TaskGroup.from(N.group._id),de.group&&N.group.isDefault&&(de.group=new C.TaskGroup(de.group.id,de.group.label),N.group.isDefault===!0&&(de.group.isDefault=N.group.isDefault))),N.presentationOptions&&(de.presentationOptions=h.to(N.presentationOptions)),N._id&&(de._id=N._id),N.detail&&(de.detail=N.detail),de}M.to=H})(w=e.TaskDTO||(e.TaskDTO={}));var R;(function(M){function W(H){return H}M.from=W;function ee(H){if(!!H)return Object.assign(Object.create(null),H)}M.to=ee})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(W,ee,H){this._id=ee,this._task=H,m.set(this,void 0),et(this,m,W,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}m=new WeakMap;var O;(function(M){function W(ee){return{id:ee._id,task:void 0}}M.from=W})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let k=class{constructor(W,ee,H,N,j,x,q,ie){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=N,this._configurationService=j,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,ee,H){if(!H)return new C.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:ee,provider:H,extension:W}),this._proxy.$registerTaskProvider(N,ee),new C.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(W,ee){this._proxy.$registerTaskSystem(W,ee)}fetchTasks(W){return this._proxy.$fetchTasks(R.from(W)).then(async ee=>{const H=[];for(let N of ee){const j=await w.to(N,this._workspaceProvider,this._providedCustomExecutions2);j&&H.push(j)}return H})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(ee=>W.push(ee)),W}terminateTask(W){if(!(W instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,ee,H){const N=this._providedCustomExecutions2.get(W.id);N&&(this._activeCustomExecutions2.set(W.id,N),this._terminalService.attachPtyToTerminal(ee,await N.callback(H))),this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const ee=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const ee=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const ee=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:W.exitCode})}$provideTasks(W,ee){const H=this._handlers.get(W);if(!H)return Promise.reject(new Error("no handler found"));const N=[],j=(0,i.asPromise)(()=>H.provider.provideTasks(L.CancellationToken.None)).then(x=>this.provideTasksInternal(ee,N,H,x));return new Promise(x=>{j.then(q=>{Promise.all(N).then(()=>{x(q)})})})}async $resolveTask(W,ee){const H=this._handlers.get(W);if(!H)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${H.type}].`);const N=await w.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const j=await H.provider.resolveTask(N,L.CancellationToken.None);if(!j)return;this.checkDeprecation(j,H);const x=w.from(j,H.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(x.execution)&&await this.addCustomExecution(x,j,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,ee,H){const N=await this._proxy.$createTaskId(W);!H&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,ee.execution)),this._providedCustomExecutions2.set(N,ee.execution)}async getTaskExecution(W,ee){if(typeof W=="string"){const j=this._taskExecutionPromises.get(W);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let H=this._taskExecutionPromises.get(W.id);if(H)return H;const N=new Promise((j,x)=>{function q(ie,Q,de){de?j(new F(ie,Q.id,de)):x("Unexpected: Task does not exist.")}ee?q(this,W,ee):w.to(W.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>q(this,W,ie))});return this._taskExecutionPromises.set(W.id,N),N.then(j=>(this._taskExecutions.set(W.id,j),j),j=>Promise.reject(j))}checkDeprecation(W,ee){W._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let H=this._notProvidedCustomExecutions.values(),N=H.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=H.next()}};k=je([xe(0,S.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,D.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,T.IExtHostTerminalService),xe(6,p.ILogService),xe(7,b.IExtHostApiDeprecationService)],k),e.ExtHostTaskBase=k;let B=class extends k{constructor(W,ee,H,N,j,x,q,ie){super(W,ee,H,N,j,x,q,ie);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(W,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const H=w.from(ee,W);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,ee,!1);else throw new a.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),ee);return this._proxy.$executeTask(H).catch(j=>{throw new Error(j)}),N}provideTasksInternal(W,ee,H,N){const j=[];if(N)for(let x of N){this.checkDeprecation(x,H),(!x.definition||!W[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const q=w.from(x,H.extension);q&&c.is(q.execution)?(j.push(q),ee.push(this.addCustomExecution(q,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:H.extension}}async resolveTaskInternal(W){if(c.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,ee){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,ee,H){}};B=je([xe(0,S.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,D.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,T.IExtHostTerminalService),xe(6,p.ILogService),xe(7,b.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(Ie[273],Te([1,0,9,21,51,34,22,49,31]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(S,I,_){this.config=S,this.provider=I,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&A.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&A.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const I=this.config.folderQueries||[];return new Promise((_,g)=>{const v=p=>{this.resultCount++,S(p)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const b=p.toString(),f=u.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,f)||this.matchFile(v,{base:p,basename:f})}),Promise.all(I.map(p=>this.searchInFolder(p,v))).then(p=>{_({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{g(new Error((0,y.toErrorMessage)(p)))})})}async searchInFolder(S,I){const _=new i.CancellationTokenSource,g=this.getSearchOptionsForFolder(S),v=this.initDirectoryTree(),p=new E.QueryGlobTester(this.config,S),b=!p.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(_),f=D.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,_.token),m=f.elapsed(),o=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(h=>{const r=u.posix.relative(S.folder.path,h.path);if(b){const s=u.basename(h.path);this.matchFile(I,{base:S.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(v,S.folder,r,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,p,I),{providerTime:m,postProcessTime:o.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(S){const I=(0,E.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),_=(0,E.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:_,includes:I,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},I,_,g){if(_===this.filePattern){const p=u.basename(this.filePattern);this.matchFile(g,{base:I,relativePath:this.filePattern,basename:p})}function v(p){const b=u.basename(p),f=u.dirname(p);let a=S[f];a||(a=S[f]=[],v(f)),a.push({base:I,relativePath:p,basename:b})}v(_)}matchDirectoryTree({rootEntries:S,pathToEntries:I},_,g){const v=this,p=this.filePattern;function b(f){const a=(0,E.hasSiblingFn)(()=>f.map(m=>m.basename));for(let m=0,o=f.length;m<o;m++){const h=f[m],{relativePath:r,basename:s}=h;if(_.matchesExcludesSync(r,s,p!==s?a:void 0))continue;const n=I[r];if(n)b(n);else{if(r===p)continue;v.matchFile(g,h)}if(v.isLimitHit)break}}b(S)}matchFile(S,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(I))}}class L{constructor(){this.sessions=new Map}fileSearch(S,I,_,g){const v=this.getSessionTokenSource(S.cacheKey),p=new P(S,I,v&&v.token);let b=0;const f=a=>{b+=a.length,_(a.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(p,L.BATCH_SIZE,f,g).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:a.stats}}))}clearCache(S){const I=this.getSessionTokenSource(S);I&&I.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new i.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:C.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,I,_,g){g.onCancellationRequested(()=>{S.cancel()});const v=b=>{b&&(p.push(b),I>0&&p.length>=I&&(_(p),p=[]))};let p=[];return S.search(v).then(b=>(p.length&&_(p),b),b=>(p.length&&_(p),Promise.reject(b)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ie[274],Te([1,0,16,48,34,103,25,10,9,22,8,12,2,156,187,84,14,45,130,272,31]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(d,w,R,F,O){this.configurationService=d,this.workspaceContextService=w,this.editorGroupsService=R,this.logService=F,this.pathService=O}text(d,w,R={}){d=this.getContentPattern(d,R);const F=this.configurationService.getValue(),O=w&&w.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(w?.map(p.toWorkspaceFolder),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:F.search.usePCRE2||O||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(d,w){const R=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const F={...d,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(d,w)&&(F.isCaseSensitive=!0),this.isMultiline(d)&&(F.isMultiline=!0),F}file(d,w={}){return{...this.commonQuery(d,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(d,w){return d?(d=Array.isArray(d)?d.map(n):n(d),w?this.parseSearchPaths(d):{pattern:h(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],w={}){const R=this.handleIncludeExclude(w.includePattern,w.expandPatterns),F=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),O=d.length>1,k=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,w,F)):d.map(W=>this.getFolderQueryForRoot(W,w,F,O))).filter(W=>!!W),B={_reason:w._reason,folderQueries:k,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:F.pattern,includePattern:R.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const W=u.coalesce(u.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(j=>j.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(W));const ee=W.filter(N=>(0,a.pathIncludedInQuery)(B,N.fsPath)),H=this.commonQueryFromFileList(ee);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...B,...H}}const M=w.extraFileResources&&w.extraFileResources.filter(W=>(0,a.pathIncludedInQuery)(B,W.fsPath));return B.extraFileResources=M&&M.length?M:void 0,B}commonQueryFromFileList(d){const w=[],R=new C.ResourceMap,F={};let O=!1;return d.forEach(k=>{if(k.scheme===D.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(k)){const M=this.workspaceContextService.getWorkspaceFolder(k)?.uri??k.with({path:E.dirname(k.fsPath)});let W=R.get(M);W||(O=!0,W={folder:M,includePattern:{}},w.push(W),R.set(M,W));const ee=E.relative(M.fsPath,k.fsPath);(0,T.assertIsDefined)(W.includePattern)[ee.replace(/\\/g,"/")]=!0}else k.fsPath&&(O=!0,F[k.fsPath]=!0)}),{folderQueries:w,includePattern:F,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(d,w){if(w.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,I.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const w=H=>E.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),F=(Array.isArray(d)?d:r(d)).map(H=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(H,N.scheme===D.Schemas.file?N.fsPath:N.path):H}),O=i.groupBy(F,H=>w(H)?"searchPaths":"exprSegments"),k=(O.exprSegments||[]).map(H=>L.rtrim(H,"/")).map(H=>L.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),B={},M=this.expandSearchPathPatterns(O.searchPaths||[]);M&&M.length&&(B.searchPaths=M);const W=u.flatten(k),ee=h(...W);return ee&&(B.pattern=ee),B}getExcludesForFolder(d,w){return w.disregardExcludeSettings?void 0:(0,a.getExcludes)(d,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const w=u.flatten(d.map(F=>{let{pathPortion:O,globPortion:k}=o(F);k&&(k=t(k));const B=this.expandOneSearchPath(O);return u.flatten(B.map(M=>this.resolveOneSearchPathPattern(M,k)))})),R=new Map;return w.forEach(F=>{const O=F.searchPath.toString(),k=R.get(O);k?F.pattern&&(k.pattern=k.pattern||{},k.pattern[F.pattern]=!0):R.set(O,{searchPath:F.searchPath,pattern:F.pattern?h(F.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(d){if(E.isAbsolute(d)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==D.Schemas.file?[{searchPath:w[0].uri.with({path:d})}]:[{searchPath:S.URI.file(E.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=n(d),d.startsWith("../")||d===".."){const F=E.posix.resolve(w.path,d);return[{searchPath:w.with({path:F})}]}const R=t(d);return[{searchPath:w,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const w=d.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(O=>{const k=w.match(new RegExp(`^${L.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return k?{match:k,folder:O}:null}).filter(T.isDefined);if(F.length)return F.map(O=>{const k=O.match[1];return{searchPath:O.folder.uri,pattern:k&&t(k)}});{const O=d.match(/\.[\/\\](.+)[\/\\]?/),k=O?O[1]:d,B=_.localize(0,null,k);throw new Error(B)}}}}resolveOneSearchPathPattern(d,w){const R=d.pattern&&w?`${d.pattern}/${w}`:d.pattern||w,F=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&F.push({searchPath:d.searchPath,pattern:R+"/**"}),F}getFolderQueryForSearchPath(d,w,R){const F=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(d.searchPath),w,R,!1);return F?{...F,includePattern:d.pattern}:null}getFolderQueryForRoot(d,w,R,F){let O;const k=S.URI.isUri(d)?d:d.uri;if(R.searchPaths){const H=R.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,k))[0];if(H&&!H.pattern)return null;H&&(O=H.pattern)}const B=this.configurationService.getValue({resource:k}),W={...this.getExcludesForFolder(B,w)||{},...O||{}},ee=S.URI.isUri(d)?(0,P.basename)(d):d.name;return{folder:k,folderName:F?ee:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!B.search.followSymlinks}}};m=je([xe(0,g.IConfigurationService),xe(1,p.IWorkspaceContextService),xe(2,b.IEditorGroupsService),xe(3,v.ILogService),xe(4,f.IPathService)],m),e.QueryBuilder=m;function o(l){const d=l.match(/[\*\{\}\(\)\[\]\?]/);if(d){const w=d.index,R=l.substr(0,w).match(/[/|\\][^/\\]*$/);if(R){let F=l.substr(0,R.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:l.substr((R.index||0)+1)}}}return{pathPortion:l}}function h(...l){return l.length?l.reduce((d,w)=>(d[w]=!0,d),Object.create(null)):void 0}function r(l){return y.splitGlobAware(l,",").map(d=>d.trim()).filter(d=>!!d.length)}function s(l){return[`**/${l}/**`,`**/${l}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function n(l){return l.replace(/\\/g,"/")}function t(l){return n(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(l,d){l=u.distinct(l,F=>F.toString());const w=[],R=d.getWorkspace();return l&&l.forEach(F=>{let O;if(d.getWorkbenchState()===2)O=(0,P.relativePath)(R.folders[0].uri,F),O&&O!=="."&&(O="./"+O);else{const k=d.getWorkspaceFolder(F);if(k){const B=k.name;if(R.folders.filter(W=>W.name===B).length===1){const W=(0,P.relativePath)(k.uri,F);W===""?O=`./${k.name}`:O=`./${k.name}/${W}`}else O=F.fsPath}}O&&w.push(O)}),w}e.resolveResourcesForSearchIncludes=c}),define(Ie[275],Te([1,0,22,2,21,11,4,274,31,45]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(g,v){const p=v.activationEvents;if(!p)return Promise.resolve(void 0);const b=[],f=[];for(const s of p)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||g.forceUsingSearch?f.push(n):b.push(n)}if(b.length===0&&f.length===0)return Promise.resolve(void 0);let a;const m=new Promise((s,n)=>{a=s}),o=s=>a({activationEvent:s}),h=Promise.all(b.map(s=>S(g,s,o))).then(()=>{}),r=I(g,v.identifier,f,o);return Promise.all([h,r]).then(()=>{a(void 0)}),m}e.checkActivateWorkspaceContainsExtension=T;async function S(g,v,p){for(const b of g.folders)if(await g.exists(u.joinPath(i.URI.revive(b),v))){p(`workspaceContains:${v}`);return}}async function I(g,v,p,b){if(p.length===0)return Promise.resolve(void 0);const f=new y.CancellationTokenSource,a=g.checkExists(g.folders,p,f.token),m=setTimeout(async()=>{f.cancel(),g.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${p.join(",")}`)},L);let o=!1;try{o=await a}catch(h){A.isCancellationError(h)||A.onUnexpectedError(h)}f.dispose(),clearTimeout(m),o&&b(`workspaceContains:${p.join(",")}`)}function _(g,v,p,b){const f=g.get(C.IInstantiationService),a=g.get(E.ISearchService),o=f.createInstance(D.QueryBuilder).file(v.map(h=>(0,P.toWorkspaceFolder)(i.URI.revive(h))),{_reason:"checkExists",includePattern:p,exists:!0});return a.fileSearch(o,b).then(h=>!!h.limitHit,h=>A.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=_});var et=this&&this.__classPrivateFieldSet||function(Y,e,u,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,u):y?y.value=u:e.set(Y,u),u},Ue=this&&this.__classPrivateFieldGet||function(Y,e,u,i){if(u==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?i:u==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[39],Te([1,0,171,9,75,22,17,6,25,2,14,5,33,226,92,32,28,225,11,26,23,205,7,121,4,27,71,18,86,53,38,3,275,91,207,10]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m,o,h,r,s,n,t,c,l,d,w,R,F,O,k){"use strict";var B,M,W;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let ee=class yi extends D.Disposable{constructor(Q,de,ue,X,ge,Se,oe,_e,Pe,pe){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=ue,this._initData=oe,this._extHostWorkspace=X,this._extHostConfiguration=ge,this._logService=Se,this._extHostTunnelService=Pe,this._extHostTerminalService=pe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._globalRegistry=new p.ExtensionDescriptionRegistry(this._initData.allExtensions);const ve=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new p.ExtensionDescriptionRegistry(j(this._globalRegistry,ve)),this._storage=new _.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=Q.createChild(new c.ServiceCollection([_.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));let Ae=[],ce=[];this._initData.remote.isRemote&&(Ae=this._initData.allExtensions.filter(te=>!te.main&&!te.browser).map(te=>te.identifier),ce=this._initData.allExtensions.filter(te=>!ve.has(f.ExtensionIdentifier.toKey(te.identifier.value))).filter(te=>(te.main||te.browser)&&te.api==="none").map(te=>te.identifier));const me=(0,v.extensionIdentifiersArrayToSet)(ce);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,Ae,ce,{onExtensionActivationError:(te,ne,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,b.transformErrorForSerialization(ne),U)},actualActivateExtension:async(te,ne)=>{if(me.has(f.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ne),new I.HostExtension;const U=this._myRegistry.getExtensionDescription(te);return this._activateExtension(U,ne)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){b.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Q)}terminate(Q,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),b.setUnexpectedErrorHandler(X=>{this._logService.error(X)}),this._extHostContext.dispose();const ue=this._deactivateAll();Promise.race([(0,C.timeout)(5e3),ue]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const de=await this._mainThreadExtensionsProxy.$getExtension(Q);return de&&{...de,identifier:new f.ExtensionIdentifier(de.identifier.value),extensionLocation:P.URI.revive(de.extensionLocation)}}_activateByEvent(Q,de){return this._activator.activateByEvent(Q,de)}_activateById(Q,de){return this._activator.activateById(Q,de)}activateByIdWithErrors(Q,de){return this._activateById(Q,de).then(()=>{const ue=this._activator.getActivatedExtension(Q);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==k.Schemas.file)return Q;const de=await this._hostUtils.realpath(Q.fsPath);return P.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const de=E.TernarySearchTree.forUris(ue=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ue));return await Promise.all(Q.map(async ue=>{if(this._getEntryPoint(ue)){const X=await this._realPathExtensionUri(ue.extensionLocation);de.set(X,ue)}})),de}_deactivate(Q){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return de;const ue=this._activator.getActivatedExtension(Q);if(!ue)return de;try{typeof ue.module.deactivate=="function"&&(de=Promise.resolve(ue.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(X)}try{(0,D.dispose)(ue.subscriptions)}catch(X){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(X)}return de}async _activateExtension(Q,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,de).then(ue=>{const X=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,de),this._logExtensionActivationTimes(Q,de,"success",X),ue},ue=>{throw this._logExtensionActivationTimes(Q,de,"failure"),ue})}_logExtensionActivationTimes(Q,de,ue,X){const ge=H(Q,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...X||{},outcome:ue})}_doActivateExtension(Q,de){const ue=H(Q,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const X=this._getEntryPoint(Q);if(!X)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${Q.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const ge=new I.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(Q.identifier,(0,A.joinPath)(Q.extensionLocation,X),ge),this._loadExtensionContext(Q)]).then(Se=>(y.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),yi._callActivate(this._logService,Q.identifier,Se[0],Se[1],ge))).then(Se=>(y.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Se))}_loadExtensionContext(Q){const de=new m.ExtensionGlobalMemento(Q,this._storage),ue=new m.ExtensionMemento(Q.identifier.value,!1,this._storage),X=new O.ExtensionSecrets(Q,this._secretState),ge=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Se=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([de.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const oe=this;let _e,Pe;const pe=(0,v.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:ue,secrets:X,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ve){return i.join(Q.extensionLocation.fsPath,ve)},get storagePath(){return oe._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return oe._storagePath.globalValue(Q).fsPath},get logPath(){return i.join(oe._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return P.URI.joinPath(oe._initData.logsLocation,Q.identifier.value)},get storageUri(){return oe._storagePath.workspaceValue(Q)},get globalStorageUri(){return oe._storagePath.globalValue(Q)},get extensionMode(){return ge},get extension(){return _e===void 0&&(_e=new N(oe,Q.identifier,Q,Se,!1)),_e},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(Q,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!Pe){if(!pe)return;const ve=w.Event.buffer(w.Event.fromDOMEventEmitter(pe,"message",Ae=>Ae.data));pe.start(),Pe={onDidReceiveMessage:ve,postMessage:pe.postMessage.bind(pe)}}return Pe}})})}static _callActivate(Q,de,ue,X,ge){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,de,ue,X,ge).then(Se=>new I.ActivatedExtension(!1,null,ge.build(),ue,Se,X.subscriptions))}static _callActivateOptional(Q,de,ue,X,ge){if(typeof ue.activate=="function")try{ge.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${de.value}`);const Se=typeof global=="object"?global:self,oe=ue.activate.apply(Se,[X]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(oe).then(_e=>(ge.activateResolveStop(),_e))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(ue)}_activateOneStartupFinished(Q,de){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:de}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const de of Q.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(Q,de)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(de),X=Promise.all([Q,ue]).then(()=>{});return Promise.race([X,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(Q,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,de){if(this.isActivated(de.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={logService:this._logService,folders:Q.map(Se=>Se.uri),forceUsingSearch:ue,exists:Se=>this._hostUtils.exists(Se.fsPath),checkExists:(Se,oe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Se,oe,_e)},ge=await(0,R.checkActivateWorkspaceContainsExtension)(X,de);if(!!ge)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:ge.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:de}=this._initData.environment;if(!Q||!de)throw new Error(u.localize(0,null));const ue=await this._loadCommonJSModule(null,de,new I.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(u.localize(1,null,de.toString()));return new Promise((X,ge)=>{const Se=(Pe,pe)=>{Pe?ge(Pe):X(typeof pe=="number"&&pe>0?1:0)},oe=(0,A.originalFSPath)(de),_e=ue.run(oe,Se);_e&&_e.then&&_e.then(()=>{X(0)}).catch(Pe=>{ge(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}async $extensionTestsExit(Q){this.terminate(`test runner requested exit with code ${Q}`,Q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,de){return this._resolvers[Q]=de,(0,D.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const de=Q.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const ue=Q.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(Q,de){this._logService.info(`$resolveAuthority invoked for authority (${x(Q)})`);const{authorityPrefix:ue,resolver:X}=await this._activateAndGetResolver(Q);if(!X)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(X)),y.mark(`code/extHost/willResolveAuthority/${ue}`);const ge=await X.resolve(Q,{resolveAttempt:de});y.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const Se={authority:Q,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},oe={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Se,options:oe,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(y.mark(`code/extHost/didResolveAuthorityError/${ue}`),ge instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Q,de){this._logService.info(`$getCanonicalURI invoked for authority (${x(Q)})`);const{resolver:ue}=await this._activateAndGetResolver(Q);if(!ue)return null;const X=P.URI.revive(de);if(typeof ue.getCanonicalURI=="undefined")return X;const ge=await(0,C.asPromise)(()=>ue.getCanonicalURI(X));return ge||X}static _applyExtensionsDelta(Q,de,ue){const X=new p.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());X.deltaExtensions(ue.toAdd,ue.toRemove);const ge=(0,v.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of ue.myToRemove)ge.delete(f.ExtensionIdentifier.toKey(oe));for(const oe of ue.myToAdd)ge.add(f.ExtensionIdentifier.toKey(oe));const Se=j(X,ge);return{globalRegistry:X,myExtensions:Se}}$startExtensionHost(Q){Q.toAdd.forEach(X=>X.extensionLocation=P.URI.revive(X.extensionLocation));const{globalRegistry:de,myExtensions:ue}=yi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(ue),this._startExtensionHost()}$activateByEvent(Q,de){return de===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(Q,!1))}async $activate(Q,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,de),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Se=>Se.extensionLocation=P.URI.revive(Se.extensionLocation));const{globalRegistry:de,myExtensions:ue}=yi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),X=await this._createExtensionPathIndex(ue);return(await this.getExtensionPathIndex()).setSearchTree(X),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(ue),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){let de=a.VSBuffer.alloc(Q),ue=Math.random()%256;for(let X=0;X<Q;X++)de.writeUInt8(ue,X);return de}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};ee=je([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,g.IExtHostWorkspace),xe(4,S.IExtHostConfiguration),xe(5,L.ILogService),xe(6,s.IExtHostInitDataService),xe(7,n.IExtensionStoragePaths),xe(8,l.IExtHostTunnelService),xe(9,d.IExtHostTerminalService)],ee),e.AbstractExtHostExtensionService=ee;function H(ie,Q){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(Q,de,ue,X,ge){B.set(this,void 0),M.set(this,void 0),W.set(this,void 0),et(this,B,Q,"f"),et(this,M,de,"f"),et(this,W,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=i.normalize((0,A.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=X,this.isFromDifferentExtensionHost=ge}get isActive(){return Ue(this,B,"f").isActivated(Ue(this,W,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,B,"f").getExtensionExports(Ue(this,W,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,B,"f").activateByIdWithErrors(Ue(this,W,"f"),{startup:!1,extensionId:Ue(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=N,B=new WeakMap,M=new WeakMap,W=new WeakMap;function j(ie,Q){return ie.getAllExtensionDescriptions().filter(de=>Q.has(f.ExtensionIdentifier.toKey(de.identifier)))}function x(ie){const Q=ie.indexOf("+");return Q===-1?ie:ie.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(Ie[276],Te([1,0,75,2,5,33,28,26,18,27,4,39,40,14,8]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(m,o,h,r,s,n,t){this._apiFactory=m,this._extensionRegistry=o,this._instaService=h,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,o,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(b,o)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,o,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let o of m.nodeModuleName)this._factories.set(o,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(o=>m.alternativeModuleName(o))}};g=je([xe(2,L.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,T.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,I.ILogService)],g),e.RequireInterceptor=g;let v=class Gi{constructor(m){if(m.environment.appRoot&&Gi.aliased.size){const o=(0,_.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(m));if(!o)return;const[,h,r,s]=o,n=Gi.aliased.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),h+n+s}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=je([xe(0,P.IExtHostInitDataService)],v);class p{constructor(m,o,h,r,s){this._apiFactory=m,this._extensionPaths=o,this._extensionRegistry=h,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,o){const h=this._extensionPaths.findSubstr(o);if(h){let r=this._extApiImpl.get(D.ExtensionIdentifier.toKey(h.identifier));return r||(r=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,n)=>r+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(m,o,h){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(y.MainContext.MainThreadTelemetry);const{environment:r}=h,s=o.getProxy(y.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;S.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>s.$getPassword(n,t),setPassword:(n,t,c)=>s.$setPassword(n,t,c),deletePassword:(n,t)=>s.$deletePassword(n,t),findPassword:n=>s.$findPassword(n),findCredentials(n){return s.$findCredentials(n)}}}load(m,o){const h=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const o=m.length;if(o<=7||!this.alternativeNames)return;const h=o-7;if((m.charAt(h)==="/"||m.charAt(h)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};b=je([xe(1,E.IExtHostRpcService),xe(2,P.IExtHostInitDataService)],b);let f=class{constructor(m,o,h){this._extensionPaths=m,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(y.MainContext.MainThreadTelemetry);const r=h.getProxy(y.MainContext.MainThreadWindow);this._impl=(s,n)=>{const t=i.URI.parse(s);return n?this.callOriginal(s,n):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,s,{}):this.callOriginal(s,n)}}load(m,o,h){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=h(m),this._impl}callOriginal(m,o){return this.sendNoForwardTelemetry(),this._original(m,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=je([xe(2,E.IExtHostRpcService)],f)}),define(Ie[47],Te([1,0,80,6,9,40,4,55,56,39,7,32,219,33]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class _ extends S.AbstractVariableResolverService{constructor(p,b,f,a,m,o,h){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const n=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof L.TextDiffTabInput||n.input instanceof L.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof L.TextTabInput||n.input instanceof L.NotebookEditorTabInput||n.input instanceof L.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=o.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(s,n)=>m.getConfiguration(void 0,s).get(n),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return y.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const s=r();if(s){const n=b.getWorkspaceFolder(s);if(n)return y.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>p.getExtension(s)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(A.env))}}let g=class extends i.Disposable{constructor(p,b,f,a,m){super();this.extensionService=p,this.workspaceService=b,this.editorService=f,this.configurationService=a,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};g=je([xe(0,P.IExtHostExtensionService),xe(1,T.IExtHostWorkspace),xe(2,D.IExtHostDocumentsAndEditors),xe(3,I.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],g),e.ExtHostVariableResolverProviderService=g}),define(Ie[76],Te([1,0,17,3,12,2,4,5,56,39,18,7,32,126,214,33,47]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let p=class{constructor(r,s,n,t,c,l){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=c,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new i.Emitter,this._onDidTerminateDebugSession=new i.Emitter,this._onDidChangeActiveDebugSession=new i.Emitter,this._onDidReceiveDebugSessionCustomEvent=new i.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new i.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(d=>{d.onDidChange(w=>{this.registerAllDebugTypes(d)}),this.registerAllDebugTypes(d)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,s){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,c="?";return s&&(t+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),t+=`${c}ref=${n.sourceReference}`,A.URI.parse(t)}else{if(n.path)return A.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,_.isDebuggerMainContribution)(c)&&s.push(c.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(c=>{const l=c.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,c),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const c of s)if(c instanceof T.SourceBreakpoint){let l=t.get(c.location.uri.toString());l||(l={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),l),n.push(l)),l.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof T.FunctionBreakpoint&&n.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(l=>l instanceof T.SourceBreakpoint).map(l=>l.id),t=s.filter(l=>l instanceof T.FunctionBreakpoint).map(l=>l.id),c=s.filter(l=>l instanceof T.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,c)}startDebugging(r,s,n){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,n){if(!s)return new T.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,n){if(!n)return new T.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new T.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:n,factory:s}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let n;const t=await this.getFolder(r);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new m(r.implementation)}createSignService(){}async $startDASession(r,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const l=this.convertToDto(c),d=this.createDebugAdapter(l,t);if(!d)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const w=d;return this._debugAdapters.set(r,w),this.getDebugAdapterTrackers(t).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),w.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const O=F,k={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(O.arguments.value);k.body={signature:B},w.sendResponse(k)}else throw new Error("no signer")}catch(B){k.success=!1,k.message=B.message,w.sendResponse(k)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(F),F=(0,_.convertToVSCPaths)(F,!0),n._debugServiceProxy.$acceptDAMessage(r,F)}),w.onError(F=>{R&&R.onError&&R.onError(F),this._debugServiceProxy.$acceptDAError(r,F.name,F.message,F.stack)}),w.onExit(F=>{R&&R.onExit&&R.onExit((0,y.withNullAsUndefined)(F),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,y.withNullAsUndefined)(F),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,s){s=(0,_.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s);const t=this._debugAdapters.get(r);t&&t.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(r);return this._debugAdapters.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],n=[],t=[];if(r.added)for(const c of r.added){const l=c.id;if(l&&!this._breakpoints.has(l)){let d;if(c.type==="function")d=new T.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")d=new T.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const w=A.URI.revive(c.uri);d=new T.SourceBreakpoint(new T.Location(w,new T.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}d._id=l,this._breakpoints.set(l,d),s.push(d)}}if(r.removed)for(const c of r.removed){const l=this._breakpoints.get(c);l&&(this._breakpoints.delete(c),n.push(l))}if(r.changed){for(const c of r.changed)if(c.id){const l=this._breakpoints.get(c.id);if(l){if(l instanceof T.FunctionBreakpoint&&c.type==="function"){const d=l;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.functionName=c.functionName}else if(l instanceof T.SourceBreakpoint&&c.type==="source"){const d=l;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.location=new T.Location(A.URI.revive(c.uri),new T.Position(c.line,c.character))}t.push(l)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(r,s,n){return(0,u.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(s);return t.provideDebugConfigurations(c,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,n,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(s);return c.resolveDebugConfiguration(l,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,n,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(s);return c.resolveDebugConfigurationWithSubstitutedVariables(l,n,t)})}async $provideDebugAdapter(r,s){const n=this.getAdapterDescriptorFactoryByHandle(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){const n=await this.getSession(r);n&&n._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof T.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof T.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(n=>n.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(n=>n.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(n=>n.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const n=r.configuration.type,t=this._trackerFactories.filter(c=>c.type===n||c.type==="*").map(c=>(0,u.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(t).then(c=>{const l=c.filter(d=>!!d);if(l.length>0)return new a(l)}),new Promise((c,l)=>{const d=setTimeout(()=>{clearTimeout(d),l(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(r,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new T.DebugAdapterServer(n));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,c))).then(l=>{if(l)return l})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,n){(r.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:n}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const n=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new b(this._debugServiceProxy,r.id,r.type,r.name,n,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};p=je([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,g.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],p),e.ExtHostDebugServiceBase=p;class b{constructor(r,s,n,t,c,l,d){this._debugServiceProxy=r,this._id=s,this._type=n,this._name=t,this._workspaceFolder=c,this._configuration=l,this._parentSession=d}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=b;class f{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=f;class a{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(n=>n.onExit?n.onExit(r,s):void 0)}}class m extends I.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends p{constructor(r,s,n,t,c,l){super(r,s,n,t,c,l)}};o=je([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,g.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Ie[277],Te([1,0,11,75,2,5,269,14,83,86,27,194,18,66,39]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{constructor(p,b,f,a,m){this._hostUtils=f,this._rpcProtocol=new C.RPCProtocol(p,null,a),b=g._transform(b,this._rpcProtocol);const o=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:m}),o.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),o.set(I.IURITransformerService,new I.URITransformerService(a)),o.set(_.IHostUtils,f);const h=new T.InstantiationService(o,!0);this._logService=h.invokeFunction(t=>t.get(D.ILogService)),i.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",b),this._extensionService=h.invokeFunction(t=>t.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,l)=>{let d="",w,R;for(const F of l)d+=`
	at ${F.toString()}`,R=F.getFileName(),!w&&R&&(w=t.findSubstr(y.URI.file(R)));return r.set(c,w),`${c.name||"Error"}: ${c.message||""}${d}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(t=>{const c=u.transformErrorForSerialization(t),l=r.get(t);l?s.$onExtensionRuntimeError(l.identifier,c):n.$onUnexpectedError(c)})}async asBrowserUri(p){const b=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return y.URI.revive(await b.$asBrowserUri(p))}terminate(p){this._extensionService.terminate(p)}static _transform(p,b){p.allExtensions.forEach(a=>a.extensionLocation=y.URI.revive(b.transformIncomingURIs(a.extensionLocation))),p.environment.appRoot=y.URI.revive(b.transformIncomingURIs(p.environment.appRoot));const f=p.environment.extensionDevelopmentLocationURI;return f&&(p.environment.extensionDevelopmentLocationURI=f.map(a=>y.URI.revive(b.transformIncomingURIs(a)))),p.environment.extensionTestsLocationURI=y.URI.revive(b.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=y.URI.revive(b.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=y.URI.revive(b.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=y.URI.revive(b.transformIncomingURIs(p.logsLocation)),p.logFile=y.URI.revive(b.transformIncomingURIs(p.logFile)),p.workspace=b.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=g}),define(Ie[278],Te([1,0,17,13,177,193,201,76,56,39,18,38,7,47,32,215,216,33]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let b=class extends D.ExtHostDebugServiceBase{constructor(h,r,s,n,t,c,l){super(h,r,s,n,c,l);this._terminalService=t,this._integratedTerminalInstances=new m}createDebugAdapter(h,r){switch(h.type){case"server":return new g.SocketDebugAdapter(h);case"pipeServer":return new g.NamedPipeDebugAdapter(h);case"executable":return new g.ExecutableDebugAdapter(h,r.type)}return super.createDebugAdapter(h,r)}daExecutableFromPackage(h,r){const s=g.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),h.type);if(s)return new S.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new C.SignService}async $runInTerminal(h,r){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(B=>{this._integratedTerminalInstances.onTerminalClosed(B)}));const s=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),c=h.title||y.localize(0,null),l=JSON.stringify({shell:n,shellArgs:t});let d=await this._integratedTerminalInstances.checkout(l,c),w,R=!1;if(d)w=h.cwd;else{const B={shellPath:n,shellArgs:t,cwd:h.cwd,name:c,iconPath:new S.ThemeIcon("debug")};R=!0,d=this._terminalService.createTerminalFromOptions(B,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,l)}d.show(!0);const F=await d.processId;R?await new Promise(B=>setTimeout(B,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?d.sendText("cls"):n.indexOf("bash")>=0?d.sendText("clear"):i.isWindows?d.sendText("cls"):d.sendText("clear"));const O=(0,v.prepareCommand)(n,h.args,w,h.env);d.sendText(O);const k=this.onDidTerminateDebugSession(B=>{B.id===r&&(this._integratedTerminalInstances.free(d),k.dispose())});return F}else if(h.kind==="external")return a(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,r)}};b=je([xe(0,L.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,p.IExtHostConfiguration),xe(4,T.IExtHostTerminalService),xe(5,E.IExtHostEditorTabs),xe(6,I.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let f;function a(o,h){if(!f)if(i.isWindows)f=new A.WindowsExternalTerminalService;else if(i.isMacintosh)f=new A.MacExternalTerminalService;else if(i.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=h.getConfiguration("terminal");return f.runInTerminal(o.title,o.cwd,o.args,o.env||{},r.external||{})}e.runInExternalTerminal=a;class m{constructor(){this._terminalInstances=new Map}async checkout(h,r){const n=[...this._terminalInstances.entries()].map(([t,c])=>(0,u.createCancelablePromise)(async l=>{if(t.name!==r||c.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await t.processId))return null;const d=Date.now();return c.lastUsedAt+m.minUseDelay>d||l.isCancellationRequested||c.config!==h?null:(c.lastUsedAt=d,t)}));return await(0,u.firstParallel)(n,t=>!!t)}insert(h,r){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:r})}free(h){const r=this._terminalInstances.get(h);r&&(r.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}m.minUseDelay=1e3}),define(Ie[279],Te([1,0,9,2,113,32,55,33,45,38,18,27,74,10,14,69,22,64,47]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends S.ExtHostTaskBase{constructor(m,o,h,r,s,n,t,c,l){super(m,o,h,r,s,n,t,c);this.workspaceService=h,this.variableResolver=l,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,o){const h=o;if(!o.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const r=S.TaskHandleDTO.from(h,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(s,o);return this._proxy.$executeTask(r).catch(()=>{}),n}else{const r=S.TaskDTO.from(o,m);if(r===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,o,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),o);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(m,o,h,r){const s=[];if(r)for(let n of r){this.checkDeprecation(n,h),(!n.definition||!m[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const t=S.TaskDTO.from(n,h.extension);t&&(s.push(t),S.CustomExecutionDTO.is(t.execution)&&o.push(this.addCustomExecution(t,n,!0)))}return{tasks:s,extension:h.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let o=m&&m.length>0?m[0]:void 0;if(!o){const h=i.URI.file((0,p.homedir)());o=new E.WorkspaceFolder({uri:h,name:v.basename(h),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,o){const h=i.URI.revive(m),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(h),n=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),c=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let l of o.variables)r.variables[l]=await t.resolveAsync(c,l);if(o.process!==void 0){let l;if(o.process.path!==void 0){l=o.process.path.split(u.delimiter);for(let d=0;d<l.length;d++)l[d]=await t.resolveAsync(c,l[d])}r.process=await y.win32.findExecutable(await t.resolveAsync(c,o.process.name),o.process.cwd!==void 0?await t.resolveAsync(c,o.process.cwd):void 0,l)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(m,o,h){return y.win32.findExecutable(m,o,h)}};f=je([xe(0,L.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,C.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,P.IExtHostTerminalService),xe(6,_.ILogService),xe(7,g.IExtHostApiDeprecationService),xe(8,b.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(Ie[280],Te([1,0,64,47]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class y extends i.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=y}),define(Ie[139],Te([1,0,16,17,21,51,10,9,22,12,2,31]),function(Y,e,u,i,y,A,C,D,E,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(f,a,m,o){this.query=f,this.provider=a,this.fileUtils=m,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,a){const m=this.query.folderQueries||[],o=new y.CancellationTokenSource;return a.onCancellationRequested(()=>o.cancel()),new Promise((h,r)=>{this.collector=new _(f);let s=!1;const n=(t,c)=>{if(!s&&!this.isLimitHit){const l=this.resultSize(t);v(t)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,s=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const d=this.resultSize(t);this.resultCount+=d,(d>0||!v(t))&&this.collector.add(t,c)}};Promise.all(m.map((t,c)=>this.searchInFolder(t,l=>n(l,c),o.token))).then(t=>{o.dispose(),this.collector.flush();const c=t.some(l=>!!l&&!!l.limitHit);h({limitHit:this.isLimitHit||c,messages:(0,u.flatten)(t.map(l=>l?.message?(0,P.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const c=(0,A.toErrorMessage)(t);r(new Error(c))})})}resultSize(f){return v(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,a){const m=Array.isArray(f.ranges)?f.ranges:[f.ranges],o=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:m.slice(0,a),preview:{matches:o.slice(0,a),text:f.preview.text},uri:f.uri}}async searchInFolder(f,a,m){const o=new T.QueryGlobTester(this.query,f),h=[],r={report:t=>{if(!this.validateProviderResult(t))return;const c=f.folder.scheme===C.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(t.uri))):void 0,l=E.relativePath(f.folder,t.uri);if(l){const d=o.includedInQuery(l,D.basename(l),c);(0,i.isThenable)(d)?h.push(d.then(w=>{w&&a(t)})):d&&a(t)}}},s=this.getSearchOptionsForFolder(f),n=await this.provider.provideTextSearchResults(I(this.query.contentPattern),s,r,m);return h.length&&await Promise.all(h),n}validateProviderResult(f){if(v(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const a=(0,T.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),m=(0,T.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),o={folder:L.URI.from(f.folder),excludes:m,includes:a,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=S;function I(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class _{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,a=>this.sendItems(a))}add(f,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!E.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(g(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=_;function g(b){return v(b)?{preview:{matches:(0,u.mapArrayOrNot)(b.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:b.preview.text},ranges:(0,u.mapArrayOrNot)(b.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class p{constructor(f,a){this.maxBatchSize=f,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,a){!f||this.addItemToBatch(f,a)}addItems(f,a){!f||this.addItemsToBatch(f,a)}addItemToBatch(f,a){this.batch.push(f),this.batchSize+=a,this.onUpdate()}addItemsToBatch(f,a){this.batch=this.batch.concat(f),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(Ie[77],Te([1,0,6,5,4,273,18,66,14,2,139]),function(Y,e,u,i,y,A,C,D,E,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let T=class{constructor(g,v,p){this.extHostRpc=g,this._uriTransformer=v,this._logService=p,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,v){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const p=this._handlePool++;return this._textSearchProvider.set(p,v),this._proxy.$registerTextSearchProvider(p,this._transformScheme(g)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(g,v){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const p=this._handlePool++;return this._fileSearchProvider.set(p,v),this._proxy.$registerFileSearchProvider(p,this._transformScheme(g)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(g,v,p,b){const f=S(p),a=this._fileSearchProvider.get(g);if(a)return this._fileSearchManager.fileSearch(f,a,m=>{this._proxy.$handleFileMatch(g,v,m.map(o=>o.resource))},b);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,v,p,b){const f=this._textSearchProvider.get(g);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const a=S(p);return this.createTextSearchManager(a,f).search(o=>this._proxy.$handleTextMatch(g,v,o),b)}$enableExtensionHostSearch(){}createTextSearchManager(g,v){return new L.TextSearchManager(g,v,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"textSearchProvider")}};T=je([xe(0,C.IExtHostRpcService),xe(1,D.IURITransformerService),xe(2,E.ILogService)],T),e.ExtHostSearch=T;function S(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(I),extraFileResources:_.extraFileResources&&_.extraFileResources.map(g=>P.URI.revive(g))}}e.reviveQuery=S;function I(_){return{..._,folder:P.URI.revive(_.folder)}}}),define(Ie[281],Te([1,0,83,138,32,135,33,37,55,38,74,76,77,92,53,69,137,70,46,91,124,56,136,14,227,47]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m,o,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(h.ILoggerService,o.ExtHostLoggerService),(0,u.registerSingleton)(h.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,u.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,u.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,u.registerSingleton)(p.IExtHostConsumerFileSystem,p.ExtHostConsumerFileSystem),(0,u.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,u.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,u.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,u.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,u.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch),(0,u.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage),(0,u.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,u.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,u.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService),(0,u.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,u.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,u.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,u.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(Ie[93],Te([1,0,16,14,31,73]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=C;function D(T,S,I,_){const g=(0,u.mapArrayOrNot)(I,E),v=new y.TextSearchMatch(S,g,_),p=v.preview.matches;return{ranges:(0,u.mapArrayOrNot)(g,P),uri:T,preview:{text:v.preview.text,matches:(0,u.mapArrayOrNot)(p,P)}}}e.createTextSearchResult=D;function E(T){return new y.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function P(T){return new A.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(S,I){this.prefix=S,this.logService=I}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};L=je([xe(1,i.ILogService)],L),e.OutputChannel=L}),define(Ie[282],Te([1,0,42,9,82,30,13,8,93,283]),function(Y,e,u,i,y,A,C,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(f,a,m,o){const h=S(f,a,m,o),r=a.folder.fsPath;return{cmd:u.spawn(L,h.args,{cwd:r}),rgDiskPath:L,siblingClauses:h.siblingClauses,rgArgs:h,cwd:r}}e.spawnRipgrepCmd=T;function S(f,a,m,o){const h=["--files","--hidden","--case-sensitive"];_([a],m,!1).forEach(s=>{const n=(0,E.anchorGlob)(s);if(h.push("-g",n),C.isMacintosh){const t=(0,y.normalizeNFD)(n);t!==n&&h.push("-g",t)}});const r=I([a],o,void 0,!1);return r.globArgs.forEach(s=>{const n=`!${(0,E.anchorGlob)(s)}`;if(h.push("-g",n),C.isMacintosh){const t=(0,y.normalizeNFD)(n);t!==n&&h.push("-g",t)}}),a.disregardIgnoreFiles!==!1?h.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),a.ignoreSymlinks||h.push("--follow"),f.exists&&h.push("--quiet"),h.push("--no-config"),a.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:r.siblingClauses}}function I(f,a,m,o=!0){const h=[];let r={};return f.forEach(s=>{const n=Object.assign({},s.excludePattern||{},a||{}),t=g(n,o?s.folder.fsPath:void 0,m);h.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:h,siblingClauses:r}}e.foldersToRgExcludeGlobs=I;function _(f,a,m=!0){const o=[];return f.forEach(h=>{const r=Object.assign({},a||{},h.includePattern||{}),s=g(r,m?h.folder.fsPath:void 0);o.push(...s.globArgs)}),o}e.foldersToIncludeGlobs=_;function g(f,a,m){const o=[],h={};return Object.keys(f).forEach(r=>{if(m&&m.has(r)||!r)return;const s=f[r];r=p(a?v(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),o.push(b(r))):s&&s.when&&(h[r]=s)}),{globArgs:o,siblingClauses:h}}function v(f,a){return i.isAbsolute(a)?a:i.join(f,a)}e.getAbsoluteGlob=v;function p(f){return f=D.rtrim(f,"\\"),D.rtrim(f,"/")}function b(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=b}),define(Ie[284],Te([1,0,42,63,9,105,16,51,34,82,30,13,49,8,12,29,31,282,101]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(r=>r())});class a{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&E.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&E.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(n=>{const t=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),c=n.folder.fsPath;s.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==c).forEach(l=>{(0,L.isEqualOrParent)(l,c)&&(t[y.relative(c,l)]=!0)}),this.folderExcludePatterns.set(c,new o(t,c))})}cancel(){this.isCanceled=!0,f.forEach(s=>s())}walk(s,n,t,c,l){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);n.forEach(d=>{const w=y.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,w)||this.matchFile(t,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(s,(d,w)=>{this.call(this.cmdTraversal,this,d,t,c,R=>{if(R){const F=(0,D.toErrorMessage)(R);console.error(F),this.errors.push(F),w(R,void 0)}else w(null,void 0)})},(d,w)=>{this.fileWalkSW.stop();const R=d?C.coalesce(d)[0]:null;l(R,this.isLimitHit)})}parallel(s,n,t){const c=new Array(s.length),l=new Array(s.length);let d=!1,w=0;if(s.length===0)return t(null,[]);s.forEach((R,F)=>{n(R,(O,k)=>{if(O?(d=!0,c[F]=null,l[F]=O):(c[F]=k,l[F]=null),++w===s.length)return t(d?l:null,c)})})}call(s,n,...t){try{s.apply(n,t)}catch(c){t[t.length-1](c)}}cmdTraversal(s,n,t,c){const l=s.folder.fsPath,d=T.isMacintosh;let w;const R=()=>w&&w.kill();f.add(R);let F=H=>{f.delete(R),F=()=>{},c(H)},O="";const k=this.initDirectoryTree();let B;const M=(0,p.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression);w=M.cmd,B=!Object.keys(M.siblingClauses).length;const W=M.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let ee=`${M.rgDiskPath} ${W}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(ee+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),t({message:ee}),this.cmdResultCount=0,this.collectStdout(w,"utf8",t,(H,N,j)=>{if(H){F(H);return}if(this.isLimitHit){F();return}const q=(O+(d?P.normalizeNFC(N||""):N)).split(`
`);if(j){const ie=q.length;q[ie-1]=q[ie-1].trim(),q[ie-1]||q.pop()}else O=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,B){for(const ie of q)if(this.matchFile(n,{base:l,relativePath:ie,searchPath:this.getSearchPath(s,ie)}),this.isLimitHit){R();break}(j||this.isLimitHit)&&F();return}this.addDirectoryEntries(s,k,l,q,n),j&&(this.matchDirectoryTree(k,l,n),F())})}spawnFindCmd(s){const n=this.folderExcludePatterns.get(s.folder.fsPath),t=n.getBasenameTerms(),c=n.getPathTerms(),l=["-L","."];if(t.length||c.length){l.push("-not","(","(");for(const d of t)l.push("-name",d),l.push("-o");for(const d of c)l.push("-path",d),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:s.folder.fsPath})}readStdout(s,n,t){let c="";this.collectStdout(s,n,()=>{},(l,d,w)=>{if(l){t(l);return}c+=d,w&&t(null,c)})}collectStdout(s,n,t,c){let l=(R,F,O)=>{(R||O)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),c(R,F,O)},d=!1;s.stdout?(this.forwardData(s.stdout,n,l),s.stdout.once("data",()=>d=!0)):t({message:"stdout is null"});let w;s.stderr?w=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",R=>{l(R)}),s.on("close",R=>{let F;!d&&(F=this.decodeData(w,n))&&h(F)?l(new Error(`command failed with error code ${R}: ${this.decodeData(w,n)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(s,n,t){const c=new A.StringDecoder(n);return s.on("data",l=>{t(null,c.write(l))}),c}collectData(s){const n=[];return s.on("data",t=>{n.push(t)}),n}decodeData(s,n){const t=new A.StringDecoder(n);return s.map(c=>t.write(c)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:n},t,c,l){c.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const d=w=>{const R=y.basename(w),F=y.dirname(w);let O=n[F];O||(O=n[F]=[],d(F)),O.push({base:t,relativePath:w,basename:R,searchPath:this.getSearchPath(s,w)})};c.forEach(d)}matchDirectoryTree({rootEntries:s,pathToEntries:n},t,c){const l=this,d=this.folderExcludePatterns.get(t),w=this.filePattern;function R(F){l.directoriesWalked++;const O=(0,v.hasSiblingFn)(()=>F.map(k=>k.basename));for(let k=0,B=F.length;k<B;k++){const M=F[k],{relativePath:W,basename:ee}=M;if(d.test(W,ee,w!==ee?O:void 0))continue;const H=n[W];if(H)R(H);else{if(l.filesWalked++,W===w)continue;l.matchFile(c,M)}if(l.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,n,t,c,l){const d=s.folder,w=(0,v.hasSiblingFn)(()=>t);this.parallel(t,(R,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const O=n?[n,R].join(y.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(O,R,this.config.filePattern!==R?w:void 0))return F(null);const k=[d.fsPath,O].join(y.sep);i.lstat(k,(B,M)=>{if(B||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(k,M,(W,ee)=>W||this.isCanceled||this.isLimitHit?F(null):ee.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(k,M,(H,N)=>H||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?F(null):(this.walkedPaths[N]=!0,g.Promises.readdir(k).then(j=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(s,O,j,c,x=>F(x||null))},j=>{F(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&_.isNumber(ee.size)&&ee.size>this.maxFilesize||this.matchFile(c,{base:d.fsPath,relativePath:O,searchPath:this.getSearchPath(s,O)}),F(null,void 0)))})},R=>{const F=R&&C.coalesce(R);return l(F&&F.length>0?F[0]:void 0)})}matchFile(s,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,y.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(n))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,n,t){return n.isSymbolicLink()?i.stat(s,t):t(null,n)}realPathIfNeeded(s,n,t){return n.isSymbolicLink()?i.realpath(s,(c,l)=>c?t(c):t(null,l)):t(null,s)}getSearchPath(s,n){return s.folderName?y.join(s.folderName,n):n}}e.FileWalker=a;class m{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new a(s)}search(s,n,t){this.walker.walk(this.folderQueries,this.extraFiles,s,n,(c,l)=>{t(c,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class o{constructor(s,n){this.expression=s,this.root=n,this.init(s)}init(s){let n,t;Object.keys(s).filter(c=>s[c]).forEach(c=>{y.isAbsolute(c)?(n=n||E.getEmptyExpression(),n[c]=s[c]):(t=t||E.getEmptyExpression(),t[c]=s[c])}),this.absoluteParsedExpr=n&&E.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=t&&E.parse(t,{trimForExclusions:!0})}test(s,n,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,n,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,s),n,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getPathTerms(this.relativeParsedExpr)),s}}function h(r){const s=r.trim().split(`
`),n=s[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return I.uppercaseFirstLetter(s[s.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=h}),define(Ie[285],Te([1,0,97,23]),function(Y,e,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,D=512*8,E=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(s,n){super(s);this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class T{constructor(s){this.iconvLiteDecoder=s}static async create(s){let n;if(s!==e.UTF8)n=(await new Promise((c,l)=>{Y(["@vscode/iconv-lite-umd"],c,l)})).getDecoder(g(s));else{const t=new TextDecoder;n={write(c){return t.decode(c,{stream:!0})},end(){return t.decode()}}}return new T(n)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function S(r,s){const n=s.minBytesRequiredForDetection??s.guessEncoding?D:C;return new Promise((t,c)=>{const l=(0,u.newWriteableStream)(k=>k.join("")),d=[];let w=0,R,F;const O=async()=>{try{const k=await h({buffer:i.VSBuffer.concat(d),bytesRead:w},s.guessEncoding);if(k.seemsBinary&&s.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);k.encoding=await s.overwriteEncoding(k.encoding),R=await T.create(k.encoding);const B=R.write(i.VSBuffer.concat(d).buffer);l.write(B),d.length=0,w=0,t({stream:l,detected:k})}catch(k){F?.dispose(),l.destroy(),c(k)}};F=(0,u.listenStream)(r,{onData:async k=>{R?l.write(R.write(k.buffer)):(d.push(k),w+=k.byteLength,w>=n&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:k=>l.error(k),onEnd:async()=>{R||await O(),l.end(R?.end())}})})}e.toDecodeStream=S;async function I(r,s,n){const c=(await new Promise((w,R)=>{Y(["@vscode/iconv-lite-umd"],w,R)})).getEncoder(g(s),n);let l=!1,d=!1;return{read(){if(d)return null;const w=r.read();if(typeof w!="string"){if(d=!0,!l&&n?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=c.end();return R&&R.length>0?(l=!0,i.VSBuffer.wrap(R)):null}return l=!0,i.VSBuffer.wrap(c.write(w))}}}e.toEncodeReadable=I;async function _(r){return(await new Promise((n,t)=>{Y(["@vscode/iconv-lite-umd"],n,t)})).encodingExists(g(r))}e.encodingExists=_;function g(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=g;function v(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),t=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const p=["ascii","utf-16","utf-32"];async function b(r){const s=await new Promise((d,w)=>{Y(["jschardet"],d,w)}),n=r.slice(0,E),t=m(n.buffer),c=s.detect(t);if(!c||!c.encoding)return null;const l=c.encoding.toLowerCase();return 0<=p.indexOf(l)?null:a(c.encoding)}const f={ibm866:"cp866",big5:"cp950"};function a(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[s]||s}function m(r){let s="";for(let n=0;n<r.length;n++)s+=String.fromCharCode(r[n]);return s}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=o;function h({buffer:r,bytesRead:s},n){let t=v(r,s),c=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let l=!0,d=!0,w=!1;for(let R=0;R<s&&R<A;R++){const F=R%2==1,O=r.readUInt8(R)===0;if(O&&(w=!0),l&&(F&&!O||!F&&O)&&(l=!1),d&&(F&&O||!F&&!O)&&(d=!1),O&&!l&&!d)break}w&&(l?t=e.UTF16le:d?t=e.UTF16be:c=!0)}return n&&!c&&!t&&r?b(r.slice(0,s)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:c,encoding:t}}e.detectEncodingFromBuffer=h,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[140],Te([1,0,285,29,139]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends y.TextSearchManager{constructor(D,E,P=i,L="searchProcess"){super(D,E,{readdir:T=>P.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,u.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=A}),define(Ie[286],Te([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const A=this._dragOperations.get(y);return this._dragOperations.delete(y),A}}addDragOperationTransfer(y,A){this._dragOperations.set(y,A)}getRenderedTreeElement(y){if(this._renderedElements.has(y))return this._renderedElements.get(y)}addRenderedTreeItemElement(y,A){this._renderedElements.set(y,A)}removeRenderedTreeItemElement(y){this._renderedElements.has(y)&&this._renderedElements.delete(y)}}e.TreeviewsService=u}),define(Ie[287],Te([1,0,175,7,22,2,3,6,17,7,12,16,15,21,286,28]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(f,a){if((0,L.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let m;return Array.isArray(f.highlights)&&(m=f.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),m=m.length?m:void 0),{label:f.label,highlights:m}}}class p{constructor(a,m,o){this._proxy=a,this.commands=m,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new _.TreeviewsService;function h(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>h(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>h(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,m,o){const h=this.createTreeView(a,{treeDataProvider:m},o);return{dispose:()=>h.dispose()}}createTreeView(a,m,o){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=m.dragAndDropController?.dropMimeTypes??[],r=m.dragAndDropController?.dragMimeTypes??[],s=!!m.dragAndDropController?.handleDrag,n=!!m.dragAndDropController?.handleDrop,t=(0,g.isProposedApiEnabled)(o,"dataTransferFiles"),c=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:h,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:n,supportsFileDataTransfers:t}),l=this.createExtHostTreeView(a,m,o);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(d){l.message=d},get title(){return l.title},set title(d){l.title=d},get description(){return l.description},set description(d){l.description=d},get badge(){return(0,g.checkProposedApiEnabled)(o,"badges"),l.badge},set badge(d){(0,g.checkProposedApiEnabled)(o,"badges"),l.badge=d},reveal:(d,w)=>l.reveal(d,w),dispose:async()=>{await c,this.treeViews.delete(a),l.dispose()}}}$getChildren(a,m){const o=this.treeViews.get(a);return o?o.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,a)))}async $handleDrop(a,m,o,h,r,s,n,t){const c=this.treeViews.get(a);if(!c)return Promise.reject(new Error((0,u.localize)(1,null,a)));const l=S.DataTransfer.toDataTransfer(o,async d=>(await this._proxy.$resolveDropFileData(a,m,d)).buffer);return n===a&&t&&await this.addAdditionalTransferItems(l,c,t,r,s),c.onDrop(l,h,r)}async addAdditionalTransferItems(a,m,o,h,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((n,t)=>{n&&a.set(t,n)});else if(r&&m.handleDrag){const n=m.handleDrag(o,a,h);this.treeDragAndDropService.addDragOperationTransfer(r,n),await n}return a}async $handleDrag(a,m,o,h){const r=this.treeViews.get(a);if(!r)return Promise.reject(new Error((0,u.localize)(2,null,a)));const s=await this.addAdditionalTransferItems(new i.DataTransfer,r,m,h,o);if(!!s)return S.DataTransfer.toDataTransferDTO(s)}async $hasResolve(a){const m=this.treeViews.get(a);if(!m)throw new Error((0,u.localize)(3,null,a));return m.hasResolve}$resolve(a,m,o){const h=this.treeViews.get(a);if(!h)throw new Error((0,u.localize)(4,null,a));return h.resolveTreeItem(m,o)}$setExpanded(a,m,o){const h=this.treeViews.get(a);if(!h)throw new Error((0,u.localize)(5,null,a));h.setExpanded(m,o)}$setSelection(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(6,null,a));o.setSelection(m)}$setVisible(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(7,null,a));o.setVisible(m)}createExtHostTreeView(a,m,o){const h=new b(a,m,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(a,h),h}convertArgument(a){const m=this.treeViews.get(a.$treeViewId);return m?m.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=p;class b extends D.Disposable{constructor(a,m,o,h,r,s){super();if(this.viewId=a,this.proxy=o,this.commands=h,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const l of s.contributes.views[c])l.id===a&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(c,l)=>(c||(c={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(d=>t=d),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(l.element)?c.elements.push(...l.element):c.elements.push(l.element)),l.message&&(c.message=!0),c),200,!0)(({message:c,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=t;return n=null,this.refresh(l).then(()=>d())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}async getChildren(a){const m=a?this.getExtensionElement(a):void 0;if(a&&!m)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(a);return o||(o=await this.fetchChildrenNodes(m)),o?o.map(h=>h.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,m){m=m||{select:!0,focus:!1};const o=(0,L.isUndefinedOrNull)(m.select)?!0:m.select,h=(0,L.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,L.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:o,focus:h,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:h,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=S.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,m){const o=this.getExtensionElement(a);o&&(m?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(a){(0,T.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,m,o){const h=[];for(const r of a){const s=this.getExtensionElement(r);s&&h.push(s)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,m,o),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,m,o){const h=m?this.getExtensionElement(m):void 0;if(!(!h&&m||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,a,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,m){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(a);if(o){const h=this.nodes.get(o);if(h){const r=await this.dataProvider.resolveTreeItem(h.extensionItem,o,m)??h.extensionItem;return h.item.tooltip=this.getTooltip(r.tooltip),h.item.command=this.getCommand(h.disposableStore,r.command),h.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(m=>m?this.resolveUnknownParentChain(m).then(o=>this.resolveTreeNode(m,o[o.length-1]).then(h=>(o.push(h),o))):Promise.resolve([]))}resolveParent(a){const m=this.nodes.get(a);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,m){const o=this.nodes.get(a);return o?Promise.resolve(o):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(h=>this.createHandle(a,h,m,!0)).then(h=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(h);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(a){if(a){let m;if(typeof a=="string"){const o=this.getExtensionElement(a);m=o?this.nodes.get(o):void 0}else m=a;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const m=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=a?this.nodes.get(a):void 0,h=await this.dataProvider.getChildren(a);if(m.token.isCancellationRequested)return;const r=await Promise.all((0,T.coalesce)(h||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,o):null}));return m.token.isCancellationRequested?void 0:(0,T.coalesce)(r)}finally{m.dispose()}}refresh(a){if(a.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(a);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const m=new Set,o=a.map(r=>this.nodes.get(r));for(const r of o)if(r&&!m.has(r.item.handle)){let s=r;for(;s&&s.parent&&o.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&m.add(r.item.handle)}const h=[];return m.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!m.has(n.parent.item.handle))&&h.push(r)}}),h}refreshHandles(a){const m={};return Promise.all(a.map(o=>this.refreshNode(o).then(h=>{h&&(m[o]=h.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(a){const m=this.getExtensionElement(a);if(m){const o=this.nodes.get(m);if(o)return this.clearChildren(m),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(h=>{if(h){const r=this.createTreeNode(m,h,o.parent);return this.updateNodeCache(m,r,o,o.parent),o.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,m,o){const h=this.createTreeNode(a,m,o);if(m.id&&this.elements.has(h.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(a,h),this.addNodeToParentCache(h,o),h}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?S.MarkdownString.from(a):a}getCommand(a,m){return m?this.commands.toInternal(m,a):void 0}createTreeNode(a,m,o){const h=new D.DisposableStore,r=this.createHandle(a,m,o),s=this.getLightIconPath(m);return{item:{handle:r,parentHandle:o?o.item.handle:void 0,label:v(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(h,m.command),contextValue:m.contextValue,icon:s,iconDark:this.getDarkIconPath(m)||s,themeIcon:this.getThemeIcon(m),collapsibleState:(0,L.isUndefinedOrNull)(m.collapsibleState)?P.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:o,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:m,label:o,resourceUri:h},r,s){if(m)return`${b.ID_HANDLE_PREFIX}/${m}`;const n=v(o,this.extension),t=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let c=n?n.label:h?(0,y.basename)(h):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const l=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,d=this.getChildrenNodes(r)||[];let w,R=0;do{if(w=`${t}/${R}:${c}`,s||!this.elements.has(w)||l===w)break;R++}while(R<=d.length);return w}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||A.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return A.URI.isUri(a)?a:A.URI.file(a)}addNodeToCache(a,m){this.elements.set(m.item.handle,a),this.nodes.set(a,m)}updateNodeCache(a,m,o,h){this.elements.delete(m.item.handle),this.nodes.delete(a),m.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(a,m);const r=this.getChildrenNodes(h)||[],s=r.filter(n=>n.item.handle===o.item.handle)[0];s&&r.splice(r.indexOf(s),1,m)}addNodeToParentCache(a,m){m?(m.children||(m.children=[]),m.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const h=this.elements.get(o.item.handle);h&&this.clear(h)}m.children=void 0}}else this.clearAll()}clear(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const h=this.elements.get(o.item.handle);h&&this.clear(h)}this.nodes.delete(a),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(Ie[288],Te([1,0,21,11,3,41,2,114,111,152,151,43,5,134,236,235,37,237,33,238,239,240,221,241,55,39,242,243,246,247,248,138,223,253,254,255,92,38,257,287,15,7,260,72,137,32,48,212,245,122,135,74,76,77,14,66,18,27,249,208,53,69,233,258,71,70,263,261,262,234,46,256,259,91,56,124,251,73,252,10,117,250,206,244,6,28,213]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a,m,o,h,r,s,n,t,c,l,d,w,R,F,O,k,B,M,W,ee,H,N,j,x,q,ie,Q,de,ue,X,ge,Se,oe,_e,Pe,pe,ve,Ae,ce,me,te,ne,U,$,G,K,he,we,se,De,ye,ze,Ve,Me,Je,J,re,Ce,ae,ke,Ne,He,Ge,qe,Ze,Xe,rt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function tt(st){const ot=st.get(Ae.IExtHostInitDataService),Et=st.get(ye.IExtHostFileSystemInfo),Ot=st.get(K.IExtHostConsumerFileSystem),kt=st.get(s.IExtHostExtensionService),mt=st.get(ie.IExtHostWorkspace),Ft=st.get(J.IExtHostTelemetry),Wt=st.get(b.IExtHostConfiguration),Dt=st.get(pe.IURITransformerService),Ke=st.get(ve.IExtHostRpcService),At=st.get(B.IExtHostStorage),Ut=st.get(G.IExtensionStoragePaths),Nt=st.get(Pe.ILoggerService),pt=st.get(Pe.ILogService),Ct=st.get(te.IExtHostTunnelService),Tt=st.get(ne.IExtHostApiDeprecationService),_t=st.get(q.IExtHostWindow),Re=st.get(Me.IExtHostSecretState),Fe=st.get(Je.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Et),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Ke.set(S.ExtHostContext.ExtHostWorkspace,mt),Ke.set(S.ExtHostContext.ExtHostConfiguration,Wt),Ke.set(S.ExtHostContext.ExtHostExtensionService,kt),Ke.set(S.ExtHostContext.ExtHostStorage,At),Ke.set(S.ExtHostContext.ExtHostTunnelService,Ct),Ke.set(S.ExtHostContext.ExtHostWindow,_t),Ke.set(S.ExtHostContext.ExtHostSecretState,Re),Ke.set(S.ExtHostContext.ExtHostTelemetry,Ft),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Fe);const be=Ke.set(S.ExtHostContext.ExtHostDecorations,st.get(ge.IExtHostDecorations)),Z=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,st.get(r.IExtHostDocumentsAndEditors)),Oe=Ke.set(S.ExtHostContext.ExtHostCommands,st.get(v.IExtHostCommands)),We=Ke.set(S.ExtHostContext.ExtHostTerminalService,st.get(M.IExtHostTerminalService)),it=Ke.set(S.ExtHostContext.ExtHostDebugService,st.get(oe.IExtHostDebugService)),Qe=Ke.set(S.ExtHostContext.ExtHostSearch,st.get(_e.IExtHostSearch)),ut=Ke.set(S.ExtHostContext.ExtHostTask,st.get(Se.IExtHostTask)),ht=Ke.set(S.ExtHostContext.ExtHostOutputService,st.get(w.IExtHostOutputService)),wt=Ke.set(S.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Ke)),ft=Ke.set(S.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ke,Z)),It=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ke,Z,pt)),Rt=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(pt,ft,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),vt=Ke.set(S.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,Oe,Z,ft,Ut)),$t=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ge.ExtHostNotebookDocuments(vt)),Jt=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new He.ExtHostNotebookEditors(pt,Ke,vt)),vi=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new re.ExtHostNotebookKernels(Ke,ot,vt,Oe,pt)),ui=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers(Ke,vt)),St=Ke.set(S.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(Ke,Z)),ri=Ke.set(S.ExtHostContext.ExtHostTreeViews,new ee.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),Oe,pt)),di=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),St,ot.remote)),Xt=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Ke,pt,Et)),Qt=Ke.set(S.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ke,ft,Oe.converter,Dt)),dt=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,Dt,ft,Oe,Xt,pt,Tt)),hi=Ke.set(S.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ke,dt)),Ht=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ke,pt,Z)),jt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Ke,mt,Oe)),wi=Ke.set(S.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Ke,Oe,pt)),Ci=Ke.set(S.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Ke,Oe,ft)),si=Ke.set(S.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),fi=Ke.set(S.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ke)),oi=Ke.set(S.ExtHostContext.ExtHostTheming,new me.ExtHostTheming(Ke)),Yt=Ke.set(S.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ke)),Di=Ke.set(S.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(Ke,Oe)),Zt=Ke.set(S.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Ke,ot.remote,mt,pt,Tt)),ei=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new se.ExtHostWebviewPanels(Ke,Zt,mt)),Ii=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ke,ft,Ut,Zt,ei)),ki=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ke,Zt)),ti=Ke.set(S.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ke,Oe)),Ti=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new Ve.ExtHostUriOpeners(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new qe.ExtHostInteractive(Ke,vt,Z,Oe));const Pi=(0,Q.values)(S.ExtHostContext);Ke.assertRegistered(Pi);const Ai=new De.ExtHostBulkEdits(Ke,Z),mi=new g.ExtHostClipboard(Ke),ii=new d.ExtHostMessageService(Ke,pt),bi=new a.ExtHostDialogs(Ke),Ei=new k.ExtHostStatusBar(Ke,Oe.converter);return _.ExtHostApiCommands.register(Oe),function($e,Bt,_i){const gt=function(){let fe=!$e.isUnderDevelopment;function Ee(){fe||(pt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(at){if(Array.isArray(at))at.forEach(Be);else if(typeof at=="string")Ee();else{const bt=at;typeof bt.scheme=="undefined"&&Ee(),typeof bt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return at}}(),Ri={getSession(fe,Ee,Be){return Yt.getSession($e,fe,Ee,Be)},async hasSession(fe,Ee){return(0,Xe.checkProposedApiEnabled)($e,"authSession"),!!await Yt.getSession($e,fe,Ee,{silent:!0})},get onDidChangeSessions(){return Yt.onDidChangeSessions},registerAuthenticationProvider(fe,Ee,Be,at){return Yt.registerAuthenticationProvider(fe,Ee,Be,at)}},Li={registerCommand(fe,Ee,Be){return Oe.registerCommand(!0,fe,Ee,Be,void 0,$e)},registerTextEditorCommand(fe,Ee,Be){return Oe.registerCommand(!0,fe,(...at)=>{const bt=St.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return bt.edit(Pt=>{Ee.apply(Be,[bt,Pt,...at])}).then(Pt=>{Pt||pt.warn("Edits from command "+fe+" were not applied.")},Pt=>{pt.warn("An error occurred while running command "+fe,Pt)})},void 0,void 0,$e)},registerDiffInformationCommand:(fe,Ee,Be)=>((0,Xe.checkProposedApiEnabled)($e,"diffCommand"),Oe.registerCommand(!0,fe,async(...at)=>{const bt=Z.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Pt=await St.getDiffInformation(bt.id);Ee.apply(Be,[Pt,...at])},void 0,void 0,$e)),executeCommand(fe,...Ee){return Oe.executeCommand(fe,...Ee)},getCommands(fe=!1){return Oe.getCommands(fe)}},ai={get machineId(){return ot.telemetryInfo.machineId},get sessionId(){return ot.telemetryInfo.sessionId},get language(){return ot.environment.appLanguage},get appName(){return ot.environment.appName},get appRoot(){return ot.environment.appRoot?.fsPath??""},get appHost(){return ot.environment.appHost},get uriScheme(){return ot.environment.appUriScheme},get clipboard(){return mi.value},get shell(){return We.getDefaultShell(!1)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ft.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),Ft.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const fe=Date.now()-new Date(ot.telemetryInfo.firstSessionDate).getTime();return isNaN(fe)?!1:fe<1e3*60*60*24},openExternal(fe,Ee){return _t.openUri(fe,{allowTunneling:!!ot.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===ot.environment.appUriScheme)return wt.createAppUri(fe);try{return await _t.asExternalUri(fe,{allowTunneling:!!ot.remote.authority})}catch(Ee){if((0,Ne.matchesScheme)(fe,ke.Schemas.http)||(0,Ne.matchesScheme)(fe,ke.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,X.getRemoteName)(ot.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)($e,"resolvers"),ot.remote.authority},get uiKind(){return ot.uiKind}};ot.environment.extensionTestsLocationURI||Object.freeze(ai);const Oi={createTestController(fe,Ee,Be){return ti.createTestController(fe,Ee,Be)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),ti.createTestObserver()},runTests(fe){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),ti.runTests(fe)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),ti.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),ti.results}},Mt=ot.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,qt={getExtension(fe,Ee){(0,Xe.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Be=Bt.mine.getExtensionDescription(fe);if(Be)return new s.Extension(kt,$e.identifier,Be,Mt,!1);if(Ee){const at=Bt.all.getExtensionDescription(fe);if(at)return new s.Extension(kt,$e.identifier,at,Mt,!0)}},get all(){const fe=[];for(const Ee of Bt.mine.getAllExtensionDescriptions())fe.push(new s.Extension(kt,$e.identifier,Ee,Mt,!1));return fe},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)($e,"extensionsAny");const fe=new Xe.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of Bt.all.getAllExtensionDescriptions()){const at=!fe.has(Be.identifier);Ee.push(new s.Extension(kt,$e.identifier,Be,Mt,at))}return Ee},get onDidChange(){return(0,Xe.isProposedApiEnabled)($e,"extensionsAny")?y.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Fi={createDiagnosticCollection(fe){return Xt.createDiagnosticCollection($e.identifier,fe)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:fe=>Xt.getDiagnostics(fe),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(fe,Ee){return Qt.changeLanguage(fe.uri,Ee)},match(fe,Ee){const Be=ft.getDocumentData(Ee.uri)?.notebook;return(0,L.score)(H.LanguageSelector.from(fe),Ee.uri,Ee.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(fe,Ee,Be){return dt.registerCodeActionProvider($e,gt(fe),Ee,Be)},registerDocumentPasteEditProvider(fe,Ee){return(0,Xe.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,gt(fe),Ee)},registerCodeLensProvider(fe,Ee){return dt.registerCodeLensProvider($e,gt(fe),Ee)},registerDefinitionProvider(fe,Ee){return dt.registerDefinitionProvider($e,gt(fe),Ee)},registerDeclarationProvider(fe,Ee){return dt.registerDeclarationProvider($e,gt(fe),Ee)},registerImplementationProvider(fe,Ee){return dt.registerImplementationProvider($e,gt(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return dt.registerTypeDefinitionProvider($e,gt(fe),Ee)},registerHoverProvider(fe,Ee){return dt.registerHoverProvider($e,gt(fe),Ee,$e.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return dt.registerEvaluatableExpressionProvider($e,gt(fe),Ee,$e.identifier)},registerInlineValuesProvider(fe,Ee){return dt.registerInlineValuesProvider($e,gt(fe),Ee,$e.identifier)},registerDocumentHighlightProvider(fe,Ee){return dt.registerDocumentHighlightProvider($e,gt(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return dt.registerLinkedEditingRangeProvider($e,gt(fe),Ee)},registerReferenceProvider(fe,Ee){return dt.registerReferenceProvider($e,gt(fe),Ee)},registerRenameProvider(fe,Ee){return dt.registerRenameProvider($e,gt(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,Be){return dt.registerDocumentSymbolProvider($e,gt(fe),Ee,Be)},registerWorkspaceSymbolProvider(fe){return dt.registerWorkspaceSymbolProvider($e,fe)},registerDocumentFormattingEditProvider(fe,Ee){return dt.registerDocumentFormattingEditProvider($e,gt(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return dt.registerDocumentRangeFormattingEditProvider($e,gt(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,Be,...at){return dt.registerOnTypeFormattingEditProvider($e,gt(fe),Ee,[Be].concat(at))},registerDocumentSemanticTokensProvider(fe,Ee,Be){return dt.registerDocumentSemanticTokensProvider($e,gt(fe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(fe,Ee,Be){return dt.registerDocumentRangeSemanticTokensProvider($e,gt(fe),Ee,Be)},registerSignatureHelpProvider(fe,Ee,Be,...at){return typeof Be=="object"?dt.registerSignatureHelpProvider($e,gt(fe),Ee,Be):dt.registerSignatureHelpProvider($e,gt(fe),Ee,typeof Be=="undefined"?[]:[Be,...at])},registerCompletionItemProvider(fe,Ee,...Be){return dt.registerCompletionItemProvider($e,gt(fe),Ee,Be)},registerInlineCompletionItemProvider(fe,Ee){return Ee.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,gt(fe),Ee)},registerInlineCompletionItemProviderNew(fe,Ee){if((0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsNew"),Ee.handleDidShowCompletionItem&&!(0,Xe.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,gt(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return dt.registerDocumentLinkProvider($e,gt(fe),Ee)},registerColorProvider(fe,Ee){return dt.registerColorProvider($e,gt(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return dt.registerFoldingRangeProvider($e,gt(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return dt.registerSelectionRangeProvider($e,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return dt.registerCallHierarchyProvider($e,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return dt.registerTypeHierarchyProvider($e,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>dt.setLanguageConfiguration($e,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,Xe.checkProposedApiEnabled)($e,"tokenInformation"),Qt.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return dt.registerInlayHintsProvider($e,fe,Ee)},createLanguageStatusItem(fe,Ee){return Qt.createLanguageStatusItem($e,fe,Ee)},registerDocumentOnDropEditProvider(fe,Ee){return(0,Xe.checkProposedApiEnabled)($e,"textEditorDrop"),dt.registerDocumentOnDropEditProvider($e,fe,Ee)}},zt={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(fe,Ee,Be){const at=await(C.URI.isUri(fe)?Promise.resolve(ni.openTextDocument(fe)):Promise.resolve(fe));return St.showTextDocument(at,Ee,Be)},createTextEditorDecorationType(fe){return St.createTextEditorDecorationType($e,fe)},onDidChangeActiveTextEditor(fe,Ee,Be){return St.onDidChangeActiveTextEditor(fe,Ee,Be)},onDidChangeVisibleTextEditors(fe,Ee,Be){return St.onDidChangeVisibleTextEditors(fe,Ee,Be)},onDidChangeTextEditorSelection(fe,Ee,Be){return St.onDidChangeTextEditorSelection(fe,Ee,Be)},onDidChangeTextEditorOptions(fe,Ee,Be){return St.onDidChangeTextEditorOptions(fe,Ee,Be)},onDidChangeTextEditorVisibleRanges(fe,Ee,Be){return St.onDidChangeTextEditorVisibleRanges(fe,Ee,Be)},onDidChangeTextEditorViewColumn(fe,Ee,Be){return St.onDidChangeTextEditorViewColumn(fe,Ee,Be)},onDidCloseTerminal(fe,Ee,Be){return We.onDidCloseTerminal(fe,Ee,Be)},onDidOpenTerminal(fe,Ee,Be){return We.onDidOpenTerminal(fe,Ee,Be)},onDidChangeActiveTerminal(fe,Ee,Be){return We.onDidChangeActiveTerminal(fe,Ee,Be)},onDidChangeTerminalDimensions(fe,Ee,Be){return(0,Xe.checkProposedApiEnabled)($e,"terminalDimensions"),We.onDidChangeTerminalDimensions(fe,Ee,Be)},onDidChangeTerminalState(fe,Ee,Be){return We.onDidChangeTerminalState(fe,Ee,Be)},onDidWriteTerminalData(fe,Ee,Be){return(0,Xe.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),We.onDidWriteTerminalData(fe,Ee,Be)},get state(){return _t.state},onDidChangeWindowState(fe,Ee,Be){return _t.onDidChangeWindowState(fe,Ee,Be)},showInformationMessage(fe,...Ee){return ii.showMessage($e,A.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return ii.showMessage($e,A.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return ii.showMessage($e,A.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,Be){return jt.showQuickPick(fe,Ee,Be)},showWorkspaceFolderPick(fe){return jt.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return jt.showInput(fe,Ee)},showOpenDialog(fe){return bi.showOpenDialog(fe)},showSaveDialog(fe){return bi.showSaveDialog(fe)},createStatusBarItem(fe,Ee,Be){let at,bt,Pt;return typeof fe=="string"?(at=fe,bt=Ee,Pt=Be):(bt=fe,Pt=Ee),Ei.createStatusBarEntry($e,at,bt,Pt)},setStatusBarMessage(fe,Ee){return Ei.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Tt.report("window.withScmProgress",$e,"Use 'withProgress' instead."),si.withProgress($e,{location:N.ProgressLocation.SourceControl},(Ee,Be)=>fe({report(at){}}))},withProgress(fe,Ee){return si.withProgress($e,fe,Ee)},createOutputChannel(fe,Ee){return ht.createOutputChannel(fe,Ee,$e)},createWebviewPanel(fe,Ee,Be,at){return ei.createWebviewPanel($e,fe,Ee,Be,at)},createWebviewTextEditorInset(fe,Ee,Be,at){return(0,Xe.checkProposedApiEnabled)($e,"editorInsets"),di.createWebviewEditorInset(fe,Ee,Be,at,$e)},createTerminal(fe,Ee,Be){return typeof fe=="object"?"pty"in fe?We.createExtensionTerminal(fe):We.createTerminalFromOptions(fe):We.createTerminal(fe,Ee,Be)},registerTerminalLinkProvider(fe){return We.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return We.registerProfileProvider($e,fe,Ee)},registerTreeDataProvider(fe,Ee){return ri.registerTreeDataProvider(fe,Ee,$e)},createTreeView(fe,Ee){return ri.createTreeView(fe,Ee,$e)},registerWebviewPanelSerializer:(fe,Ee)=>ei.registerWebviewPanelSerializer($e,fe,Ee),registerCustomEditorProvider:(fe,Ee,Be={})=>Ii.registerCustomEditorProvider($e,fe,Ee,Be),registerFileDecorationProvider(fe){return be.registerFileDecorationProvider(fe,$e.identifier)},registerUriHandler(fe){return wt.registerUriHandler($e.identifier,fe)},createQuickPick(){return jt.createQuickPick($e)},createInputBox(){return jt.createInputBox($e)},get activeColorTheme(){return oi.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,Be){return oi.onDidChangeActiveColorTheme(fe,Ee,Be)},registerWebviewViewProvider(fe,Ee,Be){return ki.registerWebviewViewProvider($e,fe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,Be){return vt.onDidChangeActiveNotebookEditor(fe,Ee,Be)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(fe,Ee,Be){return Jt.onDidChangeNotebookEditorSelection(fe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be){return Jt.onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be)},showNotebookDocument(fe,Ee){return C.URI.isUri(fe)&&Tt.report("window.showNotebookDocument(uri)",$e,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),vt.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,Be){return(0,Xe.checkProposedApiEnabled)($e,"externalUriOpener"),Ti.registerExternalUriOpener($e.identifier,fe,Ee,Be)},get tabGroups(){return Fe.tabGroups}},ni={get rootPath(){return Tt.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(fe){throw i.readonly()},getWorkspaceFolder(fe){return mt.getWorkspaceFolder(fe)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(fe){throw i.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(fe){throw i.readonly()},updateWorkspaceFolders:(fe,Ee,...Be)=>mt.updateWorkspaceFolders($e,fe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(fe,Ee,Be){return mt.onDidChangeWorkspace(fe,Ee,Be)},asRelativePath:(fe,Ee)=>mt.getRelativePath(fe,Ee),findFiles:(fe,Ee,Be,at)=>mt.findFiles(fe,Ee,Be,$e.identifier,at),findTextInFiles:(fe,Ee,Be,at)=>{(0,Xe.checkProposedApiEnabled)($e,"findTextInFiles");let bt,Pt;return typeof Ee=="object"?(bt=Ee,Pt=Be):(bt={},Pt=Ee,at=Be),mt.findTextInFiles(fe,bt||{},Pt,$e.identifier,at)},saveAll:fe=>mt.saveAll(fe),applyEdit(fe){return Ai.applyWorkspaceEdit(fe)},createFileSystemWatcher:(fe,Ee,Be,at)=>Ht.createFileSystemWatcher(mt,$e,fe,Ee,Be,at),get textDocuments(){return ft.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw i.readonly()},openTextDocument(fe){let Ee;const Be=fe;if(typeof fe=="string")Ee=Promise.resolve(C.URI.file(fe));else if(C.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!Be||typeof Be=="object")Ee=ft.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(at=>ft.ensureDocumentData(at).then(bt=>bt.document))},onDidOpenTextDocument:(fe,Ee,Be)=>ft.onDidAddDocument(fe,Ee,Be),onDidCloseTextDocument:(fe,Ee,Be)=>ft.onDidRemoveDocument(fe,Ee,Be),onDidChangeTextDocument:(fe,Ee,Be)=>ft.onDidChangeDocument(fe,Ee,Be),onDidSaveTextDocument:(fe,Ee,Be)=>ft.onDidSaveDocument(fe,Ee,Be),onWillSaveTextDocument:(fe,Ee,Be)=>Rt.getOnWillSaveTextDocumentEvent($e)(fe,Ee,Be),get notebookDocuments(){return vt.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let Be;if(C.URI.isUri(fe))Be=fe,await vt.openNotebookDocument(fe);else if(typeof fe=="string")Be=C.URI.revive(await vt.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Ee,Be){return $t.onDidSaveNotebookDocument(fe,Ee,Be)},onDidChangeNotebookDocument(fe,Ee,Be){return $t.onDidChangeNotebookDocument(fe,Ee,Be)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(fe,Ee,Be,at){return vt.registerNotebookSerializer($e,fe,Ee,Be,(0,Xe.isProposedApiEnabled)($e,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(fe,Ee,Be,at)=>((0,Xe.checkProposedApiEnabled)($e,"notebookContentProvider"),Tt.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider($e,fe,Ee,Be,(0,Xe.isProposedApiEnabled)($e,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(fe,Ee,Be)=>_i.onDidChangeConfiguration(fe,Ee,Be),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,_i.getConfiguration(fe,Ee,$e)},registerTextDocumentContentProvider(fe,Ee){return It.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Tt.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),ut.registerTaskProvider($e,fe,Ee)),registerFileSystemProvider(fe,Ee,Be){return(0,Ze.combinedDisposable)(hi.registerFileSystemProvider($e,fe,Ee,Be),Ot.addFileSystemProvider(fe,Ee))},get fs(){return Ot.value},registerFileSearchProvider:(fe,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"fileSearchProvider"),Qe.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"textSearchProvider"),Qe.registerTextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),fi.$registerResourceLabelFormatter(fe)),onDidCreateFiles:(fe,Ee,Be)=>Ht.onDidCreateFile(fe,Ee,Be),onDidDeleteFiles:(fe,Ee,Be)=>Ht.onDidDeleteFile(fe,Ee,Be),onDidRenameFiles:(fe,Ee,Be)=>Ht.onDidRenameFile(fe,Ee,Be),onWillCreateFiles:(fe,Ee,Be)=>Ht.getOnWillCreateFileEvent($e)(fe,Ee,Be),onWillDeleteFiles:(fe,Ee,Be)=>Ht.getOnWillDeleteFileEvent($e)(fe,Ee,Be),onWillRenameFiles:(fe,Ee,Be)=>Ht.getOnWillRenameFileEvent($e)(fe,Ee,Be),openTunnel:fe=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),Ct.openTunnel($e,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,Xe.checkProposedApiEnabled)($e,"resolvers"),Ct.getTunnels()},onDidChangeTunnels:(fe,Ee,Be)=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),Ct.onDidChangeTunnels(fe,Ee,Be)),registerPortAttributesProvider:(fe,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"portsAttributes"),Ct.registerPortsAttributesProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"timeline"),Di.registerTimelineProvider(fe,Ee,$e.identifier,Oe.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:fe=>((0,Xe.checkProposedApiEnabled)($e,"workspaceTrust"),mt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,Be)=>mt.onDidGrantWorkspaceTrust(fe,Ee,Be)},Ni={get inputBox(){return Tt.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox($e)},createSourceControl(fe,Ee,Be){return wi.createSourceControl($e,fe,Ee,Be)}},Mi={createCommentController(fe,Ee){return Ci.createCommentController($e,fe,Ee)}},Ui={get activeDebugSession(){return it.activeDebugSession},get activeDebugConsole(){return it.activeDebugConsole},get breakpoints(){return it.breakpoints},onDidStartDebugSession(fe,Ee,Be){return it.onDidStartDebugSession(fe,Ee,Be)},onDidTerminateDebugSession(fe,Ee,Be){return it.onDidTerminateDebugSession(fe,Ee,Be)},onDidChangeActiveDebugSession(fe,Ee,Be){return it.onDidChangeActiveDebugSession(fe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(fe,Ee,Be){return it.onDidReceiveDebugSessionCustomEvent(fe,Ee,Be)},onDidChangeBreakpoints(fe,Ee,Be){return it.onDidChangeBreakpoints(fe,Ee,Be)},registerDebugConfigurationProvider(fe,Ee,Be){return it.registerDebugConfigurationProvider(fe,Ee,Be||rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return it.registerDebugAdapterDescriptorFactory($e,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return it.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?it.startDebugging(fe,Ee,{parentSession:Be}):it.startDebugging(fe,Ee,Be||{})},stopDebugging(fe){return it.stopDebugging(fe)},addBreakpoints(fe){return it.addBreakpoints(fe)},removeBreakpoints(fe){return it.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return it.asDebugSourceUri(fe,Ee)}},Bi={registerTaskProvider:(fe,Ee)=>ut.registerTaskProvider($e,fe,Ee),fetchTasks:fe=>ut.fetchTasks(fe),executeTask:fe=>ut.executeTask($e,fe),get taskExecutions(){return ut.taskExecutions},onDidStartTask:(fe,Ee,Be)=>ut.onDidStartTask(fe,Ee,Be),onDidEndTask:(fe,Ee,Be)=>ut.onDidEndTask(fe,Ee,Be),onDidStartTaskProcess:(fe,Ee,Be)=>ut.onDidStartTaskProcess(fe,Ee,Be),onDidEndTaskProcess:(fe,Ee,Be)=>ut.onDidEndTaskProcess(fe,Ee,Be)},zi={createNotebookController(fe,Ee,Be,at,bt){return vi.createNotebookController($e,fe,Ee,Be,at,(0,Xe.isProposedApiEnabled)($e,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>vt.registerNotebookCellStatusBarItemProvider($e,fe,Ee),createNotebookEditorDecorationType(fe){return(0,Xe.checkProposedApiEnabled)($e,"notebookEditorDecorationType"),Jt.createNotebookEditorDecorationType(fe)},createRendererMessaging(fe){return ui.createRendererMessaging($e,fe)},onDidChangeNotebookCellExecutionState(fe,Ee,Be){return(0,Xe.checkProposedApiEnabled)($e,"notebookCellExecutionState"),vi.onDidChangeNotebookCellExecutionState(fe,Ee,Be)}};return{version:ot.version,authentication:Ri,commands:Li,comments:Mi,debug:Ui,env:ai,extensions:qt,languages:Fi,notebooks:zi,scm:Ni,tasks:Bi,tests:Oi,window:zt,workspace:ni,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CommentThreadState:N.CommentThreadState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:N.InlineCompletionTriggerKindNew,EventEmitter:y.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionItemNew:N.InlineSuggestionNew,InlineCompletionList:N.InlineSuggestionList,InlineCompletionListNew:N.InlineSuggestionsNew,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SnippetTextEdit:N.SnippetTextEdit,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:I.UIKind,Uri:C.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,NotebookEdit:N.NotebookEdit,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ce.TextSearchCompleteMessageType,DataTransfer:N.DataTransfer,DataTransferItem:N.DataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind,InputBoxValidationSeverity:N.InputBoxValidationSeverity,TabInputText:N.TextTabInput,TabInputTextDiff:N.TextDiffTabInput,TabInputCustom:N.CustomEditorTabInput,TabInputNotebook:N.NotebookEditorTabInput,TabInputNotebookDiff:N.NotebookDiffEditorTabInput,TabInputWebview:N.WebviewEditorTabInput,TabInputTerminal:N.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=tt}),define(Ie[289],Te([1,0,290,300,301,2,302]),function(Y,e,u,i,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(T,S,I,_,g,v){const p=v.environment.useHostProxy,b=typeof p=="boolean"?p:!v.remote.isRemote,f=(0,C.createProxyResolver)({resolveProxy:m=>T.resolveProxy(m),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(m,o,...h)=>{switch(m){case C.LogLevel.Trace:_.trace(o,...h);break;case C.LogLevel.Debug:_.debug(o,...h);break;case C.LogLevel.Info:_.info(o,...h);break;case C.LogLevel.Warning:_.warn(o,...h);break;case C.LogLevel.Error:_.error(o,...h);break;case C.LogLevel.Critical:_.critical(o,...h);break;case C.LogLevel.Off:break;default:r(m,o,h);break}function r(s,n,...t){_.error("Unknown log level",s),_.error(n,...t)}},getLogLevel:()=>_.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),a=E(S,f);return L(I,a)}e.connectProxyResolver=D;function E(T,S){const I={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(g=>{I.config=T.getConfiguration("http").get("proxySupport")||"off"});const _={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(g=>{_.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"off"},_,!0)),on:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"on"},_,!0)),override:Object.assign({},u,(0,C.createHttpPatch)(u,S,{config:"override"},_,!0)),onRequest:Object.assign({},u,(0,C.createHttpPatch)(u,S,I,_,!0)),default:Object.assign(u,(0,C.createHttpPatch)(u,S,I,_,!1))},https:{off:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"off"},_,!0)),on:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"on"},_,!0)),override:Object.assign({},i,(0,C.createHttpPatch)(i,S,{config:"override"},_,!0)),onRequest:Object.assign({},i,(0,C.createHttpPatch)(i,S,I,_,!0)),default:Object.assign(i,(0,C.createHttpPatch)(i,S,I,_,!1))},tls:Object.assign(y,(0,C.createTlsPatch)(y))}}const P=new Map;function L(T,S){return T.getExtensionPathIndex().then(I=>{const _=Y.__$__nodeRequire("module"),g=_._load;_._load=function(p,b,f){if(p==="tls")return S.tls;if(p!=="http"&&p!=="https")return g.apply(this,arguments);const a=S[p],m=I.findSubstr(A.URI.file(b.filename));let o=P.get(m);if(o||P.set(m,o={}),!o[p]){let h=a.default;o[p]={...h}}return o[p]}})}}),define(Ie[141],Te([1,0,42,303,105,16,48,34,9,8,2,31,73,304,283,93]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=_.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class p{constructor(d){this.outputChannel=d}provideTextSearchResults(d,w,R,F){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,k)=>{F.onCancellationRequested(()=>x());const B=h(d,w),M=w.folder.fsPath,W=B.map(ue=>ue.match(/^-/)?ue:`'${ue}'`).join(" ");this.outputChannel.appendLine(`${v} ${W}
 - cwd: ${M}`);let ee=u.spawn(v,B,{cwd:M});ee.on("error",ue=>{console.error(ue),this.outputChannel.appendLine("Error: "+(ue&&ue.message)),k((0,T.serializeSearchError)(new T.SearchError(ue&&ue.message,T.SearchErrorCode.rgProcessError)))});let H=!1;const N=new a(w.maxResults,M,w.previewOptions);N.on("result",ue=>{H=!0,ie="",R.report(ue)});let j=!1;const x=()=>{j=!0,ee&&ee.kill(),N&&N.cancel()};let q=!1;N.on("hitLimit",()=>{q=!0,x()});let ie="";ee.stdout.on("data",ue=>{N.handleData(ue),H||(ie+=ue)});let Q=!1;ee.stdout.once("data",()=>Q=!0);let de="";ee.stderr.on("data",ue=>{const X=ue.toString();this.outputChannel.appendLine(X),de+=X}),ee.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(H?"Got result from parser":"No result from parser"),ie&&this.outputChannel.appendLine(`Got data without result: ${ie}`),this.outputChannel.appendLine(""),j)O({limitHit:q});else{N.flush(),ee=null;let ue;de&&!Q&&(ue=b(de))?k((0,T.serializeSearchError)(new T.SearchError(ue.message,ue.code))):O({limitHit:q})}})})}}e.RipgrepTextSearchEngine=p;function b(l){const d=l.split(`
`),w=d[0].trim();if(d.some(F=>F.startsWith("regex parse error")))return new T.SearchError(f(d),T.SearchErrorCode.regexParseError);const R=w.match(/grep config error: unknown encoding: (.*)/);if(R)return new T.SearchError(`Unknown encoding: ${R[1]}`,T.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new T.SearchError(w.charAt(0).toUpperCase()+w.substr(1),T.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new T.SearchError(w.charAt(0).toUpperCase()+w.substr(1),T.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(w,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function f(l){const d=["Regex parse error"],w=l.filter(R=>R.startsWith("PCRE2:"));if(w.length>=1){const R=w[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const F=R.split(":")[1];d.push(":"+F)}}return d.join("")}e.buildRegexParseError=f;class a extends i.EventEmitter{constructor(d,w,R){super();this.maxResults=d,this.rootFolder=w,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,w){return super.on(d,w),this}handleData(d){if(this.isDone)return;const w=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(w)}handleDecodedData(d){let w=d.indexOf(`
`);const R=this.remainder+d;if(w>=0)w+=this.remainder.length;else{this.remainder=R;return}let F=0;for(;w>=0;)this.handleLine(R.substring(F,w).trim()),F=w+1,w=R.indexOf(`
`,F);this.remainder=R.substring(F)}handleLine(d){if(this.isDone||!d)return;let w;try{w=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(w.type==="match"){const R=m(w.data.path),F=L.URI.file(E.join(this.rootFolder,R)),O=this.createTextSearchMatch(w.data,F);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const R=m(w.data.path),F=L.URI.file(E.join(this.rootFolder,R));this.createTextSearchContext(w.data,F).forEach(k=>this.onResult(k))}}createTextSearchMatch(d,w){const R=d.line_number-1,F=m(d.lines),O=Buffer.from(F);let k=0,B=0,M=R;d.submatches.length===0&&d.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const W=(0,A.coalesce)(d.submatches.map((ee,H)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const N=m(ee.match),j=O.slice(k,ee.start).toString().length,x=B+j,q=o(N),ie=M,Q=q.numLines+ie,de=q.numLines>0?q.lastLineLength:q.lastLineLength+x;return k=ee.end,B=de,M=Q,new S.Range(ie,x,Q,de)}));return(0,g.createTextSearchResult)(w,F,W,this.previewOptions)}createTextSearchContext(d,w){const R=m(d.lines),F=d.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((O,k)=>({text:O,uri:w,lineNumber:F+k}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=a;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function o(l){const d=/\n/g;let w=0,R=-1,F;for(;F=d.exec(l);)w++,R=F.index;const O=R>=0?l.length-R-1:l.length;return{numLines:w,lastLineLength:O}}function h(l,d){const w=["--hidden"];w.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:F}=(0,C.groupBy)(d.includes,k=>k.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const k=new Set;F.forEach(B=>{k.add(B)}),w.push("-g","!*"),k.forEach(B=>{r(B).map(g.anchorGlob).forEach(M=>{w.push("-g",M)})})}R&&R.length&&R.forEach(k=>{w.push("-g",k)}),d.excludes.map(g.anchorGlob).forEach(k=>w.push("-g",`!${k}`)),d.maxFileSize&&w.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),d.followSymlinks&&w.push("--follow"),d.encoding&&d.encoding!=="utf8"&&w.push("--encoding",d.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,P.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),d.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),l.isRegExp&&(l.pattern=s(l.pattern),w.push("--engine","auto"));let O;if(l.isWordMatch){const B=(0,P.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",B)}else if(l.isRegExp){let k=t(l.pattern);k=c(k),w.push("--regexp",k)}else O=l.pattern,w.push("--fixed-strings");return w.push("--no-config"),d.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),l.isMultiline&&w.push("--multiline"),d.beforeContext&&w.push("--before-context",d.beforeContext+""),d.afterContext&&w.push("--after-context",d.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function r(l){const d=(0,D.splitGlobAware)(l,"/");return d.map((w,R)=>d.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function s(l){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(d);)l=l.replace(d,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=s;const n=l=>l.type==="Assertion"&&l.kind==="lookbehind";function t(l){let d;try{d=new I.RegExpParser().parsePattern(l)}catch{return l}let w="",R=0;const F=(B,M,W)=>{w+=l.slice(R,B)+W,R=M},O=[];return new I.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const M=O[0];if(!M)F(B.start,B.end,"\\r?\\n");else if(!O.some(n))if(M.type==="CharacterClass")if(M.negate){const W=l.slice(M.start+2,B.start)+l.slice(B.end,M.end-1);M.parent?.type==="Quantifier"?F(M.start,M.end,W?`[^${W}]`:"."):F(M.start,M.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=l.slice(M.start+1,B.start)+l.slice(B.end,M.end-1);F(M.start,M.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else M.type==="Quantifier"&&F(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){O.unshift(B)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(B){O.unshift(B)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(B){O.unshift(B)},onCharacterClassLeave(){O.shift()},onAssertionEnter(B){n(B)&&O.push(B)},onAssertionLeave(B){O[0]===B&&O.shift()}}).visit(d),w+=l.slice(R),w}e.fixRegexNewline=t;function c(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(Ie[291],Te([1,0,21,141,118,10]),function(Y,e,u,i,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,T,S){const I=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===A.Schemas.vscodeUserData){const _={...L,folder:L.folder.with({scheme:A.Schemas.file})},g=new y.Progress(v=>T.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(S,v=>I.provideTextSearchResults(P,_,g,v))}else return this.withToken(S,_=>I.provideTextSearchResults(P,L,T,_))}async withToken(P,L){const T=D(P);this.inProgress.add(T);const S=await L(T.token);return this.inProgress.delete(T),S}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=C;function D(E){const P=new u.CancellationTokenSource;return E.onCancellationRequested(()=>P.cancel()),P}}),define(Ie[292],Te([1,0,29,141,140]),function(Y,e,u,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(E){this.query=E}search(E,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(I){L({message:I})}},S=new y.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(T),u);return new Promise((I,_)=>S.search(g=>{P(g.map(C))},E).then(g=>I({limitHit:g.limitHit,type:"success",stats:g.stats}),_))}}e.TextSearchEngineAdapter=A;function C(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((E,P)=>{if(P.ranges){const L=P;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(Ie[293],Te([1,0,16,17,11,3,101,9,49,2,43,31,284,292]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let m;const o=p(a),h=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(S.Engine,o,s=>h.fire(s),r)),m.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return h.event}textSearch(a){let m;const o=p(a),h=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(o,s=>h.fire(s),r)),m.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return h.event}ripgrepTextSearch(a,m,o){return a.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(a).search(o,m,m)}doFileSearch(a,m,o){return this.doFileSearchWithEngine(S.Engine,a,m,o)}doFileSearchWithEngine(a,m,o,h,r=_.BATCH_SIZE){let s=0;const n=c=>{Array.isArray(c)?(s+=c.length,o(c.map(l=>this.rawMatchToSearchItem(l)))):c.relativePath?(s++,o(this.rawMatchToSearchItem(c))):o(c)};if(m.sortByScore){let c=this.trySortedSearchFromCache(m,n,h);if(!c){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,d=new a(l);c=this.doSortedSearch(d,m,o,n,h)}return new Promise((l,d)=>{c.then(([w,R])=>{const F=R.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(F,o,r),l(w)},d)})}const t=new a(m);return this.doSearch(t,n,r,h).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,D.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,m,o,h,r){const s=new A.Emitter;let n=(0,i.createCancelablePromise)(c=>{let l=[];const d=w=>{Array.isArray(w)?l=w:(h(w),s.fire(w))};return this.doSearch(a,d,-1,c).then(w=>[w,l])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const c={promise:n,event:s.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=c,n.then(()=>{c.resolved=!0},l=>{delete t.resultsToSearchCache[m.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([c,l])=>{const d=t?t.scorerCache:Object.create(null),w=(typeof m.maxResults!="number"||m.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(m,l,d,r).then(R=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:F,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:R.length},messages:c.messages,limitHit:c.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},R]})})}getOrCreateCache(a){const m=this.caches[a];return m||(this.caches[a]=new g)}trySortedSearchFromCache(a,m,o){const h=a.cacheKey&&this.caches[a.cacheKey];if(!h)return;const r=this.getResultsFromCache(h,a.filePattern||"",m,o);if(r)return r.then(([s,n,t])=>{const c=E.StopWatch.create(!1);return this.sortResults(a,n,h.scorerCache,o).then(l=>{const d=c.elapsed(),w={fromCache:!0,detailStats:t,type:this.processType,resultCount:n.length,sortingTime:d};return[{type:"success",limitHit:s.limitHit||typeof a.maxResults=="number"&&n.length>a.maxResults,stats:w},l]})})}sortResults(a,m,o,h){const r=(0,C.prepareQuery)(a.filePattern||""),s=(t,c)=>(0,C.compareItemsByFuzzyScore)(t,c,r,!0,v,o),n=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return u.topAsync(m,s,n,1e4,h)}sendProgress(a,m,o){if(o&&o>0)for(let h=0;h<a.length;h+=o)m(a.slice(h,h+o));else m(a)}getResultsFromCache(a,m,o,h){const r=E.StopWatch.create(!1),s=m.indexOf(D.sep)>=0;let n;for(const d in a.resultsToSearchCache)if(m.startsWith(d)){if(s&&d.indexOf(D.sep)<0&&d!=="")continue;const w=a.resultsToSearchCache[d];n={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!n)return null;const t=r.elapsed(),c=E.StopWatch.create(!1),l=n.event(o);return h&&h.onCancellationRequested(()=>{l.dispose()}),n.promise.then(([d,w])=>{if(h&&h.isCancellationRequested)throw(0,y.canceled)();const R=[],F=(0,C.prepareQuery)(m).normalizedLowercase;for(const O of w)!(0,T.isFilePatternMatch)(O,F)||R.push(O);return[d,R,{cacheWasResolved:n.resolved,cacheLookupTime:t,cacheFilterTime:c.elapsed(),cacheEntryCount:w.length}]})}doSearch(a,m,o,h){return new Promise((r,s)=>{let n=[];h&&h.onCancellationRequested(()=>a.cancel()),a.search(t=>{t&&(o?(n.push(t),o>0&&n.length>=o&&(m(n),n=[])):m(t))},t=>{m(t)},(t,c)=>{n.length&&m(n),t?s(t):r(c)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,o){return a.then(m,o)}catch(m){return this.then(void 0,m)}finally(m){return a.finally(m)}}}}e.SearchService=_,_.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(f){return(0,D.basename)(f.relativePath)}getItemDescription(f){return(0,D.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function p(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>P.URI.revive(a))}}function b(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Ie[294],Te([1,0,6,10,2,29,14,27,18,77,66,31,293,291,93,140]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends P.ExtHostSearch{constructor(b,f,a,m){super(b,a,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new _.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.vscodeUserData,new I.RipgrepSearchProvider(o)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new _.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new I.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(i.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,f){const a=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(b,f,a,m){const o=(0,P.reviveQuery)(a);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,f,o,m):super.$provideFileSearchResults(b,f,a,m)}doInternalFileSearch(b,f,a,m){const o=h=>{if((0,T.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){this._proxy.$handleFileMatch(b,f,h.map(r=>y.URI.file(r.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,o,m)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,f){return new g.NativeTextSearchManager(b,f,void 0,"textSearchProvider")}};v=je([xe(0,E.IExtHostRpcService),xe(1,D.IExtHostInitDataService),xe(2,L.IURITransformerService),xe(3,C.ILogService)],v),e.NativeExtHostSearch=v}),define(Ie[142],Te([1,0,305,127,64,23,11,3,6,9,13,35,107,108,306]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(w,R=""){this.debugLabel=R,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,C.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,R){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const R=F=>{this.traceSocketEvent("read",F),w(A.VSBuffer.wrap(F))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(w){const R=F=>{this.traceSocketEvent("close",{hadError:F}),w({type:0,hadError:F,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(w){const R=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,C.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,C.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=g;var v;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var p;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(p||(p={}));class b extends E.Disposable{constructor(w,R,F,O){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:F?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new f(this,R,F,O,this._onData,(k,B)=>this._write(k,B))),this._register(this._flowManager.onError(k=>{console.error(k),(0,C.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,R){this.socket.traceSocketEvent(w,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let F=2;w.byteLength<126?F+=0:w.byteLength<2**16?F+=2:F+=8;const O=A.VSBuffer.alloc(F);if(R?O.writeUInt8(194,0):O.writeUInt8(130,0),w.byteLength<126)O.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){O.writeUInt8(126,1);let k=1;O.writeUInt8(w.byteLength>>>8&255,++k),O.writeUInt8(w.byteLength>>>0&255,++k)}else{O.writeUInt8(127,1);let k=1;O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(w.byteLength>>>24&255,++k),O.writeUInt8(w.byteLength>>>16&255,++k),O.writeUInt8(w.byteLength>>>8&255,++k),O.writeUInt8(w.byteLength>>>0&255,++k)}this.socket.write(A.VSBuffer.concat([O,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),F=R.readUInt8(0),O=(F&128)>>>7,k=(F&64)>>>6,B=R.readUInt8(1),M=(B&128)>>>7,W=B&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),F=R.readUInt8(1),O=(F&128)>>>7;let k=F&127,B=1;k===126?k=R.readUInt8(++B)*2**8+R.readUInt8(++B):k===127&&(k=R.readUInt8(++B)*0+R.readUInt8(++B)*0+R.readUInt8(++B)*0+R.readUInt8(++B)*0+R.readUInt8(++B)*2**24+R.readUInt8(++B)*2**16+R.readUInt8(++B)*2**8+R.readUInt8(++B));let M=0;O&&(M=R.readUInt8(++B)*2**24+R.readUInt8(++B)*2**16+R.readUInt8(++B)*2**8+R.readUInt8(++B)),this._state.state=3,this._state.readLen=k,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),o(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class f extends E.Disposable{constructor(w,R,F,O,k,B){super();this._tracer=w,this._onData=k,this._writeFn=B,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new a(this._tracer,O,F,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(R,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,R){return new Promise((F,O)=>{w.write(R),w.flush(k=>F(k))})}acceptFrame(w,R,F){this._readQueue.push({data:w,isCompressed:R,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,R,F){return new Promise((O,k)=>{w.write(R),F&&w.write(A.VSBuffer.fromByteArray([0,0,255,255])),w.flush(B=>O(B))})}}class a extends E.Disposable{constructor(w,R,F,O){super();this._tracer=w,this._recordInflateBytes=R,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=_.createInflateRaw(O),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(A.VSBuffer.wrap(k))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(R)})}}class m extends E.Disposable{constructor(w,R){super();this._tracer=w,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=_.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(A.VSBuffer.wrap(F))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),w(R)})}}function o(d,w){if(w===0)return;let R=d.byteLength>>>2;for(let W=0;W<R;W++){const ee=d.readUInt32BE(W*4);d.writeUInt32BE(ee^w,W*4)}let F=R*4,O=d.byteLength-F;const k=w>>>24&255,B=w>>>16&255,M=w>>>8&255;O>=1&&d.writeUInt8(d.readUInt8(F)^k,F),O>=2&&d.writeUInt8(d.readUInt8(F+1)^B,F+1),O>=3&&d.writeUInt8(d.readUInt8(F+2)^M,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function r(){const d=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):w=(0,P.join)((0,y.tmpdir)(),`vscode-ipc-${d}.sock`),n(w),w}e.createRandomIPCHandle=r;function s(d,w,R){const F=(0,u.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${R}-${w}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${R}-${w}.sock`):O=(0,P.join)(d,`${R}-${w}.sock`),n(O),O}e.createStaticIPCHandle=s;function n(d){const w=h[L.platform];typeof w=="number"&&d.length>=w&&console.warn(`WARNING: IPC handle "${d}" is longer than ${w} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{constructor(w){super(t.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const R=D.Event.fromNodeEventEmitter(w,"connection");return D.Event.map(R,F=>({protocol:new I.Protocol(new g(F,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function c(d){return new Promise((w,R)=>{const F=(0,i.createServer)();F.on("error",R),F.listen(d,()=>{F.removeListener("error",R),w(new t(F))})})}e.serve=c;function l(d,w){return new Promise((R,F)=>{const O=(0,i.createConnection)(d,()=>{O.removeListener("error",F),R(I.Client.fromSocket(new g(O,`ipc-client${w}`),w))});O.once("error",F)})}e.connect=l}),define(Ie[295],Te([1,0,142,290,63,37,2,14,45]),function(Y,e,u,i,y,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(S,I,_){this._commands=S,this.logService=I,this._ipcHandlePath=_,this._server=i.createServer((g,v)=>this.onRequest(g,v)),this.setup().catch(g=>(I.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,I){const _=(v,p)=>{I.writeHead(v,{"content-type":"application/json"}),I.end(JSON.stringify(p||null),b=>b&&this.logService.error(b))},g=[];S.setEncoding("utf8"),S.on("data",v=>g.push(v)),S.on("end",async()=>{try{const v=JSON.parse(g.join(""));let p;switch(v.type){case"open":p=await this.open(v);break;case"openExternal":p=await this.openExternal(v);break;case"status":p=await this.getStatus(v);break;case"extensionManagement":p=await this.manageExtensions(v);break;default:_(404,`Unknown message type: ${v.type}`);break}_(200,p)}catch(v){const p=v instanceof Error?v.message:JSON.stringify(v);_(500,p),this.logService.error("Error while processing pipe request",v)}})}async open(S){const{fileURIs:I,folderURIs:_,forceNewWindow:g,diffMode:v,addMode:p,forceReuseWindow:b,gotoLineMode:f,waitMarkerFilePath:a,remoteAuthority:m}=S,o=[];if(Array.isArray(_))for(const n of _)try{o.push({folderUri:C.URI.parse(n)})}catch{}if(Array.isArray(I))for(const n of I)try{(0,E.hasWorkspaceFileExtension)(n)?o.push({workspaceUri:C.URI.parse(n)}):o.push({fileUri:C.URI.parse(n)})}catch{}const h=a?C.URI.file(a):void 0,s={forceNewWindow:g,diffMode:v,addMode:p,gotoLineMode:f,forceReuseWindow:b,preferNewWindow:!b&&!h&&!p,waitMarkerFileURI:h,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(S){for(const I of S.uris){const _=C.URI.parse(I),g=_.scheme==="file"?_:I;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(S){const I=g=>g?.map(v=>/\.vsix$/i.test(v)?C.URI.parse(v):v),_={list:S.list,install:I(S.install),uninstall:I(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(S,I){super(S,I,(0,u.createRandomIPCHandle)())}};L=je([xe(0,A.IExtHostCommands),xe(1,D.ILogService)],L),e.CLIServer=L}),define(Ie[296],Te([1,0,75,288,276,5,289,39,264,2,10,7,295,106]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class _ extends y.RequireInterceptor{_installInterceptor(){const p=this,b=Y.__$__nodeRequire("module"),f=b._load;b._load=function(h,r,s){return h=m(h),p._factories.has(h)?p._factories.get(h).load(h,P.URI.file((0,I.realpathSync)(r.filename)),n=>f.apply(this,[n,r,s])):f.apply(this,arguments)};const a=b._resolveLookupPaths;b._resolveLookupPaths=(o,h)=>a.call(this,m(o),h);const m=o=>{for(let h of p._alternatives){let r=h(o);if(r){o=r;break}}return o}}}class g extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const p=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(S.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(_,p,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver");const a=process.send,m=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?a.apply(process,o):(m.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(p){return p.main}_loadCommonJSModule(p,b,f){if(b.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let a=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{p&&u.mark(`code/extHost/willLoadExtensionCode/${p.value}`),a=Y.__$__nodeRequire(b.fsPath)}catch(m){return Promise.reject(m)}finally{p&&u.mark(`code/extHost/didLoadExtensionCode/${p.value}`),f.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(p){if(!!this._initData.remote.isRemote)for(const b in p){const f=p[b];f===null?delete process.env[b]:process.env[b]=f}}}e.ExtHostExtensionService=g}),define(Ie[297],Te([1,0,83,267,279,278,294,296,268,76,39,77,74,38,53,71,266,265,14,280,47]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v,p,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService),(0,u.registerSingleton)(b.ILoggerService,p.ExtHostLoggerService),(0,u.registerSingleton)(g.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,u.registerSingleton)(P.IExtHostDebugService,A.ExtHostDebugService),(0,u.registerSingleton)(T.IExtHostSearch,C.NativeExtHostSearch),(0,u.registerSingleton)(S.IExtHostTask,y.ExtHostTask),(0,u.registerSingleton)(I.IExtHostTerminalService,i.ExtHostTerminalService),(0,u.registerSingleton)(_.IExtHostTunnelService,E.ExtHostTunnelService),(0,u.registerSingleton)(a.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService)}),define(Ie[307],Te([1,0,127,308,75,11,108,142,197,134,277,23,29,106,17,114,210,281,297]),function(Y,e,u,i,y,A,C,D,E,P,L,T,S,I,_,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const p=i(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=Y.__$__nodeRequire("module"),n=s._load;s._load=function(t){if(t==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const b=process.exit.bind(process);function f(s){process.exit=function(n){if(s)b(n);else{const t=new Error("An extension called process.exit() and this was prevented.");console.warn(t.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let a=function(s){b()};function m(){if(process.env.VSCODE_WILL_SEND_MESSAGE_PORT)return new Promise((s,n)=>{const t=c=>{const l=c[0],d=new C.BufferedEmitter;l.on("message",w=>d.fire(T.VSBuffer.wrap(w.data))),l.on("close",()=>{a("renderer closed the MessagePort")}),l.start(),s({onMessage:d.event,send:w=>l.postMessage(w.buffer)})};if(global.vscodePorts){const c=global.vscodePorts;delete global.vscodePorts,t(c)}else global.vscodePortsCallback=t});if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let t=null,c=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const l=108e5,d=3e5,w=new _.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),l),R=new _.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),d);process.on("message",(O,k)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){k.setNoDelay(!0);const B=T.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new D.NodeSocket(k,"extHost-socket");else{const W=T.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new D.WebSocketNodeSocket(new D.NodeSocket(k,"extHost-socket"),O.permessageDeflate,W,!1)}t?(w.cancel(),R.cancel(),t.beginAcceptReconnection(M,B),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(c),t=new C.PersistentProtocol(M,B),t.sendResume(),t.onDidDispose(()=>a("renderer disconnected")),s(t),t.onSocketClose(()=>{w.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;w.isScheduled()&&R.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(F)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,t)=>{const c=u.createConnection(s,()=>{c.removeListener("error",t);const l=new C.PersistentProtocol(new D.NodeSocket(c,"extHost-renderer"));l.sendResume(),n(l)});c.once("error",t),c.on("close",()=>{a("renderer closed the socket")})})}}async function o(){const s=await m();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}async drain(){if(s.drain)return s.drain()}}}function h(s){return new Promise(n=>{const t=s.onMessage(c=>{t.dispose();const l=JSON.parse(c.toString()),d=l.commit,w=E.default.commit;d&&w&&d!==w&&b(55);let R=0;setInterval(function(){try{process.kill(l.parentPid,0),R=0}catch(O){O&&O.code==="EPERM"?(R++,R>=3&&a(`parent process ${l.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):a(`parent process ${l.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let F;try{F=Y.__$__nodeRequire("native-watchdog"),F.start(l.parentPid)}catch(O){(0,A.onUnexpectedError)(O)}s.send((0,P.createMessageOfType)(0)),n({protocol:s,initData:l})});s.send((0,P.createMessageOfType)(1))})}async function r(){const s=[];process.on("unhandledRejection",(R,F)=>{s.push(F),setTimeout(()=>{const O=s.indexOf(F);O>=0&&F.catch(k=>{s.splice(O,1),(0,A.isCancellationError)(k)||(console.warn(`rejected promise not handled within 1 second: ${k}`),k&&k.stack&&console.warn(`stack trace: ${k.stack}`),R&&(0,A.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const F=s.indexOf(R);F>=0&&s.splice(F,1)}),process.on("uncaughtException",function(R){(0,A.onUnexpectedError)(R)}),y.mark("code/extHost/willConnectToRenderer");const n=await o();y.mark("code/extHost/didConnectToRenderer");const t=await h(n);y.mark("code/extHost/didWaitForInitData");const{initData:c}=t;f(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,g.boolean)(p.skipWorkspaceStorageLock,!1);const l=new class{constructor(){this.pid=process.pid}exit(F){b(F)}exists(F){return S.Promises.exists(F)}realpath(F){return(0,I.realpath)(F)}};let d=null;c.remote.authority&&p.transformURIs&&(d=(0,v.createURITransformer)(c.remote.authority));const w=new L.ExtensionHostMain(t.protocol,c,l,d);a=R=>w.terminate(R)}e.startExtensionHostProcess=r,r().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/30d9c6cd9483b2cc586687151bcbcd635f373630/core/vs/workbench/api/node/extensionHostProcess.js.map
